/*
 * Copyright (c) 1994-2000 FUJITSU LABORATORIES LIMITED 
 * All rights reserved.
 * 
 * FUJITSU LABORATORIES LIMITED ("FLL") hereby grants you a limited,
 * non-exclusive and royalty-free license to use, copy, modify and
 * redistribute, solely for non-commercial and non-profit purposes, the
 * computer program, "Risa/Asir" ("SOFTWARE"), subject to the terms and
 * conditions of this Agreement. For the avoidance of doubt, you acquire
 * only a limited right to use the SOFTWARE hereunder, and FLL or any
 * third party developer retains all rights, including but not limited to
 * copyrights, in and to the SOFTWARE.
 * 
 * (1) FLL does not grant you a license in any way for commercial
 * purposes. You may use the SOFTWARE only for non-commercial and
 * non-profit purposes only, such as academic, research and internal
 * business use.
 * (2) The SOFTWARE is protected by the Copyright Law of Japan and
 * international copyright treaties. If you make copies of the SOFTWARE,
 * with or without modification, as permitted hereunder, you shall affix
 * to all such copies of the SOFTWARE the above copyright notice.
 * (3) An explicit reference to this SOFTWARE and its copyright owner
 * shall be made on your publication or presentation in any form of the
 * results obtained by use of the SOFTWARE.
 * (4) In the event that you modify the SOFTWARE, you shall notify FLL by
 * e-mail at risa-admin@sec.flab.fujitsu.co.jp of the detailed specification
 * for such modification or the source code of the modified part of the
 * SOFTWARE.
 * 
 * THE SOFTWARE IS PROVIDED AS IS WITHOUT ANY WARRANTY OF ANY KIND. FLL
 * MAKES ABSOLUTELY NO WARRANTIES, EXPRESSED, IMPLIED OR STATUTORY, AND
 * EXPRESSLY DISCLAIMS ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE OR NONINFRINGEMENT OF THIRD PARTIES'
 * RIGHTS. NO FLL DEALER, AGENT, EMPLOYEES IS AUTHORIZED TO MAKE ANY
 * MODIFICATIONS, EXTENSIONS, OR ADDITIONS TO THIS WARRANTY.
 * UNDER NO CIRCUMSTANCES AND UNDER NO LEGAL THEORY, TORT, CONTRACT,
 * OR OTHERWISE, SHALL FLL BE LIABLE TO YOU OR ANY OTHER PERSON FOR ANY
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, PUNITIVE OR CONSEQUENTIAL
 * DAMAGES OF ANY CHARACTER, INCLUDING, WITHOUT LIMITATION, DAMAGES
 * ARISING OUT OF OR RELATING TO THE SOFTWARE OR THIS AGREEMENT, DAMAGES
 * FOR LOSS OF GOODWILL, WORK STOPPAGE, OR LOSS OF DATA, OR FOR ANY
 * DAMAGES, EVEN IF FLL SHALL HAVE BEEN INFORMED OF THE POSSIBILITY OF
 * SUCH DAMAGES, OR FOR ANY CLAIM BY ANY OTHER PARTY. EVEN IF A PART
 * OF THE SOFTWARE HAS BEEN DEVELOPED BY A THIRD PARTY, THE THIRD PARTY
 * DEVELOPER SHALL HAVE NO LIABILITY IN CONNECTION WITH THE USE,
 * PERFORMANCE OR NON-PERFORMANCE OF THE SOFTWARE.
 *
 * $OpenXM: OpenXM_contrib2/asir2000/fft/fft_primes.c,v 1.5 2003/02/14 22:29:10 ohara Exp $ 
*/
#include "dft.h"

struct PrimesS Primes[NPrimes+1] = {
#if !defined(USE_FLOAT)
{536813569,234750831,29,13},
{536752129,402492685,29,12},
{536743937,186329165,29,12},
{536719361,95378865,29,12},
{536702977,245581677,29,12},
{536690689,9739040,29,14},
{536641537,295492251,29,15},
{536616961,393690063,29,13},
{536608769,291010677,29,18},
{536596481,103014380,29,12},
{536547329,239759961,29,12},
{536543233,236837218,29,16},
{536494081,476075671,29,14},
{536399873,298259227,29,12},
{536383489,405349448,29,12},
{536375297,202365348,29,12},
{536350721,181497148,29,12},
{536338433,331699927,29,13},
{536322049,263663385,29,13},
{536272897,151749197,29,13},
{536260609,3883278,29,12},
{536215553,360579775,29,17},
{536174593,172073969,29,13},
{536166401,94615858,29,14},
{536137729,535865804,29,12},
{536129537,413425539,29,12},
{536113153,237345802,29,12},
{536092673,213571388,29,13},
{536027137,26178280,29,13},
{536002561,531281091,29,14},
{535982081,257807731,29,12},
{535965697,19015705,29,12},
{535920641,394768681,29,15},
{535797761,30231376,29,13},
{535756801,373046537,29,16},
{535719937,205344434,29,12},
{535699457,247444914,29,13},
{535687169,109462788,29,12},
{535621633,212917624,29,12},
{535597057,54912267,29,12},
{535576577,138342549,29,14},
{535515137,167040109,29,12},
{535490561,218849557,29,12},
{535461889,10973144,29,15},
{535453697,30144640,29,13},
{535449601,299267429,29,12},
{535326721,48662331,29,12},
{535318529,507537577,29,12},
{535232513,151198643,29,16},
{535203841,310252406,29,12},
{535183361,441637121,29,14},
{535142401,41736754,29,13},
{535121921,24248074,29,12},
{535109633,365538970,29,13},
{535105537,338724195,29,12},
{535093249,27780626,29,13},
{535048193,367851802,29,12},
{535023617,108512195,29,12},
{534970369,92919075,29,16},
{534949889,250488631,29,12},
{534896641,8561888,29,13},
{534888449,499592811,29,14},
{534827009,89412539,29,12},
{534724609,192565215,29,14},
{534630401,313575656,29,12},
{534519809,233654795,29,13},
{534491137,49493188,29,12},
{534478849,407005633,29,15},
{534458369,56761679,29,12},
{534433793,5912048,29,12},
{534323201,286981770,29,13},
{534294529,64209761,29,12},
{534274049,399311455,29,13},
{534224897,369824991,29,13},
{534122497,400238577,29,12},
{534102017,430622136,29,14},
{534089729,276923246,29,12},
{534085633,410141529,29,15},
{534061057,451409458,29,13},
{534024193,55721226,29,12},
{533962753,446702722,29,13},
{533905409,398786932,29,14},
{533880833,525382882,29,13},
{533790721,514717025,29,16},
{533757953,519091809,29,15},
{533692417,355249309,29,15},
{533671937,467815537,29,12},
{533549057,265081597,29,12},
{533512193,504066982,29,14},
{533471233,317623602,29,13},
{533463041,13956582,29,18},
{533426177,283734551,29,12},
{533389313,496917437,29,13},
{533372929,61947542,29,13},
{533364737,96276431,29,15},
{533348353,140156098,29,14},
{533286913,397631479,29,12},
{533278721,968437,29,12},
{533241857,225492331,29,13},
{533082113,365456005,29,12},
{533041153,54952045,29,12},
{532996097,381636357,29,13},
{532992001,113979610,29,12},
{532983809,420752168,29,12},
{532959233,466760849,29,12},
{532942849,260450629,29,12},
{532930561,500039725,29,13},
{532873217,206165893,29,16},
{532860929,384848392,29,12},
{532856833,177804426,29,14},
{532787201,35516007,29,12},
{532746241,390580365,29,12},
{532738049,187427241,29,12},
{532709377,271440396,29,15},
{532541441,186617938,29,12},
{532500481,401817699,29,12},
{532451329,67560915,29,12},
{532389889,370398874,29,13},
{532357121,91402460,29,13},
{532283393,332791262,29,17},
{532267009,309964764,29,14},
{532258817,76655285,29,13},
{532193281,519383107,29,13},
{532160513,192671188,29,13},
{531910657,174287749,29,12},
{531886081,68947091,29,12},
{531767297,48982485,29,13},
{531763201,62929312,29,12},
{531750913,31507349,29,13},
{531726337,354320699,29,15},
{531701761,13466183,29,13},
{531652609,378858479,29,13},
{531628033,431112292,29,20},
{531582977,145978450,29,12},
{531578881,380511470,29,14},
{531542017,224186811,29,12},
{531443713,182796718,29,12},
{531394561,224003911,29,12},
{531161089,458901437,29,13},
{531005441,480568876,29,15},
{530993153,64256406,29,12},
{530989057,389241417,29,14},
{530952193,158449753,29,12},
{530890753,382883181,29,14},
{530870273,351805988,29,12},
{530780161,128073820,29,12},
{530767873,421524092,29,13},
{530759681,99667442,29,14},
{530706433,334734263,29,12},
{530698241,59124544,29,12},
{530649089,27137761,29,12},
{530595841,373602035,29,14},
{530546689,75947392,29,15},
{530526209,443629729,29,12},
{530464769,309461624,29,14},
{530423809,489388995,29,13},
{530362369,162078175,29,12},
{530354177,155102383,29,12},
{530276353,280548312,29,13},
{530145281,203735144,29,13},
{530010113,105794167,29,12},
{529985537,245095103,29,12},
{529960961,112843371,29,12},
{529944577,31484364,29,12},
{529932289,422300857,29,13},
{529924097,240319971,29,17},
{529907713,249806358,29,14},
{529899521,171407680,29,13},
{529887233,451762810,29,12},
{529821697,399291405,29,12},
{529809409,334691335,29,14},
{529735681,177639985,29,13},
{529727489,499429834,29,16},
{529715201,304468764,29,12},
{529702913,188606745,29,13},
{529686529,155936968,29,13},
{529678337,347960918,29,14},
{529420289,443500355,29,12},
{529391617,387255982,29,13},
{529285121,475338991,29,14},
{529268737,447629271,29,18},
{529186817,144350398,29,14},
{529182721,17103434,29,12},
{529149953,324500000,29,12},
{529145857,194451981,29,13},
{529088513,496830832,29,14},
{529084417,527528913,29,12},
{529039361,236831843,29,15},
{528986113,391026449,29,12},
{528977921,244430624,29,12},
{528916481,372519085,29,13},
{528867329,125235345,29,13},
{528818177,42558244,29,13},
{528777217,416856100,29,15},
{528752641,407110945,29,13},
{528703489,78929261,29,13},
{528691201,37070795,29,12},
{528670721,205306859,29,13},
{528633857,347691021,29,12},
{528617473,284420112,29,12},
{528609281,446362415,29,12},
{528531457,301183141,29,14},
{528519169,362135674,29,12},
{528445441,252891858,29,12},
{528437249,320488771,29,12},
{528424961,388431539,29,13},
{528408577,125859191,29,13},
{528351233,123238771,29,17},
{528347137,240359114,29,12},
{528310273,99523343,29,13},
{528265217,274448847,29,12},
{528252929,205552633,29,15},
{528228353,49731311,29,13},
{528138241,222497944,29,14},
{528064513,353564525,29,13},
{527994881,258610070,29,12},
{527941633,153777954,29,14},
{527921153,341143862,29,12},
{527917057,119139095,29,13},
{527880193,215363327,29,12},
{527859713,282970170,29,15},
{527855617,70974912,29,12},
{527831041,105259710,29,12},
{527810561,153035633,29,14},
{527794177,263292489,29,15},
{527708161,478454952,29,12},
{527650817,415227696,29,12},
{527634433,106482314,29,12},
{527585281,12710015,29,12},
{527572993,182147065,29,13},
{527527937,386656498,29,12},
{527491073,177859742,29,13},
{527441921,498832354,29,13},
{527380481,283989651,29,12},
{527351809,185527120,29,14},
{527339521,238901903,29,12},
{527269889,476081970,29,15},
{527241217,509929638,29,12},
{527220737,271149489,29,14},
{527196161,449736588,29,13},
{527167489,393867039,29,12},
{527155201,93845502,29,14},
{527093761,355183528,29,12},
{527081473,359281197,29,13},
{527024129,95834835,29,14},
{527020033,128632586,29,12},
{527011841,169675989,29,12},
{526999553,510223322,29,13},
{526970881,496538016,29,12},
{526934017,143107519,29,13},
{526876673,510218342,29,15},
{526852097,245591409,29,13},
{526835713,288297328,29,13},
{526766081,22756703,29,12},
{526712833,209744801,29,16},
{526675969,462001796,29,12},
{526651393,460697964,29,12},
{526594049,503479282,29,12},
{526544897,384456574,29,12},
{526508033,205234254,29,13},
{526503937,93161865,29,12},
{526483457,120945568,29,15},
{526381057,426362406,29,12},
{526368769,498498502,29,14},
{526360577,197358724,29,13},
{526344193,203866875,29,13},
{526336001,353505783,29,14},
{526163969,268968679,29,13},
{526135297,33009686,29,12},
{526123009,492037862,29,18},
{526090241,38097857,29,15},
{526053377,359192783,29,12},
{526036993,234709340,29,12},
{525987841,192176488,29,12},
{525950977,271971370,29,13},
{525938689,70147530,29,12},
{525918209,153170577,29,13},
{525893633,497323780,29,15},
{525889537,241240955,29,12},
{525803521,78691063,29,13},
{525770753,345150326,29,13},
{525729793,235231490,29,17},
{525721601,359269745,29,13},
{525705217,451424637,29,13},
{525684737,267601195,29,12},
{525643777,54720536,29,12},
{525570049,151940388,29,12},
{525561857,55823294,29,12},
{525545473,280285844,29,12},
{525508609,65551431,29,13},
{525463553,511761474,29,12},
{525434881,100562391,29,15},
{525426689,377726848,29,13},
{525422593,418306078,29,12},
{525414401,103217264,29,12},
{525365249,519167561,29,12},
{525316097,244029759,29,12},
{525275137,414582674,29,12},
{525213697,414228473,29,13},
{525176833,31893173,29,12},
{525156353,213871233,29,14},
{525078529,170709396,29,12},
{525053953,156546501,29,12},
{525045761,121241554,29,12},
{525033473,171046279,29,13},
{524943361,444157350,29,17},
{524906497,451780592,29,12},
{524824577,490936372,29,12},
{524812289,445426994,29,19},
{524771329,153636156,29,13},
{524763137,262558621,29,14},
{524726273,151796782,29,12},
{524640257,330310672,29,13},
{524615681,297952425,29,16},
{524587009,345295489,29,12},
{524562433,364352915,29,12},
{524554241,8035532,29,12},
{524476417,521255175,29,13},
{524455937,161466684,29,12},
{524431361,385063535,29,12},
{524414977,61376988,29,12},
{524390401,144879015,29,12},
{524369921,376234655,29,14},
{524357633,101705772,29,12},
{524353537,256100270,29,16},
{524279809,491597230,29,13},
{524267521,162143125,29,12},
{524185601,391616053,29,12},
{524111873,118955646,29,12},
{524095489,167555862,29,12},
{524075009,205548402,29,14},
{524046337,262542804,29,12},
{524001281,438247812,29,13},
{523927553,83903209,29,15},
{523911169,179630523,29,14},
{523866113,382187429,29,12},
{523825153,463970086,29,12},
{523780097,266715097,29,14},
{523767809,385448602,29,12},
{523681793,312792167,29,14},
{523677697,106608170,29,12},
{523620353,405508632,29,12},
{523595777,227596160,29,12},
{523591681,248266375,29,13},
{523534337,9364682,29,15},
{523509761,119658030,29,13},
{523468801,454571231,29,15},
{523399169,114111888,29,12},
{523333633,334416534,29,12},
{523251713,281360128,29,12},
{523227137,52022956,29,12},
{523124737,101065710,29,14},
{523067393,151036442,29,13},
{523063297,129905065,29,12},
{522956801,210644465,29,12},
{522919937,90058993,29,13},
{522883073,376814398,29,12},
{522878977,15989062,29,15},
{522833921,226090368,29,12},
{522760193,322708140,29,12},
{522719233,462028295,29,12},
{522698753,86435874,29,14},
{522670081,66147113,29,12},
{522649601,272332284,29,16},
{522620929,510678172,29,12},
{522551297,71457463,29,15},
{522539009,401399612,29,12},
{522489857,300052324,29,12},
{522424321,379581274,29,12},
{522391553,487754974,29,12},
{522387457,32868492,29,16},
{522375169,179444862,29,12},
{522350593,266918419,29,12},
{522293249,359145594,29,12},
{522289153,267887916,29,15},
{522268673,515450621,29,12},
{522117121,498787114,29,13},
{522080257,259863226,29,12},
{522047489,203935887,29,12},
{522022913,24640555,29,12},
{521945089,242212466,29,14},
{521920513,441801287,29,13},
{521875457,429283989,29,12},
{521801729,396583218,29,12},
{521699329,418000272,29,15},
{521678849,176318762,29,12},
{521588737,252199435,29,12},
{521576449,34549007,29,13},
{521551873,182513665,29,14},
{521502721,326968219,29,15},
{521445377,240037125,29,13},
{521433089,107791581,29,12},
{521342977,63077161,29,12},
{521306113,306568491,29,15},
{521261057,307059240,29,12},
{521175041,57042970,29,15},
{521072641,415318907,29,12},
{521035777,225333835,29,13},
{521011201,465255179,29,17},
{520978433,401669157,29,15},
{520929281,199105997,29,14},
{520916993,333762079,29,12},
{520888321,163482518,29,13},
{520830977,261686263,29,14},
{520818689,109447549,29,12},
{520777729,376022820,29,12},
{520716289,288753488,29,15},
{520704001,196249287,29,12},
{520585217,200343854,29,15},
{520581121,224603536,29,12},
{520523777,432281942,29,12},
{520511489,215058750,29,13},
{520499201,96434139,29,12},
{520482817,337476859,29,12},
{520462337,128704813,29,13},
{520445953,318299315,29,13},
{520347649,171653083,29,13},
{520298497,139753152,29,13},
{520286209,169344389,29,12},
{520212481,444608942,29,12},
{520101889,176830803,29,13},
{520081409,128106421,29,12},
{520040449,199747947,29,12},
{520007681,437966152,29,12},
{519966721,213997689,29,12},
{519929857,357981479,29,15},
{519917569,39818012,29,12},
{519868417,319474804,29,12},
{519823361,513563972,29,13},
{519786497,402697240,29,12},
{519770113,38904509,29,12},
{519745537,508942182,29,12},
{519725057,59186402,29,13},
{519684097,134011769,29,14},
{519659521,399952843,29,13},
{519651329,329109657,29,14},
{519622657,123978045,29,12},
{519585793,141377993,29,14},
{519540737,456289911,29,12},
{519467009,291488883,29,12},
{519442433,328273811,29,12},
{519405569,512115019,29,15},
{519401473,357638260,29,12},
{519254017,176501267,29,12},
{519233537,420341161,29,13},
{519192577,11083489,29,14},
{519155713,215617652,29,12},
{519147521,27865954,29,12},
{519106561,493402105,29,12},
{519069697,136449795,29,13},
{519008257,189578350,29,12},
{518975489,68282624,29,12},
{518946817,300195331,29,15},
{518922241,34484143,29,13},
{518914049,450248068,29,17},
{518909953,436543700,29,12},
{518860801,224474343,29,12},
{518828033,302181620,29,12},
{518803457,225650198,29,12},
{518688769,364284375,29,12},
{518676481,472989018,29,13},
{518594561,274761653,29,13},
{518520833,490694356,29,19},
{518496257,204286742,29,13},
{518422529,407723209,29,15},
{518393857,219446127,29,12},
{518381569,404432282,29,13},
{518369281,156611330,29,12},
{518361089,62157800,29,12},
{518336513,375731114,29,12},
{518332417,123539939,29,13},
{518287361,180802759,29,12},
{518246401,328443167,29,12},
{518238209,407792583,29,12},
{518103041,171825653,29,13},
{518074369,304709554,29,12},
{518049793,238903913,29,12},
{518004737,469957754,29,13},
{517988353,45691304,29,13},
{517980161,421833008,29,14},
{517931009,127111923,29,16},
{517877761,255517239,29,12},
{517828609,325923982,29,12},
{517820417,379791467,29,12},
{517808129,467111290,29,13},
{517804033,475425601,29,12},
{517722113,261480611,29,12},
{517693441,271888979,29,13},
{517644289,466867486,29,13},
{517599233,241032949,29,12},
{517488641,443365729,29,14},
{517472257,461105635,29,19},
{517427201,23926569,29,12},
{517414913,106351307,29,13},
{517373953,445793415,29,15},
{517255169,283441516,29,12},
{517120001,118479975,29,13},
{517079041,7928303,29,17},
{517070849,383138045,29,13},
{517046273,102088004,29,15},
{516997121,365055031,29,14},
{516984833,305247746,29,12},
{516935681,122440769,29,12},
{516907009,500076244,29,13},
{516861953,10202025,29,12},
{516653057,427900919,29,15},
{516640769,102055482,29,12},
{516612097,61456628,29,13},
{516538369,254709527,29,14},
{516517889,12832361,29,12},
{516513793,283870582,29,13},
{516456449,39415530,29,15},
{516444161,76337555,29,12},
{516431873,72924649,29,13},
{516403201,370854044,29,12},
{516382721,231291337,29,13},
{516366337,426079317,29,13},
{516345857,247055642,29,12},
{516308993,91971438,29,14},
{516280321,181316166,29,12},
{516231169,13320378,29,12},
{516222977,357549091,29,12},
{516136961,126769150,29,13},
{515964929,71056138,29,16},
{515903489,426684042,29,12},
{515874817,85492304,29,13},
{515854337,109694624,29,12},
{515751937,140232339,29,14},
{515715073,481450344,29,12},
{515706881,20659612,29,12},
{515694593,224332862,29,13},
{515670017,29244300,29,15},
{515592193,399672078,29,12},
{515571713,22611865,29,16},
{515530753,198206009,29,13},
{515469313,220051450,29,12},
{515448833,262603698,29,13},
{515444737,310522301,29,12},
{515411969,294315489,29,12},
{515371009,446369402,29,12},
{515309569,76070762,29,16},
{515264513,84151560,29,12},
{515198977,217081970,29,12},
{515153921,34299271,29,13},
{515100673,260233081,29,12},
{515014657,88304319,29,15},
{514994177,202055749,29,12},
{514969601,384564825,29,12},
{514920449,344777488,29,12},
{514908161,245104644,29,13},
{514871297,438320424,29,12},
{514785281,288144270,29,16},
{514768897,306978940,29,14},
{514670593,181815110,29,14},
{514510849,138467018,29,12},
{514502657,229744846,29,12},
{514416641,392426988,29,13},
{514367489,226888749,29,13},
{514363393,49779422,29,12},
{514293761,499546464,29,15},
{514244609,453911763,29,14},
{514203649,407341660,29,13},
{514134017,351126088,29,12},
{514129921,470647535,29,16},
{514117633,22917124,29,12},
{514072577,326899003,29,13},
{514068481,26609045,29,12},
{514060289,196107763,29,12},
{514048001,21538305,29,14},
{514019329,100514672,29,12},
{514007041,282563341,29,13},
{513908737,27820825,29,13},
{513650689,444368779,29,12},
{513642497,128587042,29,12},
{513617921,445921271,29,12},
{513605633,433993924,29,16},
{513601537,488663702,29,12},
{513503233,506528816,29,12},
{513421313,402498216,29,12},
{513404929,149109301,29,12},
{513392641,469828578,29,14},
{513380353,483519696,29,12},
{513343489,149415966,29,16},
{513335297,208252977,29,13},
{513294337,323368255,29,14},
{513273857,16971469,29,12},
{513150977,423524811,29,12},
{513089537,135660009,29,13},
{513073153,16549366,29,13},
{513036289,475768659,29,12},
{513011713,183008160,29,12},
{512991233,409837256,29,13},
{512974849,261620085,29,13},
{512782337,332212834,29,12},
{512778241,420714614,29,13},
{512716801,349194575,29,12},
{512618497,481149673,29,12},
{512557057,235349149,29,16},
{512483329,119463792,29,13},
{512475137,250365479,29,14},
{512438273,76192536,29,12},
{512360449,506212702,29,17},
{512352257,325782167,29,13},
{512155649,378848786,29,13},
{512126977,38954817,29,12},
{512090113,491199344,29,13},
{512040961,53808697,29,13},
{512032769,487591633,29,16},
{511983617,367935281,29,14},
{511967233,363136146,29,18},
{511942657,53664995,29,13},
{511930369,436048198,29,12},
{511918081,379801168,29,14},
{511885313,146289972,29,14},
{511860737,219405654,29,13},
{511758337,234932148,29,12},
{511746049,486074436,29,13},
{511725569,383961818,29,12},
{511713281,423605213,29,13},
{511696897,228135487,29,13},
{511684609,287807657,29,12},
{511672321,51919678,29,15},
{511614977,281482286,29,13},
{511578113,383619929,29,12},
{511537153,447809267,29,12},
{511467521,138295490,29,13},
{511414273,231440184,29,12},
{511377409,439591579,29,16},
{511344641,258822360,29,15},
{511291393,268848308,29,12},
{511266817,505477881,29,12},
{511221761,456792409,29,13},
{511209473,333545366,29,12},
{511184897,419711473,29,12},
{511168513,38801398,29,12},
{511111169,106437392,29,12},
{511098881,206581871,29,14},
{511082497,225344507,29,15},
{510996481,53340912,29,12},
{510984193,464676890,29,16},
{510947329,114068588,29,12},
{510926849,485067869,29,13},
{510898177,440031784,29,12},
{510865409,302269339,29,12},
{510861313,487967843,29,13},
{510775297,119114783,29,12},
{510763009,125789714,29,13},
{510738433,281058844,29,14},
{510717953,132000348,29,12},
{510693377,137521172,29,12},
{510640129,385817725,29,14},
{510627841,244936144,29,12},
{510595073,217504526,29,12},
{510533633,99353654,29,13},
{510509057,258243061,29,14},
{510504961,110870454,29,12},
{510455809,318153150,29,12},
{510447617,260112729,29,12},
{510435329,308739609,29,13},
{510423041,190719187,29,12},
{510349313,304648418,29,12},
{510345217,294473777,29,14},
{510320641,44816837,29,13},
{510251009,305580574,29,12},
{510189569,82710674,29,13},
{510136321,212730565,29,12},
{510025729,127677061,29,13},
{510001153,285929946,29,17},
{509943809,184190513,29,13},
{509894657,76861703,29,13},
{509890561,92150416,29,12},
{509820929,389301535,29,14},
{509595649,459418975,29,12},
{509587457,45913102,29,12},
{509575169,218117107,29,15},
{509550593,360782118,29,13},
{509513729,101207124,29,12},
{509509633,55975757,29,15},
{509464577,135994097,29,12},
{509460481,395947205,29,14},
{509423617,377788319,29,12},
{509386753,395435322,29,13},
{509378561,7282451,29,15},
{509349889,499395294,29,12},
{509337601,235279134,29,13},
{509304833,480461605,29,13},
{509288449,281759415,29,13},
{509177857,44370365,29,12},
{509104129,335278587,29,12},
{509091841,465278202,29,13},
{509071361,133296842,29,12},
{509059073,302183202,29,13},
{509042689,15266142,29,13},
{508960769,417966996,29,13},
{508936193,284790083,29,14},
{508907521,232730169,29,12},
{508813313,247166281,29,13},
{508788737,258880929,29,15},
{508776449,217179046,29,12},
{508772353,158983933,29,14},
{508764161,367414764,29,13},
{508690433,332502117,29,17},
{508600321,503302052,29,13},
{508592129,406752629,29,15},
{508502017,141051506,29,13},
{508420097,46586479,29,13},
{508403713,254396680,29,13},
{508358657,115937382,29,12},
{508346369,88489042,29,14},
{508305409,371926810,29,13},
{508284929,461174024,29,12},
{508280833,232228055,29,14},
{508170241,83684212,29,12},
{508157953,370643102,29,13},
{508059649,307063267,29,13},
{507985921,228958396,29,14},
{507973633,150742304,29,12},
{507924481,95057725,29,12},
{507842561,258797521,29,12},
{507801601,97764059,29,12},
{507789313,425534887,29,14},
{507781121,205934927,29,13},
{507764737,206995345,29,13},
{507740161,385446434,29,15},
{507727873,456257095,29,12},
{507703297,192948299,29,12},
{507682817,404397402,29,13},
{507670529,296520079,29,12},
{507596801,166924082,29,12},
{507559937,291353909,29,14},
{507486209,316349413,29,13},
{507437057,382971162,29,13},
{507424769,431720407,29,12},
{507420673,94873081,29,13},
{507371521,11343318,29,13},
{507334657,489886747,29,12},
{507277313,99095002,29,12},
{507240449,415294370,29,13},
{507215873,439335519,29,15},
{507211777,326007468,29,12},
{507199489,315900959,29,14},
{507179009,463494730,29,12},
{507113473,163527578,29,12},
{507006977,387710311,29,12},
{506953729,81483235,29,15},
{506933249,375174415,29,12},
{506908673,300147364,29,12},
{506892289,340783944,29,12},
{506847233,262990368,29,13},
{506806273,153200553,29,14},
{506736641,329390544,29,12},
{506707969,55467449,29,14},
{506699777,474304023,29,13},
{506675201,353504821,29,14},
{506535937,361758084,29,13},
{506499073,369664415,29,12},
{506441729,101646500,29,12},
{506380289,22896656,29,14},
{506355713,118252528,29,13},
{506306561,372218819,29,13},
{506290177,447924672,29,13},
{506245121,96820445,29,12},
{506122241,416862643,29,12},
{506109953,396733614,29,13},
{506073089,140334703,29,12},
{506048513,156845109,29,12},
{506044417,405570729,29,13},
{506032129,499655442,29,12},
{505946113,142706468,29,13},
{505925633,208041091,29,12},
{505860097,202097128,29,12},
{505778177,216600814,29,12},
{505774081,283497621,29,15},
{505765889,97419791,29,13},
{505761793,265599946,29,12},
{505724929,200794026,29,14},
{505700353,303995007,29,13},
{505643009,254275000,29,15},
{505630721,266765392,29,12},
{505589761,227745335,29,12},
{505577473,188691214,29,15},
{505528321,271964964,29,14},
{505520129,147377883,29,13},
{505495553,346343690,29,14},
{505491457,291144428,29,12},
{505466881,29691417,29,12},
{505405441,65387778,29,13},
{505348097,447767730,29,16},
{505344001,123079370,29,12},
{505286657,47742361,29,12},
{505270273,110461455,29,12},
{505208833,3630484,29,13},
{505004033,471370689,29,14},
{504987649,1889481,29,15},
{504979457,161116160,29,13},
{504954881,342130711,29,16},
{504918017,152737144,29,12},
{504864769,256302730,29,13},
{504844289,53945804,29,12},
{504803329,101972708,29,12},
{504782849,345400012,29,13},
{504770561,198663907,29,12},
{504754177,106751318,29,12},
{504721409,194499225,29,12},
{504635393,79503668,29,13},
{504586241,193668129,29,13},
{504512513,478477499,29,14},
{504496129,121752936,29,17},
{504483841,455571736,29,12},
{504471553,166660930,29,13},
{504385537,102602817,29,12},
{504303617,442523544,29,12},
{504266753,56586697,29,15},
{504262657,86956085,29,12},
{504180737,161928308,29,12},
{504176641,498160659,29,13},
{504143873,247548797,29,13},
{504127489,418987773,29,13},
{504082433,15555389,29,12},
{503812097,64564282,29,12},
{503799809,333870018,29,13},
{503746561,444897167,29,12},
{503697409,356061970,29,12},
{503685121,151966651,29,13},
{503664641,494903819,29,12},
{503549953,374922642,29,12},
{503468033,355294550,29,12},
{503463937,106562896,29,14},
{503377921,223902546,29,12},
{503365633,123906296,29,14},
{503255041,104286338,29,12},
{503222273,142920358,29,12},
{503197697,425377368,29,12},
{503119873,256445641,29,16},
{503062529,345622430,29,13},
{503013377,206690179,29,13},
{502951937,241701550,29,12},
{502939649,452877726,29,14},
{502935553,318505312,29,12},
{502910977,488514628,29,12},
{502824961,110951193,29,15},
{502775809,259695423,29,14},
{502743041,321801367,29,14},
{502726657,327375848,29,16},
{502484993,461250996,29,12},
{502394881,426620714,29,12},
{502333441,140667857,29,16},
{502296577,429041352,29,12},
{502112257,114765950,29,13},
{502067201,73310042,29,12},
{502026241,159255584,29,12},
{501993473,345145148,29,12},
{501944321,102136965,29,12},
{501915649,436303803,29,13},
{501907457,288596483,29,15},
{501882881,382267805,29,13},
{501809153,273496932,29,16},
{501723137,441587975,29,12},
{501710849,215285379,29,15},
{501682177,244321937,29,12},
{501350401,443327334,29,17},
{501342209,289296674,29,13},
{501317633,81641549,29,15},
{501288961,485759685,29,12},
{501256193,43764740,29,12},
{501252097,470292061,29,15},
{501227521,72199776,29,13},
{501207041,384889420,29,12},
{501178369,186204870,29,13},
{501133313,61818396,29,12},
{501129217,277080717,29,13},
{501084161,180425099,29,12},
{501030913,238968775,29,13},
{500932609,380283820,29,13},
{500764673,154380749,29,12},
{500736001,85917284,29,13},
{500674561,409704988,29,12},
{500555777,493880915,29,13},
{500543489,38628501,29,12},
{500531201,191901107,29,15},
{500441089,197075287,29,13},
{500432897,430304421,29,18},
{500428801,14933822,29,12},
{500371457,200935177,29,12},
{500359169,299023254,29,13},
{500297729,254775512,29,12},
{500285441,355326238,29,14},
{500162561,131427258,29,13},
{500133889,54095520,29,12},
{500113409,319453389,29,13},
{500088833,24757312,29,14},
{500023297,353724127,29,14},
{500002817,280825554,29,12},
{499924993,341117889,29,14},
{499867649,393343661,29,13},
{499826689,53099108,29,14},
{499802113,278813656,29,13},
{499716097,196825920,29,12},
{499642369,498186599,29,12},
{499597313,393194257,29,14},
{499580929,75399158,29,16},
{499396609,343093338,29,12},
{499351553,176201147,29,15},
{499314689,166959745,29,12},
{499310593,198153634,29,13},
{499286017,401322516,29,15},
{499273729,338753127,29,12},
{499200001,399466902,29,12},
{499187713,231007437,29,16},
{499150849,76633254,29,12},
{499138561,390966466,29,14},
{499105793,129003536,29,14},
{499040257,483420428,29,14},
{499015681,20569916,29,13},
{498905089,275170420,29,12},
{498884609,207202192,29,13},
{498872321,227245393,29,12},
{498819073,159019248,29,13},
{498794497,305127885,29,16},
{498737153,354112098,29,13},
{498700289,225227323,29,12},
{498696193,47172010,29,15},
{498675713,384875245,29,12},
{498626561,147967365,29,12},
{498597889,120876685,29,19},
{498491393,166695045,29,13},
{498466817,87026550,29,17},
{498388993,228915411,29,12},
{498331649,334470913,29,12},
{498270209,63880419,29,16},
{498266113,388114710,29,12},
{498106369,403614084,29,15},
{498098177,275169969,29,13},
{498061313,141428240,29,12},
{498020353,420959094,29,12},
{497975297,459951670,29,15},
{497950721,393350035,29,13},
{497938433,385081822,29,12},
{497876993,1606077,29,16},
{497852417,256419310,29,13},
{497836033,413192219,29,13},
{497790977,105538986,29,12},
{497778689,317956896,29,15},
{497737729,197710036,29,13},
{497688577,219325046,29,13},
{497668097,222276338,29,12},
{497614849,272353126,29,16},
{497606657,59580594,29,13},
{497565697,335505524,29,14},
{497508353,126080918,29,13},
{497471489,313602538,29,12},
{497446913,247736727,29,12},
{497348609,75485772,29,12},
{497307649,24427881,29,12},
{497295361,413952998,29,13},
{497221633,218842939,29,16},
{497123329,235327363,29,15},
{497102849,228412981,29,12},
{497098753,416410097,29,13},
{497041409,34067788,29,14},
{496979969,257915999,29,12},
{496975873,283362381,29,14},
{496918529,78101131,29,13},
{496914433,440027718,29,12},
{496832513,370155807,29,12},
{496816129,74570083,29,12},
{496791553,89319010,29,12},
{496742401,329609065,29,12},
{496734209,111313520,29,12},
{496668673,173558694,29,12},
{496648193,430535803,29,14},
{496582657,73517457,29,14},
{496525313,310430339,29,13},
{496484353,78658220,29,14},
{496275457,441667205,29,12},
{496242689,478055162,29,12},
{496230401,107784186,29,13},
{496168961,478849181,29,12},
{496119809,485404406,29,12},
{495996929,253335747,29,12},
{495968257,429280462,29,13},
{495910913,198611921,29,16},
{495886337,232044490,29,13},
{495882241,23131479,29,12},
{495833089,148451910,29,12},
{495771649,8646854,29,13},
{495759361,411117590,29,12},
{495751169,403377575,29,12},
{495747073,243556068,29,15},
{495689729,394342669,29,13},
{495566849,495135576,29,14},
{495525889,10722476,29,13},
{495517697,471678091,29,16},
{495480833,16394886,29,12},
{495452161,279221320,29,19},
{495439873,329448229,29,12},
{495357953,217165496,29,12},
{495353857,332171233,29,15},
{495329281,480427968,29,13},
{495292417,281590305,29,12},
{495271937,268118662,29,14},
{495259649,154095089,29,12},
{495112193,130052376,29,12},
{495083521,228244720,29,13},
{495050753,234190547,29,13},
{495022081,136343014,29,12},
{495001601,405903520,29,13},
{494940161,360025576,29,12},
{494841857,494083964,29,12},
{494804993,51157329,29,13},
{494780417,22410862,29,14},
{494768129,2392011,29,12},
{494714881,153053111,29,14},
{494678017,348983467,29,12},
{494604289,396844376,29,12},
{494592001,320285407,29,13},
{494534657,253230335,29,17},
{494436353,110959562,29,15},
{494419969,221078217,29,14},
{494407681,285381784,29,12},
{494370817,255843646,29,15},
{494227457,265572666,29,12},
{494223361,118591806,29,14},
{494104577,371675616,29,12},
{494063617,44085995,29,12},
{494006273,91457988,29,12},
{493965313,441040515,29,12},
{493944833,172420400,29,16},
{493940737,217469942,29,12},
{493895681,343679279,29,14},
{493879297,445034364,29,20},
{493821953,304675287,29,13},
{493805569,490286480,29,13},
{493780993,313921532,29,15},
{493744129,172521716,29,12},
{493735937,445261576,29,12},
{493723649,311249977,29,13},
{493719553,306883371,29,12},
{493596673,85722223,29,12},
{493510657,292155137,29,13},
{493477889,66014377,29,13},
{493473793,224834403,29,12},
{493436929,254702759,29,14},
{493428737,195786497,29,13},
{493424641,160240767,29,12},
{493404161,272026831,29,14},
{493387777,89511197,29,15},
{493301761,127738818,29,12},
{493289473,115892508,29,16},
{493281281,270032051,29,13},
{493264897,61753203,29,13},
{493244417,194608964,29,12},
{493228033,389092349,29,12},
{493146113,325687936,29,12},
{493121537,155967104,29,12},
{493117441,238258985,29,13},
{493060097,284383517,29,15},
{493006849,383842016,29,12},
{492875777,85798460,29,12},
{492871681,411502631,29,13},
{492863489,482651254,29,15},
{492797953,228996802,29,15},
{492777473,151821518,29,12},
{492740609,484181100,29,13},
{492687361,91098123,29,12},
{492617729,159248909,29,14},
{492556289,327581937,29,12},
{492490753,181921522,29,12},
{492421121,27557375,29,14},
{492249089,3092329,29,13},
{492195841,1143952,29,12},
{492175361,175843010,29,17},
{492146689,49370181,29,12},
{492097537,417535973,29,12},
{492040193,49086166,29,12},
{491929601,271438169,29,14},
{491888641,481509918,29,13},
{491868161,383028354,29,12},
{491851777,83189473,29,12},
{491831297,366261066,29,14},
{491790337,82615949,29,13},
{491765761,45869232,29,14},
{491753473,296607584,29,12},
{491696129,274797800,29,12},
{491667457,456408238,29,14},
{491642881,363899267,29,13},
{491630593,43320601,29,12},
{491573249,126515634,29,12},
{491524097,43872823,29,12},
{491499521,129168591,29,12},
{491483137,311067609,29,12},
{491470849,405277578,29,14},
{491409409,135825552,29,12},
{491388929,302148895,29,17},
{491384833,468447972,29,12},
{491286529,377230535,29,12},
{491225089,332906515,29,15},
{491020289,407166185,29,13},
{491016193,391141341,29,12},
{490971137,148499044,29,13},
{490967041,468047576,29,12},
{490934273,294672579,29,12},
{490930177,228850483,29,16},
{490844161,214281320,29,12},
{490811393,232486019,29,12},
{490725377,156974548,29,13},
{490672129,245676900,29,12},
{490663937,110130034,29,12},
{490598401,398759957,29,12},
{490528769,271561422,29,13},
{490455041,215917553,29,14},
{490442753,98869318,29,12},
{490426369,110878700,29,12},
{490295297,368138170,29,12},
{490291201,390349305,29,14},
{490270721,466825069,29,12},
{490254337,482868512,29,12},
{490233857,337882045,29,13},
{490098689,349873978,29,12},
{490049537,25089087,29,12},
{490045441,76291310,29,15},
{490008577,326915815,29,12},
{489963521,76600998,29,14},
{489902081,463184312,29,12},
{489861121,30937300,29,12},
{489848833,297075107,29,15},
{489803777,71986549,29,12},
{489766913,477055071,29,14},
{489730049,334409134,29,12},
{489603073,484230083,29,14},
{489582593,420542903,29,12},
{489545729,445476962,29,13},
{489533441,168506490,29,12},
{489496577,244879980,29,13},
{489480193,105384854,29,13},
{489435137,358442187,29,12},
{489422849,63726901,29,18},
{489410561,50552788,29,12},
{489381889,166803993,29,13},
{489357313,119644934,29,16},
{489234433,372334399,29,13},
{489209857,346143757,29,14},
{489189377,71220146,29,12},
{489152513,316541761,29,13},
{489066497,60220879,29,12},
{488927233,229224091,29,12},
{488906753,385595806,29,13},
{488902657,112463308,29,12},
{488857601,476042151,29,13},
{488841217,333853637,29,13},
{488685569,206748343,29,14},
{488673281,292907818,29,12},
{488660993,444816590,29,13},
{488644609,87091700,29,13},
{488632321,38332988,29,12},
{488558593,22045154,29,12},
{488534017,179348231,29,12},
{488521729,131413030,29,14},
{488501249,245171644,29,12},
{488497153,368100785,29,13},
{488460289,390225000,29,12},
{488435713,59163999,29,12},
{488378369,285019082,29,12},
{488353793,89559250,29,12},
{488288257,142841450,29,12},
{488255489,423495651,29,12},
{488243201,75730315,29,17},
{488202241,157403837,29,13},
{488144897,234704350,29,15},
{488103937,72044307,29,13},
{488091649,352303218,29,12},
{488058881,133244287,29,12},
{488046593,282962779,29,16},
{487997441,389448034,29,14},
{487919617,143812420,29,12},
{487886849,128169012,29,12},
{487874561,424588736,29,13},
{487796737,482610425,29,12},
{487723009,351040817,29,12},
{487702529,34848380,29,14},
{487698433,200225361,29,12},
{487518209,358058458,29,12},
{487514113,137973329,29,13},
{487469057,345731310,29,12},
{487464961,169957910,29,13},
{487456769,164946031,29,17},
{487444481,4571233,29,12},
{487366657,461409373,29,13},
{487346177,420639854,29,12},
{487272449,230206333,29,12},
{487260161,289179072,29,16},
{487243777,80505792,29,14},
{487231489,169979805,29,12},
{487206913,151495053,29,12},
{487186433,94761393,29,13},
{487170049,80761382,29,13},
{487145473,287939147,29,14},
{487124993,82731322,29,12},
{487063553,116430427,29,19},
{487038977,456280971,29,13},
{487022593,210828063,29,13},
{486965249,326249884,29,15},
{486924289,302778129,29,13},
{486899713,57563803,29,15},
{486891521,257783108,29,13},
{486879233,26504597,29,12},
{486854657,291953020,29,12},
{486776833,326158917,29,13},
{486715393,458010772,29,12},
{486690817,124964741,29,12},
{486658049,410062692,29,12},
{486572033,220085746,29,15},
{486510593,297932702,29,12},
{486432769,66999943,29,13},
{486424577,322550782,29,14},
{486408193,34422635,29,17},
{486326273,178242601,29,14},
{486297601,273869766,29,12},
{486264833,36868789,29,12},
{486248449,207955303,29,12},
{486227969,315949550,29,14},
{486162433,216065797,29,14},
{486154241,131630961,29,13},
{486019073,181106267,29,12},
{485978113,322759367,29,12},
{485953537,331650367,29,12},
{485933057,454820267,29,14},
{485908481,132798172,29,13},
{485867521,219232297,29,14},
{485855233,220964542,29,12},
{485810177,183973084,29,13},
{485773313,341688705,29,12},
{485711873,469388697,29,13},
{485621761,351575516,29,17},
{485609473,334028131,29,12},
{485572609,200171808,29,14},
{485560321,83276833,29,12},
{485552129,221193488,29,12},
{485416961,162131435,29,13},
{485306369,125476844,29,12},
{485277697,408538627,29,14},
{485171201,14892801,29,13},
{485158913,60016892,29,12},
{485117953,162656856,29,12},
{484999169,241497990,29,15},
{484950017,413256934,29,14},
{484945921,415734937,29,12},
{484937729,225560159,29,12},
{484909057,57158284,29,13},
{484884481,351138404,29,14},
{484847617,400506172,29,12},
{484823041,54896056,29,12},
{484663297,135892771,29,13},
{484630529,410665186,29,13},
{484397057,217483412,29,12},
{484343809,133273769,29,15},
{484175873,483563350,29,12},
{484147201,245362870,29,15},
{484077569,46257885,29,12},
{484003841,139628976,29,12},
{483987457,235241725,29,12},
{483926017,70835363,29,13},
{483905537,165217026,29,12},
{483868673,420385223,29,14},
{483840001,247242152,29,12},
{483790849,65737781,29,12},
{483741697,355753884,29,12},
{483729409,207345893,29,13},
{483717121,46736784,29,12},
{483680257,207032704,29,13},
{483655681,431404529,29,18},
{483622913,1276269,29,15},
{483557377,415993187,29,15},
{483524609,370076733,29,17},
{483512321,409975029,29,12},
{483475457,94469279,29,14},
{483471361,67089482,29,12},
{483373057,308756605,29,12},
{483315713,91014640,29,12},
{483299329,84809040,29,12},
{483225601,189750706,29,12},
{483192833,423327278,29,12},
{483188737,239552949,29,13},
{483155969,353001698,29,13},
{483131393,448633673,29,18},
{483127297,302186419,29,12},
{483069953,14334177,29,12},
{483065857,29899301,29,16},
{483053569,290614597,29,12},
{483045377,241473209,29,12},
{483020801,465749991,29,12},
{482930689,354654194,29,12},
{482910209,315338702,29,13},
{482885633,475388733,29,14},
{482758657,172875601,29,12},
{482725889,331545548,29,12},
{482697217,298088121,29,13},
{482611201,212591031,29,12},
{482541569,274991556,29,16},
{482512897,103890650,29,12},
{482467841,251027499,29,13},
{482451457,454477061,29,13},
{482353153,206417323,29,13},
{482283521,90496425,29,12},
{482242561,186478408,29,12},
{482234369,370249846,29,12},
{482123777,139076284,29,13},
{482119681,448266810,29,12},
{482111489,7887828,29,12},
{482025473,217171631,29,13},
{482021377,423809347,29,12},
{482009089,139799601,29,13},
{481988609,37696528,29,12},
{481976321,229367282,29,13},
{481947649,430275621,29,12},
{481865729,339608112,29,12},
{481853441,146781852,29,15},
{481751041,105942598,29,12},
{481652737,317448543,29,12},
{481615873,210326576,29,13},
{481595393,246644904,29,12},
{481533953,333764741,29,13},
{481505281,372081784,29,12},
{481497089,283496797,29,12},
{481423361,188841227,29,12},
{481325057,106130485,29,12},
{481271809,340368094,29,13},
{481202177,340397927,29,12},
{481189889,223489275,29,13},
{481148929,218559325,29,14},
{481128449,363260379,29,12},
{481124353,57850895,29,13},
{481116161,313567339,29,14},
{481075201,228330416,29,13},
{481067009,316062061,29,15},
{481062913,433475634,29,12},
{480956417,211534566,29,12},
{480944129,100712712,29,13},
{480919553,244831887,29,14},
{480894977,36869109,29,13},
{480755713,316241096,29,14},
{480731137,174568676,29,13},
{480669697,131173643,29,12},
{480632833,221409899,29,13},
{480608257,265066721,29,15},
{480587777,84779246,29,12},
{480550913,425658097,29,13},
{480526337,233916539,29,14},
{480522241,287223157,29,12},
{480514049,373315360,29,12},
{480501761,201892559,29,13},
{480489473,377581973,29,12},
{480448513,455445539,29,12},
{480428033,150309455,29,14},
{480391169,290503361,29,12},
{480350209,374335010,29,12},
{480305153,204196956,29,13},
{480288769,403944544,29,13},
{480268289,149355698,29,12},
{480182273,460284735,29,16},
{480178177,236335168,29,12},
{480157697,170637761,29,13},
{480096257,269989053,29,12},
{480092161,320301916,29,13},
{480030721,199544825,29,12},
{479981569,111784119,29,12},
{479956993,277609472,29,12},
{479825921,327878524,29,12},
{479715329,425430510,29,13},
{479703041,182348508,29,12},
{479662081,184430248,29,12},
{479604737,257840000,29,12},
{479567873,427293814,29,13},
{479539201,449643123,29,12},
{479502337,115735119,29,13},
{479465473,365652718,29,12},
{479457281,399658259,29,12},
{479408129,349221345,29,12},
{479395841,466197656,29,16},
{479342593,389113714,29,12},
{479297537,55202484,29,15},
{479285249,193507829,29,12},
{479256577,178864580,29,13},
{479232001,284517835,29,15},
{479223809,121361408,29,13},
{479182849,206843656,29,14},
{479137793,168680355,29,12},
{479088641,115311301,29,12},
{479035393,278359363,29,15},
{479027201,335972610,29,13},
{479010817,353834141,29,13},
{478986241,323756576,29,14},
{478973953,389592674,29,12},
{478949377,339197917,29,12},
{478937089,194851891,29,18},
{478769153,440111478,29,12},
{478740481,195070377,29,16},
{478728193,70355855,29,12},
{478679041,81413077,29,12},
{478658561,213249200,29,14},
{478609409,426552226,29,16},
{478568449,128763647,29,13},
{478556161,468946112,29,12},
{478486529,469923719,29,13},
{478420993,343672592,29,13},
{478396417,461807074,29,14},
{478384129,362341900,29,12},
{478371841,155272785,29,13},
{478351361,360835862,29,12},
{478314497,422714346,29,15},
{478310401,140725107,29,12},
{478261249,53254702,29,12},
{478253057,319028887,29,12},
{478248961,238750986,29,15},
{478228481,309068213,29,12},
{478179329,388760371,29,12},
{478117889,205404273,29,15},
{478113793,107905421,29,12},
{478093313,137721202,29,13},
{477921281,136702495,29,15},
{477880321,330725349,29,13},
{477831169,344266991,29,13},
{477822977,315214499,29,16},
{477769729,79305031,29,12},
{477720577,15876702,29,12},
{477708289,140777652,29,14},
{477638657,66121505,29,12},
{477634561,307007020,29,13},
{477573121,75365544,29,12},
{477564929,25687397,29,12},
{477560833,325053779,29,16},
{477503489,196244751,29,13},
{477474817,319830843,29,12},
{477462529,110521592,29,15},
{477429761,26418687,29,16},
{477351937,391417464,29,12},
{477294593,236420511,29,12},
{477245441,229250413,29,12},
{477093889,353396565,29,13},
{477081601,383198028,29,12},
{477061121,413904297,29,13},
{477048833,98314318,29,12},
{477024257,107973492,29,12},
{476962817,33023745,29,13},
{476958721,429516299,29,12},
{476921857,242050403,29,14},
{476848129,146313073,29,13},
{476803073,369029332,29,12},
{476766209,229580532,29,13},
{476676097,346074776,29,15},
{476631041,48418909,29,12},
{476569601,65488932,29,13},
{476532737,371111540,29,12},
{476516353,373192727,29,12},
{476434433,31314531,29,12},
{476430337,8592179,29,14},
{476397569,81982898,29,14},
{476311553,444983242,29,12},
{476307457,399017947,29,13},
{476270593,368979891,29,12},
{476250113,23366711,29,16},
{476028929,85736956,29,13},
{475987969,108682609,29,16},
{475975681,39779715,29,12},
{475967489,9914655,29,12},
{475963393,103205405,29,13},
{475955201,224229668,29,15},
{475901953,210144755,29,12},
{475877377,311938737,29,12},
{475815937,96625944,29,13},
{475770881,238688609,29,12},
{475611137,902879,29,14},
{475594753,54784470,29,16},
{475533313,9780952,29,12},
{475525121,388172748,29,12},
{475484161,385808988,29,12},
{475414529,46146812,29,14},
{475410433,22133404,29,12},
{475267073,473334364,29,18},
{475250689,379456749,29,14},
{475144193,92317114,29,13},
{475140097,30907786,29,12},
{475115521,423062581,29,12},
{475107329,473907890,29,12},
{475095041,364380292,29,13},
{475082753,201847706,29,12},
{475066369,396683045,29,12},
{475054081,317608572,29,14},
{475045889,87578499,29,13},
{474996737,72599588,29,13},
{474955777,344773816,29,14},
{474910721,342357925,29,12},
{474849281,430324613,29,13},
{474820609,461440190,29,12},
{474750977,245032166,29,13},
{474636289,5058921,29,13},
{474611713,13259076,29,17},
{474566657,316449611,29,12},
{474529793,313295017,29,14},
{474525697,473366572,29,12},
{474443777,92380592,29,12},
{474419201,468133157,29,12},
{474390529,324495805,29,13},
{474357761,167564177,29,13},
{474243073,314906395,29,13},
{474206209,200802822,29,12},
{474161153,390347483,29,13},
{474136577,421876201,29,14},
{474050561,178853740,29,12},
{473952257,43019561,29,12},
{473939969,472803518,29,14},
{473935873,466528771,29,12},
{473927681,291495511,29,12},
{473890817,23769322,29,16},
{473792513,112358942,29,15},
{473788417,19871288,29,12},
{473776129,190291571,29,14},
{473755649,214388246,29,12},
{473694209,365041450,29,18},
{473645057,40029371,29,14},
{473632769,407344116,29,12},
{473522177,103401377,29,13},
{473448449,292944683,29,14},
{473444353,322980186,29,12},
{473419777,168278388,29,12},
{473382913,167753872,29,14},
{473321473,440107486,29,12},
{473260033,209008823,29,13},
{473178113,110602813,29,13},
{473161729,50388900,29,13},
{473149441,115451458,29,12},
{473137153,94508738,29,15},
{473128961,165175567,29,13},
{473092097,168225482,29,12},
{473006081,351388154,29,15},
{472989697,309668632,29,14},
{472903681,145332734,29,12},
{472772609,176024816,29,12},
{472600577,401187776,29,12},
{472559617,1172755,29,12},
{472547329,101340098,29,15},
{472485889,204655498,29,12},
{472436737,168601655,29,12},
{472416257,358880966,29,15},
{472375297,249421914,29,13},
{472330241,163880815,29,12},
{472268801,32352518,29,14},
{472256513,410295724,29,12},
{472231937,167045980,29,12},
{472158209,157034849,29,12},
{472133633,246618337,29,12},
{472068097,155856198,29,12},
{472055809,63735015,29,16},
{472035329,93756402,29,12},
{472010753,126861763,29,12},
{471912449,203561322,29,12},
{471887873,6802197,29,12},
{471846913,410901226,29,12},
{471801857,287361446,29,13},
{471674881,335845751,29,12},
{471642113,69615343,29,12},
{471539713,214841723,29,13},
{471515137,376835855,29,14},
{471490561,361041445,29,13},
{471441409,147124484,29,13},
{471396353,398314651,29,12},
{471371777,6507939,29,12},
{471330817,196332079,29,12},
{471310337,373949131,29,13},
{471269377,467152519,29,16},
{471257089,380622821,29,12},
{471224321,119493533,29,12},
{471212033,423331456,29,13},
{471207937,448613513,29,12},
{471150593,125616542,29,12},
{471121921,316857915,29,14},
{471072769,393608054,29,18},
{470999041,90082918,29,13},
{470986753,98916880,29,12},
{470978561,19708693,29,12},
{470880257,89561043,29,12},
{470827009,47254429,29,14},
{470781953,135069729,29,12},
{470691841,330976553,29,12},
{470630401,388376902,29,14},
{470593537,313497353,29,12},
{470470657,139774732,29,12},
{470396929,331340300,29,12},
{470351873,113449062,29,16},
{470323201,131535388,29,12},
{470310913,461390209,29,13},
{470290433,66559853,29,12},
{470265857,388868125,29,12},
{470253569,117022057,29,15},
{470249473,66997574,29,12},
{470212609,400141860,29,13},
{470167553,229226504,29,12},
{470138881,46701992,29,14},
{470081537,395566000,29,13},
{470065153,258354989,29,13},
{470007809,405776148,29,14},
{469897217,11394968,29,12},
{469762049,250367992,29,26},
{469737473,145913239,29,13},
{469721089,140628146,29,13},
{469708801,312102886,29,12},
{469659649,399655560,29,12},
{469626881,175065485,29,12},
{469598209,11416441,29,15},
{469573633,444485114,29,13},
{469565441,155556027,29,16},
{469553153,322388997,29,12},
{469512193,412078886,29,12},
{469504001,259951083,29,12},
{469475329,364477993,29,13},
{469401601,386071636,29,15},
{469319681,430749165,29,14},
{469307393,374614381,29,12},
{469303297,323793694,29,16},
{469278721,181232879,29,13},
{469266433,306836477,29,12},
{469147649,370034481,29,13},
{469135361,170517320,29,12},
{469086209,216973550,29,12},
{469061633,7754318,29,12},
{469024769,151446905,29,14},
{468922369,331765092,29,12},
{468910081,429677812,29,16},
{468901889,342879380,29,13},
{468873217,8073385,29,12},
{468852737,302409045,29,13},
{468828161,186577793,29,14},
{468799489,337807606,29,12},
{468774913,310288510,29,12},
{468713473,174828298,29,20},
{468652033,141479833,29,12},
{468492289,104673127,29,13},
{468459521,59046471,29,13},
{468422657,42847096,29,12},
{468320257,448467803,29,17},
{468234241,449153494,29,12},
{468226049,282005805,29,12},
{468221953,241093489,29,15},
{468213761,425682856,29,13},
{468197377,145763680,29,13},
{468185089,52760469,29,12},
{468176897,391701817,29,12},
{468135937,257066226,29,12},
{468111361,224215868,29,12},
{468062209,394763719,29,12},
{468049921,331571375,29,13},
{468017153,400952418,29,13},
{467988481,360722136,29,12},
{467914753,347482861,29,12},
{467869697,44876321,29,13},
{467857409,406341666,29,12},
{467795969,388462946,29,17},
{467783681,409803331,29,12},
{467767297,114507458,29,12},
{467644417,459162632,29,12},
{467611649,382716188,29,12},
{467558401,261686936,29,13},
{467546113,421004068,29,12},
{467509249,264805744,29,13},
{467484673,312386342,29,14},
{467476481,123299159,29,13},
{467447809,43875747,29,12},
{467423233,9343897,29,12},
{467415041,374830864,29,12},
{467361793,110434094,29,13},
{467255297,9376900,29,14},
{467230721,391235683,29,13},
{467189761,206938735,29,14},
{467181569,225231968,29,13},
{467152897,242554602,29,12},
{467132417,416569404,29,13},
{467058689,20272161,29,14},
{467054593,186656323,29,12},
{467046401,453727555,29,12},
{467009537,406849687,29,17},
{466972673,291683250,29,12},
{466911233,65032407,29,15},
{466894849,87250294,29,14},
{466882561,357412641,29,12},
{466870273,195645105,29,13},
{466825217,100421934,29,12},
{466771969,61932948,29,13},
{466726913,177363977,29,12},
{466710529,382846194,29,12},
{466702337,228595156,29,12},
{466665473,155265432,29,14},
{466649089,31046428,29,15},
{466579457,37268572,29,12},
{466493441,303045625,29,13},
{466464769,32550004,29,12},
{466444289,457529418,29,13},
{466415617,61455928,29,12},
{466358273,6762427,29,12},
{466354177,318502814,29,18},
{466321409,231828430,29,15},
{466309121,151759709,29,12},
{466247681,85551077,29,13},
{466157569,272907136,29,16},
{466108417,131370749,29,14},
{466026497,353123379,29,16},
{466014209,280715060,29,12},
{465985537,437604233,29,13},
{465965057,425762836,29,12},
{465948673,887650,29,12},
{465879041,397576513,29,14},
{465805313,135554381,29,13},
{465764353,218304113,29,16},
{465719297,29575074,29,12},
{465653761,363816380,29,12},
{465534977,366302375,29,15},
{465518593,205619761,29,14},
{465510401,200533155,29,13},
{465481729,116668085,29,12},
{465387521,258691864,29,14},
{465346561,276259150,29,13},
{465297409,244659510,29,13},
{465289217,131144625,29,14},
{465252353,140499412,29,12},
{465162241,111288156,29,12},
{465129473,93308136,29,12},
{465088513,115334145,29,12},
{465068033,251723720,29,13},
{465051649,137976014,29,13},
{465039361,449487157,29,12},
{464977921,159294495,29,16},
{464928769,265941663,29,14},
{464916481,177380718,29,12},
{464859137,398447664,29,12},
{464781313,328402222,29,18},
{464756737,102533454,29,13},
{464723969,435230108,29,13},
{464662529,99796571,29,12},
{464498689,94896299,29,12},
{464429057,157777849,29,13},
{464412673,22112681,29,13},
{464392193,110986804,29,12},
{464355329,53201769,29,15},
{464351233,428999124,29,12},
{464330753,362349340,29,13},
{464306177,124123206,29,14},
{464293889,315539202,29,12},
{464232449,25892066,29,13},
{464220161,377355338,29,12},
{464183297,58164170,29,13},
{464179201,352043695,29,12},
{464084993,84902629,29,13},
{464068609,353047977,29,13},
{464048129,353684728,29,12},
{463872001,291448799,29,13},
{463835137,59496672,29,12},
{463777793,265630577,29,12},
{463773697,421939675,29,13},
{463716353,304992883,29,14},
{463675393,385288198,29,13},
{463618049,323640746,29,14},
{463577089,396926765,29,13},
{463527937,284662168,29,13},
{463503361,370574712,29,15},
{463470593,399930016,29,21},
{463409153,231236854,29,12},
{463368193,287244050,29,12},
{463331329,160528483,29,13},
{463319041,22424764,29,12},
{463286273,165584876,29,12},
{463282177,425745323,29,13},
{463269889,102837424,29,12},
{463261697,172756954,29,12},
{463224833,386696468,29,14},
{463187969,228273832,29,12},
{463122433,299037290,29,12},
{463097857,36070679,29,12},
{463065089,342808366,29,12},
{462974977,77504921,29,12},
{462929921,419939365,29,14},
{462856193,351128732,29,13},
{462852097,317388927,29,12},
{462839809,301540129,29,13},
{462729217,428512063,29,12},
{462716929,262712057,29,15},
{462696449,351459490,29,12},
{462692353,329690893,29,13},
{462684161,284171106,29,18},
{462573569,174121910,29,12},
{462544897,248902433,29,13},
{462520321,256991565,29,15},
{462471169,112426682,29,14},
{462462977,177278800,29,13},
{462450689,186358634,29,12},
{462376961,62720036,29,12},
{462340097,99290634,29,14},
{462327809,140597737,29,12},
{462315521,63259567,29,13},
{462299137,341910028,29,13},
{462254081,409887507,29,12},
{462237697,245292542,29,12},
{462155777,48324233,29,12},
{462069761,61732309,29,13},
{462020609,280505498,29,13},
{461996033,350059283,29,15},
{461971457,62870779,29,13},
{461832193,35767472,29,16},
{461795329,63291527,29,12},
{461770753,411512283,29,12},
{461750273,12433700,29,14},
{461660161,67041406,29,13},
{461639681,322836993,29,12},
{461590529,33891865,29,12},
{461578241,186400920,29,13},
{461516801,30091845,29,12},
{461402113,171885159,29,12},
{461352961,447910409,29,12},
{461332481,367948995,29,13},
{461320193,446821672,29,12},
{461303809,461083082,29,12},
{461295617,185180482,29,12},
{461291521,380314073,29,14},
{461209601,59070837,29,15},
{461172737,88577693,29,12},
{461168641,37560274,29,13},
{461160449,422022798,29,14},
{461074433,434826587,29,12},
{461008897,201144532,29,12},
{460951553,66717106,29,12},
{460935169,423666004,29,12},
{460914689,396956991,29,16},
{460849153,152876320,29,19},
{460800001,241891431,29,14},
{460791809,32338848,29,13},
{460701697,400367448,29,14},
{460603393,272758876,29,14},
{460546049,380672866,29,13},
{460419073,67752432,29,12},
{460361729,291369148,29,12},
{460349441,37017915,29,13},
{460337153,6405505,29,12},
{460312577,428852501,29,12},
{460308481,70847043,29,14},
{460288001,419291729,29,12},
{460275713,389848233,29,14},
{460259329,215071962,29,16},
{460115969,74488756,29,12},
{460075009,90692312,29,12},
{459931649,123864270,29,17},
{459927553,139645626,29,12},
{459907073,49628109,29,13},
{459902977,28718713,29,12},
{459816961,84171025,29,14},
{459796481,130234372,29,12},
{459743233,396045801,29,13},
{459706369,385137143,29,12},
{459563009,81263908,29,13},
{459534337,263342664,29,12},
{459476993,446646799,29,12},
{459460609,260739459,29,12},
{459452417,30211505,29,12},
{459448321,127790766,29,13},
{459427841,457828045,29,12},
{459411457,317049599,29,12},
{459390977,51714845,29,14},
{459329537,40180796,29,12},
{459304961,320577271,29,12},
{459276289,408919949,29,21},
{459268097,106775720,29,13},
{459255809,319639899,29,12},
{459251713,270088389,29,13},
{459190273,445520950,29,12},
{459182081,170467152,29,12},
{459128833,19825165,29,14},
{459042817,18685332,29,12},
{458956801,234783964,29,13},
{458924033,424648375,29,13},
{458907649,378367332,29,13},
{458895361,410224015,29,12},
{458874881,434074869,29,13},
{458764289,21508879,29,12},
{458752001,15298291,29,19},
{458723329,270279101,29,12},
{458629121,120682380,29,13},
{458616833,8272593,29,12},
{458579969,27029393,29,13},
{458551297,113959335,29,12},
{458526721,290970025,29,12},
{458465281,270215484,29,13},
{458457089,139064384,29,15},
{458395649,330247165,29,12},
{458371073,203674531,29,12},
{458305537,195131794,29,12},
{458219521,190365521,29,13},
{458211329,319594956,29,14},
{458186753,340706069,29,13},
{458149889,406751060,29,12},
{458108929,91304487,29,12},
{458022913,29936246,29,13},
{457977857,171631794,29,12},
{457961473,292529795,29,12},
{457940993,342125383,29,13},
{457924609,110712840,29,13},
{457854977,37184448,29,12},
{457850881,100651516,29,14},
{457838593,48348373,29,12},
{457814017,436017074,29,12},
{457789441,48446096,29,12},
{457781249,56686035,29,12},
{457719809,278273129,29,14},
{457670657,139217007,29,15},
{457633793,353307055,29,12},
{457568257,11915666,29,12},
{457547777,288265744,29,13},
{457535489,146645296,29,12},
{457523201,362908176,29,14},
{457506817,414446482,29,16},
{457482241,305654871,29,13},
{457474049,237752330,29,15},
{457445377,125096836,29,12},
{457302017,353925127,29,13},
{457240577,21290528,29,12},
{457166849,456112992,29,12},
{457162753,235044621,29,14},
{457052161,409567340,29,12},
{457003009,400517112,29,12},
{456982529,338175084,29,16},
{456933377,141122301,29,14},
{456871937,452903138,29,12},
{456835073,88064285,29,14},
{456830977,159418488,29,12},
{456749057,398111467,29,12},
{456708097,200010360,29,12},
{456663041,450983240,29,13},
{456634369,212789810,29,12},
{456609793,89998005,29,12},
{456560641,220254024,29,12},
{456499201,329855152,29,13},
{456380417,122050324,29,12},
{456355841,278652887,29,12},
{456327169,256937846,29,16},
{456257537,37754957,29,12},
{456220673,123144632,29,13},
{456183809,405703672,29,12},
{456159233,17074169,29,12},
{456048641,82175299,29,14},
{456032257,115954023,29,15},
{455946241,154605571,29,12},
{455933953,45979188,29,16},
{455888897,311732602,29,12},
{455663617,53212545,29,13},
{455577601,415029339,29,12},
{455544833,311035693,29,12},
{455442433,450645429,29,15},
{455405569,450235175,29,12},
{455356417,341365053,29,12},
{455344129,387441913,29,18},
{455270401,98003192,29,13},
{455200769,1784170,29,12},
{455139329,305092105,29,13},
{455110657,324972503,29,12},
{455028737,348453144,29,12},
{454926337,102364954,29,13},
{454901761,20594330,29,14},
{454864897,5971341,29,12},
{454832129,314755843,29,12},
{454807553,86179629,29,12},
{454803457,4647,29,14},
{454758401,205049367,29,12},
{454709249,402123914,29,12},
{454660097,20277781,29,12},
{454656001,63012771,29,15},
{454635521,113702126,29,12},
{454623233,9967105,29,16},
{454594561,401583457,29,12},
{454586369,441491622,29,12},
{454545409,170648738,29,12},
{454524929,161864338,29,15},
{454496257,285139257,29,12},
{454451201,176562051,29,13},
{454336513,140622858,29,13},
{454299649,69521348,29,12},
{454291457,257068967,29,12},
{454266881,39521906,29,12},
{454156289,124582228,29,13},
{454082561,426293698,29,14},
{453992449,330542064,29,13},
{453922817,424884964,29,12},
{453910529,351443181,29,13},
{453885953,14963202,29,14},
{453734401,161595880,29,12},
{453697537,232217697,29,13},
{453660673,103176712,29,12},
{453541889,408549860,29,15},
{453488641,406320426,29,12},
{453394433,18822066,29,14},
{453390337,321391245,29,12},
{453369857,395970783,29,13},
{453353473,145857867,29,13},
{453316609,73479699,29,12},
{453292033,80211972,29,12},
{453283841,368151859,29,12},
{453230593,306522127,29,14},
{453193729,233338363,29,12},
{453181441,429025338,29,16},
{453173249,101058039,29,13},
{453148673,56138159,29,15},
{453120001,362552470,29,12},
{452964353,219468147,29,12},
{452915201,445208611,29,12},
{452878337,220352049,29,13},
{452837377,367719184,29,14},
{452804609,129783684,29,14},
{452775937,171949060,29,12},
{452739073,271986255,29,14},
{452730881,5381707,29,13},
{452718593,213162526,29,12},
{452694017,255969234,29,12},
{452689921,273501603,29,15},
{452653057,322791776,29,12},
{452616193,31126618,29,13},
{452608001,306125143,29,14},
{452591617,106570082,29,17},
{452558849,88367060,29,15},
{452374529,80553475,29,12},
{452251649,343327834,29,12},
{452198401,289999409,29,18},
{452186113,297836460,29,12},
{452116481,16667441,29,14},
{452075521,206564424,29,13},
{452063233,294547170,29,12},
{452026369,256954760,29,13},
{452014081,128792215,29,12},
{451977217,224789931,29,13},
{451956737,249072472,29,12},
{451940353,350553167,29,12},
{451932161,151710783,29,12},
{451919873,343407244,29,14},
{451903489,294699660,29,15},
{451891201,346076143,29,12},
{451842049,106667645,29,12},
{451829761,383767327,29,13},
{451796993,116554464,29,13},
{451768321,437623728,29,12},
{451760129,221195792,29,12},
{451731457,71679835,29,13},
{451710977,372777031,29,12},
{451686401,155163699,29,12},
{451612673,334840086,29,12},
{451547137,406676922,29,12},
{451526657,355021011,29,14},
{451461121,110752292,29,14},
{451452929,286344276,29,13},
{451391489,86134879,29,12},
{451362817,112510989,29,14},
{451342337,191251018,29,12},
{451338241,108091370,29,13},
{451256321,178468889,29,13},
{451215361,318196986,29,16},
{451141633,73314781,29,13},
{451084289,309923100,29,16},
{450981889,419688899,29,12},
{450969601,389776156,29,14},
{450932737,198961310,29,12},
{450895873,425306390,29,13},
{450715649,155170369,29,13},
{450711553,120566515,29,12},
{450666497,282313617,29,13},
{450629633,80726154,29,12},
{450568193,286101335,29,13},
{450543617,275458080,29,14},
{450506753,366714293,29,12},
{450482177,326300201,29,12},
{450465793,182581283,29,12},
{450428929,217080332,29,16},
{450408449,48256663,29,12},
{450334721,316638859,29,12},
{450273281,32853521,29,13},
{450256897,416789488,29,13},
{450236417,417795819,29,12},
{450134017,413335669,29,15},
{450109441,370622297,29,13},
{450039809,440280281,29,12},
{450015233,410045052,29,12},
{450011137,189983287,29,13},
{449937409,423858942,29,15},
{449929217,293086280,29,13},
{449925121,446032165,29,12},
{449855489,30459209,29,14},
{449769473,179644539,29,12},
{449720321,313629603,29,12},
{449679361,338970732,29,12},
{449671169,219957547,29,12},
{449585153,342525285,29,13},
{449474561,55477431,29,12},
{449433601,159424229,29,12},
{449384449,2512972,29,12},
{449363969,266487237,29,14},
{449290241,391005235,29,13},
{449273857,295067300,29,13},
{449175553,88882357,29,13},
{449167361,161267151,29,14},
{449155073,179234294,29,12},
{449077249,308585003,29,13},
{449069057,392406355,29,14},
{449044481,302580727,29,13},
{449032193,60872155,29,12},
{449003521,80564073,29,14},
{448892929,241803749,29,12},
{448868353,130356231,29,12},
{448843777,153024542,29,12},
{448831489,80227569,29,13},
{448819201,418370192,29,12},
{448811009,334784510,29,12},
{448724993,121338338,29,16},
{448659457,428749888,29,17},
{448614401,259335015,29,12},
{448585729,423207502,29,13},
{448577537,134789609,29,14},
{448536577,285650590,29,13},
{448524289,194292651,29,12},
{448491521,446258040,29,12},
{448270337,140542875,29,12},
{448217089,233049366,29,14},
{448172033,212386220,29,12},
{448147457,287988806,29,12},
{448094209,420470202,29,13},
{448073729,66223946,29,12},
{448061441,187027552,29,13},
{448049153,268806229,29,12},
{448045057,76356494,29,13},
{448032769,184323230,29,12},
{448008193,267438815,29,12},
{447987713,370014571,29,14},
{447959041,162833972,29,12},
{447885313,440679967,29,12},
{447836161,314586366,29,12},
{447827969,298488184,29,12},
{447778817,416862515,29,12},
{447741953,123085273,29,20},
{447725569,84221613,29,14},
{447717377,108970559,29,13},
{447578113,299637410,29,15},
{447467521,228466393,29,12},
{447418369,161748093,29,12},
{447410177,21512308,29,12},
{447369217,245660324,29,12},
{447283201,99303938,29,16},
{447246337,44911978,29,12},
{447234049,201104922,29,14},
{447209473,66756109,29,13},
{447201281,148630341,29,14},
{447184897,113910867,29,15},
{447160321,135984402,29,13},
{447098881,242313972,29,12},
{447090689,317743379,29,12},
{447086593,281856589,29,17},
{447029249,182891501,29,13},
{446926849,201451236,29,12},
{446894081,350966495,29,12},
{446857217,282573004,29,15},
{446844929,353589001,29,12},
{446816257,329824226,29,13},
{446803969,99746325,29,12},
{446771201,403832024,29,12},
{446722049,347063372,29,12},
{446697473,364099809,29,12},
{446631937,5920865,29,12},
{446599169,36705685,29,12},
{446472193,221330097,29,13},
{446365697,9094357,29,16},
{446328833,189319636,29,12},
{446251009,109524553,29,14},
{446238721,250945536,29,12},
{446226433,151295959,29,13},
{446181377,400118086,29,12},
{446140417,320188757,29,12},
{446095361,440995627,29,13},
{446078977,145503533,29,13},
{445935617,129249414,29,12},
{445919233,119781379,29,12},
{445870081,128397745,29,12},
{445849601,272469879,29,13},
{445808641,443390837,29,15},
{445714433,101298672,29,12},
{445698049,65494037,29,12},
{445689857,35382793,29,12},
{445685761,180136253,29,13},
{445624321,137134349,29,12},
{445566977,290266985,29,12},
{445562881,369311974,29,14},
{445542401,219946415,29,12},
{445419521,94536032,29,12},
{445407233,303145558,29,13},
{445222913,103750744,29,12},
{445132801,436139682,29,12},
{445034497,165282813,29,12},
{444878849,324397188,29,12},
{444874753,17007720,29,14},
{444850177,371131547,29,13},
{444837889,47001053,29,12},
{444817409,125414387,29,13},
{444788737,15806343,29,12},
{444731393,152717914,29,12},
{444608513,404143117,29,12},
{444567553,110125377,29,12},
{444542977,208357502,29,12},
{444522497,333388883,29,13},
{444448769,328757608,29,14},
{444444673,203382032,29,12},
{444334081,248527037,29,18},
{444276737,1070977,29,13},
{444272641,389875910,29,12},
{444264449,63145271,29,12},
{444252161,67761156,29,14},
{444088321,187333385,29,14},
{444076033,55359100,29,12},
{444026881,440862859,29,12},
{443994113,278376960,29,12},
{443916289,1524217,29,13},
{443891713,171483038,29,14},
{443883521,191370849,29,13},
{443846657,414219142,29,12},
{443842561,9401015,29,15},
{443596801,423285185,29,14},
{443527169,273123403,29,12},
{443514881,438716202,29,15},
{443461633,62120362,29,12},
{443453441,89144300,29,12},
{443441153,103585183,29,13},
{443301889,287667277,29,14},
{443269121,223026843,29,14},
{443252737,76972126,29,15},
{443219969,109747313,29,16},
{443191297,5387801,29,12},
{443129857,323688894,29,13},
{443117569,272053982,29,12},
{443056129,281999193,29,15},
{443031553,136621813,29,13},
{442970113,252713198,29,12},
{442925057,362202509,29,15},
{442900481,122628986,29,13},
{442884097,111710245,29,13},
{442847233,270071448,29,12},
{442761217,35248346,29,18},
{442703873,259303163,29,13},
{442675201,324353003,29,12},
{442626049,422704859,29,12},
{442580993,58351001,29,14},
{442544129,90307742,29,12},
{442494977,254387639,29,12},
{442458113,346328406,29,13},
{442421249,221164773,29,12},
{442359809,156087730,29,13},
{442331137,268242950,29,12},
{442195969,292085663,29,13},
{442183681,139630028,29,12},
{442101761,78288719,29,12},
{442073089,294242479,29,15},
{442052609,29262063,29,12},
{441978881,106446559,29,12},
{441950209,171668527,29,13},
{441905153,95784482,29,12},
{441876481,170587080,29,15},
{441839617,80456487,29,12},
{441782273,81334340,29,12},
{441765889,145839799,29,12},
{441696257,167890127,29,14},
{441561089,88482847,29,12},
{441556993,283373757,29,13},
{441548801,46812100,29,15},
{441520129,426584577,29,12},
{441438209,373364835,29,12},
{441397249,59104175,29,12},
{441364481,255896247,29,12},
{441352193,305587181,29,15},
{441348097,348324746,29,12},
{441327617,427668533,29,13},
{441323521,96795983,29,12},
{441204737,302130577,29,14},
{441163777,33468337,29,13},
{441139201,250927449,29,14},
{441090049,57133973,29,15},
{441065473,352162496,29,13},
{440979457,86809711,29,12},
{440967169,277457972,29,13},
{440918017,407282732,29,13},
{440737793,398870446,29,13},
{440721409,295862636,29,13},
{440639489,291022980,29,13},
{440528897,13075518,29,12},
{440524801,201292706,29,13},
{440492033,349433947,29,13},
{440487937,156646873,29,12},
{440389633,52022780,29,12},
{440381441,364468654,29,12},
{440352769,237331566,29,14},
{440344577,259658349,29,13},
{440307713,184780770,29,12},
{440291329,257566453,29,12},
{440258561,249950845,29,12},
{440246273,1120331,29,13},
{440156161,120560857,29,14},
{440123393,123412781,29,14},
{440061953,139477953,29,12},
{440057857,61894786,29,14},
{440033281,199114229,29,13},
{439975937,344884701,29,15},
{439934977,264540889,29,13},
{439898113,283369016,29,12},
{439889921,229889061,29,12},
{439750657,391400597,29,12},
{439705601,19687461,29,13},
{439656449,194720682,29,13},
{439627777,157681125,29,12},
{439603201,113182611,29,12},
{439570433,61554923,29,12},
{439541761,436308788,29,13},
{439533569,386975768,29,14},
{439472129,79963687,29,12},
{439468033,179689258,29,14},
{439406593,116930434,29,12},
{439386113,170054145,29,15},
{439361537,125997596,29,13},
{439349249,110958322,29,12},
{439275521,354391007,29,12},
{439263233,65799653,29,13},
{439234561,168506409,29,12},
{439115777,92482821,29,13},
{439017473,161481682,29,13},
{439001089,262248087,29,13},
{438956033,402309619,29,12},
{438951937,227598625,29,13},
{438939649,307960086,29,12},
{438931457,183282119,29,12},
{438927361,108160181,29,15},
{438890497,288018629,29,12},
{438870017,94697985,29,13},
{438845441,4031444,29,14},
{438829057,83855008,29,19},
{438747137,425133474,29,14},
{438730753,347750200,29,15},
{438673409,165075029,29,13},
{438611969,111450568,29,12},
{438571009,96013933,29,12},
{438521857,190666303,29,12},
{438497281,375441315,29,12},
{438484993,129796137,29,14},
{438464513,153598257,29,12},
{438435841,353431000,29,17},
{438423553,93240014,29,12},
{438263809,415814771,29,13},
{438231041,177218363,29,13},
{438194177,43061967,29,12},
{438181889,146079434,29,13},
{438177793,37931655,29,12},
{438009857,141269083,29,15},
{437993473,206699065,29,14},
{437956609,400968984,29,12},
{437911553,135452049,29,17},
{437833729,180066937,29,12},
{437825537,49603559,29,12},
{437772289,172075170,29,13},
{437764097,170448866,29,14},
{437739521,306436933,29,13},
{437723137,320618631,29,13},
{437698561,31158721,29,14},
{437665793,169561622,29,14},
{437649409,423033456,29,17},
{437637121,233421880,29,12},
{437624833,211511039,29,13},
{437604353,38039660,29,12},
{437567489,409491765,29,14},
{437477377,125976179,29,13},
{437456897,257990133,29,12},
{437395457,404177022,29,13},
{437370881,155286112,29,14},
{437317633,193333313,29,12},
{437149697,109650213,29,13},
{437112833,253954593,29,12},
{437010433,131156838,29,14},
{436989953,259034582,29,12},
{436965377,197183293,29,12},
{436879361,49488711,29,14},
{436838401,415278592,29,13},
{436817921,386374566,29,12},
{436703233,197407798,29,12},
{436695041,141670702,29,12},
{436654081,44894835,29,12},
{436645889,28831902,29,12},
{436621313,70577739,29,12},
{436473857,268403026,29,12},
{436461569,240658409,29,13},
{436449281,421912114,29,12},
{436436993,412846256,29,15},
{436432897,74802566,29,12},
{436420609,409782273,29,14},
{436346881,182788325,29,13},
{436224001,381259594,29,14},
{436162561,214466673,29,12},
{436142081,399403389,29,16},
{436113409,82994756,29,12},
{436051969,287081602,29,13},
{436027393,21871724,29,14},
{435965953,40266637,29,12},
{435957761,80456813,29,12},
{435843073,70186091,29,12},
{435732481,152654993,29,14},
{435720193,54050333,29,12},
{435675137,81073178,29,13},
{435601409,396219844,29,14},
{435535873,269428434,29,14},
{435490817,56026849,29,12},
{435486721,422862997,29,16},
{435376129,139147732,29,12},
{435326977,128945907,29,12},
{435306497,35030211,29,14},
{435302401,352337459,29,12},
{435269633,121669547,29,12},
{435171329,112408580,29,12},
{435167233,368728199,29,13},
{435142657,261436460,29,14},
{435060737,67916401,29,15},
{435056641,53851490,29,12},
{434962433,396819286,29,16},
{434937857,199618789,29,13},
{434933761,276698425,29,12},
{434896897,37173203,29,18},
{434876417,252956940,29,12},
{434810881,345243164,29,12},
{434802689,67901397,29,12},
{434798593,156501822,29,15},
{434790401,391189187,29,13},
{434741249,54615393,29,13},
{434679809,417163401,29,12},
{434593793,152810019,29,13},
{434589697,29093101,29,12},
{434569217,273442179,29,16},
{434544641,260453564,29,13},
{434483201,296745430,29,12},
{434470913,72540459,29,15},
{434466817,255859329,29,12},
{434429953,178089582,29,13},
{434380801,160109172,29,13},
{434331649,79105597,29,13},
{434311169,167841274,29,12},
{434257921,54759786,29,14},
{434245633,120882696,29,12},
{434208769,288097620,29,15},
{434200577,245630615,29,13},
{434188289,236279707,29,12},
{434184193,391064112,29,13},
{434135041,20589116,29,13},
{434122753,75110311,29,12},
{434114561,136791655,29,12},
{434077697,314139206,29,15},
{434040833,192270469,29,12},
{434036737,190130778,29,13},
{434024449,428670531,29,12},
{433991681,362810579,29,12},
{433942529,362497805,29,12},
{433901569,294269307,29,12},
{433819649,109805327,29,12},
{433795073,349658635,29,12},
{433790977,217655799,29,13},
{433758209,201025794,29,13},
{433733633,117840927,29,14},
{433729537,316593948,29,12},
{433709057,309203715,29,13},
{433692673,271580116,29,13},
{433586177,152224450,29,19},
{433582081,193587665,29,12},
{433512449,209042580,29,13},
{433500161,395830705,29,12},
{433422337,382601589,29,15},
{433262593,406802150,29,12},
{433238017,121640146,29,12},
{433225729,251133123,29,15},
{433205249,296058593,29,12},
{433164289,334794604,29,12},
{433078273,28335924,29,14},
{433070081,158398855,29,13},
{433053697,156467539,29,13},
{433033217,274373325,29,12},
{432996353,317477040,29,16},
{432979969,76058119,29,14},
{432967681,340948277,29,12},
{432947201,4768302,29,14},
{432844801,366068463,29,12},
{432824321,111007045,29,13},
{432812033,221612685,29,12},
{432709633,179729941,29,13},
{432664577,323765437,29,12},
{432623617,317876389,29,12},
{432603137,364987760,29,16},
{432590849,42568852,29,12},
{432586753,287174313,29,14},
{432578561,246968686,29,13},
{432566273,22021641,29,12},
{432414721,103231603,29,13},
{432353281,81087428,29,12},
{432332801,422645821,29,13},
{432304129,236247877,29,12},
{432259073,154941361,29,14},
{432242689,124085239,29,15},
{432173057,282892170,29,12},
{432160769,283151617,29,14},
{432148481,74868999,29,12},
{432132097,77153573,29,12},
{432107521,50918907,29,12},
{432046081,410073969,29,15},
{432037889,167180021,29,13},
{432009217,221825855,29,12},
{431951873,108561979,29,12},
{431923201,164956069,29,13},
{431902721,152711713,29,12},
{431865857,26447001,29,14},
{431718401,244529458,29,15},
{431689729,237804341,29,12},
{431656961,390763417,29,12},
{431644673,318581791,29,13},
{431628289,395328658,29,13},
{431607809,39765612,29,12},
{431484929,105315182,29,12},
{431460353,346173748,29,12},
{431419393,366174695,29,12},
{431312897,415576801,29,12},
{431185921,397614914,29,13},
{431153153,138845701,29,13},
{431063041,277810576,29,15},
{431054849,354506075,29,13},
{431013889,331854297,29,14},
{431001601,289751927,29,12},
{430944257,396869,29,12},
{430940161,354287924,29,13},
{430919681,147370310,29,12},
{430891009,74915701,29,13},
{430866433,102906252,29,15},
{430841857,299269018,29,13},
{430755841,114945497,29,12},
{430686209,69879638,29,14},
{430682113,355640626,29,12},
{430661633,54506433,29,13},
{430657537,180138221,29,12},
{430645249,55261534,29,13},
{430637057,141957295,29,16},
{430596097,109735889,29,13},
{430583809,47479739,29,12},
{430510081,321925,29,12},
{430473217,362704106,29,15},
{430436353,153170844,29,12},
{430428161,76377088,29,12},
{430374913,108959260,29,16},
{430350337,400666563,29,13},
{430256129,135143748,29,12},
{430231553,255198767,29,12},
{430194689,291465092,29,14},
{430170113,143602668,29,13},
{430084097,399296419,29,12},
{430071809,13862627,29,13},
{430030849,406512849,29,14},
{430006273,31462863,29,13},
{429944833,3690208,29,12},
{429924353,194642663,29,13},
{429899777,385803099,29,14},
{429883393,384012304,29,15},
{429826049,392704191,29,13},
{429785089,157757837,29,17},
{429690881,179078136,29,12},
{429678593,225156194,29,13},
{429629441,78632072,29,13},
{429592577,410546433,29,12},
{429580289,270993358,29,13},
{429568001,290902182,29,12},
{429518849,143692850,29,12},
{429514753,41157070,29,13},
{429477889,282093695,29,12},
{429469697,94094752,29,12},
{429391873,378555553,29,19},
{429367297,341521002,29,13},
{429342721,300182729,29,14},
{429322241,168723984,29,12},
{429293569,126447130,29,15},
{429260801,106249767,29,17},
{429223937,137518182,29,12},
{429137921,156231159,29,13},
{429109249,375014996,29,12},
{429027329,131063577,29,12},
{428916737,156711966,29,14},
{428904449,4663556,29,12},
{428838913,49659762,29,12},
{428732417,60954429,29,12},
{428720129,19622442,29,14},
{428716033,280986466,29,12},
{428654593,342394638,29,14},
{428593153,31139440,29,12},
{428494849,399356266,29,12},
{428486657,210698598,29,12},
{428474369,102654889,29,17},
{428462081,190547035,29,12},
{428388353,291676964,29,12},
{428339201,252484190,29,12},
{428249089,252312916,29,12},
{428224513,323954508,29,12},
{428187649,225383539,29,13},
{428175361,55119385,29,12},
{428105729,178970540,29,13},
{428077057,89637874,29,12},
{427991041,268190142,29,13},
{427970561,219194784,29,12},
{427958273,346798905,29,13},
{427933697,238552430,29,14},
{427745281,426576691,29,13},
{427708417,319752560,29,12},
{427646977,345441489,29,13},
{427634689,232430897,29,12},
{427626497,51480042,29,12},
{427585537,356125957,29,12},
{427499521,81665945,29,13},
{427462657,346545710,29,12},
{427450369,85235102,29,13},
{427307009,108856210,29,12},
{427233281,291457412,29,12},
{427171841,397136593,29,13},
{427159553,403012958,29,12},
{426975233,65065914,29,13},
{426958849,362721764,29,13},
{426934273,215110153,29,15},
{426876929,340035276,29,13},
{426872833,334924971,29,12},
{426815489,335698686,29,12},
{426811393,416909503,29,13},
{426790913,164361560,29,12},
{426786817,289959901,29,14},
{426766337,347257844,29,12},
{426704897,297830892,29,16},
{426627073,291694895,29,12},
{426590209,237997966,29,14},
{426545153,74041850,29,12},
{426483713,401395438,29,13},
{426393601,167211239,29,14},
{426381313,51140598,29,12},
{426373121,311864393,29,12},
{426344449,322915009,29,15},
{426258433,163433944,29,12},
{426250241,66199302,29,12},
{426237953,200490514,29,13},
{426196993,120179004,29,14},
{426160129,332011754,29,12},
{426074113,317023445,29,13},
{426049537,188002600,29,16},
{426029057,168334027,29,12},
{425930753,224598666,29,12},
{425893889,417915297,29,13},
{425840641,408896317,29,12},
{425783297,295251968,29,12},
{425758721,14545303,29,12},
{425680897,17131415,29,13},
{425644033,243512540,29,12},
{425598977,382210258,29,13},
{425476097,179523679,29,14},
{425472001,72199633,29,12},
{425414657,246932333,29,12},
{425398273,289066805,29,12},
{425312257,91910917,29,14},
{425275393,306701246,29,12},
{425254913,302954992,29,13},
{425250817,341348558,29,12},
{425218049,299987076,29,12},
{425189377,7879727,29,13},
{425168897,183447447,29,12},
{425152513,401813042,29,12},
{425103361,99664145,29,12},
{425095169,136956358,29,12},
{425070593,74964765,29,12},
{424947713,308591040,29,12},
{424919041,357895816,29,14},
{424882177,328744680,29,12},
{424845313,51319232,29,13},
{424824833,95625256,29,12},
{424796161,78889349,29,13},
{424783873,139524657,29,12},
{424722433,304506203,29,14},
{424665089,423738314,29,13},
{424660993,345297751,29,12},
{424624129,53477465,29,14},
{424611841,112375917,29,12},
{424538113,29780199,29,12},
{424493057,269584605,29,14},
{424468481,314185296,29,13},
{424407041,352168130,29,12},
{424394753,399131107,29,14},
{424308737,208194617,29,12},
{424292353,61420424,29,12},
{424247297,103793724,29,15},
{424148993,22305508,29,19},
{424124417,323416082,29,13},
{424108033,216146846,29,13},
{424071169,2955638,29,12},
{424050689,121500216,29,15},
{424046593,61442266,29,12},
{424038401,60944016,29,12},
{423976961,2230062,29,13},
{423948289,115147726,29,12},
{423862273,91318610,29,13},
{423804929,289604172,29,14},
{423751681,89956370,29,12},
{423702529,346793457,29,12},
{423677953,308309709,29,12},
{423669761,158679179,29,12},
{423657473,209887684,29,15},
{423641089,356700248,29,14},
{423628801,80736782,29,12},
{423579649,76335464,29,12},
{423473153,175709079,29,12},
{423456769,217804424,29,12},
{423448577,268305391,29,12},
{423346177,370615486,29,14},
{423313409,199591396,29,14},
{423284737,124514229,29,12},
{423260161,362325712,29,12},
{423161857,66406790,29,12},
{423149569,70421509,29,14},
{423141377,38825074,29,13},
{423075841,217614070,29,13},
{423055361,367369792,29,12},
{422981633,125745104,29,12},
{422957057,349335132,29,12},
{422932481,201106409,29,12},
{422903809,22602606,29,16},
{422858753,48031929,29,12},
{422854657,298513688,29,14},
{422842369,323454833,29,12},
{422817793,138060458,29,12},
{422780929,229337198,29,13},
{422588417,381913798,29,12},
{422547457,283376869,29,12},
{422490113,225970043,29,12},
{422440961,365631288,29,12},
{422428673,6248062,29,14},
{422215681,85238002,29,15},
{422203393,265546078,29,12},
{422141953,360898262,29,13},
{422023169,241798087,29,12},
{421969921,133857388,29,14},
{421949441,221891171,29,12},
{421888001,7283550,29,15},
{421797889,100307783,29,13},
{421752833,265560981,29,12},
{421691393,169798982,29,15},
{421605377,81409311,29,12},
{421482497,405243658,29,12},
{421470209,92536105,29,13},
{421429249,199890969,29,15},
{421404673,332870583,29,13},
{421384193,42667221,29,12},
{421380097,133028152,29,14},
{421285889,91416648,29,12},
{421257217,386970185,29,13},
{421089281,289359493,29,12},
{421048321,134712005,29,12},
{420978689,200969319,29,13},
{420904961,311977229,29,15},
{420888577,415434645,29,14},
{420704257,273789039,29,12},
{420659201,221362993,29,14},
{420605953,82659735,29,12},
{420569089,140073027,29,13},
{420519937,304366252,29,13},
{420487169,85305867,29,13},
{420474881,329762652,29,12},
{420462593,173363729,29,14},
{420438017,263267981,29,13},
{420433921,74217456,29,12},
{420397057,366001746,29,14},
{420278273,135843849,29,12},
{420253697,320791161,29,12},
{420028417,102521064,29,13},
{419991553,178427752,29,12},
{419946497,100964079,29,13},
{419934209,228169979,29,12},
{419921921,12852771,29,15},
{419880961,245026305,29,13},
{419807233,159158401,29,14},
{419786753,150478407,29,12},
{419737601,356797833,29,12},
{419721217,174872856,29,12},
{419586049,327205791,29,13},
{419573761,315843979,29,12},
{419516417,196854153,29,12},
{419479553,97959684,29,14},
{419475457,229679351,29,12},
{419450881,277843729,29,12},
{419418113,315617052,29,12},
{419401729,143000939,29,12},
{419229697,30032018,29,12},
{419196929,324205720,29,12},
{419192833,314473069,29,13},
{419184641,107399129,29,14},
{419147777,367754533,29,12},
{419024897,269271522,29,12},
{418983937,363622341,29,12},
{418824193,390574468,29,14},
{418787329,41372787,29,12},
{418775041,105302081,29,17},
{418725889,263784100,29,14},
{418680833,338633161,29,12},
{418652161,405349536,29,13},
{418594817,240147045,29,14},
{418553857,221665614,29,13},
{418533377,200507194,29,12},
{418385921,95293131,29,12},
{418344961,284174804,29,12},
{418324481,189275764,29,13},
{418271233,70451991,29,12},
{418250753,53150204,29,17},
{418222081,305212561,29,12},
{418189313,20240566,29,12},
{418164737,363920617,29,12},
{418123777,156562683,29,12},
{418103297,166575129,29,14},
{418078721,361479360,29,13},
{418066433,117338406,29,12},
{418037761,213023560,29,14},
{418000897,127832074,29,12},
{417980417,180092504,29,13},
{417955841,340653497,29,15},
{417894401,141423546,29,12},
{417853441,38496470,29,12},
{417816577,372498628,29,13},
{417771521,177927998,29,12},
{417734657,408281191,29,13},
{417681409,272444632,29,12},
{417648641,396850433,29,12},
{417607681,35386375,29,12},
{417550337,269068062,29,12},
{417538049,133650103,29,13},
{417472513,371037763,29,13},
{417415169,341787288,29,14},
{417411073,169659549,29,12},
{417390593,373264296,29,13},
{417329153,173166118,29,12},
{417312769,344162981,29,12},
{417243137,208038944,29,13},
{417189889,357360018,29,12},
{417157121,218509808,29,12},
{417128449,148472763,29,13},
{417079297,409573636,29,13},
{417046529,354012120,29,13},
{417021953,30766352,29,14},
{417017857,182156811,29,12},
{416997377,186246351,29,13},
{416993281,40375887,29,12},
{416985089,223393405,29,12},
{416931841,28639744,29,13},
{416919553,330951058,29,12},
{416899073,121969619,29,13},
{416862209,89981810,29,12},
{416849921,308268562,29,13},
{416808961,277300278,29,19},
{416759809,282313177,29,14},
{416747521,163086969,29,12},
{416698369,184926943,29,12},
{416649217,277840788,29,12},
{416616449,116976453,29,12},
{416550913,87766785,29,12},
{416505857,412775011,29,13},
{416493569,296063593,29,12},
{416481281,170852730,29,16},
{416468993,202526267,29,12},
{416464897,236773902,29,14},
{416432129,269204109,29,14},
{416419841,318604096,29,12},
{416358401,289055174,29,13},
{416346113,413649497,29,12},
{416317441,196283665,29,15},
{416243713,329764096,29,13},
{416223233,264490450,29,12},
{416145409,291877126,29,13},
{416059393,89605688,29,12},
{416010241,234473591,29,12},
{415928321,103280230,29,12},
{415850497,242234636,29,13},
{415838209,153071466,29,12},
{415830017,109972103,29,12},
{415731713,1105369,29,12},
{415694849,155797162,29,16},
{415670273,63943537,29,13},
{415633409,6137859,29,12},
{415592449,25816372,29,12},
{415580161,134202187,29,14},
{415571969,271484523,29,13},
{415547393,119022748,29,14},
{415531009,24627250,29,15},
{415506433,364152429,29,13},
{415420417,398941763,29,12},
{415399937,121253818,29,15},
{415375361,189034919,29,13},
{415334401,412963139,29,15},
{415326209,158369766,29,13},
{415297537,237897866,29,12},
{415272961,54935044,29,12},
{415260673,402331001,29,13},
{415236097,23352297,29,22},
{415203329,127674514,29,15},
{415199233,83302077,29,12},
{415174657,280569308,29,12},
{415113217,214680462,29,13},
{415068161,247371266,29,12},
{415055873,127433313,29,14},
{414932993,194248304,29,13},
{414916609,341338399,29,13},
{414896129,261089900,29,12},
{414867457,117097941,29,13},
{414834689,106194519,29,13},
{414785537,260525028,29,13},
{414781441,164616339,29,12},
{414724097,160690583,29,12},
{414720001,313638094,29,13},
{414609409,258320619,29,12},
{414527489,95683340,29,12},
{414441473,232078289,29,13},
{414404609,386157893,29,12},
{414400513,273114876,29,14},
{414355457,157252190,29,12},
{414351361,142341809,29,15},
{414253057,360504096,29,16},
{414240769,150377441,29,12},
{414154753,144699340,29,15},
{414130177,309332012,29,13},
{414085121,324255323,29,12},
{414031873,343523560,29,13},
{414023681,75749328,29,15},
{413925377,150371889,29,18},
{413913089,148537058,29,12},
{413777921,93181602,29,14},
{413700097,274583266,29,12},
{413667329,220033033,29,12},
{413642753,21824420,29,12},
{413593601,12939422,29,12},
{413552641,290994264,29,12},
{413491201,164388255,29,13},
{413454337,253677794,29,12},
{413396993,297501044,29,12},
{413368321,136314069,29,15},
{413347841,56241816,29,12},
{413310977,237528031,29,13},
{413298689,255315441,29,12},
{413184001,206297128,29,12},
{413175809,199499678,29,12},
{413114369,202920846,29,13},
{413085697,97569113,29,12},
{413065217,91483926,29,13},
{413048833,50130770,29,13},
{412979201,40625349,29,12},
{412942337,111093074,29,16},
{412868609,231675585,29,13},
{412856321,163178480,29,12},
{412753921,298102324,29,13},
{412717057,294207103,29,12},
{412696577,308871979,29,14},
{412692481,36588837,29,12},
{412659713,129028387,29,12},
{412631041,57725370,29,14},
{412598273,52373569,29,14},
{412536833,204718777,29,12},
{412426241,114325979,29,13},
{412397569,97250695,29,12},
{412377089,56037644,29,13},
{412336129,299370341,29,14},
{412323841,8486766,29,12},
{412286977,235454645,29,16},
{412274689,153933452,29,12},
{412266497,260159206,29,12},
{412229633,292114788,29,13},
{412200961,15616906,29,12},
{412168193,320041740,29,12},
{412151809,281661171,29,12},
{412119041,138634373,29,12},
{412106753,90407502,29,14},
{412045313,191233543,29,12},
{412020737,149948423,29,12},
{411881473,271960523,29,12},
{411832321,321137440,29,12},
{411824129,329573658,29,12},
{411820033,355470876,29,13},
{411774977,66547806,29,12},
{411713537,150777628,29,14},
{411652097,355767445,29,12},
{411615233,78560465,29,14},
{411578369,34623354,29,12},
{411537409,298195990,29,12},
{411512833,403857543,29,12},
{411344897,190809128,29,13},
{411332609,364724228,29,12},
{411279361,201372534,29,13},
{411197441,303349261,29,13},
{411185153,273985238,29,12},
{411160577,6978984,29,12},
{411136001,330630811,29,12},
{411107329,135601404,29,16},
{411099137,366048322,29,13},
{411058177,186500514,29,14},
{411045889,277787416,29,12},
{410939393,88078404,29,12},
{410914817,69009762,29,12},
{410849281,174012034,29,12},
{410841089,241878386,29,12},
{410812417,311218611,29,15},
{410800129,207446597,29,12},
{410787841,314436359,29,13},
{410775553,287852250,29,12},
{410767361,57887410,29,12},
{410738689,317277554,29,13},
{410705921,64947822,29,13},
{410677249,91363278,29,12},
{410669057,311432786,29,12},
{410632193,258993098,29,14},
{410546177,233045781,29,12},
{410529793,241315701,29,12},
{410472449,385806128,29,12},
{410468353,240051536,29,14},
{410460161,398725971,29,13},
{410443777,50535793,29,13},
{410411009,107647096,29,13},
{410386433,131340671,29,17},
{410300417,231478896,29,12},
{410284033,84897501,29,12},
{410198017,37848808,29,13},
{410173441,31959164,29,14},
{410161153,347572866,29,12},
{410140673,255137791,29,14},
{410050561,100629199,29,13},
{410001409,213411293,29,13},
{409993217,270418198,29,20},
{409989121,71556278,29,12},
{409980929,212057495,29,12},
{409878529,214538018,29,14},
{409853953,88204761,29,13},
{409808897,310683497,29,12},
{409784321,110752226,29,12},
{409767937,382453922,29,12},
{409710593,343636780,29,12},
{409706497,71441485,29,13},
{409694209,395820658,29,12},
{409645057,61642078,29,12},
{409620481,115683421,29,12},
{409600001,167410651,29,17},
{409571329,219552238,29,12},
{409485313,56348300,29,14},
{409448449,101190966,29,12},
{409436161,7184926,29,15},
{409415681,313654340,29,12},
{409292801,262386309,29,12},
{409255937,347239135,29,14},
{409251841,80395538,29,12},
{409214977,380224199,29,13},
{409120769,352152570,29,12},
{409055233,42091641,29,12},
{409034753,184247470,29,13},
{408985601,369543131,29,13},
{408969217,276292208,29,13},
{408948737,17852932,29,12},
{408932353,231538421,29,12},
{408764417,404943437,29,14},
{408760321,151665160,29,12},
{408739841,310734017,29,13},
{408662017,242986940,29,12},
{408641537,325466475,29,13},
{408637441,297359583,29,12},
{408616961,222732158,29,16},
{408518657,290838228,29,15},
{408506369,395166893,29,12},
{408502273,151298264,29,14},
{408453121,267974395,29,15},
{408440833,397096475,29,12},
{408403969,367888328,29,14},
{408317953,367798619,29,12},
{408281089,315659263,29,13},
{408260609,320841653,29,12},
{408231937,289893018,29,13},
{408145921,63606948,29,12},
{408137729,46089392,29,12},
{408109057,214382543,29,14},
{408096769,389150128,29,12},
{408051713,299731853,29,13},
{408023041,222196768,29,12},
{407990273,129495909,29,12},
{407961601,381229285,29,16},
{407900161,23986192,29,12},
{407887873,98135317,29,13},
{407863297,176773970,29,15},
{407805953,332106711,29,13},
{407756801,139115520,29,13},
{407678977,168553587,29,12},
{407658497,81731082,29,13},
{407621633,254577970,29,12},
{407617537,365802079,29,14},
{407592961,405325539,29,13},
{407572481,150272588,29,12},
{407531521,46786688,29,12},
{407523329,361924349,29,12},
{407498753,203235143,29,12},
{407408641,347926512,29,12},
{407388161,154659695,29,14},
{407347201,399302839,29,13},
{407298049,283200393,29,13},
{407273473,247786872,29,15},
{407265281,294453990,29,13},
{407228417,235119050,29,12},
{407216129,69614708,29,13},
{407175169,234709879,29,16},
{407162881,238216757,29,12},
{407150593,325614878,29,13},
{407105537,389640291,29,12},
{407064577,333759669,29,12},
{407031809,325159231,29,12},
{407019521,401950204,29,13},
{407007233,236643469,29,12},
{406941697,102109532,29,12},
{406896641,99741886,29,14},
{406818817,95128889,29,12},
{406806529,324336932,29,13},
{406695937,63655243,29,12},
{406675457,40608255,29,13},
{406659073,143886680,29,13},
{406609921,19734679,29,13},
{406589441,11345265,29,12},
{406511617,16425636,29,13},
{406499329,309072342,29,12},
{406425601,209180619,29,12},
{406327297,113014907,29,12},
{406315009,352756827,29,13},
{406245377,330105408,29,12},
{406228993,214485193,29,12},
{406208513,213161580,29,14},
{406183937,99649998,29,13},
{406179841,140581542,29,12},
{406085633,103783821,29,13},
{406024193,13789165,29,12},
{405975041,297362361,29,12},
{405921793,55250975,29,13},
{405864449,341728236,29,16},
{405811201,234291270,29,12},
{405803009,181494669,29,12},
{405774337,389057161,29,13},
{405688321,261614054,29,12},
{405614593,365959963,29,12},
{405577729,265684343,29,13},
{405508097,101632570,29,12},
{405442561,241933783,29,12},
{405368833,302162086,29,12},
{405282817,236084750,29,13},
{405270529,187414768,29,12},
{405258241,288831662,29,14},
{405196801,59272764,29,12},
{405135361,86589979,29,13},
{405065729,244410294,29,12},
{405037057,131801677,29,13},
{405004289,195108150,29,13},
{404992001,277036213,29,12},
{404979713,93314708,29,15},
{404881409,204837065,29,17},
{404828161,141943256,29,12},
{404807681,159908418,29,13},
{404717569,187757574,29,15},
{404623361,132164788,29,12},
{404611073,928831,29,13},
{404570113,86458601,29,14},
{404561921,224033135,29,13},
{404533249,321457487,29,12},
{404484097,52363689,29,12},
{404398081,13225868,29,13},
{404336641,175874665,29,12},
{404316161,314301940,29,13},
{404279297,247871845,29,12},
{404226049,61340032,29,19},
{404205569,140809539,29,12},
{404193281,240521165,29,15},
{404152321,62960300,29,13},
{404144129,59786030,29,14},
{403947521,370765455,29,14},
{403910657,328247577,29,12},
{403906561,100153122,29,13},
{403894273,306274524,29,12},
{403886081,304279372,29,12},
{403873793,5890610,29,13},
{403849217,142820956,29,14},
{403836929,318428391,29,12},
{403795969,337590138,29,12},
{403771393,243918483,29,12},
{403709953,204449665,29,13},
{403685377,116374540,29,14},
{403673089,135544847,29,12},
{403603457,52787530,29,15},
{403550209,350585786,29,12},
{403517441,45493443,29,12},
{403505153,24140532,29,16},
{403480577,327544988,29,13},
{403427329,138165127,29,12},
{403304449,284401438,29,12},
{403279873,186574620,29,12},
{403271681,132540493,29,12},
{403259393,98728540,29,14},
{403218433,280858576,29,13},
{403120129,377592241,29,13},
{402984961,20410435,29,12},
{402890753,293792730,29,13},
{402841601,100828499,29,13},
{402739201,241205648,29,12},
{402731009,246076914,29,12},
{402706433,213068737,29,12},
{402681857,131104360,29,12},
{402583553,135411324,29,12},
{402558977,165506802,29,12},
{402542593,183970408,29,12},
{402460673,322344913,29,12},
{402423809,268970061,29,15},
{402419713,317925106,29,12},
{402374657,153023244,29,14},
{402362369,13876554,29,12},
{402300929,63064002,29,13},
{402296833,57163270,29,12},
{402251777,291256974,29,13},
{402190337,290249229,29,12},
{402186241,54270332,29,13},
{402173953,59282226,29,12},
{402116609,134310468,29,12},
{402104321,231089066,29,13},
{402001921,293718183,29,12},
{401993729,396960128,29,12},
{401952769,26906331,29,12},
{401940481,163566529,29,13},
{401928193,374673819,29,12},
{401870849,238284776,29,12},
{401817601,230682610,29,14},
{401760257,220895832,29,13},
{401657857,163636769,29,12},
{401596417,172346119,29,13},
{401563649,56431032,29,13},
{401473537,364401028,29,17},
{401428481,261900582,29,12},
{401399809,275113451,29,13},
{401350657,218396508,29,13},
{401330177,234759370,29,12},
{401313793,195919280,29,12},
{401252353,364197900,29,13},
{401190913,153872370,29,12},
{401141761,135957383,29,12},
{401108993,65826366,29,12},
{401104897,395230663,29,13},
{401047553,113592426,29,15},
{401022977,134627441,29,13},
{401010689,325741527,29,12},
{400969729,276360703,29,12},
{400961537,28807366,29,12},
{400838657,329351487,29,12},
{400834561,195732457,29,14},
{400826369,296819167,29,13},
{400797697,391734742,29,12},
{400785409,9083330,29,15},
{400777217,275413228,29,13},
{400678913,283001712,29,13},
{400642049,356698414,29,12},
{400637953,96893233,29,14},
{400613377,393812380,29,13},
{400588801,309375562,29,15},
{400551937,374814049,29,12},
{400470017,25227876,29,12},
{400465921,86349288,29,13},
{400416769,100633799,29,13},
{400404481,97183211,29,12},
{400396289,37924319,29,12},
{400384001,47807614,29,13},
{400281601,166003216,29,12},
{400273409,18703819,29,12},
{400211969,62668764,29,14},
{400187393,224338949,29,13},
{400097281,302294974,29,16},
{400076801,185074638,29,12},
{400035841,380130071,29,12},
{399974401,210395363,29,13},
{399966209,371130889,29,16},
{399937537,389661320,29,12},
{399925249,295849841,29,13},
{399892481,148703093,29,13},
{399876097,226050065,29,13},
{399851521,225136155,29,14},
{399839233,81611994,29,12},
{399757313,336183274,29,12},
{399716353,270595174,29,12},
{399609857,322622830,29,12},
{399572993,346094432,29,16},
{399507457,273023461,29,20},
{399495169,191833608,29,12},
{399421441,144808302,29,12},
{399175681,262103402,29,12},
{399155201,378982218,29,13},
{399126529,343914319,29,12},
{399056897,346387870,29,13},
{399044609,106454132,29,12},
{399032321,78703580,29,14},
{398942209,249105425,29,13},
{398872577,266701804,29,12},
{398860289,21319384,29,13},
{398811137,43374165,29,13},
{398675969,155971775,29,12},
{398548993,170846787,29,13},
{398512129,286666507,29,12},
{398499841,392244862,29,13},
{398491649,265527689,29,15},
{398487553,360135008,29,12},
{398442497,227410879,29,14},
{398405633,41250193,29,12},
{398401537,33392402,29,13},
{398254081,1180233,29,13},
{398245889,325701589,29,14},
{398241793,68108681,29,12},
{398233601,48371032,29,12},
{398110721,298297513,29,12},
{398098433,63575210,29,15},
{398094337,397002260,29,12},
{398000129,50370080,29,16},
{397996033,375077806,29,12},
{397987841,86794686,29,12},
{397938689,41650759,29,12},
{397873153,189414802,29,12},
{397852673,227193403,29,14},
{397836289,317444469,29,15},
{397766657,295625339,29,12},
{397701121,339416614,29,12},
{397692929,373418634,29,12},
{397582337,256366948,29,13},
{397578241,283285235,29,12},
{397570049,225830236,29,12},
{397422593,385812566,29,12},
{397406209,293904807,29,12},
{397312001,123436987,29,15},
{397271041,167620262,29,13},
{397258753,133629836,29,12},
{397238273,115354391,29,13},
{397209601,10990072,29,12},
{397078529,152783943,29,12},
{396967937,116069117,29,14},
{396963841,259981850,29,12},
{396955649,167728535,29,12},
{396926977,353605348,29,13},
{396914689,193252761,29,12},
{396869633,96605062,29,14},
{396783617,327742590,29,12},
{396779521,1832863,29,13},
{396742657,219333938,29,12},
{396685313,17180421,29,12},
{396619777,60271817,29,12},
{396595201,234867289,29,12},
{396574721,285200036,29,14},
{396546049,39413389,29,12},
{396537857,265430996,29,12},
{396341249,383322379,29,12},
{396337153,50262245,29,13},
{396312577,216027065,29,14},
{396292097,288311998,29,12},
{396238849,114160094,29,13},
{396230657,15018015,29,17},
{396193793,309191652,29,12},
{396169217,46170381,29,12},
{396152833,141178045,29,12},
{396083201,11565137,29,14},
{396066817,22934974,29,15},
{396021761,133022875,29,12},
{396009473,257639109,29,13},
{395993089,49870286,29,13},
{395968513,9136611,29,17},
{395960321,220092849,29,13},
{395911169,297706695,29,13},
{395837441,231447747,29,19},
{395821057,287937922,29,14},
{395800577,304093110,29,12},
{395776001,172199907,29,12},
{395763713,53898780,29,13},
{395747329,230893731,29,13},
{395702273,363037278,29,12},
{395677697,292843822,29,12},
{395636737,229371938,29,12},
{395591681,369119146,29,14},
{395517953,63607174,29,13},
{395493377,67457450,29,14},
{395481089,354542872,29,12},
{395431937,298276146,29,12},
{395419649,168895462,29,13},
{395366401,159391234,29,12},
{395284481,360803485,29,12},
{395272193,27407192,29,13},
{395223041,118326235,29,13},
{395194369,170202624,29,12},
{395071489,338440563,29,12},
{395046913,257486679,29,12},
{394997761,370719706,29,12},
{394985473,369117951,29,16},
{394977281,321472351,29,13},
{394960897,306274377,29,13},
{394915841,171727404,29,12},
{394899457,201818683,29,12},
{394878977,347686266,29,13},
{394801153,390795662,29,12},
{394743809,279838247,29,12},
{394719233,235618967,29,12},
{394715137,43349007,29,13},
{394657793,52836761,29,17},
{394653697,166423592,29,12},
{394629121,276496727,29,12},
{394555393,303299598,29,12},
{394547201,353694916,29,12},
{394534913,539841,29,13},
{394485761,345128663,29,13},
{394424321,209873109,29,12},
{394387457,15172011,29,13},
{394371073,222608941,29,13},
{394285057,47278119,29,12},
{394088449,141422204,29,12},
{394080257,360574515,29,12},
{394076161,16559483,29,13},
{394018817,8155239,29,14},
{393932801,168032690,29,12},
{393895937,72331996,29,13},
{393859073,270525913,29,12},
{393854977,326140662,29,14},
{393809921,47544663,29,12},
{393797633,372134015,29,13},
{393793537,249613254,29,12},
{393781249,307599693,29,13},
{393736193,181755134,29,12},
{393707521,343995358,29,15},
{393699329,156948411,29,13},
{393695233,344519215,29,12},
{393584641,58766313,29,13},
{393572353,35318056,29,12},
{393515009,103125896,29,12},
{393510913,385579379,29,15},
{393412609,242602328,29,16},
{393342977,141706027,29,12},
{393244673,94553819,29,12},
{393220097,236396374,29,12},
{393142273,137691484,29,13},
{393121793,226861156,29,12},
{393105409,55917659,29,12},
{393023489,239089433,29,12},
{392994817,362054942,29,13},
{392949761,199855087,29,12},
{392908801,185710828,29,12},
{392871937,119365354,29,14},
{392851457,350509535,29,12},
{392847361,141881833,29,13},
{392814593,392658982,29,13},
{392790017,21642249,29,15},
{392777729,29214274,29,12},
{392765441,167969142,29,13},
{392724481,349877927,29,15},
{392626177,244333917,29,16},
{392568833,327852276,29,13},
{392552449,175260963,29,13},
{392507393,387153765,29,12},
{392466433,342549071,29,12},
{392417281,39414068,29,12},
{392409089,76439742,29,12},
{392368129,370782594,29,12},
{392298497,162912725,29,17},
{392294401,234779593,29,12},
{392261633,257542148,29,12},
{392097793,77227985,29,12},
{392052737,295807270,29,14},
{392040449,47555591,29,12},
{391917569,136946032,29,12},
{391831553,331686735,29,13},
{391782401,252106917,29,13},
{391708673,309711246,29,16},
{391643137,134412795,29,19},
{391622657,187925893,29,12},
{391606273,324334326,29,12},
{391557121,354104658,29,12},
{391520257,45652737,29,13},
{391499777,277433610,29,12},
{391487489,204547702,29,13},
{391462913,192939865,29,14},
{391413761,362390469,29,15},
{391376897,80015208,29,12},
{391241729,85802554,29,13},
{391094273,221511269,29,13},
{391069697,42177411,29,14},
{391065601,188639077,29,12},
{391032833,242787463,29,12},
{390991873,22321859,29,12},
{390955009,178511134,29,15},
{390946817,69123830,29,13},
{390873089,240610879,29,14},
{390868993,20003553,29,12},
{390860801,31291643,29,12},
{390832129,388432107,29,13},
{390770689,128161456,29,12},
{390721537,164851867,29,12},
{390684673,247449816,29,13},
{390598657,167997622,29,12},
{390586369,192168627,29,13},
{390561793,335799998,29,15},
{390512641,119928090,29,14},
{390438913,87216732,29,13},
{390402049,252226258,29,12},
{390369281,11892802,29,12},
{390332417,212086784,29,18},
{390328321,96373888,29,12},
{390320129,145665858,29,12},
{390316033,336781157,29,14},
{390295553,74948703,29,12},
{390270977,53076451,29,12},
{390266881,156226365,29,16},
{390234113,306490955,29,15},
{390168577,167099027,29,15},
{390148097,68375233,29,12},
{390131713,156320363,29,12},
{390062081,319731157,29,13},
{390008833,271105829,29,12},
{389890049,87827987,29,14},
{389840897,285062176,29,15},
{389828609,211269382,29,12},
{389816321,299696042,29,13},
{389775361,275610362,29,15},
{389652481,11979205,29,13},
{389615617,72862742,29,12},
{389603329,312958154,29,13},
{389554177,337172304,29,13},
{389468161,74782107,29,12},
{389435393,17621991,29,12},
{389410817,90552283,29,12},
{389394433,112047847,29,12},
{389369857,250529501,29,12},
{389349377,310409746,29,16},
{389308417,130052537,29,13},
{389210113,195348305,29,13},
{389201921,63019689,29,14},
{389128193,10051184,29,13},
{389062657,275469943,29,13},
{388980737,19265580,29,13},
{388976641,300791167,29,12},
{388964353,122068052,29,13},
{388878337,379951025,29,12},
{388804609,259964915,29,12},
{388771841,22494430,29,12},
{388722689,314686568,29,12},
{388694017,251469564,29,16},
{388669441,82411737,29,13},
{388657153,302860703,29,12},
{388632577,42125329,29,12},
{388612097,240754768,29,14},
{388526081,388364417,29,12},
{388509697,97701152,29,12},
{388476929,103394299,29,12},
{388452353,122065462,29,12},
{388403201,201959818,29,12},
{388366337,145718897,29,17},
{388292609,140459102,29,13},
{388288513,212839522,29,12},
{388268033,66806580,29,15},
{388251649,163067056,29,14},
{388177921,176985576,29,13},
{388165633,198232242,29,12},
{388141057,125987049,29,12},
{388104193,130934812,29,17},
{388096001,66925362,29,13},
{388034561,95701623,29,12},
{388022273,156963380,29,14},
{388018177,32560506,29,12},
{387981313,78041359,29,13},
{387973121,194105329,29,21},
{387944449,134284377,29,12},
{387936257,7840608,29,12},
{387895297,84234310,29,12},
{387833857,2897490,29,13},
{387809281,105030157,29,15},
{387772417,298141733,29,12},
{387760129,129515162,29,14},
{387686401,54518325,29,13},
{387674113,15107122,29,12},
{387665921,147108832,29,12},
{387567617,347609808,29,12},
{387563521,79043622,29,14},
{387493889,88463577,29,12},
{387452929,91648594,29,12},
{387444737,93663885,29,12},
{387432449,230021090,29,14},
{387403777,200906464,29,12},
{387284993,9802914,29,15},
{387260417,158760328,29,13},
{387194881,163818090,29,13},
{387186689,48397551,29,18},
{387121153,77378186,29,16},
{387100673,128474292,29,12},
{387084289,333205092,29,12},
{387076097,204932961,29,12},
{387059713,228829481,29,12},
{387035137,99027880,29,12},
{386998273,353218033,29,13},
{386850817,19875593,29,13},
{386826241,42151501,29,15},
{386813953,100442706,29,12},
{386805761,11328859,29,12},
{386764801,328883573,29,12},
{386727937,323561350,29,16},
{386707457,54041235,29,12},
{386691073,258500660,29,12},
{386621441,144847942,29,13},
{386605057,355205547,29,13},
{386560001,124738592,29,12},
{386543617,333858892,29,12},
{386498561,291622325,29,15},
{386457601,149119413,29,13},
{386449409,236950719,29,14},
{386400257,381142775,29,19},
{386396161,223799817,29,12},
{386383873,7369894,29,14},
{386359297,361789163,29,13},
{386347009,79625936,29,12},
{386334721,143829323,29,16},
{386240513,201957243,29,12},
{386224129,309971880,29,12},
{386129921,139469874,29,13},
{386088961,43558413,29,14},
{386076673,204883803,29,12},
{386052097,159102536,29,12},
{386039809,75110160,29,15},
{386019329,213522822,29,12},
{385994753,370830736,29,12},
{385970177,199094026,29,12},
{385957889,6719074,29,14},
{385916929,331340359,29,13},
{385871873,376533086,29,12},
{385773569,129012191,29,12},
{385761281,101431773,29,14},
{385646593,246523703,29,15},
{385609729,174946118,29,12},
{385597441,93319014,29,14},
{385536001,112584130,29,12},
{385499137,199012106,29,14},
{385474561,31721286,29,13},
{385425409,15990397,29,13},
{385400833,230411416,29,14},
{385392641,81317011,29,13},
{385380353,366606340,29,12},
{385314817,263055372,29,12},
{385294337,308544728,29,13},
{385257473,82816922,29,12},
{385220609,89620496,29,17},
{385097729,379416501,29,13},
{384983041,165666158,29,13},
{384970753,112668259,29,12},
{384962561,254700843,29,12},
{384847873,20857231,29,12},
{384839681,85647528,29,12},
{384737281,322128983,29,13},
{384679937,348692568,29,14},
{384626689,113222349,29,12},
{384503809,340461813,29,12},
{384483329,209423308,29,14},
{384479233,99634798,29,12},
{384454657,102628638,29,12},
{384397313,367978541,29,12},
{384368641,138273353,29,16},
{384331777,285296368,29,12},
{384249857,22686755,29,12},
{384212993,238484741,29,13},
{384208897,266938189,29,12},
{384184321,378252381,29,12},
{384176129,244230220,29,12},
{384151553,134958916,29,12},
{384122881,169408205,29,14},
{384102401,323800232,29,12},
{384065537,67606419,29,13},
{384061441,236537549,29,12},
{384040961,358220155,29,18},
{384012289,88269026,29,12},
{383987713,131824706,29,12},
{383979521,173473879,29,12},
{383930369,215376002,29,12},
{383881217,121240498,29,12},
{383778817,312184131,29,21},
{383705089,334967574,29,13},
{383635457,146520921,29,12},
{383631361,199952088,29,14},
{383610881,240942608,29,12},
{383557633,308627621,29,13},
{383520769,111718787,29,12},
{383438849,97793953,29,12},
{383348737,114321485,29,12},
{383336449,67222231,29,14},
{383303681,192181681,29,14},
{383287297,18612028,29,15},
{383266817,219030145,29,12},
{383242241,132297159,29,12},
{383205377,124957698,29,14},
{383201281,378117381,29,12},
{383193089,206269666,29,12},
{383164417,245243640,29,13},
{383152129,37554676,29,12},
{383127553,83062106,29,12},
{383102977,141439288,29,12},
{383057921,55057771,29,16},
{383016961,17750929,29,13},
{383004673,147172139,29,12},
{382984193,14189469,29,13},
{382898177,278831837,29,12},
{382894081,208033001,29,15},
{382836737,47255237,29,13},
{382832641,219350810,29,12},
{382775297,111705157,29,12},
{382758913,233783577,29,12},
{382750721,64269898,29,12},
{382734337,191096566,29,12},
{382722049,319601130,29,13},
{382713857,258286077,29,14},
{382660609,325619542,29,12},
{382574593,297859874,29,13},
{382550017,140946308,29,14},
{382464001,313199477,29,12},
{382455809,150279534,29,12},
{382414849,165012739,29,12},
{382406657,327139740,29,12},
{382402561,265654319,29,16},
{382271489,64453736,29,16},
{382267393,232994295,29,12},
{382259201,331985303,29,12},
{382124033,4313301,29,14},
{382119937,350131636,29,12},
{382095361,349377969,29,12},
{382083073,268161622,29,13},
{382046209,194617606,29,12},
{381915137,100611083,29,12},
{381902849,268035379,29,13},
{381898753,61355084,29,12},
{381874177,316954469,29,12},
{381861889,264652389,29,14},
{381816833,67074601,29,12},
{381779969,343373494,29,15},
{381767681,218581852,29,12},
{381751297,190666952,29,12},
{381739009,352605534,29,13},
{381693953,379528564,29,12},
{381689857,2277847,29,13},
{381616129,179971654,29,16},
{381607937,330147149,29,13},
{381603841,9974176,29,12},
{381554689,9279554,29,12},
{381546497,80690244,29,12},
{381460481,223140166,29,13},
{381407233,260320435,29,12},
{381382657,153909779,29,12},
{381349889,62229785,29,12},
{381345793,337687002,29,13},
{381321217,120291421,29,15},
{381214721,58863838,29,13},
{381177857,365338553,29,12},
{381165569,64140688,29,13},
{380968961,118531416,29,13},
{380952577,296578158,29,13},
{380915713,236983015,29,12},
{380866561,63562732,29,12},
{380858369,227012460,29,12},
{380805121,238123052,29,13},
{380743681,275094300,29,12},
{380735489,365194014,29,12},
{380723201,135409233,29,13},
{380706817,70617739,29,13},
{380571649,125854913,29,12},
{380510209,182995519,29,13},
{380497921,157169586,29,12},
{380489729,310195855,29,12},
{380448769,123557693,29,12},
{380436481,245148687,29,16},
{380428289,57085091,29,13},
{380379137,237290862,29,13},
{380325889,308517822,29,12},
{380313601,158233529,29,13},
{380256257,206402779,29,14},
{380252161,116654254,29,12},
{380231681,26319667,29,13},
{380190721,304884759,29,14},
{380116993,70828342,29,13},
{380092417,24190580,29,14},
{379994113,179783524,29,14},
{379924481,48356737,29,12},
{379883521,290225901,29,12},
{379875329,272936269,29,12},
{379863041,264941618,29,14},
{379822081,27048719,29,13},
{379801601,304923709,29,12},
{379772929,274141888,29,13},
{379666433,297150836,29,14},
{379580417,215460539,29,12},
{379564033,14689546,29,12},
{379506689,185666604,29,12},
{379502593,356391661,29,14},
{379457537,347902879,29,12},
{379453441,28812134,29,17},
{379379713,210697396,29,13},
{379342849,48965607,29,12},
{379318273,215712769,29,12},
{379236353,75932864,29,12},
{379195393,36834796,29,12},
{379170817,332663484,29,12},
{379113473,92767424,29,12},
{379084801,116317079,29,13},
{379076609,100372525,29,14},
{379035649,337052859,29,13},
{378912769,37049516,29,14},
{378843137,69803297,29,12},
{378830849,191185296,29,15},
{378826753,17216242,29,12},
{378789889,335231846,29,13},
{378769409,316468085,29,12},
{378757121,227828525,29,13},
{378716161,26789079,29,14},
{378707969,356394194,29,13},
{378617857,72894876,29,14},
{378597377,231538369,29,12},
{378556417,38361888,29,12},
{378531841,176648770,29,12},
{378519553,166738659,29,14},
{378499073,270504048,29,12},
{378474497,289179972,29,12},
{378470401,359637846,29,16},
{378449921,62774357,29,12},
{378433537,98421207,29,12},
{378400769,334293350,29,12},
{378335233,271857009,29,12},
{378286081,304294771,29,12},
{378204161,337710916,29,12},
{378191873,139502789,29,14},
{378167297,162958969,29,13},
{378114049,139475547,29,12},
{378089473,122128915,29,12},
{378044417,71811263,29,15},
{378032129,94090260,29,12},
{378028033,88281361,29,14},
{378019841,348449495,29,13},
{377958401,146105516,29,12},
{377946113,360899948,29,16},
{377909249,335385175,29,12},
{377880577,14014993,29,17},
{377860097,168886860,29,12},
{377823233,57013654,29,13},
{377745409,302732821,29,12},
{377696257,176062020,29,12},
{377671681,158765037,29,12},
{377638913,276437147,29,12},
{377622529,274687884,29,12},
{377610241,279366209,29,13},
{377561089,162466111,29,13},
{377540609,374163478,29,12},
{377528321,341870173,29,13},
{377516033,107653769,29,12},
{377487361,369149882,29,23},
{377438209,253422911,29,14},
{377430017,336945891,29,13},
{377352193,58646107,29,12},
{377344001,146645232,29,12},
{377303041,355003914,29,12},
{377245697,185045713,29,12},
{377208833,355004603,29,14},
{377192449,109026717,29,15},
{377167873,165570192,29,13},
{376987649,305792602,29,13},
{376963073,223104310,29,19},
{376934401,314292986,29,12},
{376901633,205461165,29,12},
{376840193,50764704,29,13},
{376823809,279165734,29,13},
{376762369,76633938,29,12},
{376750081,48689456,29,14},
{376692737,331556009,29,13},
{376668161,279422516,29,15},
{376569857,204467173,29,17},
{376557569,223722507,29,12},
{376532993,259624800,29,12},
{376528897,59986003,29,13},
{376492033,126247261,29,12},
{376446977,323996393,29,13},
{376422401,340730323,29,14},
{376332289,310455575,29,13},
{376307713,103962266,29,17},
{376270849,172517145,29,12},
{376238081,273049960,29,12},
{376209409,44659109,29,15},
{376066049,159275192,29,12},
{376037377,218917224,29,13},
{375975937,42580209,29,12},
{375963649,100279831,29,14},
{375955457,108346324,29,13},
{375930881,39984869,29,14},
{375758849,76865535,29,13},
{375734273,16399561,29,14},
{375717889,233744430,29,16},
{375697409,16912070,29,12},
{375693313,33055418,29,13},
{375595009,347954614,29,13},
{375586817,91821727,29,16},
{375533569,25078152,29,12},
{375525377,222746767,29,12},
{375521281,279044184,29,17},
{375422977,299510803,29,15},
{375410689,56288810,29,12},
{375377921,169508995,29,12},
{375328769,67668254,29,12},
{375279617,76994428,29,12},
{375263233,229972866,29,12},
{375205889,132293659,29,12},
{375177217,281437382,29,14},
{375119873,355640846,29,13},
{375029761,185337306,29,15},
{374980609,373713719,29,14},
{374919169,307717366,29,12},
{374906881,88524016,29,13},
{374886401,149718854,29,12},
{374837249,315699226,29,12},
{374751233,82753430,29,14},
{374734849,363915564,29,17},
{374689793,193128944,29,12},
{374665217,339556878,29,12},
{374611969,92545328,29,13},
{374603777,10905801,29,18},
{374599681,274018713,29,12},
{374591489,213512806,29,12},
{374579201,207214936,29,13},
{374562817,204172641,29,13},
{374530049,307421470,29,13},
{374464513,121920943,29,13},
{374407169,154401485,29,16},
{374378497,279565647,29,12},
{374353921,138822470,29,12},
{374321153,25886765,29,12},
{374317057,295085338,29,13},
{374296577,311333239,29,12},
{374259713,346263685,29,14},
{374243329,101585940,29,15},
{374235137,202379594,29,13},
{374173697,97045206,29,12},
{374112257,267509342,29,15},
{374099969,251518141,29,12},
{374013953,209745299,29,16},
{373985281,367374531,29,12},
{373977089,5069638,29,12},
{373972993,40765680,29,13},
{373841921,312163306,29,13},
{373813249,211131293,29,12},
{373780481,196130696,29,12},
{373739521,139278321,29,12},
{373731329,264257810,29,12},
{373702657,120077459,29,14},
{373665793,81246989,29,12},
{373641217,48839346,29,12},
{373628929,341909726,29,13},
{373608449,222421677,29,12},
{373522433,30056316,29,15},
{373518337,322209664,29,12},
{373460993,358285881,29,12},
{373444609,57918270,29,12},
{373436417,295208149,29,12},
{373432321,348370429,29,13},
{373399553,226244446,29,13},
{373350401,297185077,29,13},
{373313537,225675367,29,12},
{373309441,86485902,29,14},
{373272577,349598,29,12},
{373239809,78332215,29,12},
{373153793,257443816,29,13},
{373129217,87701167,29,15},
{373088257,105125405,29,13},
{373055489,319638559,29,13},
{373043201,211519522,29,12},
{373002241,218878534,29,12},
{372969473,317341974,29,12},
{372965377,357070689,29,16},
{372940801,357304428,29,13},
{372830209,158215924,29,12},
{372809729,155240638,29,13},
{372756481,141787654,29,12},
{372723713,47262676,29,12},
{372719617,247897927,29,14},
{372699137,28133117,29,12},
{372662273,365389179,29,13},
{372658177,4777225,29,12},
{372621313,78989956,29,14},
{372596737,251406371,29,13},
{372584449,145388601,29,12},
{372293633,109117769,29,14},
{372289537,16581448,29,12},
{372264961,354994076,29,12},
{372232193,52262544,29,12},
{372228097,219844653,29,14},
{372191233,176561788,29,12},
{372183041,227177431,29,12},
{372121601,363939337,29,13},
{372023297,312100328,29,13},
{372011009,151914704,29,12},
{371961857,159205990,29,12},
{371945473,78718236,29,12},
{371875841,40407108,29,13},
{371863553,197395094,29,12},
{371847169,203329702,29,12},
{371802113,302524150,29,14},
{371777537,15636022,29,13},
{371761153,89072690,29,13},
{371740673,110940054,29,12},
{371724289,199065996,29,12},
{371617793,272427663,29,12},
{371593217,308733473,29,12},
{371589121,317731487,29,17},
{371531777,180815691,29,13},
{371494913,35522750,29,12},
{371458049,355334478,29,18},
{371408897,370522506,29,14},
{371392513,114235559,29,16},
{371322881,233670438,29,12},
{371232769,189081843,29,12},
{371208193,108470475,29,12},
{371171329,154541827,29,13},
{371150849,7895038,29,12},
{371077121,362539298,29,12},
{371060737,254852002,29,12},
{371015681,226878156,29,14},
{370999297,91102082,29,16},
{370966529,361656284,29,15},
{370937857,253914480,29,12},
{370917377,327793556,29,14},
{370913281,247717028,29,12},
{370905089,12355150,29,12},
{370855937,18457295,29,12},
{370851841,111461344,29,14},
{370819073,106673576,29,14},
{370778113,239945102,29,13},
{370728961,218439184,29,13},
{370692097,183204750,29,12},
{370634753,126875834,29,12},
{370630657,104620714,29,13},
{370544641,229381664,29,12},
{370532353,215571440,29,13},
{370487297,108005713,29,12},
{370462721,272482998,29,12},
{370434049,267406612,29,13},
{370339841,222953612,29,12},
{370311169,60856791,29,15},
{370286593,226359592,29,13},
{370278401,159260337,29,17},
{370249729,189974186,29,12},
{370241537,256908898,29,12},
{370216961,353617822,29,12},
{370155521,13648861,29,13},
{370143233,193809100,29,12},
{370126849,63486342,29,12},
{370118657,44890773,29,12},
{370057217,148678856,29,13},
{370053121,100886690,29,12},
{370044929,50136918,29,12},
{370040833,229243288,29,13},
{369983489,76551801,29,15},
{369954817,282104324,29,12},
{369786881,290123513,29,15},
{369770497,149173797,29,14},
{369737729,281948893,29,14},
{369733633,245809910,29,12},
{369725441,169232781,29,12},
{369684481,282042239,29,12},
{369602561,152275624,29,12},
{369561601,116514108,29,12},
{369426433,272925726,29,16},
{369381377,88211752,29,12},
{369364993,313757665,29,12},
{369283073,295697046,29,12},
{369278977,82391685,29,14},
{369254401,199899758,29,13},
{369180673,49925560,29,14},
{369172481,262953927,29,13},
{369160193,205813936,29,12},
{369135617,295122371,29,12},
{369070081,59822249,29,12},
{369037313,206368386,29,12},
{369008641,281805243,29,13},
{369000449,63608762,29,15},
{368885761,84406196,29,14},
{368873473,324303061,29,12},
{368848897,216695328,29,12},
{368812033,319128970,29,13},
{368754689,81901383,29,14},
{368664577,65982630,29,13},
{368652289,13588684,29,12},
{368627713,179746376,29,12},
{368558081,180460186,29,14},
{368541697,333066240,29,15},
{368529409,304830058,29,12},
{368521217,150910867,29,12},
{368435201,247478336,29,13},
{368394241,356876838,29,14},
{368336897,137075739,29,13},
{368300033,290532156,29,12},
{368295937,238884831,29,14},
{368283649,3226687,29,12},
{368263169,321751570,29,14},
{368250881,263388906,29,12},
{368238593,111813717,29,13},
{368222209,172668771,29,13},
{368214017,72685986,29,15},
{368160769,308751881,29,12},
{368111617,11404615,29,12},
{368017409,47787759,29,15},
{367976449,105499413,29,13},
{367968257,277472131,29,14},
{367931393,364326223,29,12},
{367894529,278924570,29,13},
{367841281,178559431,29,12},
{367808513,161194380,29,12},
{367792129,236896626,29,12},
{367747073,163354649,29,13},
{367722497,297991601,29,16},
{367718401,349642433,29,12},
{367595521,191639098,29,12},
{367575041,224969429,29,14},
{367538177,140881178,29,12},
{367501313,215038587,29,13},
{367497217,68939837,29,12},
{367476737,367365248,29,14},
{367288321,198635974,29,13},
{367214593,3598435,29,14},
{367190017,297116522,29,13},
{367132673,48940198,29,17},
{367116289,54463719,29,14},
{367108097,30011780,29,13},
{367091713,234437883,29,13},
{367030273,144994988,29,12},
{367005697,301191870,29,12},
{366993409,264592118,29,13},
{366972929,176561458,29,12},
{366960641,155624603,29,13},
{366862337,166330468,29,13},
{366850049,62686971,29,12},
{366764033,300913080,29,13},
{366759937,49439320,29,12},
{366747649,230280308,29,13},
{366723073,208130987,29,14},
{366551041,247119287,29,13},
{366542849,253422956,29,16},
{366530561,154923809,29,12},
{366469121,219278432,29,13},
{366440449,137426174,29,12},
{366415873,327220315,29,12},
{366391297,89613090,29,12},
{366379009,132397044,29,15},
{366333953,306220678,29,12},
{366317569,318091594,29,12},
{366297089,128616874,29,14},
{366284801,132294003,29,12},
{366272513,164064775,29,13},
{366206977,325237104,29,13},
{366186497,243000209,29,12},
{366120961,69275443,29,12},
{366088193,217160622,29,12},
{366026753,319818825,29,13},
{365985793,212420023,29,15},
{365940737,187698431,29,12},
{365928449,19849936,29,13},
{365875201,176463404,29,12},
{365867009,348764451,29,12},
{365813761,100581251,29,13},
{365731841,128150167,29,13},
{365715457,175867899,29,13},
{365694977,238921224,29,12},
{365682689,126172429,29,13},
{365670401,315828242,29,12},
{365608961,108517302,29,14},
{365580289,297938892,29,12},
{365568001,32056380,29,13},
{365518849,93997316,29,13},
{365178881,45728081,29,12},
{365142017,329641989,29,13},
{365080577,74089032,29,12},
{365002753,218668814,29,15},
{364994561,241698075,29,13},
{364982273,62940703,29,12},
{364871681,343005582,29,15},
{364843009,105878422,29,12},
{364834817,229603886,29,12},
{364830721,97382116,29,13},
{364781569,132161344,29,13},
{364773377,362049321,29,17},
{364720129,272384374,29,12},
{364711937,42851572,29,12},
{364707841,294307842,29,16},
{364687361,300111484,29,12},
{364613633,281547842,29,12},
{364572673,243683727,29,12},
{364523521,80198704,29,12},
{364486657,329460810,29,13},
{364453889,158644685,29,13},
{364449793,119609075,29,12},
{364429313,360739283,29,14},
{364367873,339193638,29,12},
{364351489,232613534,29,12},
{364306433,350258491,29,13},
{364281857,224769972,29,15},
{364240897,228719330,29,13},
{364146689,198269366,29,12},
{364142593,335116049,29,13},
{364093441,2297554,29,13},
{364060673,141353806,29,13},
{364036097,185923360,29,14},
{364023809,172338291,29,12},
{364019713,334206597,29,15},
{364011521,239239822,29,13},
{363974657,51050538,29,12},
{363962369,48572528,29,13},
{363921409,272585431,29,16},
{363896833,260689895,29,13},
{363790337,6365059,29,16},
{363778049,215790762,29,12},
{363712513,149422555,29,12},
{363704321,123143172,29,12},
{363667457,100407448,29,13},
{363601921,123497766,29,13},
{363491329,250930488,29,12},
{363368449,63642934,29,12},
{363347969,15024525,29,14},
{363282433,116144205,29,14},
{363220993,239610118,29,12},
{363171841,234090794,29,12},
{363089921,161772027,29,12},
{362979329,302553091,29,13},
{362975233,146584022,29,12},
{362938369,182662546,29,17},
{362917889,308554613,29,12},
{362893313,176623368,29,12},
{362844161,184345215,29,12},
{362766337,169042708,29,13},
{362729473,251266550,29,12},
{362692609,74309982,29,14},
{362680321,149956008,29,12},
{362569729,315596039,29,13},
{362500097,44259228,29,12},
{362446849,300367069,29,15},
{362385409,34633524,29,12},
{362360833,261761290,29,12},
{362311681,47105421,29,12},
{362303489,289406632,29,12},
{362254337,115522253,29,12},
{362250241,211804647,29,15},
{362201089,279686222,29,14},
{362176513,323999976,29,13},
{362119169,203558998,29,15},
{362078209,233290579,29,13},
{362045441,255419585,29,13},
{362033153,359610935,29,12},
{361971713,108864319,29,14},
{361943041,65674668,29,12},
{361934849,64813573,29,12},
{361885697,279999623,29,12},
{361844737,303637694,29,12},
{361824257,48843997,29,16},
{361799681,105407024,29,13},
{361771009,89884262,29,12},
{361758721,199699442,29,20},
{361725953,67248253,29,15},
{361684993,347925882,29,13},
{361676801,97010700,29,14},
{361648129,248168319,29,12},
{361623553,204516688,29,12},
{361586689,115767047,29,13},
{361553921,143816390,29,13},
{361504769,174840958,29,13},
{361455617,324357275,29,13},
{361418753,28643771,29,12},
{361369601,301339409,29,12},
{361209857,168536238,29,13},
{361172993,76868080,29,12},
{361136129,211585829,29,15},
{361132033,345959125,29,12},
{361095169,83904136,29,13},
{361025537,135133343,29,12},
{360972289,105972866,29,18},
{360951809,35199246,29,12},
{360927233,346777026,29,12},
{360923137,99774992,29,14},
{360878081,248570831,29,12},
{360800257,199667352,29,13},
{360755201,17940690,29,12},
{360701953,153004102,29,13},
{360681473,14276332,29,12},
{360677377,197024472,29,15},
{360665089,326627390,29,12},
{360583169,271012418,29,12},
{360554497,288130608,29,13},
{360534017,201752739,29,12},
{360509441,289056208,29,12},
{360472577,177630437,29,13},
{360411137,273553051,29,12},
{360398849,238470355,29,14},
{360386561,360135820,29,12},
{360370177,6054745,29,12},
{360357889,80652894,29,13},
{360337409,353434687,29,12},
{360333313,56430759,29,14},
{360247297,257346998,29,12},
{360222721,186165974,29,12},
{360124417,315384888,29,12},
{360099841,317841450,29,12},
{360091649,174315928,29,12},
{359976961,299183034,29,12},
{359968769,351982969,29,12},
{359882753,34160208,29,13},
{359854081,39041591,29,12},
{359841793,209949248,29,14},
{359833601,234441409,29,13},
{359796737,129955303,29,12},
{359780353,274937640,29,12},
{359755777,276352764,29,12},
{359710721,267499432,29,14},
{359698433,222437367,29,12},
{359682049,179327299,29,12},
{359661569,332209053,29,20},
{359612417,90279072,29,14},
{359559169,201287654,29,12},
{359546881,141103608,29,14},
{359497729,171792375,29,15},
{359477249,250809560,29,12},
{359452673,306274467,29,12},
{359391233,7909589,29,13},
{359301121,168306121,29,15},
{359202817,128020813,29,16},
{359104513,98914526,29,15},
{359034881,316199858,29,12},
{359018497,47528937,29,12},
{358944769,79933445,29,12},
{358920193,348927702,29,12},
{358899713,255792094,29,13},
{358871041,344707643,29,12},
{358850561,186113103,29,13},
{358821889,187312366,29,12},
{358752257,184946613,29,13},
{358649857,2441700,29,12},
{358604801,222309690,29,13},
{358592513,128648701,29,12},
{358576129,209102094,29,12},
{358555649,122460987,29,13},
{358551553,102079191,29,12},
{358494209,30837755,29,12},
{358359041,137081201,29,13},
{358285313,291024704,29,16},
{358244353,339856799,29,13},
{358236161,337852517,29,14},
{358219777,213070900,29,17},
{358187009,116111404,29,15},
{358146049,300005048,29,13},
{358133761,178226224,29,12},
{358100993,220618810,29,12},
{358096897,157611147,29,13},
{358014977,146927771,29,13},
{357990401,123222564,29,15},
{357900289,132763226,29,13},
{357888001,181066407,29,12},
{357818369,348159477,29,13},
{357756929,21463666,29,12},
{357744641,113575734,29,14},
{357691393,228935882,29,12},
{357683201,224627678,29,12},
{357560321,296582306,29,12},
{357548033,156352507,29,14},
{357543937,95418442,29,12},
{357482497,68531986,29,14},
{357445633,284376499,29,12},
{357408769,12425307,29,13},
{357179393,200658556,29,13},
{357175297,230488889,29,12},
{357142529,70485119,29,12},
{356978689,19496565,29,12},
{356892673,114002988,29,14},
{356782081,278444586,29,12},
{356773889,341420016,29,12},
{356720641,331179004,29,13},
{356687873,108294994,29,13},
{356671489,34269259,29,13},
{356626433,296233964,29,12},
{356610049,302962811,29,12},
{356577281,124242000,29,12},
{356564993,269269098,29,14},
{356536321,321327797,29,12},
{356524033,294101947,29,13},
{356442113,113483520,29,13},
{356413441,339989434,29,12},
{356392961,326494356,29,13},
{356356097,300497949,29,12},
{356343809,304713776,29,13},
{356294657,270727526,29,13},
{356282369,92077915,29,12},
{356233217,293591469,29,12},
{356196353,242201277,29,13},
{356192257,237375345,29,12},
{356179969,160298590,29,13},
{356147201,147170821,29,13},
{356098049,245999997,29,13},
{356024321,50077438,29,15},
{355921921,48744463,29,12},
{355913729,262396543,29,12},
{355909633,92161807,29,14},
{355889153,316163639,29,12},
{355827713,316278280,29,15},
{355811329,331577138,29,14},
{355790849,268282656,29,12},
{355663873,208647311,29,16},
{355594241,122386571,29,12},
{355581953,175617895,29,14},
{355577857,158490146,29,12},
{355565569,88330585,29,15},
{355553281,99502101,29,12},
{355520513,228160565,29,12},
{355504129,224401288,29,12},
{355454977,350126918,29,12},
{355422209,38403467,29,12},
{355225601,57942033,29,12},
{355188737,329377594,29,14},
{355147777,103178261,29,13},
{355123201,345053841,29,14},
{355110913,157099721,29,12},
{355090433,95147037,29,14},
{355086337,14664474,29,12},
{355065857,90384864,29,13},
{355049473,176805991,29,13},
{355024897,18075987,29,14},
{354963457,228990769,29,12},
{354951169,77656526,29,13},
{354930689,265435839,29,12},
{354856961,182131030,29,12},
{354844673,86662075,29,15},
{354828289,199351556,29,14},
{354820097,147933795,29,13},
{354795521,203569623,29,14},
{354766849,158625539,29,12},
{354594817,114130071,29,12},
{354451457,108162862,29,15},
{354447361,63316347,29,12},
{354336769,280225365,29,14},
{354312193,164737481,29,13},
{354242561,246997735,29,12},
{354213889,169903306,29,13},
{354189313,238691218,29,15},
{354168833,116137337,29,12},
{354164737,303344770,29,13},
{354144257,9120549,29,12},
{354107393,100850912,29,14},
{354091009,136789965,29,16},
{354045953,260941007,29,12},
{354029569,324902029,29,12},
{353959937,289117835,29,16},
{353898497,190833443,29,12},
{353886209,283726682,29,13},
{353820673,8179430,29,13},
{353771521,28957653,29,13},
{353710081,234459270,29,12},
{353538049,293378496,29,12},
{353431553,23067819,29,12},
{353427457,230775631,29,13},
{353390593,164112802,29,12},
{353366017,198178177,29,12},
{353304577,210730523,29,16},
{353284097,78460378,29,12},
{353198081,86631880,29,13},
{353124353,106749942,29,14},
{353099777,178536438,29,13},
{352985089,274289074,29,13},
{352972801,21872599,29,12},
{352952321,91761468,29,13},
{352940033,76471105,29,12},
{352935937,81938318,29,13},
{352915457,54423227,29,12},
{352878593,40181823,29,15},
{352837633,308308842,29,13},
{352813057,313835018,29,15},
{352788481,242184150,29,13},
{352755713,68338022,29,13},
{352727041,310157242,29,12},
{352714753,36657100,29,17},
{352616449,25953204,29,15},
{352608257,92558209,29,13},
{352542721,6696897,29,13},
{352473089,249909103,29,12},
{352423937,153220322,29,12},
{352387073,217972383,29,16},
{352276481,40979333,29,12},
{352227329,261277734,29,12},
{352161793,2258343,29,12},
{352141313,326587622,29,14},
{352137217,180865760,29,12},
{352112641,286262777,29,12},
{352079873,299312959,29,12},
{351981569,134783126,29,12},
{351956993,123351229,29,12},
{351866881,89465673,29,12},
{351846401,173806630,29,14},
{351834113,180255121,29,12},
{351809537,198006422,29,12},
{351797249,153736345,29,19},
{351625217,71663003,29,13},
{351612929,160730561,29,12},
{351510529,7287779,29,13},
{351465473,253784787,29,12},
{351404033,110698124,29,17},
{351387649,65688591,29,14},
{351363073,89944479,29,13},
{351240193,106748108,29,15},
{351215617,12183992,29,13},
{351133697,322923377,29,13},
{351092737,54899481,29,14},
{350986241,148034969,29,13},
{350932993,295830229,29,12},
{350863361,8993507,29,14},
{350822401,202685199,29,13},
{350814209,183855444,29,16},
{350752769,53861756,29,12},
{350728193,10856312,29,12},
{350679041,339610023,29,12},
{350617601,136398664,29,17},
{350502913,262551498,29,14},
{350494721,46255299,29,13},
{350457857,190409556,29,12},
{350445569,204474772,29,13},
{350416897,194523574,29,12},
{350384129,139710906,29,12},
{350371841,315291199,29,14},
{350355457,48263582,29,17},
{350318593,251868238,29,12},
{350232577,153279504,29,13},
{350212097,82032370,29,12},
{350199809,62341014,29,13},
{350187521,137773279,29,12},
{350150657,206343748,29,13},
{350134273,109934143,29,13},
{350097409,333461982,29,12},
{350089217,177950730,29,12},
{350011393,116753955,29,14},
{350003201,37638397,29,13},
{349986817,143510230,29,13},
{349962241,70377986,29,18},
{349925377,276772240,29,12},
{349900801,224222566,29,12},
{349863937,83200268,29,15},
{349827073,74325261,29,12},
{349806593,64011329,29,13},
{349720577,309400382,29,12},
{349704193,302941912,29,12},
{349646849,240175450,29,12},
{349642753,291341788,29,13},
{349618177,316632266,29,14},
{349585409,276214266,29,14},
{349519873,37988904,29,14},
{349458433,230863143,29,12},
{349372417,121101468,29,16},
{349315073,115087387,29,13},
{349253633,267820770,29,12},
{349212673,2479009,29,12},
{349188097,9354877,29,12},
{349155329,5010168,29,12},
{349065217,202825728,29,12},
{349052929,309184659,29,13},
{349028353,103161938,29,14},
{349007873,21267001,29,12},
{348942337,89142165,29,12},
{348921857,210543533,29,13},
{348880897,91222465,29,15},
{348868609,212159885,29,12},
{348835841,254974947,29,12},
{348758017,185550658,29,13},
{348745729,68604217,29,12},
{348737537,246090270,29,12},
{348725249,324455042,29,13},
{348602369,190868059,29,14},
{348577793,266205037,29,13},
{348499969,17357054,29,12},
{348491777,212733505,29,12},
{348438529,105730184,29,14},
{348413953,140371507,29,13},
{348307457,36306563,29,14},
{348295169,304872915,29,12},
{348241921,157649328,29,14},
{348229633,314908991,29,12},
{348205057,317661126,29,12},
{348110849,318639101,29,14},
{348106753,152582987,29,12},
{348069889,57778903,29,13},
{348061697,297251366,29,16},
{348037121,83239923,29,13},
{347996161,222281794,29,17},
{347983873,233739633,29,12},
{347975681,337209410,29,12},
{347947009,311665387,29,14},
{347926529,218850316,29,12},
{347914241,150731902,29,14},
{347877377,93198001,29,12},
{347852801,19843783,29,12},
{347840513,173039737,29,13},
{347750401,228576453,29,14},
{347742209,93832388,29,13},
{347717633,247690942,29,14},
{347693057,181572886,29,13},
{347668481,324361632,29,16},
{347656193,83885235,29,12},
{347631617,167701744,29,12},
{347496449,197298817,29,13},
{347435009,281291952,29,12},
{347430913,283498448,29,13},
{347422721,196439930,29,14},
{347394049,267023467,29,12},
{347348993,27463775,29,13},
{347344897,336212493,29,12},
{347312129,1509833,29,12},
{347262977,56929538,29,12},
{347238401,143810957,29,12},
{347148289,78314880,29,12},
{347140097,127200986,29,12},
{347136001,302929513,29,13},
{347078657,282275793,29,20},
{347074561,227812139,29,12},
{347000833,293212828,29,12},
{346939393,210268780,29,13},
{346931201,193879447,29,14},
{346890241,285256440,29,13},
{346877953,219238903,29,12},
{346857473,16676305,29,13},
{346808321,328231802,29,13},
{346767361,251974812,29,14},
{346759169,164252133,29,13},
{346705921,247971399,29,12},
{346644481,131774751,29,13},
{346624001,106767261,29,12},
{346607617,122758500,29,12},
{346472449,79909136,29,14},
{346398721,168119779,29,13},
{346386433,172895637,29,12},
{346349569,340835960,29,13},
{346304513,155752335,29,12},
{346279937,65343301,29,12},
{346275841,121995550,29,14},
{346177537,210587642,29,14},
{346120193,303511437,29,13},
{346083329,125344230,29,12},
{345931777,210061832,29,15},
{345858049,302633673,29,13},
{345776129,183764909,29,13},
{345772033,109154839,29,12},
{345710593,213223635,29,13},
{345673729,158938480,29,12},
{345624577,147294379,29,12},
{345604097,87596250,29,15},
{345563137,235991180,29,13},
{345542657,339203081,29,12},
{345538561,73418677,29,15},
{345481217,132598487,29,13},
{345456641,79761001,29,14},
{345444353,261043988,29,12},
{345366529,37945166,29,13},
{345333761,75460552,29,13},
{345305089,2319015,29,12},
{345284609,176573004,29,13},
{345280513,38105817,29,12},
{345272321,327087373,29,12},
{345157633,111696196,29,12},
{345137153,225622843,29,13},
{345133057,175947156,29,12},
{345108481,33876698,29,12},
{345051137,183353785,29,12},
{345010177,92899186,29,12},
{344928257,244909716,29,12},
{344903681,220961185,29,12},
{344875009,113517060,29,13},
{344850433,340789441,29,17},
{344825857,206755442,29,13},
{344780801,301573385,29,12},
{344768513,141776958,29,14},
{344743937,192460890,29,13},
{344641537,304144747,29,12},
{344424449,297211881,29,15},
{344363009,278985668,29,12},
{344338433,239435394,29,12},
{344276993,285205111,29,14},
{344248321,224585565,29,12},
{344240129,97311595,29,12},
{344154113,239830012,29,13},
{344150017,277736808,29,12},
{344068097,336265140,29,12},
{344006657,130118543,29,13},
{343994369,300468538,29,12},
{343867393,249385383,29,16},
{343822337,134949071,29,12},
{343760897,289015556,29,13},
{343683073,91855654,29,12},
{343633921,2201695,29,12},
{343613441,30339701,29,13},
{343576577,304369029,29,12},
{343511041,72126911,29,12},
{343453697,20135196,29,12},
{343441409,236695051,29,15},
{343416833,210327579,29,13},
{343379969,291862418,29,12},
{343306241,328063305,29,12},
{343195649,328533516,29,14},
{343166977,301369913,29,12},
{343048193,206368845,29,15},
{343031809,201272053,29,14},
{343023617,341186997,29,13},
{343007233,44741596,29,13},
{342982657,96175102,29,15},
{342937601,170953080,29,12},
{342896641,31234888,29,12},
{342876161,339706008,29,13},
{342847489,11324896,29,12},
{342822913,165509093,29,12},
{342765569,180031546,29,12},
{342761473,183892530,29,13},
{342724609,191178424,29,12},
{342691841,224824104,29,12},
{342650881,328394637,29,12},
{342601729,164705309,29,12},
{342581249,323198492,29,13},
{342519809,90718609,29,12},
{342515713,210587351,29,13},
{342495233,46684262,29,12},
{342446081,250510399,29,12},
{342417409,286043431,29,13},
{342409217,145949362,29,14},
{342372353,176145380,29,12},
{342355969,11656667,29,12},
{342335489,181190660,29,13},
{342286337,109047225,29,13},
{342151169,75173742,29,12},
{342147073,231101131,29,14},
{342126593,205120119,29,12},
{342048769,154803824,29,14},
{342016001,300867916,29,14},
{341999617,58321238,29,15},
{341987329,265867704,29,12},
{341905409,212846365,29,12},
{341893121,63926310,29,13},
{341856257,278327714,29,12},
{341819393,68192396,29,14},
{341815297,252789049,29,12},
{341770241,15827034,29,16},
{341667841,139974180,29,12},
{341655553,148233157,29,14},
{341585921,143237434,29,12},
{341544961,210615781,29,12},
{341446657,21961142,29,12},
{341434369,140563004,29,13},
{341426177,93475947,29,14},
{341389313,319399808,29,12},
{341352449,281658755,29,13},
{341327873,61727418,29,14},
{341217281,205475521,29,12},
{341168129,156025249,29,12},
{341127169,81804112,29,12},
{341118977,166222088,29,12},
{341114881,28698273,29,16},
{341082113,99810556,29,15},
{341053441,200479323,29,12},
{341041153,190809087,29,13},
{341032961,320031867,29,14},
{340832257,207107237,29,12},
{340811777,174938135,29,13},
{340750337,304285555,29,12},
{340738049,170927178,29,14},
{340725761,98672800,29,12},
{340697089,143463113,29,13},
{340602881,277751321,29,12},
{340541441,166699546,29,14},
{340406273,26611579,29,12},
{340377601,250813385,29,14},
{340369409,331968680,29,13},
{340320257,6211151,29,13},
{340316161,325556794,29,12},
{340254721,176462304,29,13},
{340185089,150298796,29,12},
{340172801,155518641,29,13},
{340119553,208794643,29,12},
{340111361,70059340,29,12},
{340099073,45505977,29,15},
{340013057,123381869,29,12},
{340000769,52435323,29,18},
{339972097,73631818,29,12},
{339886081,268831630,29,14},
{339812353,77779279,29,13},
{339804161,278494836,29,16},
{339767297,330633180,29,12},
{339763201,117856514,29,13},
{339640321,163498189,29,15},
{339632129,111998731,29,13},
{339566593,334503633,29,13},
{339542017,299953040,29,16},
{339468289,199364088,29,13},
{339423233,139480635,29,12},
{339419137,206804785,29,13},
{339406849,248478061,29,12},
{339324929,182870527,29,12},
{339296257,41085216,29,14},
{339234817,70047464,29,12},
{339222529,74786249,29,13},
{339197953,317739933,29,14},
{339177473,61102651,29,12},
{339161089,32127620,29,12},
{339116033,303189112,29,15},
{339087361,331717018,29,12},
{339038209,25391660,29,12},
{338964481,5418767,29,12},
{338931713,254578320,29,12},
{338890753,30673952,29,12},
{338845697,37101044,29,13},
{338792449,335698119,29,12},
{338767873,239631268,29,12},
{338731009,196710559,29,13},
{338649089,199786318,29,13},
{338563073,124053462,29,12},
{338472961,234106357,29,12},
{338460673,89109988,29,15},
{338452481,186194735,29,13},
{338436097,93307013,29,13},
{338399233,129951769,29,12},
{338378753,247415619,29,14},
{338362369,83459265,29,16},
{338337793,2456226,29,13},
{338128897,260204613,29,12},
{338092033,314786276,29,13},
{338046977,269402468,29,12},
{338030593,104349652,29,12},
{338022401,165168722,29,12},
{338006017,259323001,29,12},
{337985537,37353636,29,14},
{337948673,227931820,29,12},
{337911809,155545426,29,13},
{337899521,89013362,29,12},
{337887233,233080502,29,14},
{337825793,115906400,29,12},
{337821697,136384928,29,14},
{337784833,75416265,29,12},
{337760257,47254041,29,12},
{337735681,87597956,29,12},
{337702913,199361308,29,12},
{337674241,8370680,29,15},
{337661953,132052058,29,12},
{337625089,36349008,29,14},
{337575937,280479854,29,16},
{337563649,333093239,29,12},
{337543169,40513144,29,15},
{337539073,67955336,29,12},
{337514497,318629458,29,12},
{337477633,209793739,29,15},
{337391617,172386203,29,12},
{337358849,243833901,29,12},
{337354753,53544596,29,13},
{337346561,251846746,29,15},
{337272833,91765664,29,13},
{337248257,327174180,29,17},
{337223681,224463669,29,13},
{337211393,183972105,29,12},
{337133569,228130940,29,14},
{337100801,309198527,29,14},
{337072129,300378010,29,12},
{337059841,263219900,29,13},
{337039361,21496664,29,12},
{336998401,192829903,29,12},
{336867329,153236836,29,12},
{336855041,251481871,29,18},
{336818177,217249004,29,12},
{336801793,93799146,29,12},
{336764929,212489594,29,13},
{336756737,225123021,29,15},
{336596993,279217380,29,12},
{336572417,111320688,29,12},
{336568321,309124731,29,13},
{336498689,2957451,29,12},
{336445441,188936266,29,14},
{336437249,108034682,29,13},
{336424961,315956264,29,12},
{336351233,267869740,29,12},
{336322561,222442797,29,13},
{336142337,291059862,29,13},
{336068609,236241202,29,19},
{336039937,195771418,29,12},
{335994881,166710603,29,13},
{335982593,37599655,29,12},
{335941633,96846152,29,12},
{335904769,221080759,29,15},
{335794177,127320623,29,12},
{335761409,93000771,29,12},
{335757313,289051028,29,14},
{335695873,176876220,29,12},
{335589377,260327717,29,12},
{335552513,252441711,29,13},
{335527937,225351347,29,14},
{335503361,329289806,29,13},
{335454209,131953350,29,13},
{335450113,22340579,29,12},
{335413249,169374548,29,17},
{335388673,307764091,29,13},
{335306753,313806547,29,13},
{335265793,128585618,29,14},
{335216641,227637173,29,16},
{335097857,128223400,29,12},
{335093761,39001337,29,13},
{334983169,110503629,29,12},
{334962689,276039400,29,13},
{334938113,84419997,29,14},
{334897153,102909105,29,13},
{334876673,130055505,29,12},
{334852097,247955095,29,12},
{334835713,321622834,29,12},
{334815233,162627587,29,13},
{334811137,266967150,29,12},
{334790657,273808890,29,15},
{334774273,202684019,29,14},
{334729217,168830276,29,12},
{334704641,291453734,29,12},
{334688257,244143723,29,12},
{334651393,143782819,29,13},
{334594049,248589264,29,15},
{334589953,293577880,29,12},
{334565377,40543258,29,12},
{334544897,324460274,29,14},
{334520321,42764248,29,13},
{334508033,134120164,29,12},
{334491649,332712541,29,12},
{334479361,224285311,29,14},
{334409729,239106257,29,12},
{334405633,283674068,29,13},
{334360577,242817834,29,12},
{334336001,301359810,29,12},
{334323713,111744300,29,13},
{334221313,91466038,29,12},
{334176257,290705653,29,13},
{334135297,182150431,29,15},
{333975553,131945957,29,12},
{333926401,246820744,29,12},
{333905921,219117270,29,16},
{333877249,50649249,29,12},
{333869057,288085271,29,12},
{333864961,131831478,29,13},
{333856769,230699289,29,14},
{333803521,51942507,29,12},
{333791233,124503068,29,14},
{333783041,230584836,29,13},
{333619201,67325772,29,13},
{333598721,302546113,29,12},
{333549569,29882583,29,12},
{333520897,65214651,29,13},
{333500417,154924378,29,12},
{333496321,202434300,29,14},
{333484033,330325961,29,12},
{333463553,177318381,29,14},
{333414401,24215566,29,15},
{333361153,41089257,29,12},
{333299713,106611171,29,14},
{333242369,166056499,29,13},
{333230081,321981460,29,12},
{333201409,18966576,29,14},
{333189121,225331767,29,12},
{333090817,219058550,29,12},
{333066241,150587309,29,12},
{333045761,256446007,29,13},
{333017089,294460524,29,12},
{333004801,196764695,29,14},
{332947457,324181208,29,13},
{332943361,23587706,29,12},
{332931073,89156646,29,13},
{332894209,59410444,29,12},
{332886017,44154885,29,12},
{332869633,152010877,29,12},
{332812289,138483367,29,12},
{332738561,130823887,29,12},
{332709889,3712478,29,14},
{332685313,55849429,29,13},
{332660737,183014064,29,18},
{332627969,222290398,29,15},
{332603393,208439714,29,13},
{332554241,51193556,29,13},
{332541953,283652566,29,12},
{332525569,193788954,29,12},
{332480513,306497860,29,14},
{332451841,265360322,29,12},
{332443649,243968717,29,12},
{332439553,4511748,29,13},
{332394497,69362155,29,12},
{332382209,225624829,29,14},
{332378113,149813740,29,12},
{332328961,117102394,29,12},
{332292097,26612979,29,13},
{332267521,306513845,29,17},
{332259329,256373263,29,13},
{332144641,215089549,29,13},
{332087297,98014469,29,14},
{332070913,109206064,29,16},
{332021761,180907015,29,14},
{331952129,126495037,29,12},
{331923457,182736316,29,14},
{331911169,160278060,29,12},
{331886593,88559618,29,12},
{331849729,311240901,29,13},
{331829249,59900327,29,12},
{331776001,30346624,29,15},
{331665409,242313845,29,12},
{331640833,254395528,29,12},
{331431937,203807689,29,14},
{331399169,176369476,29,14},
{331370497,181804255,29,12},
{331333633,139574604,29,14},
{331309057,96631352,29,13},
{331276289,40887797,29,13},
{331235329,3304489,29,14},
{331227137,122934450,29,13},
{331223041,171254129,29,12},
{331165697,320161956,29,12},
{331153409,45695583,29,16},
{331124737,128924186,29,12},
{331079681,171781751,29,13},
{331063297,75960499,29,13},
{331018241,129848886,29,12},
{330989569,246393639,29,15},
{330977281,287204987,29,12},
{330915841,22584135,29,13},
{330858497,5277441,29,15},
{330805249,42937627,29,12},
{330657793,275166823,29,12},
{330633217,108684196,29,12},
{330588161,57547098,29,13},
{330571777,303621038,29,13},
{330510337,209401033,29,12},
{330416129,251446858,29,14},
{330391553,33907273,29,13},
{330366977,210488787,29,16},
{330362881,177644378,29,12},
{330313729,326675313,29,12},
{330301441,76588151,29,20},
{330252289,142799276,29,14},
{330227713,68798716,29,13},
{330043393,288871430,29,12},
{330035201,77224647,29,12},
{330018817,71962353,29,12},
{329994241,96853752,29,12},
{329986049,312215199,29,12},
{329912321,77506885,29,12},
{329883649,277233921,29,13},
{329875457,161895345,29,15},
{329834497,32152168,29,13},
{329822209,68178834,29,12},
{329777153,152897624,29,19},
{329748481,197918021,29,12},
{329740289,92542139,29,12},
{329715713,80445000,29,12},
{329691137,233026251,29,12},
{329687041,171512841,29,13},
{329629697,206405075,29,14},
{329588737,127197719,29,13},
{329515009,154987406,29,18},
{329506817,290465073,29,13},
{329453569,277862823,29,12},
{329428993,241966790,29,12},
{329367553,82572118,29,14},
{329359361,322702334,29,13},
{329330689,136936812,29,12},
{329297921,284407876,29,12},
{329199617,240339542,29,12},
{329195521,163627232,29,13},
{329183233,312285164,29,12},
{329158657,129618427,29,12},
{329125889,177739326,29,12},
{329072641,300433355,29,14},
{329023489,223456797,29,15},
{329003009,306693946,29,12},
{328974337,311645587,29,14},
{328953857,136821005,29,12},
{328900609,11078492,29,13},
{328888321,188620895,29,12},
{328769537,247640871,29,13},
{328732673,263774703,29,12},
{328728577,120759392,29,19},
{328683521,160915582,29,12},
{328593409,71313588,29,12},
{328560641,45074931,29,12},
{328531969,176836406,29,16},
{328499201,311491720,29,15},
{328486913,305010762,29,12},
{328470529,272585184,29,12},
{328437761,136429106,29,12},
{328425473,96766094,29,13},
{328302593,320339456,29,15},
{328298497,94174227,29,12},
{328192001,288213304,29,12},
{328138753,291223530,29,16},
{328093697,264215642,29,12},
{328052737,242996459,29,12},
{328019969,74481631,29,12},
{328007681,71209474,29,16},
{327991297,54618720,29,14},
{327958529,303357958,29,14},
{327868417,79688967,29,13},
{327847937,273786862,29,12},
{327823361,124255226,29,12},
{327651329,283661214,29,12},
{327647233,288021491,29,15},
{327598081,25728921,29,14},
{327561217,150615395,29,12},
{327548929,44652618,29,17},
{327536641,203827683,29,12},
{327528449,209535711,29,12},
{327479297,215350515,29,12},
{327467009,287174914,29,14},
{327380993,95812426,29,12},
{327356417,138082357,29,12},
{327331841,117397352,29,12},
{327294977,8550722,29,13},
{327282689,66453621,29,12},
{327217153,153897283,29,12},
{327192577,91852898,29,12},
{327118849,237578301,29,12},
{327069697,63171317,29,12},
{327036929,256623363,29,12},
{327032833,314707376,29,13},
{326983681,174817174,29,13},
{326975489,29860435,29,14},
{326901761,204136754,29,13},
{326889473,44192137,29,12},
{326873089,25653255,29,12},
{326860801,249540799,29,15},
{326766593,138170073,29,12},
{326750209,73424734,29,12},
{326729729,313433324,29,15},
{326668289,315639552,29,12},
{326639617,75876772,29,13},
{326602753,105895289,29,12},
{326557697,212125436,29,13},
{326479873,46994951,29,12},
{326471681,296489969,29,12},
{326430721,63320560,29,12},
{326361089,130736763,29,13},
{326336513,133198931,29,15},
{326275073,180869420,29,12},
{326234113,62873461,29,12},
{326152193,149089270,29,12},
{326135809,210524750,29,12},
{326127617,278587881,29,12},
{326123521,283457550,29,14},
{326074369,158511485,29,15},
{326062081,324319250,29,12},
{326049793,276201463,29,13},
{325992449,264860601,29,14},
{325943297,216767554,29,15},
{325931009,57061124,29,12},
{325906433,238257993,29,12},
{325890049,161938888,29,12},
{325865473,9781277,29,12},
{325857281,67096069,29,12},
{325844993,195119108,29,18},
{325828609,296141214,29,14},
{325779457,47924181,29,16},
{325746689,109807686,29,15},
{325685249,322957487,29,12},
{325636097,275152008,29,12},
{325632001,42289686,29,14},
{325611521,56618644,29,12},
{325570561,244622563,29,12},
{325558273,82912679,29,13},
{325550081,288436672,29,15},
{325521409,76141127,29,12},
{325410817,289085751,29,13},
{325386241,281570613,29,16},
{325328897,104223337,29,13},
{325312513,98702921,29,13},
{325267457,48479994,29,12},
{325263361,60811391,29,13},
{325242881,309004941,29,12},
{325230593,274715397,29,13},
{325206017,272381428,29,14},
{325169153,274396882,29,12},
{324997121,221378947,29,12},
{324960257,21605579,29,15},
{324943873,10156842,29,14},
{324919297,248354510,29,13},
{324857857,852714,29,12},
{324845569,282068164,29,14},
{324812801,183642220,29,14},
{324800513,307509279,29,12},
{324640769,244275032,29,13},
{324599809,252232293,29,16},
{324554753,77645786,29,12},
{324427777,94122461,29,13},
{324354049,229050949,29,14},
{324292609,177726709,29,12},
{324268033,251665937,29,12},
{324231169,320268081,29,13},
{324198401,259749179,29,13},
{324145153,30998912,29,12},
{324124673,147135959,29,14},
{324096001,14504991,29,12},
{324087809,239888943,29,12},
{324083713,229024417,29,13},
{324014081,257531569,29,12},
{323915777,196658512,29,12},
{323891201,29980943,29,12},
{323878913,163563544,29,17},
{323854337,98190879,29,13},
{323829761,99493319,29,14},
{323813377,279035383,29,16},
{323776513,58626425,29,12},
{323751937,172081163,29,12},
{323657729,136115819,29,13},
{323608577,188678274,29,13},
{323596289,308987049,29,12},
{323469313,188867474,29,14},
{323432449,83244934,29,12},
{323420161,67180590,29,16},
{323411969,204314638,29,13},
{323297281,112717623,29,13},
{323284993,270375381,29,12},
{323223553,198590275,29,18},
{323141633,173468458,29,14},
{323137537,104984265,29,12},
{323112961,58119377,29,12},
{323092481,143035373,29,17},
{323063809,87725507,29,12},
{322834433,53989158,29,12},
{322809857,103616802,29,12},
{322805761,98664932,29,13},
{322772993,223708634,29,13},
{322736129,211096575,29,12},
{322695169,221283337,29,12},
{322682881,73445839,29,14},
{322662401,238657566,29,12},
{322547713,174517544,29,12},
{322510849,273225805,29,13},
{322490369,102738395,29,12},
{322416641,65715978,29,12},
{322379777,174339503,29,13},
{322375681,271405326,29,12},
{322342913,178873413,29,12},
{322338817,131111179,29,15},
{322293761,75252499,29,12},
{322281473,117059935,29,13},
{322265089,112042549,29,13},
{322220033,158184524,29,12},
{322215937,212720196,29,13},
{322195457,30320770,29,12},
{322179073,77555374,29,12},
{322170881,92056240,29,12},
{322134017,99270145,29,13},
{322117633,42026486,29,13},
{322109441,109746355,29,16},
{322080769,232299465,29,12},
{322019329,176006476,29,13},
{321998849,108308312,29,12},
{321994753,201427453,29,14},
{321974273,109170100,29,12},
{321863681,224949334,29,14},
{321699841,236504425,29,14},
{321679361,19658053,29,12},
{321630209,196040869,29,12},
{321568769,167242347,29,14},
{321544193,136962821,29,13},
{321458177,296503204,29,12},
{321335297,140228098,29,12},
{321331201,277091807,29,13},
{321310721,51570638,29,12},
{321261569,208285433,29,12},
{321212417,237865087,29,12},
{321003521,179118165,29,13},
{320991233,258250710,29,12},
{320954369,166091483,29,13},
{320913409,49351333,29,14},
{320901121,309480848,29,12},
{320843777,195118445,29,12},
{320802817,293243080,29,12},
{320790529,4074937,29,13},
{320757761,262896419,29,13},
{320647169,300677798,29,12},
{320622593,5405006,29,12},
{320593921,240839843,29,13},
{320585729,279213791,29,14},
{320499713,302673953,29,12},
{320458753,49612816,29,12},
{320438273,120481337,29,15},
{320413697,192632555,29,13},
{320409601,88970822,29,12},
{320315393,47086425,29,13},
{320167937,260333811,29,13},
{320114689,74225759,29,12},
{320081921,59555539,29,12},
{320028673,210434718,29,14},
{319979521,115422968,29,15},
{319971329,250171450,29,13},
{319922177,138702208,29,13},
{319897601,18120854,29,14},
{319868929,78732043,29,12},
{319848449,291172622,29,15},
{319807489,211357818,29,13},
{319762433,94411646,29,12},
{319700993,186241169,29,14},
{319639553,314735221,29,12},
{319635457,267934172,29,14},
{319578113,299310534,29,13},
{319549441,209979131,29,12},
{319500289,126040046,29,12},
{319492097,39835762,29,12},
{319467521,275371536,29,12},
{319455233,178462210,29,15},
{319451137,18720375,29,12},
{319393793,211760671,29,12},
{319356929,83902107,29,16},
{319328257,212273454,29,12},
{319295489,30673982,29,12},
{319291393,83585573,29,19},
{319234049,191017609,29,13},
{319180801,108506702,29,12},
{319168513,116724325,29,13},
{319160321,190115962,29,17},
{319107073,91031697,29,12},
{319098881,184289988,29,12},
{319045633,44108842,29,14},
{319025153,107820696,29,12},
{318963713,54148740,29,16},
{318947329,221804785,29,14},
{318922753,71277395,29,13},
{318902273,122048750,29,12},
{318877697,120508389,29,12},
{318873601,69780270,29,13},
{318853121,32711213,29,12},
{318836737,184065663,29,12},
{318763009,189900795,29,12},
{318607361,30492916,29,12},
{318566401,37950810,29,12},
{318558209,90285653,29,12},
{318529537,45171832,29,13},
{318435329,62489180,29,12},
{318410753,146524654,29,12},
{318394369,170662758,29,12},
{318382081,5909706,29,13},
{318287873,282102494,29,12},
{318201857,94536279,29,13},
{318189569,241181034,29,12},
{318160897,208218587,29,14},
{318136321,202202770,29,13},
{318087169,167226176,29,13},
{318078977,88299522,29,15},
{318074881,186394049,29,12},
{317976577,52639439,29,12},
{317956097,12396523,29,13},
{317931521,130872774,29,14},
{317890561,303597438,29,13},
{317870081,101067329,29,12},
{317829121,123226881,29,12},
{317816833,245541660,29,15},
{317792257,289617099,29,13},
{317747201,252652378,29,12},
{317706241,7605663,29,12},
{317685761,172380814,29,15},
{317657089,213328360,29,12},
{317562881,120317835,29,13},
{317546497,7371603,29,13},
{317521921,59289301,29,16},
{317489153,303391586,29,15},
{317448193,192531651,29,13},
{317390849,292444221,29,16},
{317329409,206298998,29,12},
{317304833,230554862,29,12},
{317276161,133962807,29,14},
{317267969,140428804,29,13},
{317214721,40499262,29,12},
{317132801,142696289,29,12},
{317116417,93249873,29,12},
{317030401,228283322,29,15},
{316973057,26792516,29,13},
{316919809,276257307,29,12},
{316846081,35142122,29,12},
{316833793,191809218,29,15},
{316796929,253132471,29,12},
{316751873,40126042,29,14},
{316727297,225718590,29,13},
{316723201,967912,29,12},
{316710913,269252846,29,13},
{316653569,72914368,29,14},
{316624897,303421608,29,12},
{316567553,186939250,29,12},
{316538881,276907578,29,17},
{316526593,34098313,29,12},
{316469249,107059604,29,12},
{316444673,3755650,29,12},
{316383233,11839632,29,13},
{316354561,101421113,29,12},
{316346369,282410782,29,12},
{316317697,221913570,29,13},
{316284929,21129488,29,13},
{316256257,126083833,29,12},
{316121089,211333685,29,13},
{316071937,55418187,29,13},
{316059649,24770159,29,12},
{315985921,171574350,29,12},
{315973633,124846762,29,13},
{315805697,66304685,29,12},
{315764737,129445971,29,12},
{315691009,247620072,29,12},
{315682817,118220264,29,12},
{315523073,118798486,29,15},
{315498497,225708319,29,13},
{315486209,187493834,29,12},
{315482113,91940992,29,13},
{315461633,38773518,29,12},
{315351041,182612097,29,13},
{315322369,22429940,29,12},
{315310081,53744727,29,14},
{315166721,138956043,29,12},
{314990593,117829202,29,13},
{314970113,228787549,29,12},
{314966017,82810086,29,17},
{314953729,188588288,29,12},
{314941441,157277644,29,13},
{314920961,6704287,29,12},
{314830849,136332473,29,12},
{314720257,90731013,29,14},
{314707969,88704349,29,12},
{314626049,33244784,29,12},
{314621953,182525491,29,14},
{314560513,167151022,29,12},
{314449921,77113900,29,13},
{314400769,136231908,29,13},
{314376193,67454170,29,16},
{314351617,112865331,29,13},
{314339329,45458526,29,12},
{314331137,12772306,29,12},
{314306561,46899089,29,12},
{314216449,148509412,29,12},
{314191873,188194089,29,12},
{314171393,27040256,29,13},
{314142721,211516887,29,12},
{314130433,257765770,29,14},
{314109953,250343429,29,12},
{314093569,176452825,29,12},
{314085377,299435431,29,12},
{314060801,9998406,29,12},
{314007553,113451103,29,13},
{313987073,249204715,29,12},
{313958401,16329362,29,13},
{313950209,60275857,29,15},
{313901057,235887727,29,14},
{313860097,15858866,29,13},
{313798657,177418177,29,12},
{313778177,171322038,29,13},
{313774081,153636406,29,12},
{313741313,78895628,29,12},
{313737217,106420840,29,14},
{313716737,109437614,29,12},
{313704449,118080830,29,14},
{313655297,72053375,29,17},
{313643009,306058248,29,12},
{313540609,74401087,29,14},
{313516033,11590930,29,13},
{313479169,147021271,29,12},
{313458689,264386701,29,16},
{313454593,1064688,29,12},
{313372673,100439826,29,12},
{313356289,306861157,29,12},
{313335809,136307013,29,13},
{313311233,248127666,29,14},
{313282561,212091910,29,12},
{313188353,135397355,29,13},
{313102337,170448378,29,12},
{313085953,251644720,29,12},
{313077761,16294760,29,12},
{313061377,66626065,29,12},
{313028609,215331123,29,12},
{313024513,89586840,29,13},
{313016321,294747271,29,14},
{312954881,274339573,29,12},
{312938497,246904241,29,12},
{312877057,196589930,29,13},
{312840193,293311364,29,12},
{312819713,245865905,29,14},
{312803329,207951448,29,16},
{312758273,146013669,29,12},
{312754177,139142861,29,14},
{312741889,297932730,29,12},
{312729601,104985261,29,13},
{312696833,251458001,29,13},
{312659969,248583775,29,12},
{312647681,308438470,29,13},
{312598529,228729346,29,13},
{312569857,144346083,29,12},
{312557569,97036772,29,14},
{312545281,244614452,29,12},
{312524801,39660733,29,14},
{312483841,294797157,29,13},
{312471553,21201345,29,12},
{312426497,52155971,29,14},
{312422401,244216382,29,12},
{312414209,111605675,29,12},
{312410113,118321208,29,16},
{312389633,541547,29,12},
{312324097,1689412,29,12},
{312287233,26694929,29,13},
{312139777,190582648,29,13},
{312127489,143941249,29,12},
{312102913,12117419,29,12},
{312066049,16311353,29,14},
{312057857,279771280,29,13},
{312053761,166416724,29,12},
{312041473,226218196,29,13},
{312020993,239066873,29,12},
{311996417,52319860,29,12},
{311992321,188974660,29,13},
{311971841,152048969,29,12},
{311959553,150273585,29,13},
{311808001,91993973,29,12},
{311799809,170450812,29,12},
{311787521,25735172,29,15},
{311738369,145398252,29,14},
{311697409,180130106,29,13},
{311672833,93084828,29,14},
{311615489,172712794,29,13},
{311611393,45777859,29,12},
{311541761,239810370,29,14},
{311427073,185523482,29,20},
{311406593,132882426,29,12},
{311365633,234607476,29,12},
{311357441,213726451,29,12},
{311341057,268296445,29,12},
{311197697,282249233,29,15},
{311160833,129478381,29,12},
{311132161,159614471,29,15},
{311013377,295581020,29,12},
{310996993,117480610,29,12},
{310927361,94815484,29,13},
{310890497,85042261,29,12},
{310865921,51484354,29,12},
{310824961,87866581,29,12},
{310730753,48283747,29,13},
{310726657,65184827,29,12},
{310689793,130697542,29,14},
{310669313,246285853,29,12},
{310652929,177994135,29,12},
{310620161,46385654,29,12},
{310521857,232816567,29,12},
{310448129,200370619,29,12},
{310419457,180245186,29,13},
{310362113,296996160,29,14},
{310358017,246363062,29,12},
{310345729,91681999,29,15},
{310276097,197424580,29,12},
{310251521,121564762,29,12},
{310235137,21743804,29,12},
{310222849,244791530,29,13},
{310038529,9068747,29,12},
{310013953,76138797,29,12},
{309870593,112814120,29,14},
{309780481,267085116,29,13},
{309760001,287990638,29,12},
{309719041,204370350,29,12},
{309698561,299372174,29,13},
{309637121,30974410,29,12},
{309583873,135132573,29,13},
{309563393,142963166,29,12},
{309514241,277402668,29,12},
{309501953,194482006,29,13},
{309460993,239420270,29,17},
{309362689,156331715,29,15},
{309350401,126609481,29,12},
{309301249,269829064,29,12},
{309178369,263347004,29,12},
{309145601,147718674,29,12},
{309104641,232079114,29,12},
{308883457,14800940,29,12},
{308862977,179167351,29,13},
{308809729,36935775,29,12},
{308797441,170737168,29,13},
{308789249,228516626,29,14},
{308760577,45055351,29,12},
{308748289,304444679,29,13},
{308715521,220925899,29,13},
{308686849,243045598,29,12},
{308662273,278884211,29,12},
{308637697,17930831,29,12},
{308555777,255695642,29,12},
{308551681,129879500,29,13},
{308539393,220486418,29,12},
{308494337,53826284,29,14},
{308490241,291759284,29,12},
{308428801,87062619,29,14},
{308371457,69935539,29,13},
{308330497,41505245,29,14},
{308318209,242317863,29,12},
{308297729,3875600,29,14},
{308285441,107419526,29,12},
{308224001,49890885,29,13},
{308150273,278982101,29,17},
{308109313,7915341,29,13},
{308084737,169346961,29,16},
{308060161,252439987,29,13},
{308027393,229115786,29,13},
{307949569,142196394,29,12},
{307888129,195019491,29,17},
{307879937,165045557,29,13},
{307814401,36971282,29,13},
{307781633,250438282,29,13},
{307740673,267839165,29,14},
{307695617,24304972,29,12},
{307691521,249805033,29,16},
{307671041,113299020,29,12},
{307658753,250967500,29,15},
{307621889,159219019,29,12},
{307597313,216148018,29,12},
{307593217,73652219,29,15},
{307486721,27589302,29,13},
{307470337,92311699,29,13},
{307384321,255271108,29,12},
{307372033,157389134,29,13},
{307322881,284483017,29,13},
{307286017,151519133,29,12},
{307253249,242185193,29,12},
{307228673,303730305,29,12},
{307200001,80760786,29,15},
{307105793,181796148,29,12},
{307056641,206155539,29,12},
{307040257,200678529,29,12},
{307007489,183149795,29,12},
{306921473,158803909,29,14},
{306905089,138469498,29,16},
{306823169,32046457,29,14},
{306737153,188303715,29,12},
{306708481,283675289,29,19},
{306696193,126799251,29,12},
{306659329,302358776,29,14},
{306647041,127783878,29,12},
{306573313,159611210,29,12},
{306552833,304477649,29,13},
{306475009,133102102,29,12},
{306466817,75624604,29,12},
{306425857,211720572,29,12},
{306388993,28828438,29,13},
{306302977,89100370,29,12},
{306282497,193311347,29,15},
{306266113,274547258,29,14},
{306229249,251290117,29,12},
{306196481,38257514,29,12},
{306135041,95191712,29,14},
{306073601,216428131,29,12},
{306061313,197475395,29,13},
{305971201,22906154,29,14},
{305860609,91653854,29,12},
{305848321,31112483,29,13},
{305815553,128676205,29,13},
{305778689,21188657,29,12},
{305631233,73458919,29,12},
{305627137,15616007,29,15},
{305614849,300771169,29,12},
{305606657,100821989,29,12},
{305594369,236970364,29,16},
{305569793,169675370,29,13},
{305545217,105249089,29,14},
{305541121,108918062,29,12},
{305520641,290709317,29,13},
{305491969,9333748,29,12},
{305442817,218360653,29,12},
{305418241,277106440,29,12},
{305385473,156777025,29,12},
{305299457,98750077,29,15},
{305283073,200213467,29,14},
{305262593,72476771,29,12},
{305246209,262201393,29,12},
{305221633,19000224,29,12},
{305164289,147592677,29,12},
{305139713,115980535,29,12},
{305135617,45361947,29,20},
{305078273,78146743,29,13},
{305049601,80251421,29,12},
{305012737,270509109,29,13},
{304967681,197556675,29,12},
{304918529,151667702,29,12},
{304869377,218064778,29,12},
{304857089,18141642,29,14},
{304844801,225728935,29,12},
{304803841,295490758,29,12},
{304795649,110991753,29,12},
{304754689,288230776,29,12},
{304742401,34502733,29,17},
{304672769,230242236,29,12},
{304648193,117335938,29,12},
{304586753,237560922,29,13},
{304537601,8998035,29,13},
{304484353,32639547,29,12},
{304447489,205583914,29,15},
{304439297,297673978,29,13},
{304422913,74928580,29,13},
{304300033,29305213,29,14},
{304238593,49483710,29,12},
{304218113,77348920,29,17},
{304214017,207653727,29,12},
{304189441,80419331,29,12},
{304181249,101898616,29,12},
{304078849,224789528,29,13},
{304066561,279822901,29,12},
{303992833,126797960,29,12},
{303931393,71973820,29,13},
{303910913,174763481,29,12},
{303869953,183840876,29,12},
{303788033,176455778,29,12},
{303763457,143609578,29,12},
{303702017,234511161,29,13},
{303579137,80252299,29,14},
{303554561,246819868,29,13},
{303513601,223966591,29,14},
{303505409,232805459,29,13},
{303476737,179079460,29,12},
{303443969,185319875,29,12},
{303415297,17183281,29,14},
{303382529,73214533,29,14},
{303370241,110212048,29,12},
{303235073,110733264,29,16},
{303210497,94806800,29,13},
{303194113,80684463,29,13},
{303157249,202377064,29,12},
{303108097,237982727,29,12},
{303071233,26494962,29,15},
{303050753,210292014,29,12},
{303013889,230643103,29,13},
{302985217,255250854,29,12},
{302952449,171948942,29,12},
{302850049,243126203,29,13},
{302837761,119976186,29,12},
{302825473,71820909,29,14},
{302780417,76711468,29,12},
{302776321,101411113,29,18},
{302768129,195788097,29,13},
{302755841,80502134,29,12},
{302702593,225027978,29,13},
{302616577,138344546,29,12},
{302592001,115399227,29,12},
{302530561,212065503,29,14},
{302481409,284875570,29,15},
{302350337,15415510,29,15},
{302309377,174630910,29,13},
{302288897,297577462,29,12},
{302252033,42314833,29,18},
{302235649,48857509,29,14},
{302166017,201303711,29,12},
{302129153,231777104,29,13},
{302080001,17506969,29,13},
{302063617,239226545,29,13},
{301977601,181355079,29,12},
{301957121,139899856,29,15},
{301895681,210161488,29,12},
{301879297,157171375,29,12},
{301842433,155439961,29,14},
{301834241,183937471,29,13},
{301785089,20004649,29,13},
{301760513,75326774,29,15},
{301744129,182998911,29,14},
{301723649,218093132,29,12},
{301674497,211725870,29,12},
{301613057,172653175,29,14},
{301588481,195106042,29,13},
{301551617,164282106,29,12},
{301498369,121870765,29,15},
{301477889,239944062,29,12},
{301473793,299615036,29,13},
{301387777,153913618,29,12},
{301355009,170124019,29,12},
{301314049,265234417,29,12},
{301240321,300587251,29,12},
{301191169,123558249,29,12},
{301121537,193919777,29,14},
{301117441,139502137,29,12},
{301047809,205508401,29,13},
{301035521,253832271,29,12},
{301019137,11043676,29,12},
{300974081,255102259,29,15},
{300863489,131345019,29,12},
{300834817,18685828,29,13},
{300802049,48857229,29,13},
{300797953,152765611,29,12},
{300728321,53159703,29,14},
{300711937,15189735,29,15},
{300666881,260073116,29,12},
{300630017,108308412,29,14},
{300617729,95293307,29,12},
{300531713,148251344,29,14},
{300494849,173524071,29,12},
{300470273,67094660,29,12},
{300453889,8766241,29,12},
{300343297,139873212,29,13},
{300322817,74727035,29,12},
{300318721,90302367,29,15},
{300269569,23279560,29,14},
{300244993,16140237,29,13},
{300224513,57203735,29,12},
{300175361,275868166,29,12},
{300158977,263227294,29,12},
{300122113,120231169,29,15},
{300085249,231887711,29,12},
{299950081,77722996,29,13},
{299917313,153427477,29,13},
{299806721,30136658,29,12},
{299794433,264914979,29,15},
{299778049,145155097,29,14},
{299765761,251546864,29,12},
{299692033,108117414,29,12},
{299683841,234044997,29,12},
{299634689,114735006,29,12},
{299606017,22241349,29,13},
{299544577,180770349,29,12},
{299524097,42298384,29,13},
{299511809,258115945,29,12},
{299499521,11665077,29,17},
{299483137,147383025,29,14},
{299364353,104857000,29,12},
{299335681,140258614,29,15},
{299327489,121623620,29,13},
{299278337,1546118,29,13},
{299261953,74148379,29,13},
{299200513,251813264,29,12},
{299077633,145828200,29,12},
{299008001,180264521,29,15},
{298954753,91162308,29,12},
{298909697,104055899,29,16},
{298835969,123012313,29,13},
{298807297,35374943,29,12},
{298762241,100994404,29,14},
{298749953,157076183,29,12},
{298651649,208794649,29,12},
{298647553,196990381,29,16},
{298622977,207219753,29,13},
{298467329,205938472,29,14},
{298455041,218201678,29,12},
{298418177,227453530,29,15},
{298352641,219535252,29,15},
{298340353,158386835,29,12},
{298254337,149624151,29,16},
{298229761,150312589,29,13},
{298221569,277413979,29,15},
{298196993,75194939,29,13},
{298180609,94077484,29,13},
{298160129,213250300,29,12},
{298135553,99139232,29,12},
{298110977,161886398,29,12},
{298086401,152753802,29,12},
{298008577,37099218,29,14},
{297996289,187035829,29,12},
{297975809,60056810,29,14},
{297963521,65217754,29,12},
{297914369,179230200,29,12},
{297828353,123827078,29,15},
{297824257,30842298,29,12},
{297799681,162767902,29,12},
{297779201,35535476,29,14},
{297664513,35737900,29,17},
{297619457,93763714,29,12},
{297615361,228709329,29,14},
{297594881,222109577,29,12},
{297521153,178400343,29,12},
{297517057,41600369,29,14},
{297504769,226741366,29,12},
{297443329,291445924,29,13},
{297435137,82372780,29,15},
{297394177,104834531,29,13},
{297369601,214052358,29,15},
{297349121,261231922,29,12},
{297299969,258631162,29,12},
{297275393,157431212,29,12},
{297136129,236157691,29,12},
{297115649,35841150,29,13},
{297062401,153306504,29,12},
{297029633,129837740,29,12},
{296968193,95656495,29,13},
{296927233,245101415,29,14},
{296902657,125181072,29,13},
{296890369,95847911,29,12},
{296828929,59335386,29,14},
{296820737,153492281,29,13},
{296796161,258187628,29,14},
{296783873,24884815,29,12},
{296767489,204443924,29,12},
{296755201,238751448,29,13},
{296734721,25033006,29,12},
{296718337,71824710,29,12},
{296673281,68912786,29,13},
{296660993,86397571,29,12},
{296624129,139197676,29,13},
{296595457,276240582,29,12},
{296574977,283948458,29,13},
{296476673,21061277,29,13},
{296452097,17968871,29,15},
{296390657,179195999,29,12},
{296316929,262459183,29,12},
{296304641,275633020,29,14},
{296251393,5602579,29,12},
{296181761,162814324,29,13},
{296083457,274114912,29,13},
{296071169,27063979,29,12},
{296067073,50737927,29,13},
{296017921,265289249,29,13},
{295997441,43251116,29,12},
{295968769,253076789,29,13},
{295956481,116931133,29,12},
{295944193,278078202,29,14},
{295923713,55114186,29,12},
{295899137,76852858,29,12},
{295882753,74828039,29,12},
{295874561,51182203,29,12},
{295845889,32470384,29,14},
{295813121,192647722,29,14},
{295784449,100996143,29,12},
{295759873,173863471,29,12},
{295751681,47766658,29,12},
{295714817,70298310,29,14},
{295653377,89253997,29,12},
{295649281,259791190,29,14},
{295616513,176400621,29,14},
{295530497,68852595,29,12},
{295477249,61065655,29,13},
{295444481,43214569,29,13},
{295407617,3195322,29,12},
{295370753,78493111,29,16},
{295321601,124546376,29,14},
{295305217,156251804,29,17},
{295280641,133411586,29,13},
{295247873,79139890,29,13},
{295219201,149566520,29,12},
{295211009,223282374,29,12},
{295170049,261776062,29,12},
{295161857,173095244,29,12},
{295063553,231469987,29,12},
{295026689,127853046,29,14},
{294977537,274278542,29,16},
{294961153,21053470,29,14},
{294899713,136863263,29,12},
{294739969,290864726,29,13},
{294666241,214066332,29,14},
{294555649,5519338,29,12},
{294531073,165703819,29,12},
{294522881,184138992,29,12},
{294461441,160954121,29,13},
{294359041,217303490,29,12},
{294326273,111891251,29,12},
{294322177,249425853,29,16},
{294289409,46862424,29,15},
{294264833,244468953,29,13},
{294178817,52657747,29,12},
{294166529,288319412,29,13},
{294080513,181514585,29,12},
{294076417,23823533,29,14},
{293957633,114426859,29,12},
{293928961,24554463,29,16},
{293859329,285353467,29,12},
{293793793,202368007,29,12},
{293744641,84454395,29,12},
{293736449,33898684,29,12},
{293695489,156665855,29,12},
{293675009,254066498,29,13},
{293670913,218447808,29,12},
{293646337,125606517,29,12},
{293634049,238068548,29,15},
{293613569,258508506,29,12},
{293584897,286252457,29,14},
{293560321,88738781,29,13},
{293490689,280718292,29,12},
{293416961,122447220,29,12},
{293388289,193591760,29,14},
{293376001,7417250,29,12},
{293326849,235122610,29,12},
{293318657,114185149,29,12},
{293244929,68447248,29,12},
{293216257,129250222,29,13},
{293171201,79350593,29,12},
{293117953,232857460,29,13},
{293011457,24986189,29,16},
{292974593,223989124,29,12},
{292958209,9109282,29,12},
{292950017,19119952,29,12},
{292888577,127937299,29,13},
{292741121,266586035,29,13},
{292724737,116211421,29,13},
{292712449,36434301,29,12},
{292687873,170519132,29,12},
{292642817,224898447,29,13},
{292638721,56121788,29,12},
{292618241,174703260,29,16},
{292569089,31559075,29,14},
{292495361,221771938,29,13},
{292417537,223959383,29,12},
{292405249,31143716,29,14},
{292397057,153588573,29,13},
{292323329,245880646,29,15},
{292294657,269847510,29,12},
{292282369,26944041,29,13},
{292261889,135715834,29,12},
{292257793,226535261,29,15},
{292212737,138393031,29,12},
{292171777,139327266,29,12},
{292159489,86998080,29,17},
{292126721,24062103,29,15},
{292098049,113144776,29,12},
{292024321,60879252,29,12},
{291893249,168312660,29,12},
{291880961,97839877,29,14},
{291864577,17747252,29,15},
{291852289,5990968,29,12},
{291840001,58670249,29,13},
{291778561,111303649,29,12},
{291721217,281832265,29,12},
{291708929,29268257,29,13},
{291573761,253779926,29,12},
{291557377,257261952,29,12},
{291536897,99032312,29,15},
{291373057,178184453,29,17},
{291311617,4798856,29,12},
{291287041,64774972,29,12},
{291254273,148515636,29,12},
{291237889,23408496,29,12},
{291213313,10102508,29,12},
{291164161,85770606,29,12},
{291082241,271890855,29,12},
{291069953,263566142,29,13},
{291008513,117040617,29,12},
{290983937,99359412,29,12},
{290906113,230053269,29,13},
{290885633,244572258,29,12},
{290820097,187313748,29,12},
{290795521,224465666,29,12},
{290639873,272327844,29,12},
{290611201,262045676,29,13},
{290574337,77244008,29,12},
{290549761,16912176,29,12},
{290512897,204325877,29,13},
{290467841,207664034,29,12},
{290455553,286021515,29,20},
{290430977,50395879,29,13},
{290353153,7674639,29,12},
{290344961,171662295,29,12},
{290308097,8942795,29,14},
{290267137,24991853,29,13},
{290246657,153316491,29,12},
{290123777,281781568,29,12},
{290119681,109158020,29,13},
{290082817,199238392,29,12},
{290045953,53703776,29,14},
{290009089,192358359,29,12},
{290000897,162083427,29,12},
{289976321,119004496,29,12},
{289964033,30078584,29,15},
{289947649,102011521,29,14},
{289861633,241134430,29,12},
{289837057,251814320,29,12},
{289751041,116646107,29,14},
{289701889,220206549,29,15},
{289677313,94256284,29,13},
{289615873,209845715,29,12},
{289591297,5082097,29,12},
{289579009,106310072,29,13},
{289566721,169663114,29,12},
{289529857,203868299,29,13},
{289456129,42417991,29,14},
{289386497,26316129,29,12},
{289370113,57777062,29,12},
{289349633,48255737,29,13},
{289300481,30320030,29,13},
{289226753,157526398,29,14},
{289198081,264055467,29,12},
{289148929,168917639,29,12},
{289128449,201991530,29,14},
{289103873,62380695,29,13},
{289005569,184919918,29,13},
{289001473,25446487,29,12},
{288903169,264822909,29,12},
{288890881,156479098,29,13},
{288882689,75463169,29,19},
{288821249,7078492,29,12},
{288731137,169545493,29,12},
{288686081,173332354,29,16},
{288673793,37786792,29,12},
{288612353,177045377,29,13},
{288575489,118001122,29,12},
{288563201,163820225,29,13},
{288428033,3681650,29,12},
{288337921,71910592,29,12},
{288317441,260994807,29,13},
{288288769,181405534,29,12},
{288276481,78670520,29,14},
{288243713,78117444,29,14},
{288239617,44245844,29,12},
{288157697,266753334,29,12},
{288055297,9329090,29,13},
{288022529,180413296,29,13},
{288018433,119153631,29,12},
{287936513,37168805,29,12},
{287899649,105381901,29,16},
{287875073,105754225,29,13},
{287858689,131530628,29,13},
{287846401,174842361,29,12},
{287838209,1618094,29,12},
{287825921,87643067,29,13},
{287813633,183164861,29,12},
{287727617,281671028,29,13},
{287674369,228512156,29,12},
{287666177,149348022,29,12},
{287526913,41129471,29,12},
{287469569,31608739,29,12},
{287358977,189365779,29,14},
{287293441,16077283,29,14},
{287281153,54733132,29,12},
{287211521,21503488,29,15},
{287133697,248626146,29,12},
{287121409,135831593,29,13},
{287113217,94271474,29,16},
{287100929,281060849,29,12},
{287035393,192524714,29,12},
{287010817,262294057,29,12},
{286953473,15207726,29,12},
{286855169,145393523,29,12},
{286851073,35160919,29,16},
{286826497,189191708,29,13},
{286781441,181817304,29,12},
{286740481,278710211,29,12},
{286707713,230910096,29,12},
{286703617,199733097,29,14},
{286691329,212633492,29,12},
{286670849,1739501,29,14},
{286666753,174414178,29,12},
{286617601,255398591,29,12},
{286568449,278785644,29,12},
{286560257,32837257,29,12},
{286535681,214211267,29,12},
{286482433,258236656,29,13},
{286474241,50882604,29,14},
{286420993,188225900,29,12},
{286412801,282179094,29,12},
{286384129,206453838,29,13},
{286375937,10657823,29,14},
{286322689,98483715,29,12},
{286216193,99051917,29,12},
{286175233,55634253,29,12},
{286126081,57978952,29,12},
{286068737,279626195,29,12},
{286007297,69621699,29,13},
{285892609,282949829,29,13},
{285806593,175465545,29,12},
{285749249,120448086,29,12},
{285745153,52239090,29,13},
{285720577,116907685,29,14},
{285700097,20828949,29,12},
{285646849,131450041,29,13},
{285614081,57113637,29,13},
{285560833,152332646,29,12},
{285491201,7404852,29,14},
{285474817,81439832,29,18},
{285388801,68816386,29,12},
{285376513,135407705,29,15},
{285294593,76387209,29,14},
{285229057,151284912,29,14},
{285204481,268854282,29,13},
{285122561,83804998,29,13},
{285044737,156612812,29,12},
{285020161,272138380,29,12},
{284987393,251788189,29,12},
{284983297,139142460,29,15},
{284971009,235820309,29,12},
{284950529,279995920,29,18},
{284803073,126517719,29,14},
{284717057,136243731,29,12},
{284700673,149025955,29,12},
{284663809,77770950,29,13},
{284655617,215809322,29,15},
{284643329,64933386,29,12},
{284618753,212548551,29,12},
{284602369,166914139,29,12},
{284569601,53316429,29,12},
{284540929,26445468,29,14},
{284532737,37224718,29,13},
{284491777,37654333,29,16},
{284454913,87934822,29,12},
{284434433,250680501,29,13},
{284368897,104043977,29,13},
{284348417,85711204,29,12},
{284282881,225155656,29,12},
{284209153,17028506,29,12},
{284098561,199209865,29,16},
{284024833,242540698,29,13},
{284016641,252571174,29,14},
{283926529,184723152,29,13},
{283852801,278907760,29,14},
{283803649,228011891,29,15},
{283779073,104525682,29,13},
{283721729,93093212,29,14},
{283693057,220361978,29,12},
{283680769,269175210,29,13},
{283586561,129174123,29,12},
{283574273,199723501,29,16},
{283537409,19178487,29,12},
{283508737,102097287,29,17},
{283471873,152972275,29,12},
{283451393,59703359,29,13},
{283410433,104667464,29,15},
{283353089,199689410,29,13},
{283348993,102227130,29,12},
{283324417,185282644,29,12},
{283291649,71478938,29,12},
{283242497,49528772,29,12},
{283226113,159427564,29,12},
{283201537,204431462,29,12},
{283144193,62273876,29,12},
{283107329,146348890,29,13},
{283041793,99823626,29,13},
{283033601,272152624,29,14},
{282992641,109226261,29,13},
{282943489,144901471,29,13},
{282836993,225000794,29,14},
{282832897,132354491,29,12},
{282800129,274338363,29,12},
{282775553,234729483,29,12},
{282750977,125197153,29,12},
{282746881,39001878,29,13},
{282738689,273865800,29,14},
{282734593,216049848,29,12},
{282726401,90720967,29,12},
{282685441,86461993,29,12},
{282664961,194542323,29,13},
{282611713,152015883,29,12},
{282505217,55580856,29,12},
{282468353,118233386,29,13},
{282406913,71269206,29,12},
{282402817,27575657,29,13},
{282390529,87887419,29,12},
{282382337,8754796,29,12},
{282341377,248495756,29,12},
{282279937,162156888,29,14},
{282193921,9797905,29,12},
{282136577,64891388,29,12},
{282132481,261752362,29,16},
{282095617,192969684,29,12},
{282062849,1786593,29,12},
{282058753,182120446,29,13},
{282021889,67615975,29,12},
{281939969,183954571,29,12},
{281935873,214124588,29,17},
{281886721,72083873,29,14},
{281866241,78439123,29,12},
{281825281,178458975,29,12},
{281776129,149661200,29,12},
{281751553,57214240,29,12},
{281743361,158511866,29,12},
{281714689,28801413,29,13},
{281690113,264161044,29,14},
{281645057,212421684,29,12},
{281620481,39359265,29,12},
{281567233,92330697,29,13},
{281530369,50356849,29,12},
{281522177,211595497,29,12},
{281485313,198250323,29,13},
{281481217,155735691,29,12},
{281395201,60954160,29,14},
{281313281,160455301,29,15},
{281202689,269633180,29,12},
{281128961,147458273,29,12},
{281116673,14805223,29,15},
{281079809,280162598,29,12},
{281055233,242533524,29,12},
{281026561,242018552,29,13},
{281014273,249645505,29,12},
{280944641,248233225,29,13},
{280891393,186618223,29,12},
{280846337,21823580,29,13},
{280842241,271533790,29,12},
{280834049,248022656,29,12},
{280768513,230058516,29,12},
{280743937,92154858,29,12},
{280670209,176116315,29,12},
{280657921,156347561,29,15},
{280649729,223210690,29,13},
{280588289,130433815,29,12},
{280576001,93245405,29,14},
{280563713,69638282,29,12},
{280485889,129985623,29,13},
{280440833,269510705,29,12},
{280424449,62721016,29,12},
{280403969,54364785,29,13},
{280375297,135400105,29,12},
{280354817,145375757,29,13},
{280301569,71485690,29,12},
{280256513,184864264,29,13},
{280252417,172668991,29,12},
{280158209,27659636,29,13},
{280117249,18859193,29,14},
{280104961,188137467,29,12},
{280096769,156836744,29,12},
{280084481,267420596,29,14},
{279986177,168776637,29,14},
{279932929,116465175,29,12},
{279912449,13963824,29,13},
{279883777,151653014,29,12},
{279838721,262825721,29,17},
{279789569,15025330,29,14},
{279736321,29647691,29,12},
{279666689,59447855,29,13},
{279625729,240908503,29,14},
{279617537,146414723,29,13},
{279613441,124554138,29,12},
{279564289,274657749,29,12},
{279556097,196671065,29,12},
{279539713,19586544,29,12},
{279502849,225342588,29,13},
{279482369,90403981,29,12},
{279453697,264168187,29,13},
{279306241,177624866,29,13},
{279212033,129452641,29,12},
{279207937,237755045,29,13},
{279171073,13909314,29,12},
{279162881,273713857,29,12},
{279150593,275633804,29,15},
{279101441,211232199,29,14},
{279085057,98065854,29,15},
{279027713,204452058,29,13},
{279023617,75296537,29,12},
{278999041,3086932,29,12},
{278990849,248098429,29,12},
{278978561,205057327,29,13},
{278941697,36385365,29,12},
{278937601,243877539,29,14},
{278925313,48147271,29,12},
{278904833,260296418,29,14},
{278876161,19451079,29,12},
{278863873,225483082,29,13},
{278843393,131774030,29,12},
{278827009,166398220,29,12},
{278818817,260398453,29,12},
{278781953,158588302,29,13},
{278777857,193435908,29,12},
{278757377,124031128,29,15},
{278720513,138515876,29,12},
{278634497,65490831,29,13},
{278597633,108123533,29,12},
{278593537,124287546,29,16},
{278556673,270717268,29,12},
{278507521,143450339,29,12},
{278495233,57880154,29,15},
{278437889,181931767,29,13},
{278384641,51412691,29,12},
{278274049,73843317,29,13},
{278249473,130545166,29,14},
{278204417,90057041,29,12},
{278151169,214208524,29,14},
{278138881,153402358,29,12},
{278130689,111325658,29,12},
{278106113,101175543,29,12},
{278102017,145988113,29,15},
{278077441,5179841,29,13},
{277995521,268535871,29,13},
{277979137,22110381,29,13},
{277946369,111412985,29,13},
{277934081,204209995,29,12},
{277921793,238692782,29,14},
{277860353,133176228,29,12},
{277831681,39473329,29,13},
{277688321,161582078,29,12},
{277659649,186347676,29,14},
{277651457,219578551,29,13},
{277549057,194909495,29,12},
{277475329,75406746,29,12},
{277405697,136959828,29,13},
{277344257,89775632,29,12},
{277327873,216715831,29,12},
{277303297,82449558,29,12},
{277270529,200162714,29,12},
{277266433,204891121,29,14},
{277229569,38478065,29,12},
{277159937,31626114,29,13},
{277143553,156642953,29,13},
{277094401,41768831,29,13},
{277086209,94034585,29,18},
{277061633,119178918,29,13},
{277012481,261749788,29,13},
{276983809,262364158,29,12},
{276975617,233783446,29,12},
{276971521,11032499,29,14},
{276889601,95414632,29,16},
{276729857,262500680,29,12},
{276668417,227726745,29,13},
{276656129,98405957,29,12},
{276590593,44584886,29,12},
{276570113,249757516,29,13},
{276553729,248543538,29,13},
{276492289,158781984,29,12},
{276430849,64726980,29,17},
{276418561,148593622,29,12},
{276398081,81529417,29,15},
{276344833,150493253,29,12},
{276295681,84833795,29,12},
{276197377,212492291,29,12},
{276172801,156266657,29,12},
{276160513,239391039,29,13},
{276123649,267344025,29,12},
{276111361,256066465,29,13},
{276062209,112043181,29,13},
{276037633,238257357,29,18},
{276029441,93196974,29,13},
{275988481,31202725,29,14},
{275939329,247476477,29,15},
{275931137,185807574,29,13},
{275890177,222541882,29,14},
{275869697,220100839,29,12},
{275845121,167916860,29,12},
{275804161,7044438,29,12},
{275693569,111799283,29,14},
{275582977,110931088,29,12},
{275525633,241557321,29,12},
{275521537,274784109,29,13},
{275488769,71655192,29,13},
{275439617,152500104,29,13},
{275435521,144720683,29,12},
{275386369,182598720,29,12},
{275365889,66884868,29,14},
{275337217,223179789,29,12},
{275214337,163627151,29,12},
{275107841,117529502,29,12},
{275034113,174386506,29,12},
{275005441,197199986,29,14},
{274894849,145196622,29,12},
{274886657,211358871,29,12},
{274726913,120686212,29,21},
{274685953,191687950,29,13},
{274640897,190674311,29,12},
{274636801,268754491,29,13},
{274628609,113121966,29,15},
{274624513,223813014,29,12},
{274575361,171114442,29,12},
{274505729,164241615,29,13},
{274481153,172878409,29,14},
{274440193,159858374,29,13},
{274321409,236097911,29,12},
{274309121,9186371,29,13},
{274296833,268931637,29,12},
{274292737,221370390,29,13},
{274259969,25411400,29,13},
{274247681,119773416,29,12},
{274194433,168278887,29,13},
{274173953,271115983,29,12},
{274149377,95633780,29,12},
{274083841,34573944,29,12},
{274034689,18867595,29,12},
{273805313,137362444,29,12},
{273801217,54929502,29,13},
{273788929,124422364,29,12},
{273764353,112617293,29,12},
{273739777,213362178,29,12},
{273715201,6918025,29,12},
{273653761,69120178,29,13},
{273645569,69717526,29,15},
{273633281,130650338,29,12},
{273620993,3963241,29,13},
{273616897,117581228,29,12},
{273580033,58079682,29,15},
{273461249,154539147,29,12},
{273395713,112399699,29,12},
{273375233,226720241,29,13},
{273235969,97321670,29,14},
{273186817,126228552,29,15},
{273174529,123041514,29,12},
{273166337,108664182,29,12},
{273149953,104843855,29,12},
{273129473,157928685,29,13},
{273113089,46489612,29,13},
{273018881,245098249,29,12},
{272990209,185567629,29,15},
{272928769,4167328,29,12},
{272879617,64719208,29,12},
{272760833,122275086,29,17},
{272719873,195358430,29,13},
{272699393,234875005,29,12},
{272670721,64819610,29,13},
{272560129,155537655,29,12},
{272539649,29642030,29,13},
{272535553,248984043,29,12},
{272478209,125085015,29,12},
{272429057,204636486,29,12},
{272363521,4199340,29,12},
{272314369,174273620,29,12},
{272228353,32133566,29,13},
{272142337,83164150,29,12},
{272097281,190267979,29,13},
{272068609,6298645,29,12},
{272060417,89770786,29,12},
{272019457,18773749,29,12},
{271962113,48880061,29,12},
{271958017,15229603,29,14},
{271937537,102700208,29,12},
{271896577,54167990,29,12},
{271872001,28148451,29,12},
{271839233,120618780,29,12},
{271761409,223769714,29,14},
{271736833,177367162,29,13},
{271728641,81397999,29,14},
{271699969,233326479,29,12},
{271687681,173954401,29,13},
{271650817,65490089,29,12},
{271618049,110760644,29,12},
{271593473,218763052,29,12},
{271589377,161235397,29,13},
{271564801,176681709,29,14},
{271544321,72201944,29,12},
{271532033,267448551,29,14},
{271470593,226468410,29,12},
{271392769,223036080,29,13},
{271380481,172811687,29,12},
{271310849,75134512,29,13},
{271306753,97467010,29,12},
{271286273,230229691,29,15},
{271257601,41507546,29,12},
{271183873,206044912,29,12},
{271163393,3297988,29,13},
{271126529,213669171,29,12},
{271097857,102918315,29,13},
{271065089,92469512,29,13},
{271052801,90483042,29,12},
{270950401,269564554,29,13},
{270929921,117874825,29,12},
{270913537,210178668,29,12},
{270880769,31358312,29,12},
{270794753,11593786,29,18},
{270790657,79125962,29,12},
{270770177,154832008,29,13},
{270766081,114556658,29,12},
{270581761,17050087,29,14},
{270569473,51126774,29,12},
{270532609,259709108,29,21},
{270499841,12547977,29,15},
{270450689,263232385,29,14},
{270446593,212933239,29,12},
{270438401,220535030,29,12},
{270364673,217869730,29,12},
{270360577,109280172,29,13},
{270348289,166134071,29,12},
{270241793,87490604,29,12},
{270237697,36839094,29,15},
{270225409,252815020,29,12},
{270151681,147808103,29,12},
{269991937,232718560,29,14},
{269905921,155702593,29,12},
{269844481,191997529,29,15},
{269824001,66580061,29,12},
{269807617,36599127,29,12},
{269733889,184538825,29,12},
{269660161,209679621,29,12},
{269586433,23640025,29,12},
{269561857,205866133,29,12},
{269529089,261161113,29,12},
{269504513,156345721,29,12},
{269414401,240705560,29,12},
{269402113,37875201,29,14},
{269365249,58008870,29,12},
{269344769,85932610,29,13},
{269316097,240565128,29,12},
{269295617,45773440,29,13},
{269279233,230460065,29,13},
{269258753,119874574,29,12},
{269230081,29404391,29,13},
{269221889,185779497,29,18},
{269193217,6585141,29,12},
{269148161,210048226,29,13},
{269135873,161574904,29,12},
{269119489,95008431,29,12},
{269049857,122598394,29,13},
{268947457,131307970,29,12},
{268935169,62272173,29,13},
{268890113,156237469,29,12},
{268861441,29737469,29,15},
{268840961,19603651,29,12},
{268804097,51060157,29,13},
{268787713,151638621,29,13},
{268779521,70724940,29,14},
{268730369,51927950,29,15},
{268718081,262139531,29,12},
{268689409,192294430,29,13},
{268677121,186983494,29,12},
{268664833,91678374,29,15},
{268640257,218131045,29,13},
{268582913,197382283,29,14},
{268496897,1612764,29,12},
{268460033,142155586,29,13},
{268369921,54707015,28,16},
{268361729,197527063,28,13},
{268271617,88366872,28,15},
{268238849,205669083,28,16},
{268189697,107535640,28,14},
{268185601,230715646,28,12},
{268177409,197148604,28,12},
{268148737,26459837,28,13},
{268091393,64570641,28,14},
{268042241,244770479,28,17},
{268001281,214638227,28,13},
{267968513,189451632,28,13},
{267943937,200671166,28,15},
{267804673,254790352,28,13},
{267767809,198461431,28,12},
{267644929,172016709,28,12},
{267571201,11066155,28,12},
{267558913,195519143,28,13},
{267550721,54064434,28,15},
{267489281,214741034,28,12},
{267472897,28288708,28,12},
{267436033,133349072,28,14},
{267427841,234861537,28,13},
{267411457,67896785,28,13},
{267337729,102031919,28,14},
{267317249,59190811,28,12},
{267292673,235552537,28,12},
{267268097,194109373,28,12},
{267227137,172927676,28,12},
{267202561,165979773,28,12},
{267108353,34747179,28,14},
{267067393,83640627,28,13},
{267059201,38830679,28,16},
{267022337,221148049,28,12},
{267010049,137045634,28,14},
{267005953,165007040,28,12},
{266895361,208271839,28,15},
{266887169,60105262,28,13},
{266858497,68639587,28,12},
{266838017,36314338,28,13},
{266825729,123062793,28,12},
{266813441,64604208,28,14},
{266776577,109903310,28,12},
{266735617,45739468,28,12},
{266579969,86121799,28,12},
{266551297,10848206,28,14},
{266526721,159771309,28,13},
{266514433,81503495,28,12},
{266506241,86175836,28,12},
{266407937,1384347,28,12},
{266334209,65871823,28,12},
{266309633,141691500,28,12},
{266293249,27182720,28,12},
{266231809,108788085,28,13},
{266162177,159012360,28,12},
{266145793,180682357,28,12},
{266125313,126150852,28,14},
{266096641,45130878,28,12},
{265875457,213555907,28,12},
{265777153,236643577,28,12},
{265732097,137604107,28,14},
{265695233,248859848,28,12},
{265658369,199777951,28,13},
{265654273,23164671,28,12},
{265605121,6760233,28,12},
{265486337,168400145,28,16},
{265445377,155771240,28,13},
{265433089,81113603,28,12},
{265420801,17901136,28,17},
{265400321,224397588,28,12},
{265359361,225617040,28,12},
{265338881,65905341,28,14},
{265285633,264545850,28,12},
{265265153,197071995,28,13},
{265248769,99280217,28,13},
{265199617,1040996,28,13},
{265179137,137710919,28,12},
{265166849,109254182,28,13},
{265138177,129544628,28,12},
{265101313,14127464,28,13},
{265080833,181045048,28,12},
{265043969,105440578,28,14},
{265003009,103085139,28,13},
{264941569,189056676,28,12},
{264933377,197681278,28,12},
{264921089,181650773,28,13},
{264908801,180803081,28,12},
{264847361,235473496,28,14},
{264818689,10259366,28,12},
{264749057,224849618,28,14},
{264732673,96846924,28,15},
{264663041,118128019,28,12},
{264634369,117064984,28,17},
{264622081,11263688,28,12},
{264589313,53825302,28,12},
{264564737,140906133,28,12},
{264499201,150513007,28,12},
{264364033,23258406,28,13},
{264343553,226853456,28,12},
{264306689,209851295,28,16},
{264282113,124192009,28,13},
{264245249,32768365,28,12},
{264171521,39243530,28,12},
{264134657,255481094,28,13},
{264097793,116248029,28,12},
{264081409,100836461,28,12},
{264069121,66842618,28,13},
{264019969,19954184,28,13},
{263913473,5346929,28,16},
{263884801,136586238,28,12},
{263766017,231025257,28,14},
{263753729,170335052,28,12},
{263729153,233515212,28,12},
{263643137,251816361,28,13},
{263581697,232543735,28,12},
{263540737,90871575,28,12},
{263528449,106157256,28,13},
{263503873,140126490,28,14},
{263454721,213471764,28,18},
{263335937,312239,28,12},
{263331841,176480523,28,13},
{263323649,121639108,28,17},
{263311361,217040711,28,12},
{263274497,103426790,28,14},
{263270401,102953140,28,12},
{263258113,193121466,28,16},
{263237633,96605084,28,12},
{263221249,235297858,28,12},
{263098369,241676833,28,12},
{263086081,94429725,28,13},
{263049217,56195739,28,12},
{262991873,168527671,28,12},
{262926337,225078014,28,12},
{262868993,16075734,28,12},
{262852609,90681982,28,12},
{262635521,243989438,28,15},
{262623233,258215623,28,12},
{262594561,182797904,28,13},
{262557697,51706633,28,12},
{262524929,250697889,28,12},
{262500353,249444474,28,12},
{262496257,171710004,28,13},
{262434817,182787511,28,12},
{262397953,160765937,28,13},
{262361089,239793091,28,12},
{262328321,77571699,28,12},
{262311937,57591150,28,12},
{262279169,191257118,28,12},
{262250497,30554489,28,13},
{262193153,155288540,28,14},
{262176769,219357651,28,15},
{262103041,34314769,28,13},
{262070273,145707059,28,13},
{262066177,158345035,28,12},
{261947393,135993983,28,16},
{261931009,250457945,28,14},
{261881857,97403207,28,18},
{261824513,144295164,28,13},
{261783553,127328132,28,15},
{261775361,77456578,28,13},
{261758977,31316795,28,13},
{261738497,13317884,28,12},
{261701633,83106662,28,14},
{261623809,177622044,28,12},
{261562369,134369129,28,13},
{261488641,204541688,28,17},
{261480449,40771625,28,13},
{261419009,26178484,28,12},
{261406721,112566799,28,14},
{261328897,87145408,28,12},
{261308417,175245047,28,14},
{261296129,43859984,28,12},
{261271553,80864270,28,12},
{261206017,193868593,28,12},
{261144577,91214788,28,14},
{261050369,54946978,28,12},
{260947969,154735122,28,14},
{260898817,136648962,28,16},
{260886529,253691605,28,12},
{260878337,100173921,28,12},
{260841473,101474181,28,13},
{260800513,108138076,28,15},
{260792321,54017181,28,13},
{260755457,160495648,28,12},
{260702209,112315126,28,17},
{260694017,43960075,28,13},
{260689921,4295193,28,12},
{260657153,233088932,28,12},
{260640769,231266716,28,12},
{260571137,132093648,28,19},
{260558849,173937278,28,12},
{260493313,161355723,28,12},
{260468737,180844866,28,12},
{260386817,113993614,28,12},
{260362241,190879965,28,12},
{260345857,107673094,28,12},
{260333569,80159400,28,13},
{260116481,52588244,28,12},
{260087809,150552875,28,13},
{260063233,258010998,28,14},
{260055041,205836050,28,13},
{260038657,66676481,28,13},
{260001793,179937663,28,12},
{259977217,42340206,28,12},
{259891201,147481287,28,13},
{259854337,203675601,28,12},
{259694593,90246206,28,13},
{259502081,249278482,28,12},
{259485697,104915965,28,12},
{259350529,176881462,28,13},
{259215361,79006243,28,12},
{259166209,155158430,28,12},
{259145729,213028275,28,14},
{259141633,137617914,28,12},
{259121153,111199495,28,13},
{259096577,251363693,28,15},
{259080193,226588111,28,14},
{259043329,10365856,28,12},
{258936833,77220081,28,12},
{258912257,193381549,28,12},
{258908161,16931055,28,13},
{258899969,113879275,28,15},
{258859009,133148115,28,13},
{258850817,54166860,28,14},
{258838529,166715934,28,12},
{258772993,109539589,28,12},
{258752513,76668371,28,14},
{258691073,100495838,28,12},
{258662401,213011626,28,13},
{258650113,43659785,28,12},
{258605057,177862351,28,17},
{258543617,191258353,28,12},
{258469889,137240112,28,12},
{258441217,80322212,28,15},
{258404353,205446365,28,12},
{258334721,97522672,28,13},
{258306049,230202776,28,12},
{258256897,185670429,28,12},
{258138113,163641537,28,13},
{258027521,10268005,28,12},
{257974273,127625742,28,13},
{257966081,46216631,28,14},
{257953793,84148113,28,12},
{257949697,119738366,28,21},
{257925121,247909871,28,13},
{257826817,27149332,28,13},
{257806337,115896664,28,12},
{257794049,219495223,28,13},
{257789953,33635347,28,12},
{257667073,66834402,28,12},
{257560577,215450021,28,12},
{257536001,7946104,28,12},
{257486849,158745880,28,12},
{257376257,47106405,28,14},
{257249281,48682920,28,12},
{257216513,114437052,28,12},
{257200129,90490561,28,12},
{257191937,197956621,28,12},
{257187841,89229465,28,13},
{257118209,132539439,28,12},
{257056769,62580224,28,13},
{257003521,21549575,28,12},
{256995329,912319,28,12},
{256921601,240402923,28,12},
{256909313,28947571,28,13},
{256905217,33338054,28,12},
{256880641,98455940,28,12},
{256847873,172647111,28,12},
{256831489,156099208,28,12},
{256798721,245708351,28,12},
{256770049,179298703,28,17},
{256749569,145360768,28,12},
{256684033,65402709,28,12},
{256675841,207608673,28,12},
{256663553,226550263,28,13},
{256622593,161795078,28,14},
{256614401,110702874,28,13},
{256516097,126205031,28,13},
{256393217,35918789,28,14},
{256376833,61438381,28,19},
{256339969,201704083,28,12},
{256327681,212086557,28,14},
{256307201,126196586,28,12},
{256184321,179373938,28,12},
{256155649,15512014,28,13},
{256147457,210672676,28,15},
{256135169,79678418,28,12},
{256106497,124814407,28,13},
{256049153,90775233,28,16},
{256000001,237369295,28,14},
{255938561,61959416,28,12},
{255926273,75384452,28,13},
{255909889,28418971,28,13},
{255840257,112821866,28,12},
{255741953,146839336,28,12},
{255717377,202283743,28,12},
{255643649,19440889,28,12},
{255619073,918477,28,12},
{255614977,220082481,28,13},
{255602689,70380249,28,12},
{255594497,99071872,28,12},
{255496193,124692253,28,12},
{255418369,15768705,28,13},
{255393793,144990529,28,16},
{255356929,178548331,28,12},
{255336449,235659606,28,13},
{255307777,223856510,28,12},
{255295489,18099639,28,15},
{255250433,18910176,28,12},
{255246337,162831222,28,14},
{255225857,124252561,28,12},
{255209473,76996776,28,12},
{255201281,242592466,28,12},
{255152129,121739914,28,12},
{255127553,63643771,28,12},
{255111169,241876897,28,12},
{255102977,219848167,28,12},
{255098881,214504929,28,15},
{255025153,185320894,28,13},
{254988289,49201855,28,12},
{254955521,137359927,28,12},
{254902273,160389659,28,15},
{254853121,82573952,28,14},
{254820353,135794807,28,14},
{254816257,34035966,28,12},
{254754817,69214890,28,14},
{254730241,757278,28,13},
{254722049,2888672,28,14},
{254693377,205909710,28,12},
{254656513,237703972,28,14},
{254619649,71613524,28,12},
{254586881,90415362,28,12},
{254537729,196473990,28,12},
{254525441,115886544,28,14},
{254484481,185362157,28,13},
{254353409,39916185,28,13},
{254349313,236196189,28,12},
{254341121,124671436,28,12},
{254304257,22053685,28,13},
{254279681,55164525,28,19},
{254189569,48815535,28,13},
{254156801,30450109,28,13},
{254083073,49892954,28,16},
{254033921,104276296,28,14},
{253984769,124336482,28,15},
{253956097,16466126,28,12},
{253931521,26863197,28,12},
{253861889,52697338,28,13},
{253849601,193026691,28,12},
{253734913,215944772,28,12},
{253689857,26022785,28,16},
{253530113,243296711,28,12},
{253526017,115993649,28,15},
{253493249,16329415,28,18},
{253480961,243242083,28,12},
{253452289,239438694,28,13},
{253419521,201113142,28,13},
{253390849,162803056,28,12},
{253378561,56849875,28,14},
{253329409,240005738,28,15},
{253308929,168034749,28,12},
{253304833,227755712,28,13},
{253100033,126722973,28,17},
{253095937,236319054,28,12},
{253063169,20956653,28,12},
{253014017,183976387,28,12},
{253001729,56970095,28,15},
{252952577,90861599,28,14},
{252948481,100891033,28,12},
{252928001,111451201,28,13},
{252829697,135515479,28,13},
{252792833,95361922,28,12},
{252694529,63257679,28,12},
{252592129,46303834,28,14},
{252542977,53024951,28,15},
{252518401,236840979,28,13},
{252485633,79838726,28,13},
{252469249,139900868,28,13},
{252461057,226627268,28,14},
{252456961,152028744,28,12},
{252362753,220100804,28,14},
{252264449,180840516,28,14},
{252260353,54667042,28,12},
{252235777,6866976,28,12},
{252203009,152391661,28,12},
{252174337,251521993,28,13},
{252162049,139987694,28,12},
{252092417,250332888,28,13},
{252006401,200247273,28,12},
{251969537,251620970,28,14},
{251891713,104255281,28,12},
{251871233,238451039,28,14},
{251842561,50416646,28,12},
{251834369,243946467,28,12},
{251772929,175159450,28,14},
{251748353,107026365,28,13},
{251711489,130218822,28,12},
{251662337,70280041,28,12},
{251637761,244330641,28,12},
{251473921,125885947,28,12},
{251453441,212154617,28,13},
{251441153,116917583,28,12},
{251424769,169383450,28,12},
{251404289,229724575,28,13},
{251338753,224897854,28,13},
{251330561,226055351,28,16},
{251281409,22548094,28,14},
{251240449,174649010,28,13},
{251228161,72209480,28,12},
{251207681,243372856,28,13},
{251179009,72947193,28,12},
{251170817,159641883,28,12},
{251154433,47171927,28,12},
{251072513,197182431,28,12},
{251068417,66480530,28,16},
{250974209,44318740,28,12},
{250970113,161711799,28,15},
{250802177,240122098,28,12},
{250699777,143281042,28,13},
{250662913,195388555,28,12},
{250556417,66490733,28,12},
{250552321,166731758,28,13},
{250515457,50502913,28,12},
{250433537,196968204,28,12},
{250380289,65893673,28,15},
{250372097,47030717,28,13},
{250335233,70007901,28,12},
{250269697,244223277,28,12},
{250249217,224392045,28,15},
{250224641,181438559,28,13},
{250146817,42084850,28,12},
{250134529,112383760,28,14},
{250126337,12492997,28,13},
{250089473,180749636,28,12},
{250064897,142809926,28,12},
{250060801,176071259,28,13},
{250040321,222559597,28,12},
{250028033,105468585,28,13},
{250011649,191613512,28,13},
{249925633,245190135,28,12},
{249880577,155462325,28,13},
{249876481,89426225,28,12},
{249806849,244280426,28,14},
{249794561,40015516,28,12},
{249765889,194187815,28,13},
{249745409,54535380,28,12},
{249683969,236939853,28,13},
{249659393,135215420,28,15},
{249655297,56278553,28,12},
{249593857,151214549,28,15},
{249561089,140793965,28,21},
{249536513,233384613,28,13},
{249487361,140689117,28,13},
{249438209,4883250,28,13},
{249434113,221119595,28,12},
{249376769,197418213,28,12},
{249315329,221821216,28,14},
{249311233,39754104,28,12},
{249229313,9023286,28,12},
{249151489,127937546,28,14},
{249139201,143470247,28,12},
{249118721,231921322,28,14},
{249065473,189037136,28,12},
{249020417,22455918,28,14},
{248995841,210899749,28,13},
{248893441,163487606,28,12},
{248881153,157346981,28,13},
{248856577,27230497,28,14},
{248795137,208467377,28,12},
{248721409,42844176,28,12},
{248709121,124746041,28,16},
{248700929,124380410,28,13},
{248688641,209816862,28,12},
{248549377,138915660,28,12},
{248537089,169411787,28,13},
{248475649,203466452,28,12},
{248328193,117164540,28,12},
{248320001,127024974,28,12},
{248303617,28913968,28,12},
{248197121,182265054,28,12},
{248135681,235107202,28,14},
{248086529,104445933,28,15},
{248061953,144841725,28,13},
{248057857,55338145,28,12},
{248045569,87054072,28,13},
{247939073,14343185,28,14},
{247902209,126822853,28,12},
{247889921,53951527,28,15},
{247873537,110841593,28,14},
{247861249,17350778,28,12},
{247853057,107946146,28,12},
{247828481,211111818,28,12},
{247791617,146240041,28,16},
{247787521,61553601,28,12},
{247767041,244855978,28,13},
{247730177,91002462,28,12},
{247713793,234645382,28,12},
{247689217,43920147,28,12},
{247566337,233787065,28,12},
{247504897,119531962,28,13},
{247472129,238972628,28,13},
{247431169,116000303,28,15},
{247422977,8175966,28,13},
{247418881,208979730,28,12},
{247410689,148899104,28,12},
{247369729,158299504,28,12},
{247361537,140998423,28,12},
{247308289,130091157,28,13},
{247287809,143946090,28,12},
{247283713,52220234,28,14},
{247275521,39288753,28,13},
{247259137,169429747,28,13},
{247185409,45877507,28,14},
{247136257,178478806,28,16},
{247099393,83065040,28,12},
{247037953,152125913,28,15},
{247001089,203266775,28,12},
{246956033,222654943,28,14},
{246931457,50535050,28,13},
{246878209,226775313,28,12},
{246865921,231178928,28,13},
{246771713,88284941,28,12},
{246755329,83090580,28,12},
{246743041,6261142,28,16},
{246521857,243400270,28,13},
{246476801,147688360,28,12},
{246464513,208679010,28,14},
{246415361,207549474,28,20},
{246312961,23062235,28,12},
{246276097,217764546,28,13},
{246243329,87557773,28,13},
{246177793,39469227,28,13},
{246157313,44139991,28,12},
{246132737,144543768,28,12},
{246067201,25700521,28,12},
{245956609,176718288,28,16},
{245932033,186668890,28,13},
{245862401,84755689,28,12},
{245784577,177731810,28,13},
{245764097,66186077,28,12},
{245760001,243552383,28,17},
{245702657,242972865,28,13},
{245698561,91345554,28,12},
{245637121,39585169,28,13},
{245604353,44654773,28,13},
{245579777,22641673,28,14},
{245567489,48644118,28,12},
{245477377,60557144,28,12},
{245444609,114865011,28,12},
{245440513,192994772,28,13},
{245379073,90722583,28,12},
{245354497,82305629,28,12},
{245297153,116941172,28,12},
{245293057,82650226,28,13},
{245260289,95667316,28,13},
{245235713,52225843,28,17},
{245125121,199487857,28,12},
{245075969,127378592,28,12},
{245051393,219442994,28,12},
{245035009,125360001,28,12},
{245022721,38836026,28,14},
{245014529,539687,28,13},
{245010433,181776371,28,12},
{244973569,216342137,28,17},
{244965377,178732323,28,13},
{244928513,210751904,28,12},
{244887553,53428639,28,12},
{244879361,229811064,28,12},
{244850689,163396748,28,13},
{244842497,188635778,28,19},
{244838401,88016077,28,12},
{244817921,117612747,28,13},
{244707329,7426736,28,12},
{244695041,218500516,28,14},
{244658177,205184955,28,12},
{244555777,28674911,28,13},
{244535297,115413854,28,12},
{244432897,77418169,28,14},
{244408321,170099444,28,13},
{244387841,151395276,28,12},
{244359169,126369672,28,13},
{244289537,112573720,28,12},
{244264961,37742405,28,12},
{244248577,48620277,28,12},
{244228097,39279924,28,13},
{244211713,27596363,28,13},
{244174849,179430931,28,12},
{244162561,162828217,28,13},
{244129793,230917643,28,13},
{244113409,25448477,28,13},
{244092929,33520472,28,12},
{244088833,751063,28,15},
{243990529,88182194,28,16},
{243945473,50359032,28,12},
{243929089,59358810,28,12},
{243904513,35100203,28,12},
{243896321,125843342,28,12},
{243843073,85304130,28,14},
{243773441,77629027,28,12},
{243757057,211546923,28,12},
{243699713,202003131,28,12},
{243683329,135096825,28,12},
{243671041,2899521,28,13},
{243613697,127456208,28,14},
{243597313,104911588,28,16},
{243539969,206127399,28,13},
{243527681,33334660,28,12},
{243511297,182517577,28,12},
{243486721,43510425,28,12},
{243453953,142717899,28,12},
{243412993,21547776,28,12},
{243388417,239442400,28,12},
{243376129,229625786,28,13},
{243343361,80942645,28,13},
{243281921,113472992,28,12},
{243265537,63524456,28,12},
{243240961,48353688,28,12},
{243204097,104853296,28,16},
{243183617,35464652,28,12},
{243142657,18300767,28,12},
{243122177,130408758,28,14},
{243118081,98000738,28,12},
{243023873,47279098,28,14},
{242995201,198580083,28,12},
{242987009,138952382,28,12},
{242925569,119833577,28,14},
{242851841,212795581,28,13},
{242835457,33691332,28,13},
{242814977,99158238,28,12},
{242802689,192855728,28,13},
{242679809,62133852,28,16},
{242577409,176897102,28,12},
{242556929,78934276,28,13},
{242552833,172362082,28,12},
{242528257,172305734,28,12},
{242495489,201506290,28,12},
{242405377,21346769,28,12},
{242368513,176328055,28,14},
{242307073,70933972,28,12},
{242286593,219897289,28,16},
{242249729,97476932,28,12},
{242196481,191582901,28,13},
{242126849,217803897,28,12},
{242077697,25205738,28,12},
{242036737,110892362,28,12},
{241963009,168241535,28,12},
{241950721,113145087,28,13},
{241917953,7952533,28,13},
{241868801,167954559,28,13},
{241831937,162193000,28,12},
{241827841,202518133,28,17},
{241778689,15046365,28,14},
{241745921,79879888,28,14},
{241733633,226618305,28,12},
{241717249,99020182,28,12},
{241709057,24622723,28,12},
{241573889,184416757,28,13},
{241569793,2535066,28,12},
{241561601,101358399,28,12},
{241520641,65580128,28,12},
{241483777,115219955,28,14},
{241410049,124803311,28,13},
{241401857,96798251,28,15},
{241377281,98291248,28,13},
{241340417,104339425,28,12},
{241274881,108594530,28,12},
{241254401,82542913,28,14},
{241238017,191354830,28,16},
{241201153,1232786,28,12},
{241192961,130235642,28,12},
{241152001,9450205,28,12},
{241131521,91559424,28,13},
{241057793,60016716,28,14},
{241033217,214709951,28,13},
{241020929,37609179,28,12},
{241016833,3060117,28,13},
{240979969,26827569,28,12},
{240918529,44830051,28,13},
{240893953,176449814,28,14},
{240885761,74516191,28,13},
{240848897,120566623,28,12},
{240824321,49377511,28,12},
{240795649,26678420,28,14},
{240771073,198563727,28,13},
{240762881,88119615,28,14},
{240664577,43023829,28,14},
{240648193,175112530,28,19},
{240627713,172885053,28,12},
{240578561,173783656,28,12},
{240549889,178802472,28,15},
{240488449,61043080,28,12},
{240427009,38637117,28,13},
{240418817,208576166,28,15},
{240402433,235354150,28,14},
{240377857,226668265,28,13},
{240365569,227141183,28,12},
{240279553,106442591,28,13},
{240173057,40192765,28,14},
{240156673,25535178,28,15},
{240148481,74979852,28,13},
{240132097,117835891,28,13},
{240119809,124610398,28,12},
{240111617,84903903,28,12},
{240033793,161855786,28,13},
{239996929,87690229,28,12},
{239976449,129031917,28,14},
{239964161,48729922,28,12},
{239935489,190237235,28,13},
{239915009,62247854,28,12},
{239890433,134839796,28,12},
{239861761,26231485,28,18},
{239853569,66066949,28,13},
{239828993,208444801,28,15},
{239767553,77866252,28,12},
{239763457,176801720,28,15},
{239742977,138604735,28,12},
{239702017,137502949,28,12},
{239628289,42814751,28,12},
{239546369,178263481,28,12},
{239534081,28976682,28,16},
{239456257,31218835,28,12},
{239394817,89026017,28,13},
{239362049,191416311,28,13},
{239337473,160167983,28,18},
{239312897,231148838,28,13},
{239300609,103654294,28,12},
{239276033,20052197,28,12},
{239214593,43828599,28,13},
{239210497,173310181,28,12},
{239198209,160138047,28,13},
{239104001,124193698,28,12},
{239067137,146963585,28,13},
{239013889,122549176,28,12},
{238903297,187002200,28,13},
{238878721,208286511,28,16},
{238870529,162941371,28,13},
{238858241,190855958,28,12},
{238821377,171143624,28,13},
{238698497,176949416,28,14},
{238686209,37297309,28,12},
{238624769,67201703,28,13},
{238583809,168841247,28,15},
{238538753,205607850,28,12},
{238522369,62141843,28,12},
{238497793,131814298,28,12},
{238452737,34869131,28,15},
{238448641,7964178,28,12},
{238436353,20601543,28,14},
{238366721,33666562,28,12},
{238329857,105464883,28,13},
{238264321,77009944,28,13},
{238256129,9102906,28,15},
{238252033,134286052,28,12},
{238206977,128152510,28,14},
{238194689,71644438,28,12},
{238170113,114724385,28,12},
{238133249,201234311,28,13},
{238071809,161655065,28,12},
{238043137,167395451,28,14},
{238022657,81389797,28,12},
{237985793,14228877,28,13},
{237981697,136169845,28,12},
{237948929,155175035,28,12},
{237813761,133255945,28,14},
{237776897,6943445,28,12},
{237760513,89025536,28,12},
{237678593,30512382,28,12},
{237654017,133231834,28,12},
{237649921,8891352,28,14},
{237555713,215025843,28,12},
{237551617,168617383,28,14},
{237395969,163494296,28,13},
{237391873,188634259,28,12},
{237273089,86975742,28,15},
{237248513,78494493,28,13},
{237211649,100877046,28,12},
{237182977,104838177,28,13},
{237096961,108629421,28,12},
{237060097,94562131,28,14},
{237015041,173509719,28,12},
{236953601,51958729,28,13},
{236924929,171123027,28,12},
{236900353,171998000,28,12},
{236863489,40022244,28,14},
{236838913,98779752,28,13},
{236830721,226204924,28,14},
{236818433,70878777,28,12},
{236781569,228268513,28,16},
{236716033,164398411,28,18},
{236707841,35968239,28,13},
{236691457,101869033,28,13},
{236658689,90098310,28,13},
{236617729,30038032,28,15},
{236609537,145133236,28,13},
{236593153,34184378,28,13},
{236584961,92701629,28,17},
{236572673,121765866,28,12},
{236494849,183897697,28,13},
{236449793,58513498,28,12},
{236421121,126649739,28,15},
{236384257,46660654,28,12},
{236302337,183587873,28,12},
{236249089,178279143,28,13},
{236179457,206805965,28,12},
{236175361,64170759,28,14},
{236163073,751050,28,12},
{236154881,231210514,28,12},
{236118017,68520595,28,13},
{236113921,26673721,28,12},
{236064769,29753326,28,12},
{235982849,80500920,28,12},
{235978753,117799557,28,14},
{235970561,168850740,28,13},
{235896833,206885229,28,15},
{235892737,223725089,28,12},
{235868161,226320294,28,12},
{235859969,41622758,28,12},
{235835393,138300942,28,12},
{235798529,20207239,28,17},
{235663361,72140479,28,12},
{235626497,11515641,28,13},
{235552769,75637083,28,14},
{235528193,79534491,28,13},
{235487233,84902268,28,14},
{235462657,89762959,28,13},
{235438081,206592769,28,15},
{235294721,125220554,28,12},
{235257857,28594872,28,14},
{235241473,172908469,28,15},
{235196417,185468578,28,12},
{235184129,181967052,28,13},
{235171841,124761589,28,12},
{235130881,51456712,28,12},
{235098113,170516951,28,12},
{235036673,30700,28,13},
{235008001,93675140,28,12},
{234889217,93394957,28,13},
{234835969,8212739,28,12},
{234786817,113633580,28,12},
{234651649,110907083,28,15},
{234631169,134423659,28,12},
{234627073,129765397,28,13},
{234557441,185488459,28,12},
{234545153,28987017,28,13},
{234520577,9503201,28,15},
{234516481,53365234,28,12},
{234479617,215800316,28,13},
{234442753,131862865,28,12},
{234405889,34555587,28,14},
{234356737,8272122,28,19},
{234344449,119188674,28,12},
{234270721,119226434,28,12},
{234262529,45167070,28,12},
{234250241,95439101,28,13},
{234196993,89111674,28,12},
{234147841,33209016,28,12},
{234135553,120606052,28,13},
{234090497,114828337,28,12},
{234012673,37482294,28,14},
{233951233,23374876,28,12},
{233926657,211508318,28,12},
{233889793,214270032,28,13},
{233865217,40492020,28,15},
{233779201,177745519,28,12},
{233635841,91745669,28,16},
{233623553,83131207,28,12},
{233607169,62056931,28,12},
{233574401,225920022,28,12},
{233537537,161886096,28,15},
{233533441,211394593,28,12},
{233459713,212018075,28,12},
{233451521,207832172,28,12},
{233336833,61818468,28,12},
{233267201,123741290,28,13},
{233254913,133939576,28,12},
{233238529,75914561,28,12},
{233230337,188690960,28,12},
{233164801,87858794,28,12},
{233144321,133743458,28,15},
{233091073,156431624,28,12},
{233066497,224454362,28,12},
{232980481,106007278,28,16},
{232910849,80362278,28,12},
{232775681,80768817,28,13},
{232734721,6330155,28,14},
{232722433,206590837,28,12},
{232660993,209593932,28,13},
{232652801,42645634,28,17},
{232624129,133084973,28,12},
{232542209,200599915,28,12},
{232538113,135064699,28,14},
{232513537,209913573,28,13},
{232501249,165719946,28,12},
{232488961,216072578,28,15},
{232390657,22861003,28,17},
{232345601,74506343,28,12},
{232329217,223467088,28,12},
{232284161,231524665,28,13},
{232255489,58839729,28,12},
{232230913,141098151,28,12},
{232222721,22284124,28,12},
{232112129,141608766,28,14},
{232099841,91076606,28,12},
{232083457,149106356,28,12},
{232062977,94882099,28,16},
{232022017,76157782,28,13},
{231960577,39782534,28,12},
{231862273,1310428,28,12},
{231841793,90323697,28,13},
{231817217,2121712,28,14},
{231718913,52977860,28,14},
{231690241,125227803,28,12},
{231657473,51068219,28,12},
{231641089,39189465,28,12},
{231628801,140368239,28,13},
{231596033,201098626,28,13},
{231567361,89053500,28,12},
{231555073,229451281,28,14},
{231473153,130664675,28,18},
{231456769,31072551,28,14},
{231383041,190050742,28,13},
{231362561,77692729,28,12},
{231346177,123469931,28,12},
{231333889,154028068,28,13},
{231272449,83578227,28,12},
{231247873,222128738,28,12},
{231223297,143775696,28,12},
{231161857,226299973,28,14},
{231141377,119259518,28,12},
{231116801,53750756,28,12},
{231100417,219416940,28,12},
{231088129,107858396,28,13},
{231067649,36884395,28,12},
{231026689,83702808,28,12},
{231018497,121274810,28,12},
{231014401,115639368,28,16},
{231002113,172234156,28,12},
{230916097,3393794,28,15},
{230895617,10527423,28,12},
{230842369,172422719,28,13},
{230830081,11312832,28,12},
{230817793,229286797,28,17},
{230780929,94125779,28,12},
{230768641,137662636,28,14},
{230756353,33489951,28,12},
{230707201,4978072,28,12},
{230699009,230424311,28,12},
{230686721,81500630,28,22},
{230608897,46805077,28,12},
{230596609,129176795,28,13},
{230588417,33033590,28,15},
{230551553,197915454,28,12},
{230510593,122334268,28,12},
{230502401,94292963,28,12},
{230473729,47531504,28,14},
{230424577,128414156,28,18},
{230391809,44786753,28,15},
{230363137,172471843,28,12},
{230350849,148323146,28,13},
{230281217,34727569,28,12},
{230105089,46685924,28,13},
{230035457,65864204,28,12},
{230023169,140784362,28,13},
{229994497,193598389,28,12},
{229961729,50310384,28,12},
{229896193,80239584,28,12},
{229875713,81574224,28,13},
{229851137,51358785,28,14},
{229838849,182492406,28,12},
{229810177,223821014,28,13},
{229777409,223139013,28,13},
{229703681,43992703,28,16},
{229662721,55157922,28,13},
{229642241,145444634,28,12},
{229613569,174322972,28,13},
{229605377,133180628,28,15},
{229531649,105176401,28,13},
{229519361,182609689,28,12},
{229470209,37897996,28,12},
{229445633,84356892,28,12},
{229421057,93014915,28,12},
{229404673,108283911,28,12},
{229380097,154566102,28,12},
{229355521,55118651,28,12},
{229306369,122733120,28,12},
{229294081,136703207,28,14},
{229236737,110554234,28,13},
{229195777,37418666,28,14},
{229138433,176653698,28,13},
{229134337,122014421,28,12},
{229101569,134866134,28,12},
{229072897,45810901,28,13},
{229048321,123662839,28,16},
{229011457,168308335,28,12},
{228966401,56402900,28,14},
{228937729,109740587,28,12},
{228925441,97611538,28,13},
{228864001,197285356,28,12},
{228806657,155361815,28,12},
{228790273,183086579,28,12},
{228765697,43198630,28,12},
{228720641,114376480,28,17},
{228671489,221328270,28,14},
{228667393,17231321,28,12},
{228659201,101937859,28,12},
{228630529,212743512,28,13},
{228548609,141395325,28,13},
{228458497,81568723,28,17},
{228446209,33946975,28,12},
{228413441,144679274,28,12},
{228335617,85775382,28,13},
{228274177,95579410,28,12},
{228212737,220125824,28,14},
{228130817,8933497,28,16},
{228093953,18964377,28,12},
{228065281,209080686,28,19},
{228007937,214648445,28,13},
{227954689,69763951,28,12},
{227942401,155661242,28,13},
{227921921,105836938,28,12},
{227905537,207164007,28,12},
{227885057,47736822,28,14},
{227819521,224271056,28,14},
{227786753,134838545,28,14},
{227721217,122113886,28,14},
{227688449,182727405,28,14},
{227676161,93113465,28,12},
{227647489,69227380,28,13},
{227627009,92145830,28,12},
{227516417,202595108,28,13},
{227504129,9063829,28,12},
{227500033,125211302,28,13},
{227414017,224893453,28,12},
{227389441,166724533,28,12},
{227356673,69634675,28,12},
{227332097,188456578,28,12},
{227328001,83763204,28,14},
{227315713,187679845,28,12},
{227270657,179062827,28,13},
{227209217,96509645,28,12},
{227184641,137247939,28,12},
{227123201,186411701,28,13},
{227094529,179578530,28,12},
{227082241,110012592,28,16},
{227033089,112122042,28,14},
{226951169,208569379,28,16},
{226902017,139798693,28,14},
{226824193,71226024,28,12},
{226766849,10249870,28,12},
{226693121,118986205,28,12},
{226639873,195263625,28,14},
{226631681,136206278,28,13},
{226541569,172617710,28,14},
{226508801,216100095,28,14},
{226471937,129365059,28,12},
{226467841,137231974,28,13},
{226455553,90486825,28,12},
{226435073,151317626,28,13},
{226410497,80518174,28,14},
{226398209,195455468,28,12},
{226369537,101931452,28,13},
{226357249,159990163,28,12},
{226295809,53907721,28,16},
{226287617,203491434,28,13},
{226250753,77209526,28,12},
{226164737,7110765,28,16},
{226152449,184329039,28,12},
{226148353,171698833,28,14},
{226066433,35477915,28,15},
{226041857,98401771,28,13},
{226037761,110172653,28,12},
{225976321,121285483,28,13},
{225964033,15496531,28,12},
{225918977,121265878,28,14},
{225906689,217925255,28,12},
{225882113,205850629,28,12},
{225878017,203012974,28,13},
{225865729,35033055,28,12},
{225841153,147554219,28,12},
{225742849,86559253,28,12},
{225710081,42418192,28,12},
{225697793,50075318,28,13},
{225693697,201684399,28,12},
{225632257,12162986,28,13},
{225595393,19992957,28,12},
{225574913,34718881,28,17},
{225570817,95693447,28,12},
{225550337,78853660,28,13},
{225546241,71697161,28,12},
{225435649,100051973,28,13},
{225374209,185092329,28,12},
{225353729,91014690,28,13},
{225325057,90623561,28,12},
{225239041,188546522,28,13},
{225218561,136917376,28,12},
{225120257,171214038,28,12},
{225079297,206569703,28,12},
{225067009,195018907,28,14},
{225046529,53391958,28,12},
{225034241,155955114,28,14},
{225005569,193917248,28,12},
{224911361,146913663,28,13},
{224894977,77159358,28,13},
{224858113,204335898,28,12},
{224837633,181972773,28,14},
{224796673,200363268,28,13},
{224759809,51350030,28,12},
{224751617,138083650,28,12},
{224747521,90291858,28,13},
{224690177,156694891,28,15},
{224677889,114424867,28,12},
{224653313,86584720,28,12},
{224628737,10606394,28,12},
{224604161,212869572,28,12},
{224563201,100028786,28,12},
{224530433,113571580,28,12},
{224514049,91820525,28,12},
{224432129,166654547,28,12},
{224346113,73576616,28,14},
{224342017,201139656,28,12},
{224317441,164526845,28,12},
{224309249,217324353,28,12},
{224305153,126191834,28,13},
{224247809,74912536,28,14},
{224235521,46840133,28,12},
{224198657,56981993,28,16},
{224145409,210174587,28,12},
{224137217,29343625,28,12},
{224133121,185236872,28,18},
{224112641,152099594,28,12},
{224075777,99963654,28,13},
{224022529,186660824,28,12},
{224002049,77270449,28,17},
{223936513,208445895,28,16},
{223928321,8313423,28,13},
{223911937,15071296,28,13},
{223891457,216659389,28,12},
{223887361,214368437,28,14},
{223879169,148429128,28,13},
{223830017,36317911,28,13},
{223813633,130673468,28,13},
{223768577,83376325,28,12},
{223756289,73229807,28,14},
{223703041,161370875,28,12},
{223653889,118199919,28,12},
{223633409,100081972,28,13},
{223461377,107682924,28,14},
{223334401,78658752,28,12},
{223301633,12459823,28,12},
{223272961,113152113,28,13},
{223260673,180518961,28,12},
{223215617,14242088,28,17},
{223113217,128013729,28,12},
{223076353,91736927,28,13},
{223068161,61534203,28,14},
{223039489,153530484,28,12},
{223027201,50254210,28,13},
{222994433,100459929,28,13},
{222953473,114382626,28,17},
{222932993,178120168,28,12},
{222908417,5681634,28,12},
{222883841,210000625,28,12},
{222871553,194878640,28,14},
{222842881,59608484,28,12},
{222830593,143410239,28,13},
{222793729,90106837,28,12},
{222711809,22701970,28,12},
{222597121,103009415,28,12},
{222535681,207715235,28,13},
{222515201,68248322,28,12},
{222486529,494279,28,13},
{222441473,88464827,28,12},
{222400513,152996712,28,12},
{222363649,193025975,28,16},
{222351361,161745258,28,12},
{222343169,211328677,28,12},
{222220289,70712855,28,12},
{222216193,9738016,28,14},
{222195713,141459164,28,12},
{222179329,176823712,28,12},
{222167041,67576094,28,17},
{222097409,84978727,28,12},
{222035969,182515145,28,18},
{221913089,146918774,28,13},
{221908993,180258992,28,12},
{221884417,26091794,28,12},
{221839361,116066475,28,16},
{221749249,168764007,28,13},
{221736961,116375132,28,12},
{221704193,206257708,28,12},
{221655041,5774971,28,12},
{221638657,172127611,28,12},
{221605889,195126649,28,12},
{221581313,22543419,28,12},
{221577217,211934803,28,16},
{221564929,55898896,28,12},
{221532161,84293246,28,12},
{221417473,125791456,28,12},
{221335553,8680545,28,12},
{221331457,192143328,28,14},
{221306881,1811305,28,13},
{221274113,36865380,28,13},
{221270017,76567453,28,12},
{221249537,91044652,28,20},
{221237249,89140655,28,12},
{221208577,190427635,28,13},
{221196289,125779469,28,12},
{221175809,150736525,28,13},
{221163521,211547747,28,12},
{221102081,10869757,28,14},
{221089793,59467068,28,12},
{221052929,126657087,28,16},
{221040641,90660381,28,12},
{220938241,149928574,28,14},
{220930049,47211520,28,13},
{220925953,77040109,28,12},
{220889089,120086553,28,15},
{220844033,144271697,28,12},
{220839937,59531644,28,14},
{220696577,180155813,28,12},
{220635137,24900697,28,13},
{220594177,202164422,28,17},
{220573697,111699051,28,12},
{220557313,185777775,28,12},
{220499969,42589648,28,12},
{220475393,17393171,28,12},
{220438529,152606392,28,13},
{220385281,56795665,28,12},
{220327937,62277876,28,12},
{220323841,204948348,28,13},
{220205057,106624993,28,12},
{220090369,138665525,28,12},
{220065793,44329468,28,12},
{220045313,169180392,28,13},
{220008449,64641987,28,12},
{219959297,173716448,28,12},
{219947009,210424170,28,13},
{219893761,6878374,28,12},
{219844609,39580367,28,12},
{219836417,120857259,28,12},
{219820033,179892561,28,12},
{219774977,197694024,28,15},
{219713537,203095528,28,12},
{219688961,102960894,28,12},
{219676673,126511122,28,19},
{219627521,94091318,28,14},
{219586561,46156546,28,13},
{219578369,41888468,28,15},
{219443201,108425280,28,12},
{219402241,213213593,28,12},
{219389953,201481426,28,13},
{219332609,109631668,28,14},
{219303937,121642576,28,12},
{219246593,181779081,28,12},
{219181057,101916865,28,12},
{219144193,208834006,28,13},
{219074561,196928688,28,12},
{219062273,36718175,28,13},
{219025409,112870299,28,12},
{218972161,67113332,28,14},
{218902529,215406973,28,12},
{218828801,122204463,28,12},
{218767361,5667302,28,13},
{218755073,38710836,28,12},
{218726401,14042391,28,15},
{218669057,64795643,28,13},
{218628097,95739407,28,19},
{218615809,75507855,28,12},
{218603521,1611066,28,13},
{218570753,113716680,28,13},
{218546177,53316290,28,14},
{218521601,46779252,28,13},
{218431489,136600996,28,16},
{218411009,26790063,28,12},
{218398721,58339789,28,15},
{218349569,90908748,28,14},
{218308609,80767241,28,13},
{218226689,66105761,28,13},
{218165249,204178855,28,12},
{218140673,48506056,28,12},
{218124289,147455513,28,12},
{218050561,123184988,28,12},
{218038273,167871654,28,16},
{217976833,196657093,28,12},
{217919489,153359572,28,12},
{217894913,135874965,28,12},
{217870337,195328661,28,12},
{217808897,76712066,28,15},
{217796609,111384033,28,12},
{217784321,205668427,28,13},
{217706497,32926001,28,12},
{217694209,6867370,28,14},
{217624577,434001,28,12},
{217612289,133258726,28,15},
{217600001,4382552,28,12},
{217526273,210130181,28,12},
{217440257,37412985,28,13},
{217403393,208950803,28,12},
{217374721,21333122,28,13},
{217362433,51900304,28,12},
{217317377,10753918,28,18},
{217276417,100480685,28,13},
{217239553,93808093,28,12},
{217231361,138521860,28,12},
{217182209,164475192,28,12},
{217169921,112536154,28,14},
{217030657,160650899,28,13},
{217010177,170258743,28,12},
{216993793,74214927,28,12},
{216948737,96919444,28,13},
{216924161,88844262,28,17},
{216883201,81037625,28,13},
{216862721,109784152,28,12},
{216846337,169322949,28,12},
{216801281,76809036,28,13},
{216760321,157274425,28,15},
{216690689,89344342,28,12},
{216686593,764940,28,13},
{216600577,172503128,28,12},
{216580097,3069967,28,14},
{216563713,31818908,28,15},
{216543233,7499125,28,12},
{216432641,194487062,28,15},
{216416257,199726769,28,14},
{216379393,135643133,28,12},
{216330241,183693666,28,12},
{216317953,126363863,28,14},
{216293377,152305260,28,13},
{216231937,204197559,28,12},
{216195073,156930967,28,13},
{216174593,211175330,28,12},
{216137729,197517762,28,17},
{216133633,173337963,28,12},
{216113153,98648114,28,13},
{216109057,153484289,28,12},
{216027137,209013962,28,12},
{215949313,159829093,28,13},
{215928833,4324473,28,12},
{215912449,83977588,28,12},
{215900161,169473245,28,13},
{215891969,167298155,28,14},
{215879681,33178114,28,12},
{215818241,151700761,28,13},
{215801857,89619896,28,13},
{215789569,129238083,28,12},
{215744513,27297511,28,18},
{215646209,177206594,28,15},
{215560193,121874217,28,12},
{215531521,207523666,28,14},
{215519233,196441048,28,12},
{215482369,70180907,28,19},
{215449601,175474655,28,15},
{215339009,177263250,28,12},
{215326721,27745103,28,13},
{215273473,57699200,28,12},
{215142401,173505016,28,12},
{215113729,154480107,28,13},
{215101441,43511087,28,12},
{215080961,53449366,28,13},
{215052289,6947443,28,12},
{215019521,40425093,28,12},
{215003137,209330539,28,12},
{214982657,159988328,28,13},
{214966273,57432370,28,13},
{214929409,123619520,28,12},
{214867969,89020051,28,13},
{214786049,102675564,28,13},
{214700033,111158202,28,12},
{214622209,167089551,28,13},
{214597633,70388951,28,15},
{214573057,52151311,28,13},
{214552577,151379282,28,12},
{214466561,125241382,28,15},
{214450177,158293519,28,14},
{214355969,106656670,28,12},
{214351873,160779888,28,14},
{214343681,79052495,28,13},
{214171649,117295817,28,18},
{214110209,155482696,28,12},
{214097921,24983002,28,13},
{214081537,158203197,28,13},
{214069249,113060939,28,12},
{214044673,37796706,28,12},
{214036481,162812128,28,12},
{213938177,167097220,28,12},
{213934081,63330588,28,13},
{213876737,99120372,28,15},
{213835777,96356463,28,13},
{213815297,39712836,28,12},
{213811201,4950764,28,15},
{213790721,155644675,28,12},
{213762049,68638600,28,14},
{213749761,8592482,28,12},
{213692417,51194238,28,12},
{213618689,131669985,28,12},
{213594113,204852013,28,12},
{213569537,143782061,28,12},
{213483521,60760943,28,15},
{213454849,41411571,28,12},
{213434369,2578417,28,14},
{213409793,155660600,28,13},
{213311489,26056671,28,13},
{213299201,825093,28,12},
{213270529,154940284,28,14},
{213221377,94681075,28,15},
{213196801,84705248,28,13},
{213184513,192047823,28,12},
{213176321,126221665,28,12},
{213061633,166589782,28,12},
{212963329,34198913,28,12},
{212815873,199366433,28,12},
{212717569,109663845,28,12},
{212705281,118411151,28,13},
{212549633,143380219,28,14},
{212533249,179634102,28,16},
{212410369,46998184,28,13},
{212385793,202729409,28,14},
{212365313,147383706,28,12},
{212361217,6595395,28,13},
{212328449,145983808,28,13},
{212324353,87950871,28,12},
{212303873,97368622,28,15},
{212299777,183465810,28,12},
{212287489,55563630,28,14},
{212279297,187661132,28,13},
{212267009,77551893,28,12},
{212213761,119743703,28,13},
{212193281,156456356,28,12},
{212152321,181988949,28,12},
{212094977,168536692,28,12},
{212008961,44183072,28,16},
{211992577,198517315,28,14},
{211955713,116814614,28,12},
{211935233,86606957,28,13},
{211873793,9618689,28,12},
{211836929,94851107,28,13},
{211812353,206442508,28,21},
{211775489,35081435,28,12},
{211722241,77206151,28,13},
{211714049,44397994,28,15},
{211648513,134480254,28,15},
{211640321,205009977,28,13},
{211587073,197886043,28,12},
{211562497,15408017,28,12},
{211517441,163578486,28,15},
{211501057,129806357,28,14},
{211468289,109749620,28,14},
{211456001,2222815,28,12},
{211357697,159597329,28,12},
{211320833,156669343,28,15},
{211292161,53096037,28,12},
{211234817,91114343,28,12},
{211169281,9522818,28,12},
{211099649,68986167,28,13},
{211025921,148463274,28,18},
{211009537,194116780,28,14},
{210997249,164820974,28,12},
{210972673,164088882,28,12},
{210923521,172967370,28,12},
{210915329,146223821,28,12},
{210903041,191319288,28,13},
{210890753,33492635,28,12},
{210853889,108575736,28,13},
{210829313,151719233,28,16},
{210800641,118287610,28,12},
{210731009,157527757,28,15},
{210628609,109892869,28,12},
{210583553,51130188,28,14},
{210567169,73744233,28,16},
{210558977,21480350,28,13},
{210472961,106930658,28,12},
{210374657,161132214,28,12},
{210370561,172519615,28,17},
{210358273,105775544,28,12},
{210337793,79892202,28,15},
{210296833,8130971,28,13},
{210259969,196032649,28,12},
{210235393,33331669,28,12},
{210227201,46522533,28,12},
{210210817,137677307,28,12},
{210186241,143724306,28,12},
{210137089,60445103,28,12},
{210087937,15294449,28,12},
{210063361,185794836,28,12},
{209981441,103363253,28,12},
{209809409,187941551,28,12},
{209747969,35160732,28,15},
{209719297,62491971,28,12},
{209682433,3263406,28,15},
{209661953,92644390,28,12},
{209612801,198030777,28,12},
{209600513,185383521,28,14},
{209571841,33828063,28,12},
{209514497,202152225,28,12},
{209461249,143615280,28,13},
{209436673,44487792,28,14},
{209379329,137181629,28,13},
{209354753,113239781,28,15},
{209338369,149955003,28,14},
{209305601,95251212,28,14},
{209293313,202700939,28,12},
{209289217,23714915,28,15},
{209256449,139257805,28,16},
{209166337,137331755,28,13},
{209145857,159661598,28,12},
{209121281,42657682,28,12},
{209104897,108934948,28,12},
{209080321,106741981,28,12},
{209059841,103118003,28,17},
{209010689,13014702,28,14},
{208936961,17494659,28,13},
{208924673,90999864,28,12},
{208883713,190349054,28,12},
{208859137,57275107,28,12},
{208826369,179513891,28,12},
{208801793,144070155,28,12},
{208723969,89435088,28,13},
{208654337,163620424,28,12},
{208576513,106634179,28,13},
{208465921,150207000,28,12},
{208453633,135057693,28,14},
{208429057,24097477,28,13},
{208347137,144227643,28,13},
{208293889,109622319,28,12},
{208261121,159873318,28,12},
{208224257,69929263,28,14},
{208171009,49551069,28,12},
{208162817,135090165,28,12},
{208027649,1389019,28,14},
{208003073,102276452,28,13},
{207974401,33073708,28,12},
{207892481,160765404,28,12},
{207880193,177191355,28,18},
{207851521,126414428,28,12},
{207843329,100069547,28,12},
{207790081,19101083,28,13},
{207777793,13292195,28,12},
{207757313,101111197,28,13},
{207732737,110270322,28,14},
{207720449,65057952,28,12},
{207708161,117816216,28,13},
{207659009,148059256,28,13},
{207654913,99848619,28,12},
{207634433,165604811,28,14},
{207597569,105306478,28,12},
{207544321,161827770,28,13},
{207511553,189274243,28,13},
{207400961,42975750,28,12},
{207384577,90646655,28,12},
{207364097,10659962,28,13},
{207204353,184346721,28,12},
{207187969,3617116,28,12},
{207167489,24973183,28,13},
{207142913,86551312,28,14},
{207118337,48419155,28,13},
{207044609,134335481,28,14},
{207040513,70917194,28,12},
{207015937,151307742,28,12},
{207003649,17725136,28,13},
{206958593,99731512,28,12},
{206872577,69521463,28,13},
{206798849,7197577,28,15},
{206774273,5778905,28,13},
{206745601,116768469,28,12},
{206712833,86535055,28,12},
{206708737,36609521,28,13},
{206589953,156040285,28,12},
{206565377,199213648,28,12},
{206561281,103055140,28,13},
{206553089,75411327,28,14},
{206540801,190962296,28,12},
{206487553,133490390,28,14},
{206467073,154265198,28,12},
{206450689,63287582,28,12},
{206401537,201208364,28,12},
{206364673,16331201,28,13},
{206307329,3827439,28,18},
{206245889,140128121,28,12},
{206192641,116137024,28,14},
{206155777,189308938,28,12},
{206135297,62931739,28,13},
{206131201,56733716,28,12},
{206094337,96687521,28,14},
{206020609,68602354,28,13},
{206008321,130950208,28,12},
{205910017,203462790,28,12},
{205824001,133969708,28,13},
{205811713,68655059,28,12},
{205729793,195720500,28,12},
{205651969,65362350,28,17},
{205619201,32805067,28,15},
{205565953,22580243,28,12},
{205529089,155906900,28,13},
{205508609,122698423,28,12},
{205496321,12071432,28,13},
{205434881,414578,28,12},
{205385729,172775287,28,12},
{205332481,69888819,28,13},
{205234177,158662415,28,13},
{205152257,179605182,28,13},
{205078529,46452077,28,14},
{205012993,153985446,28,14},
{205004801,122030907,28,13},
{204967937,184337637,28,12},
{204869633,141012161,28,12},
{204865537,129319039,28,17},
{204845057,85525616,28,12},
{204808193,82550177,28,13},
{204783617,118726509,28,14},
{204730369,4388807,28,12},
{204718081,54483918,28,14},
{204619777,45443100,28,14},
{204607489,10188188,28,12},
{204546049,193825698,28,13},
{204533761,40323668,28,12},
{204472321,202076629,28,20},
{204464129,8999241,28,13},
{204439553,5151526,28,15},
{204423169,105701755,28,14},
{204410881,147731201,28,12},
{204378113,46423664,28,12},
{204353537,34332811,28,12},
{204349441,73327553,28,13},
{204267521,76451228,28,13},
{204238849,152234891,28,12},
{204230657,9773724,28,12},
{204189697,177066708,28,12},
{204128257,32446198,28,14},
{204029953,101948724,28,14},
{204021761,185315707,28,13},
{204009473,48211335,28,12},
{203984897,62201170,28,12},
{203943937,78768885,28,12},
{203931649,146250714,28,14},
{203923457,121650185,28,13},
{203907073,72197460,28,13},
{203845633,40866882,28,12},
{203800577,129074768,28,14},
{203788289,24430814,28,12},
{203735041,29081733,28,14},
{203726849,154404082,28,13},
{203702273,153567294,28,14},
{203530241,2160808,28,13},
{203517953,166948340,28,12},
{203489281,35981994,28,16},
{203476993,103608852,28,12},
{203427841,177957752,28,12},
{203419649,129248503,28,12},
{203304961,192406522,28,12},
{203268097,156060006,28,13},
{203210753,66479102,28,14},
{203173889,4696623,28,12},
{203149313,168934794,28,12},
{203071489,80642840,28,13},
{202960897,54401655,28,12},
{202948609,134778874,28,14},
{202915841,28952532,28,14},
{202862593,46002100,28,12},
{202854401,183957900,28,12},
{202838017,73160186,28,12},
{202813441,76307409,28,12},
{202756097,64671096,28,12},
{202752001,76858097,28,14},
{202731521,131593814,28,12},
{202670081,90578409,28,15},
{202653697,123039818,28,14},
{202596353,145666254,28,13},
{202555393,84865665,28,14},
{202518529,131356514,28,12},
{202485761,61587639,28,12},
{202473473,179167457,28,15},
{202457089,44314096,28,14},
{202395649,36130281,28,12},
{202350593,90199506,28,13},
{202346497,175562193,28,12},
{202211329,157760257,28,15},
{202203137,37483287,28,13},
{202149889,174226187,28,12},
{202117121,155173959,28,12},
{202055681,175899266,28,13},
{202014721,65423628,28,15},
{201957377,47915142,28,13},
{201953281,47543671,28,12},
{201945089,76985911,28,12},
{201916417,67073651,28,16},
{201895937,34848545,28,12},
{201891841,50412614,28,13},
{201871361,173582796,28,12},
{201854977,120251674,28,12},
{201842689,66036170,28,13},
{201719809,13786464,28,17},
{201695233,156414793,28,13},
{201687041,131999246,28,15},
{201670657,3540966,28,14},
{201625601,130863828,28,12},
{201564161,16010972,28,13},
{201551873,172105606,28,12},
{201490433,96720899,28,15},
{201465857,178241318,28,13},
{201453569,64654483,28,12},
{201428993,134092377,28,12},
{201306113,119317780,28,12},
{201289729,155589794,28,12},
{201277441,29137347,28,14},
{201228289,61306235,28,15},
{201183233,6168627,28,12},
{201105409,195915518,28,13},
{201035777,179802365,28,12},
{200949761,149161466,28,14},
{200908801,42117380,28,13},
{200888321,117603002,28,12},
{200876033,75455074,28,13},
{200859649,34369435,28,13},
{200851457,168485534,28,14},
{200839169,9386299,28,12},
{200826881,76982570,28,13},
{200790017,71885493,28,12},
{200773633,46542634,28,12},
{200736769,189371460,28,16},
{200630273,112132889,28,13},
{200568833,198784687,28,12},
{200540161,53882869,28,18},
{200507393,141438646,28,15},
{200503297,162546658,28,12},
{200482817,84975718,28,13},
{200478721,29744350,28,12},
{200466433,96121876,28,13},
{200380417,20056898,28,12},
{200347649,140843176,28,12},
{200343553,72701019,28,16},
{200282113,56533787,28,12},
{200220673,89860527,28,13},
{200200193,26979558,28,12},
{200151041,138490737,28,12},
{200114177,27292747,28,15},
{200077313,151712292,28,12},
{200052737,135218458,28,12},
{199913473,187102932,28,12},
{199905281,195400520,28,12},
{199876609,115070075,28,13},
{199843841,81282115,28,13},
{199806977,183682361,28,12},
{199790593,21615346,28,12},
{199733249,93388244,28,12},
{199684097,118753868,28,12},
{199618561,41971009,28,12},
{199606273,110512719,28,14},
{199598081,7765489,28,13},
{199487489,50239313,28,12},
{199413761,77406950,28,12},
{199397377,120804166,28,12},
{199372801,86424055,28,12},
{199340033,2097848,28,12},
{199229441,177131826,28,21},
{199213057,190542946,28,14},
{199155713,148495678,28,13},
{199127041,55152622,28,12},
{199118849,59815806,28,12},
{199057409,82756656,28,13},
{199032833,90010850,28,16},
{199028737,60290292,28,12},
{198905857,54367344,28,12},
{198885377,165733680,28,14},
{198787073,187055091,28,14},
{198762497,10235908,28,13},
{198709249,47719758,28,12},
{198701057,69071241,28,12},
{198688769,108336931,28,14},
{198660097,70598937,28,12},
{198647809,182233178,28,13},
{198602753,126058861,28,12},
{198574081,130145555,28,17},
{198565889,148263013,28,13},
{198553601,183752091,28,12},
{198537217,83790231,28,12},
{198516737,88637849,28,13},
{198512641,104347594,28,12},
{198475777,31033186,28,15},
{198381569,74523747,28,12},
{198328321,47762046,28,14},
{198270977,139815871,28,13},
{198254593,101658033,28,13},
{198209537,192000150,28,12},
{198156289,42101298,28,13},
{198082561,90687631,28,15},
{198021121,70243013,28,12},
{197939201,36857470,28,12},
{197902337,180607072,28,14},
{197767169,131751344,28,12},
{197754881,49683470,28,15},
{197713921,13290268,28,13},
{197591041,169538020,28,16},
{197533697,100932646,28,13},
{197509121,175857399,28,14},
{197419009,13571575,28,13},
{197357569,123930849,28,12},
{197324801,129498560,28,12},
{197296129,43585293,28,15},
{197275649,149040143,28,12},
{197234689,62621158,28,12},
{197185537,94625188,28,12},
{197140481,153464588,28,13},
{197124097,101960732,28,13},
{197050369,57125105,28,14},
{197005313,26587522,28,12},
{196964353,60809620,28,12},
{196816897,62140234,28,12},
{196595713,104837456,28,12},
{196452353,9338993,28,13},
{196448257,155117527,28,12},
{196403201,64005610,28,13},
{196390913,167877766,28,12},
{196300801,5155070,28,12},
{196239361,170457487,28,13},
{196202497,69051869,28,12},
{196120577,1461104,28,12},
{196079617,92999611,28,12},
{196046849,51974332,28,12},
{196022273,1620284,28,12},
{196005889,194713079,28,12},
{195973121,127998150,28,12},
{195944449,119505793,28,13},
{195923969,92169463,28,12},
{195919873,52675,28,15},
{195899393,163139303,28,12},
{195874817,98666442,28,12},
{195850241,144523810,28,12},
{195727361,157692931,28,12},
{195686401,100821082,28,12},
{195616769,17905251,28,13},
{195555329,14843563,28,12},
{195514369,158071004,28,12},
{195502081,126748733,28,13},
{195493889,98894347,28,16},
{195444737,175697747,28,14},
{195428353,113590448,28,17},
{195403777,53039019,28,13},
{195379201,85773472,28,14},
{195358721,142130609,28,12},
{195346433,171481643,28,14},
{195342337,55932728,28,12},
{195284993,190645321,28,12},
{195198977,167642523,28,15},
{195186689,132729652,28,12},
{195162113,159702182,28,12},
{195145729,49892436,28,12},
{195121153,188695050,28,12},
{195084289,191017491,28,14},
{195072001,68621606,28,12},
{195014657,112194740,28,12},
{194977793,51773112,28,13},
{194949121,189129986,28,12},
{194891777,98225076,28,12},
{194826241,61821095,28,12},
{194805761,20090251,28,15},
{194666497,122624308,28,13},
{194646017,143312788,28,12},
{194641921,69823023,28,17},
{194572289,101566207,28,12},
{194560001,81150327,28,14},
{194547713,109948863,28,12},
{194523137,41852823,28,12},
{194445313,164850680,28,16},
{194424833,62737631,28,12},
{194408449,174918670,28,12},
{194338817,128709106,28,13},
{194215937,176554150,28,15},
{194199553,18817937,28,14},
{194150401,86539015,28,15},
{194080769,38784132,28,12},
{193994753,182351338,28,13},
{193970177,128354503,28,14},
{193892353,105378890,28,12},
{193867777,30036847,28,12},
{193843201,104857571,28,12},
{193785857,128185586,28,12},
{193781761,62487327,28,13},
{193769473,59501626,28,12},
{193699841,92275882,28,13},
{193662977,174970178,28,12},
{193622017,13797982,28,12},
{193609729,123140849,28,14},
{193601537,157358125,28,13},
{193585153,173871890,28,13},
{193540097,11011970,28,12},
{193536001,44150363,28,13},
{193527809,105305565,28,16},
{193437697,169473126,28,13},
{193425409,149300401,28,12},
{193404929,46224322,28,13},
{193400833,11852662,28,12},
{193376257,56192610,28,12},
{193343489,173002994,28,12},
{193290241,138453632,28,13},
{193257473,160908455,28,13},
{193191937,96058344,28,13},
{193155073,139814243,28,12},
{193146881,77886295,28,12},
{193069057,52953298,28,17},
{193056769,50898437,28,12},
{192995329,66970922,28,13},
{192950273,156616944,28,12},
{192946177,185842063,28,13},
{192847873,314818,28,13},
{192790529,102074404,28,14},
{192778241,27808812,28,12},
{192765953,109193358,28,13},
{192761857,189898364,28,12},
{192626689,62507529,28,14},
{192577537,34203039,28,15},
{192544769,105068527,28,17},
{192479233,98384111,28,16},
{192458753,122292931,28,12},
{192393217,36892905,28,12},
{192372737,98833085,28,13},
{192360449,117425508,28,12},
{192307201,1088177,28,13},
{192237569,98159540,28,12},
{192086017,36673310,28,16},
{192073729,158523331,28,12},
{191950849,113629522,28,12},
{191942657,128884186,28,12},
{191938561,113884526,28,14},
{191918081,47031950,28,12},
{191856641,152227140,28,15},
{191844353,158356737,28,12},
{191721473,191264296,28,12},
{191705089,128024309,28,12},
{191684609,107849068,28,13},
{191660033,12622846,28,15},
{191619073,105935584,28,13},
{191512577,60820323,28,14},
{191488001,186447119,28,13},
{191471617,52993914,28,13},
{191426561,50044337,28,12},
{191389697,189750970,28,13},
{191365121,18418401,28,19},
{191328257,158826356,28,12},
{191303681,141747186,28,12},
{191229953,32245304,28,12},
{191188993,90166786,28,12},
{191127553,143665093,28,13},
{191119361,88706048,28,14},
{191090689,184649735,28,12},
{191078401,117133331,28,13},
{191041537,186107499,28,12},
{191016961,13096489,28,12},
{190918657,188918169,28,12},
{190857217,2146590,28,14},
{190832641,41206133,28,13},
{190820353,54259116,28,12},
{190701569,40561174,28,13},
{190697473,119135695,28,12},
{190672897,15021588,28,12},
{190660609,6939246,28,14},
{190652417,40261926,28,13},
{190648321,162643166,28,12},
{190590977,58451129,28,12},
{190488577,115448735,28,13},
{190382081,43339163,28,16},
{190369793,118976518,28,12},
{190353409,62970651,28,12},
{190341121,14510704,28,13},
{190242817,75798333,28,13},
{190218241,14613775,28,15},
{190210049,25829666,28,13},
{190185473,122971828,28,17},
{190087169,177933500,28,15},
{190021633,100542396,28,15},
{190013441,118130510,28,13},
{189964289,161173779,28,13},
{189837313,65973755,28,12},
{189829121,96586867,28,12},
{189677569,186884213,28,14},
{189657089,81986061,28,12},
{189566977,165814213,28,12},
{189530113,60568125,28,18},
{189485057,35071959,28,12},
{189468673,47227210,28,12},
{189411329,49860604,28,12},
{189300737,152466748,28,15},
{189284353,23303094,28,14},
{189165569,13295817,28,12},
{189100033,178113281,28,12},
{189050881,111953340,28,12},
{188989441,179162515,28,14},
{188981249,42447249,28,13},
{188977153,13512874,28,12},
{188870657,183227206,28,12},
{188854273,162933062,28,12},
{188768257,182734653,28,13},
{188755969,33930920,28,12},
{188735489,7757967,28,13},
{188731393,138312493,28,12},
{188723201,24634735,28,12},
{188674049,169124594,28,12},
{188661761,44385846,28,14},
{188624897,156073093,28,12},
{188612609,32991811,28,17},
{188588033,125169663,28,13},
{188522497,118030080,28,13},
{188510209,154494615,28,12},
{188477441,181706034,28,12},
{188465153,180354450,28,14},
{188379137,39348260,28,12},
{188301313,135256841,28,14},
{188239873,116426565,28,12},
{188190721,127650767,28,12},
{188182529,104528222,28,12},
{188157953,147068502,28,12},
{188153857,106073701,28,16},
{188059649,40193734,28,12},
{187949057,78835743,28,13},
{187936769,91950226,28,12},
{187887617,95973859,28,12},
{187846657,33501056,28,12},
{187785217,86266042,28,13},
{187703297,52252566,28,13},
{187678721,83318899,28,14},
{187564033,128846712,28,17},
{187506689,122200388,28,13},
{187445249,97745492,28,12},
{187432961,181970102,28,18},
{187392001,52373274,28,13},
{187379713,7587968,28,12},
{187359233,184741566,28,13},
{187355137,142672575,28,12},
{187297793,174459599,28,12},
{187232257,130860693,28,12},
{187199489,26089640,28,12},
{187146241,101659595,28,13},
{187133953,157391522,28,12},
{187084801,117518531,28,12},
{187072513,107398335,28,15},
{186990593,102071557,28,14},
{186986497,60720229,28,12},
{186929153,90227163,28,12},
{186900481,92193456,28,13},
{186888193,89493803,28,12},
{186806273,58149237,28,12},
{186769409,10702957,28,13},
{186695681,174537777,28,14},
{186646529,82323596,28,21},
{186642433,139205217,28,12},
{186634241,41565663,28,12},
{186597377,148363471,28,14},
{186580993,3019444,28,16},
{186556417,174120564,28,13},
{186531841,57688636,28,14},
{186511361,94457794,28,12},
{186499073,23680985,28,14},
{186413057,50494282,28,12},
{186396673,121699280,28,12},
{186372097,31470500,28,12},
{186314753,133437603,28,12},
{186286081,5098470,28,15},
{186273793,30954660,28,12},
{186265601,75760588,28,12},
{186224641,15767193,28,12},
{186187777,67418461,28,16},
{186175489,174229985,28,12},
{186155009,176118956,28,15},
{186089473,14328988,28,15},
{186052609,23663126,28,12},
{186028033,147363696,28,12},
{186007553,84657649,28,14},
{185909249,18437380,28,14},
{185806849,4144757,28,12},
{185757697,144129130,28,12},
{185745409,63459276,28,14},
{185700353,7347691,28,12},
{185683969,126140897,28,12},
{185651201,107991383,28,12},
{185602049,177018756,28,12},
{185597953,159502347,28,20},
{185577473,113076328,28,12},
{185499649,183461748,28,15},
{185487361,87576075,28,12},
{185430017,70052007,28,12},
{185413633,133067633,28,12},
{185356289,62708844,28,12},
{185344001,143366687,28,13},
{185282561,58727349,28,12},
{185241601,39742715,28,12},
{185147393,56014687,28,13},
{185118721,117346121,28,12},
{185110529,76708908,28,12},
{185049089,147597228,28,13},
{184983553,80104148,28,13},
{184938497,173181862,28,12},
{184922113,75019726,28,12},
{184913921,152672237,28,12},
{184864769,155069890,28,12},
{184860673,170100545,28,14},
{184811521,64161063,28,18},
{184799233,150448033,28,12},
{184774657,72113756,28,12},
{184750081,57184197,28,12},
{184676353,162678245,28,12},
{184655873,92815622,28,13},
{184619009,17760135,28,12},
{184467457,150124524,28,14},
{184430593,96727031,28,12},
{184422401,175503793,28,12},
{184406017,159707566,28,12},
{184381441,34320047,28,12},
{184373249,80260255,28,12},
{184348673,164054411,28,12},
{184332289,66362821,28,12},
{184324097,166950484,28,12},
{184197121,45314528,28,13},
{184188929,145354751,28,15},
{184164353,131938852,28,13},
{184160257,21444661,28,12},
{184061953,151857378,28,12},
{184053761,124835492,28,12},
{183980033,85632034,28,12},
{183975937,47728957,28,14},
{183918593,7874278,28,13},
{183889921,137045222,28,12},
{183881729,112963794,28,12},
{183857153,78093875,28,12},
{183779329,144682932,28,14},
{183672833,153509445,28,13},
{183631873,156876215,28,17},
{183586817,28027203,28,12},
{183521281,4985678,28,12},
{183463937,90388448,28,12},
{183427073,62012413,28,13},
{183422977,8432968,28,12},
{183144449,111757257,28,12},
{183103489,6645474,28,12},
{183078913,176061796,28,12},
{183058433,75632666,28,14},
{183054337,126562208,28,12},
{183017473,71320850,28,13},
{182931457,120953809,28,12},
{182919169,24928207,28,13},
{182898689,58896832,28,12},
{182886401,171800915,28,13},
{182845441,95712478,28,17},
{182771713,163600273,28,13},
{182763521,64031452,28,14},
{182747137,31174010,28,15},
{182611969,89883109,28,12},
{182603777,144574769,28,12},
{182542337,181189848,28,13},
{182480897,124525375,28,12},
{182415361,136112269,28,12},
{182366209,66465872,28,12},
{182353921,7927284,28,15},
{182341633,140380503,28,12},
{182296577,33404333,28,13},
{182272001,112679964,28,14},
{182136833,152749631,28,12},
{182075393,123439940,28,14},
{182038529,123066869,28,12},
{182009857,12158196,28,14},
{181985281,74587557,28,13},
{181903361,11197574,28,13},
{181850113,111781132,28,12},
{181841921,46447341,28,12},
{181764097,102089497,28,15},
{181682177,42567614,28,14},
{181616641,94277242,28,14},
{181579777,98031241,28,12},
{181567489,169051978,28,15},
{181559297,24329894,28,13},
{181493761,152615280,28,13},
{181485569,64664413,28,14},
{181444609,68930267,28,13},
{181424129,48686408,28,12},
{181334017,47427270,28,12},
{181321729,145780763,28,14},
{181313537,7355867,28,13},
{181309441,51516061,28,12},
{181227521,149872254,28,12},
{181178369,128356760,28,12},
{181153793,150720248,28,12},
{181149697,16065856,28,13},
{181051393,107965545,28,13},
{180981761,147324270,28,12},
{180969473,53796772,28,13},
{180965377,169928201,28,12},
{180953089,135746475,28,13},
{180928513,171247904,28,14},
{180920321,86187048,28,13},
{180883457,120252410,28,12},
{180817921,150104812,28,12},
{180809729,64061623,28,12},
{180748289,148612222,28,17},
{180723713,76403594,28,13},
{180674561,10639446,28,13},
{180625409,119972832,28,13},
{180551681,127374736,28,16},
{180539393,22333318,28,12},
{180535297,92226915,28,14},
{180510721,150545026,28,13},
{180498433,81840880,28,12},
{180461569,51238488,28,13},
{180441089,149276745,28,12},
{180387841,108365129,28,15},
{180318209,163995082,28,12},
{180269057,156135227,28,12},
{180244481,140290965,28,12},
{180232193,123442646,28,13},
{180215809,169916533,28,13},
{180207617,124097379,28,14},
{180191233,96447768,28,15},
{180105217,106121034,28,12},
{180068353,166403050,28,13},
{180060161,150294198,28,15},
{179945473,167935539,28,14},
{179937281,2467435,28,13},
{179908609,57697751,28,12},
{179847169,81796953,28,14},
{179773441,54717238,28,13},
{179703809,94626711,28,12},
{179642369,144267012,28,13},
{179630081,25146394,28,12},
{179613697,28537335,28,12},
{179576833,127668796,28,13},
{179556353,139599144,28,12},
{179470337,58806817,28,15},
{179466241,136686069,28,12},
{179429377,90976775,28,13},
{179404801,156975932,28,15},
{179347457,28264933,28,13},
{179269633,159627034,28,12},
{179232769,137544740,28,13},
{179212289,114272564,28,12},
{179187713,77543335,28,12},
{179159041,33255216,28,14},
{179064833,145426886,28,12},
{178999297,135797433,28,12},
{178917377,141064214,28,12},
{178913281,153163135,28,17},
{178864129,28192736,28,14},
{178839553,16297100,28,13},
{178831361,50857104,28,14},
{178782209,85492167,28,19},
{178741249,1927336,28,13},
{178720769,5969995,28,12},
{178597889,88147620,28,12},
{178585601,97540743,28,16},
{178532353,16395452,28,12},
{178524161,122361774,28,12},
{178425857,98471772,28,12},
{178413569,120162597,28,13},
{178372609,160954560,28,14},
{178352129,152112733,28,12},
{178298881,16051565,28,13},
{178204673,84123294,28,12},
{178200577,2518592,28,13},
{178143233,37418508,28,14},
{178118657,69908259,28,13},
{178102273,156902399,28,13},
{178016257,35782014,28,12},
{177979393,683005,28,14},
{177917953,134512918,28,12},
{177811457,160781658,28,12},
{177725441,87941976,28,13},
{177709057,85157725,28,13},
{177672193,81866815,28,12},
{177651713,81079974,28,14},
{177623041,90255679,28,12},
{177610753,149607559,28,13},
{177602561,66872542,28,17},
{177586177,159512965,28,14},
{177573889,89805634,28,12},
{177549313,153296195,28,12},
{177528833,40926116,28,13},
{177500161,173990212,28,12},
{177401857,20209755,28,12},
{177381377,165039786,28,13},
{177340417,55233014,28,17},
{177295361,149347290,28,12},
{177233921,33320877,28,13},
{177197057,166805141,28,12},
{177184769,17760394,28,13},
{177180673,140265955,28,12},
{177143809,143371713,28,16},
{177111041,108221365,28,15},
{177094657,132108537,28,14},
{177037313,41949474,28,13},
{176975873,78970498,28,12},
{176934913,163914918,28,12},
{176914433,10103137,28,15},
{176898049,92004755,28,14},
{176889857,129835660,28,13},
{176828417,114982028,28,12},
{176775169,89577125,28,13},
{176754689,156015036,28,12},
{176713729,47857199,28,12},
{176680961,37761158,28,12},
{176664577,157213030,28,12},
{176578561,44924328,28,13},
{176541697,172448940,28,12},
{176484353,82619518,28,12},
{176467969,161407437,28,12},
{176455681,110677327,28,15},
{176435201,52385677,28,12},
{176418817,139319803,28,12},
{176373761,163593328,28,14},
{176345089,116714269,28,12},
{176324609,138429161,28,15},
{176222209,80024387,28,12},
{176197633,113492385,28,12},
{176189441,2768146,28,12},
{176148481,145200139,28,12},
{176136193,79722908,28,13},
{176078849,152718160,28,14},
{176074753,26789360,28,12},
{176029697,18647223,28,17},
{176017409,148744629,28,12},
{175951873,168360088,28,12},
{175943681,133139386,28,12},
{175915009,89992390,28,14},
{175882241,146322013,28,14},
{175865857,56326147,28,15},
{175833089,148799627,28,16},
{175779841,156146848,28,12},
{175747073,141325400,28,12},
{175681537,127881771,28,12},
{175636481,96677383,28,19},
{175624193,39655127,28,12},
{175599617,171446914,28,12},
{175558657,8381106,28,12},
{175521793,110004285,28,14},
{175513601,64727600,28,13},
{175484929,14391214,28,12},
{175472641,150529813,28,15},
{175423489,85388026,28,14},
{175362049,68784561,28,12},
{175349761,110912251,28,13},
{175329281,20206606,28,12},
{175292417,100551988,28,14},
{175251457,44766331,28,13},
{175226881,43744572,28,14},
{175214593,19102599,28,12},
{175108097,142083856,28,12},
{175046657,63061628,28,16},
{175034369,145350419,28,12},
{175005697,88225527,28,13},
{174911489,12433003,28,12},
{174899201,59227990,28,14},
{174886913,52578435,28,12},
{174845953,89089492,28,12},
{174821377,145159312,28,12},
{174788609,36080976,28,12},
{174653441,64816972,28,16},
{174604289,13982248,28,14},
{174592001,23715023,28,12},
{174575617,98188961,28,12},
{174563329,94735564,28,13},
{174555137,16754057,28,15},
{174440449,51366676,28,14},
{174317569,44708711,28,13},
{174268417,22786390,28,13},
{174256129,159135241,28,12},
{174231553,15091724,28,12},
{174125057,148406090,28,12},
{174071809,95779851,28,13},
{174022657,160460034,28,13},
{173989889,54302557,28,13},
{173887489,95683109,28,12},
{173867009,136406199,28,16},
{173854721,146651344,28,12},
{173842433,97002645,28,13},
{173826049,112974298,28,13},
{173801473,72354804,28,18},
{173780993,97052418,28,12},
{173756417,108633981,28,12},
{173731841,170204888,28,12},
{173658113,93208595,28,12},
{173621249,142323310,28,14},
{173580289,61764157,28,13},
{173568001,12415604,28,12},
{173555713,39015595,28,14},
{173506561,104906703,28,15},
{173494273,46741111,28,12},
{173473793,151027299,28,16},
{173350913,25628439,28,13},
{173314049,171251293,28,12},
{173240321,64669056,28,12},
{173068289,87814217,28,12},
{172978177,101463633,28,12},
{172953601,159472591,28,12},
{172904449,121425767,28,12},
{172855297,106699157,28,12},
{172797953,99437835,28,12},
{172769281,15101502,28,14},
{172756993,67872602,28,12},
{172748801,92064893,28,12},
{172720129,54337582,28,15},
{172711937,32486798,28,13},
{172707841,119093652,28,12},
{172695553,72598698,28,13},
{172670977,162016944,28,14},
{172646401,49481591,28,13},
{172449793,76428000,28,13},
{172392449,141460945,28,15},
{172388353,102251547,28,12},
{172367873,46518027,28,13},
{172339201,54793001,28,12},
{172318721,105336933,28,13},
{172277761,135295135,28,14},
{172269569,12176092,28,13},
{172240897,43276149,28,12},
{172220417,141036932,28,13},
{172081153,133914569,28,14},
{172072961,135238246,28,13},
{172032001,130822871,28,16},
{172023809,79815980,28,13},
{171982849,64913132,28,14},
{171937793,7137174,28,12},
{171900929,51562545,28,16},
{171872257,45575379,28,12},
{171859969,100581268,28,13},
{171839489,89773190,28,12},
{171835393,3193749,28,17},
{171814913,115772740,28,12},
{171790337,164949414,28,12},
{171737089,109727739,28,15},
{171724801,45278592,28,12},
{171687937,71033946,28,14},
{171675649,169763809,28,12},
{171663361,90460681,28,13},
{171601921,69309029,28,12},
{171593729,123344858,28,12},
{171565057,76822124,28,13},
{171491329,112082590,28,14},
{171479041,28117839,28,12},
{171466753,81372498,28,13},
{171446273,87066749,28,12},
{171175937,102418421,28,12},
{171122689,10855023,28,13},
{171102209,42786809,28,12},
{171048961,159506493,28,17},
{171036673,107870598,28,12},
{171016193,153982847,28,15},
{170999809,70956069,28,14},
{170979329,35342862,28,12},
{170954753,87754566,28,12},
{170889217,87626694,28,12},
{170831873,49258824,28,12},
{170782721,109672249,28,12},
{170729473,24849813,28,13},
{170721281,2274155,28,16},
{170610689,114642353,28,12},
{170557441,7509505,28,15},
{170545153,68835841,28,12},
{170500097,76815645,28,13},
{170459137,16598334,28,16},
{170438657,99916129,28,12},
{170426369,65876814,28,15},
{170401793,23981313,28,13},
{170397697,89783499,28,12},
{170311681,74416060,28,14},
{170237953,48832519,28,13},
{170201089,75122703,28,12},
{170180609,109059390,28,14},
{170168321,155056923,28,12},
{170156033,54545634,28,13},
{170127361,65395092,28,12},
{170004481,25006961,28,12},
{169967617,100874242,28,15},
{169955329,121990347,28,12},
{169930753,28180918,28,12},
{169869313,126367740,28,21},
{169844737,124328712,28,13},
{169799681,66668011,28,12},
{169787393,155344571,28,14},
{169746433,54282153,28,13},
{169721857,19775012,28,14},
{169701377,79487076,28,12},
{169603073,37948047,28,12},
{169586689,38925879,28,12},
{169517057,161532254,28,13},
{169455617,5650291,28,12},
{169451521,119845202,28,13},
{169439233,149805539,28,12},
{169381889,4934410,28,12},
{169320449,25882656,28,13},
{169291777,41237689,28,12},
{169193473,92226361,28,12},
{169185281,12214174,28,12},
{169168897,61071699,28,12},
{169144321,151811973,28,12},
{169123841,9293543,28,13},
{169062401,56315568,28,12},
{169050113,165390290,28,15},
{169033729,27216004,28,14},
{168878081,165491771,28,13},
{168841217,138855716,28,12},
{168837121,52259127,28,14},
{168828929,150744626,28,13},
{168800257,125779679,28,12},
{168755201,102999968,28,16},
{168726529,160017921,28,12},
{168681473,120645921,28,13},
{168665089,82419776,28,13},
{168620033,9627763,28,12},
{168603649,43812763,28,12},
{168595457,113148247,28,12},
{168534017,73684616,28,13},
{168521729,9262808,28,12},
{168456193,131292872,28,12},
{168349697,32037503,28,12},
{168325121,133681129,28,12},
{168308737,98730056,28,12},
{168288257,60411656,28,13},
{168284161,118495437,28,12},
{168275969,15449130,28,12},
{168251393,39495472,28,12},
{168247297,131493100,28,14},
{168222721,166096714,28,13},
{168202241,9701291,28,12},
{168161281,106626008,28,12},
{168124417,64118423,28,13},
{168103937,64991624,28,12},
{168087553,14931254,28,12},
{168050689,149224752,28,14},
{167968769,21124193,28,16},
{167903233,122920039,28,17},
{167854081,120043186,28,14},
{167845889,114786022,28,13},
{167796737,53024212,28,13},
{167772161,7717845,28,25},
{167723009,124111493,28,14},
{167649281,58426025,28,13},
{167600129,51152019,28,13},
{167571457,109289985,28,12},
{167534593,94801760,28,13},
{167510017,27121083,28,18},
{167473153,6154381,28,12},
{167464961,158791626,28,12},
{167436289,74995135,28,13},
{167387137,111326562,28,13},
{167362561,141449665,28,14},
{167313409,155565378,28,16},
{167288833,140094199,28,13},
{167251969,62565115,28,12},
{167243777,75018610,28,12},
{167219201,24390245,28,12},
{167202817,95442059,28,12},
{167178241,62820607,28,12},
{167165953,36827230,28,14},
{167116801,145569010,28,17},
{167108609,135667013,28,13},
{167084033,8196143,28,15},
{167047169,9413737,28,12},
{167043073,139354554,28,13},
{166936577,103069172,28,14},
{166871041,92579625,28,14},
{166858753,148475576,28,12},
{166760449,66800262,28,12},
{166674433,133430198,28,14},
{166653953,54257740,28,12},
{166625281,2340413,28,15},
{166576129,154079801,28,14},
{166567937,144844462,28,13},
{166490113,162650599,28,12},
{166453249,14293427,28,13},
{166404097,36924250,28,13},
{166391809,120150827,28,12},
{166309889,110905061,28,12},
{166174721,161824958,28,13},
{166162433,25581034,28,12},
{166113281,81973565,28,12},
{166084609,55060640,28,14},
{165990401,109644821,28,12},
{165855233,48146382,28,14},
{165830657,51096643,28,13},
{165789697,93576055,28,14},
{165744641,109727512,28,12},
{165707777,40769704,28,15},
{165609473,129106579,28,16},
{165593089,57210964,28,14},
{165584897,4962904,28,13},
{165572609,748350,28,12},
{165511169,30429223,28,15},
{165507073,86951738,28,12},
{165408769,69528030,28,12},
{165400577,108538521,28,12},
{165396481,120686127,28,14},
{165359617,144201219,28,12},
{165339137,83976488,28,13},
{165335041,100208879,28,12},
{165326849,32241693,28,12},
{165314561,90372342,28,15},
{165236737,163853166,28,12},
{165212161,32346194,28,12},
{165199873,5551843,28,14},
{165142529,58050457,28,13},
{165093377,15865423,28,13},
{165081089,15905182,28,12},
{165019649,137968820,28,17},
{164995073,147881840,28,13},
{164990977,62737104,28,12},
{164929537,114107091,28,13},
{164868097,75291856,28,12},
{164843521,76824540,28,12},
{164810753,47722235,28,12},
{164786177,144444196,28,12},
{164761601,27940580,28,12},
{164610049,150214763,28,14},
{164548609,50605398,28,12},
{164524033,21598842,28,12},
{164462593,110244685,28,15},
{164380673,1597864,28,14},
{164339713,72057768,28,13},
{164282369,62902171,28,14},
{164278273,25195792,28,12},
{164270081,62592477,28,12},
{164233217,162903475,28,17},
{164208641,116734222,28,13},
{164073473,28372463,28,12},
{164069377,58033079,28,15},
{164012033,103451368,28,13},
{163995649,116310429,28,13},
{163962881,141485488,28,13},
{163950593,156510639,28,12},
{163934209,65089434,28,12},
{163889153,118456928,28,14},
{163852289,87271046,28,12},
{163803137,150481879,28,12},
{163762177,123954263,28,12},
{163749889,118958521,28,13},
{163737601,151544110,28,12},
{163729409,5171503,28,12},
{163688449,18632264,28,12},
{163618817,41213863,28,13},
{163614721,142391322,28,12},
{163577857,158107942,28,22},
{163565569,143522713,28,12},
{163532801,149713913,28,12},
{163504129,156876877,28,13},
{163459073,58786473,28,12},
{163434497,35834530,28,12},
{163422209,23564938,28,13},
{163409921,71475110,28,12},
{163393537,108239801,28,12},
{163348481,153472230,28,15},
{163336193,44343562,28,12},
{163299329,67278713,28,14},
{163287041,61712478,28,12},
{163237889,143956526,28,12},
{163209217,143586598,28,13},
{163188737,51143967,28,12},
{163176449,157111774,28,13},
{163164161,111423905,28,12},
{163127297,90025688,28,13},
{163123201,81655961,28,12},
{163074049,152947545,28,12},
{162979841,153346255,28,13},
{162963457,52744396,28,13},
{162889729,66081033,28,15},
{162840577,15027240,28,14},
{162807809,37709257,28,14},
{162783233,28229418,28,13},
{162672641,92448899,28,12},
{162643969,139605179,28,14},
{162557953,50405444,28,12},
{162500609,89188585,28,12},
{162488321,143479559,28,13},
{162471937,87138110,28,13},
{162439169,46863023,28,13},
{162435073,34653691,28,12},
{162377729,152809767,28,12},
{162287617,128639573,28,12},
{162226177,65250801,28,13},
{162181121,106535289,28,12},
{162168833,89114571,28,15},
{162152449,17678943,28,14},
{162131969,32200804,28,12},
{162103297,107288005,28,15},
{162041857,58803524,28,12},
{161886209,127628362,28,12},
{161775617,21637469,28,15},
{161771521,122502988,28,12},
{161751041,110717946,28,13},
{161714177,131696372,28,12},
{161660929,140844725,28,14},
{161652737,134286782,28,13},
{161628161,110495894,28,14},
{161615873,147626137,28,12},
{161525761,116300450,28,12},
{161464321,109990414,28,14},
{161452033,143409411,28,12},
{161415169,24382880,28,16},
{161292289,87821743,28,13},
{161259521,84204854,28,13},
{161185793,159166634,28,15},
{161157121,144609085,28,12},
{161136641,89811662,28,14},
{161120257,42213990,28,15},
{161026049,111094863,28,12},
{161013761,158729816,28,13},
{160985089,23197449,28,12},
{160935937,110771589,28,12},
{160899073,2972560,28,13},
{160878593,15411638,28,12},
{160739329,5255607,28,12},
{160665601,55745405,28,12},
{160628737,45326150,28,16},
{160608257,12697800,28,12},
{160595969,157693762,28,15},
{160583681,149906565,28,12},
{160571393,130658686,28,13},
{160555009,25256776,28,13},
{160534529,18430739,28,12},
{160509953,73751510,28,12},
{160468993,30379263,28,12},
{160460801,158888944,28,12},
{160407553,24011088,28,13},
{160382977,94514782,28,14},
{160346113,68122138,28,12},
{160276481,26809009,28,13},
{160264193,137685900,28,12},
{160247809,77293510,28,12},
{160141313,92590464,28,12},
{160124929,101916657,28,12},
{160075777,41815070,28,12},
{160063489,41828090,28,13},
{160038913,52056936,28,17},
{160030721,21572172,28,13},
{159993857,56808027,28,12},
{159895553,122804281,28,12},
{159858689,123583419,28,14},
{159645697,31075133,28,18},
{159608833,27313318,28,12},
{159571969,73357234,28,13},
{159563777,42533869,28,14},
{159522817,75692054,28,13},
{159490049,2419303,28,13},
{159477761,25325716,28,12},
{159436801,110265365,28,12},
{159375361,27745791,28,13},
{159363073,92513520,28,12},
{159342593,108618811,28,13},
{159318017,92546786,28,16},
{159293441,77989941,28,13},
{159281153,5324397,28,12},
{159232001,39808510,28,12},
{159219713,91556265,28,15},
{159191041,148342584,28,12},
{159158273,141637105,28,12},
{159133697,153094222,28,12},
{159129601,111492192,28,13},
{159117313,3525387,28,12},
{159072257,122382528,28,14},
{159055873,68048292,28,16},
{158986241,66975277,28,12},
{158801921,91990184,28,13},
{158748673,154491235,28,12},
{158740481,150887612,28,12},
{158699521,118931786,28,12},
{158679041,1877563,28,14},
{158605313,81799555,28,13},
{158527489,78281434,28,12},
{158441473,21858615,28,13},
{158384129,24625559,28,14},
{158334977,52866207,28,20},
{158281729,16590259,28,12},
{158261249,139211667,28,13},
{158232577,22867328,28,12},
{158171137,138576563,28,15},
{158097409,150783241,28,13},
{158072833,60684235,28,18},
{158003201,17315115,28,12},
{157966337,96794619,28,13},
{157900801,36870826,28,13},
{157831169,116301439,28,12},
{157757441,131600607,28,12},
{157745153,30073570,28,16},
{157667329,35638735,28,12},
{157646849,133949881,28,15},
{157585409,156129872,28,12},
{157536257,35100924,28,12},
{157532161,60685501,28,14},
{157495297,117363220,28,12},
{157388801,116720763,28,12},
{157327361,50091148,28,13},
{157229057,137221536,28,13},
{157224961,7375235,28,12},
{157151233,84015269,28,12},
{157126657,143036510,28,12},
{157114369,32012078,28,13},
{157102081,143873518,28,12},
{157069313,112749220,28,12},
{156991489,109720857,28,15},
{156905473,56226479,28,12},
{156897281,18379086,28,12},
{156880897,117567639,28,12},
{156844033,142421491,28,14},
{156835841,69254407,28,13},
{156721153,147460818,28,13},
{156700673,80957428,28,12},
{156684289,47743006,28,12},
{156672001,156206863,28,13},
{156635137,100515658,28,12},
{156622849,111861812,28,13},
{156577793,106305790,28,12},
{156540929,94735696,28,13},
{156499969,101342635,28,18},
{156479489,13824839,28,12},
{156405761,29000528,28,12},
{156389377,148261740,28,12},
{156303361,120950334,28,16},
{156295169,117491601,28,13},
{156266497,99312639,28,12},
{156221441,149021149,28,14},
{156192769,144974339,28,12},
{156180481,105879201,28,13},
{156131329,103954511,28,13},
{156110849,110049330,28,12},
{156069889,122581149,28,12},
{156024833,30177405,28,14},
{155983873,125565007,28,13},
{155934721,140608765,28,13},
{155901953,54818348,28,13},
{155877377,11007209,28,15},
{155811841,126007799,28,15},
{155717633,18689612,28,12},
{155668481,97367112,28,12},
{155607041,14409527,28,13},
{155590657,134412863,28,13},
{155516929,979094,28,16},
{155508737,46951992,28,13},
{155496449,41288861,28,12},
{155471873,71040761,28,12},
{155443201,50527322,28,13},
{155410433,40078581,28,13},
{155381761,81048955,28,12},
{155361281,57850536,28,13},
{155344897,11995825,28,13},
{155332609,39971129,28,12},
{155287553,51113784,28,15},
{155201537,119067904,28,12},
{155189249,79608224,28,22},
{155164673,34359728,28,13},
{155066369,58828002,28,13},
{155062273,140241414,28,12},
{154955777,148134070,28,12},
{154951681,38072371,28,13},
{154857473,66604547,28,12},
{154832897,30275121,28,12},
{154779649,86350579,28,14},
{154705921,15738833,28,13},
{154636289,131876202,28,12},
{154583041,52802955,28,14},
{154570753,65296119,28,12},
{154562561,45710883,28,12},
{154533889,128631841,28,17},
{154525697,49995943,28,13},
{154513409,106995574,28,12},
{154464257,145646869,28,12},
{154398721,110054622,28,12},
{154386433,50925983,28,14},
{154329089,143089267,28,13},
{154267649,75990212,28,12},
{154177537,20362339,28,12},
{154157057,72044331,28,14},
{154152961,38577760,28,12},
{154132481,112021198,28,13},
{154120193,102484092,28,12},
{154071041,41440376,28,12},
{154058753,141796619,28,14},
{154054657,81797204,28,12},
{153948161,127587712,28,12},
{153710593,50115594,28,12},
{153640961,113411600,28,13},
{153579521,38059807,28,12},
{153530369,124228661,28,12},
{153489409,142080791,28,12},
{153468929,9479111,28,14},
{153464833,70767218,28,12},
{153341953,40042056,28,12},
{153231361,60910947,28,13},
{153210881,14679863,28,12},
{153169921,45157177,28,12},
{153149441,41601316,28,13},
{153112577,10484466,28,12},
{153034753,31189267,28,13},
{153014273,81171465,28,12},
{152887297,125381403,28,13},
{152825857,123674649,28,12},
{152768513,2484653,28,12},
{152678401,65143465,28,12},
{152670209,21587668,28,12},
{152666113,53745269,28,15},
{152621057,63640123,28,12},
{152608769,133413642,28,13},
{152580097,67784029,28,12},
{152494081,64790800,28,13},
{152485889,130853816,28,14},
{152461313,79065536,28,13},
{152371201,93276450,28,16},
{152363009,33357098,28,13},
{152252417,45667545,28,12},
{152240129,71116330,28,16},
{152236033,120663885,28,12},
{152199169,102990580,28,13},
{152174593,119218123,28,17},
{152076289,151361833,28,15},
{152068097,22995623,28,13},
{152064001,58610797,28,12},
{152027137,93433738,28,14},
{151945217,62520453,28,15},
{151920641,51630824,28,13},
{151846913,36110967,28,16},
{151818241,7470768,28,12},
{151797761,42643189,28,14},
{151748609,101340414,28,15},
{151724033,109859126,28,13},
{151674881,136688021,28,13},
{151621633,5315439,28,12},
{151490561,60756244,28,12},
{151478273,119592152,28,13},
{151461889,133190218,28,13},
{151429121,98287835,28,13},
{151400449,118979806,28,12},
{151392257,98123153,28,12},
{151388161,95948571,28,17},
{151318529,48001510,28,12},
{151306241,49142177,28,14},
{151289857,170531,28,15},
{151257089,63889241,28,18},
{151146497,144659738,28,12},
{151093249,101577339,28,15},
{151085057,6593229,28,13},
{151048193,26932819,28,12},
{151031809,23052391,28,12},
{150986753,107940757,28,13},
{150958081,131831358,28,12},
{150945793,4043374,28,14},
{150908929,98386568,28,12},
{150863873,11945038,28,17},
{150802433,116714017,28,12},
{150798337,143671265,28,16},
{150786049,92885406,28,12},
{150568961,119998301,28,15},
{150540289,76041269,28,12},
{150532097,73111952,28,12},
{150458369,139384097,28,12},
{150446081,131223328,28,13},
{150392833,11946622,28,12},
{150355969,89295598,28,14},
{150331393,119848462,28,13},
{150310913,128339890,28,12},
{150188033,50875415,28,12},
{150183937,10505504,28,13},
{150126593,102688159,28,14},
{150110209,56804032,28,15},
{150085633,18687265,28,13},
{150003713,91933029,28,13},
{149962753,90390289,28,14},
{149917697,147777569,28,12},
{149905409,17118839,28,13},
{149901313,114585507,28,12},
{149880833,92781980,28,16},
{149831681,84618075,28,14},
{149815297,14948106,28,17},
{149716993,40965890,28,15},
{149696513,98196728,28,12},
{149598209,77428521,28,12},
{149594113,90599226,28,13},
{149585921,86019575,28,15},
{149557249,41574319,28,12},
{149532673,89291758,28,12},
{149508097,95988676,28,12},
{149495809,133048651,28,13},
{149487617,94085230,28,16},
{149475329,33853735,28,12},
{149450753,5124549,28,12},
{149426177,65132409,28,12},
{149352449,128125512,28,12},
{149311489,54514814,28,12},
{149299201,109558749,28,13},
{149266433,3261168,28,13},
{149217281,71984930,28,13},
{149200897,46551624,28,13},
{149188609,130020547,28,12},
{149139457,126055369,28,12},
{149020673,40628455,28,13},
{148996097,96274487,28,15},
{148992001,82681591,28,12},
{148979713,78634490,28,14},
{148922369,76012239,28,13},
{148795393,46409732,28,12},
{148787201,91698284,28,12},
{148709377,9609663,28,13},
{148676609,142864788,28,13},
{148566017,16939947,28,12},
{148418561,53386176,28,12},
{148369409,128350794,28,12},
{148254721,115596617,28,12},
{148205569,42692415,28,12},
{148160513,58516303,28,14},
{148156417,39095604,28,12},
{148119553,15090514,28,13},
{148099073,140184882,28,12},
{148094977,41785130,28,14},
{148062209,59176205,28,14},
{148037633,55370660,28,13},
{148008961,49528521,28,12},
{147935233,32504866,28,12},
{147898369,138543257,28,14},
{147853313,116658553,28,12},
{147849217,108267293,28,20},
{147804161,104343362,28,12},
{147750913,31710601,28,15},
{147730433,141520751,28,12},
{147632129,72864371,28,12},
{147619841,33107914,28,15},
{147517441,31976406,28,12},
{147509249,142956473,28,12},
{147468289,86245497,28,12},
{147460097,3433175,28,12},
{147443713,100490188,28,12},
{147382273,65590725,28,13},
{147357697,58630318,28,15},
{147337217,90395328,28,12},
{147296257,21614107,28,12},
{147271681,37773835,28,12},
{147251201,36546522,28,13},
{147210241,114180755,28,14},
{147099649,27285515,28,12},
{147079169,10902408,28,14},
{147075073,143477992,28,12},
{147038209,93464731,28,13},
{147030017,124216731,28,15},
{146993153,121726130,28,12},
{146944001,3228162,28,12},
{146845697,6850253,28,12},
{146841601,65470234,28,13},
{146829313,37701735,28,12},
{146808833,24238814,28,13},
{146792449,75609567,28,13},
{146784257,146088105,28,14},
{146706433,20473068,28,12},
{146636801,97017682,28,15},
{146546689,53134374,28,13},
{146501633,124059955,28,12},
{146411521,4819696,28,12},
{146354177,101992680,28,12},
{146317313,120153196,28,13},
{146313217,72293599,28,12},
{146219009,139802105,28,13},
{146190337,84575434,28,12},
{146178049,101404193,28,15},
{146083841,53443553,28,12},
{146042881,5114617,28,12},
{146034689,108056266,28,12},
{146030593,138427881,28,14},
{146010113,87862370,28,12},
{145981441,63673174,28,15},
{145944577,47745635,28,12},
{145801217,20333908,28,14},
{145760257,78107286,28,13},
{145739777,108670462,28,12},
{145715201,125562494,28,12},
{145702913,124000607,28,14},
{145686529,58093102,28,16},
{145612801,54179320,28,13},
{145555457,5037515,28,16},
{145543169,34610098,28,12},
{145514497,69159078,28,13},
{145494017,21875354,28,12},
{145489921,91343526,28,18},
{145453057,31434390,28,12},
{145367041,38672167,28,13},
{145285121,16755625,28,13},
{145272833,81826178,28,12},
{145231873,133139999,28,12},
{145211393,42907819,28,14},
{145182721,90781883,28,12},
{145174529,52069685,28,12},
{145072129,32941696,28,13},
{145063937,18788946,28,15},
{145059841,18023222,28,12},
{145039361,62301078,28,13},
{144949249,116917291,28,14},
{144941057,13918183,28,13},
{144928769,305958,28,12},
{144900097,138293659,28,16},
{144863233,131734108,28,12},
{144805889,29700663,28,12},
{144793601,79459511,28,13},
{144781313,109274487,28,12},
{144715777,116256009,28,12},
{144683009,50351857,28,12},
{144642049,124281036,28,12},
{144621569,76793907,28,14},
{144580609,108597941,28,13},
{144556033,56319781,28,14},
{144519169,121896420,28,12},
{144498689,92302353,28,13},
{144494593,135444054,28,12},
{144449537,124182785,28,13},
{144433153,137361438,28,13},
{144375809,59671847,28,16},
{144310273,32724164,28,17},
{144285697,96211617,28,13},
{144265217,89475320,28,12},
{144261121,8749021,28,14},
{144252929,50031932,28,13},
{144248833,103483751,28,12},
{144240641,24464280,28,12},
{144203777,56329944,28,13},
{144199681,63049098,28,12},
{144117761,29778414,28,12},
{144105473,116921384,28,13},
{144068609,53295948,28,12},
{144019457,140856871,28,12},
{144007169,100066070,28,13},
{143953921,104953617,28,12},
{143884289,69922602,28,15},
{143822849,135882460,28,12},
{143798273,64057101,28,12},
{143769601,89060933,28,14},
{143749121,110595448,28,12},
{143736833,119080422,28,14},
{143708161,27986181,28,12},
{143675393,47938652,28,12},
{143646721,45919075,28,13},
{143597569,131264301,28,13},
{143486977,14200673,28,12},
{143462401,133564920,28,12},
{143425537,138411731,28,15},
{143364097,46581813,28,12},
{143228929,50610036,28,15},
{143142913,121572974,28,12},
{143106049,128604949,28,13},
{143093761,122045784,28,12},
{143056897,81857032,28,13},
{142938113,66524994,28,12},
{142921729,12007860,28,12},
{142909441,104928591,28,13},
{142827521,102213571,28,13},
{142798849,44376260,28,12},
{142790657,77306759,28,12},
{142786561,99761539,28,14},
{142766081,53346590,28,12},
{142729217,134558492,28,13},
{142651393,50039375,28,12},
{142630913,83452086,28,13},
{142626817,97125592,28,12},
{142602241,66288162,28,12},
{142565377,103254966,28,13},
{142508033,53697014,28,15},
{142479361,29392869,28,12},
{142446593,95854962,28,12},
{142442497,87881403,28,15},
{142397441,36610666,28,12},
{142360577,4225430,28,14},
{142344193,141754561,28,18},
{142282753,16503924,28,12},
{142245889,123582689,28,15},
{142196737,80728838,28,14},
{142163969,33541341,28,14},
{142159873,56426216,28,12},
{142102529,88081672,28,12},
{142098433,57759429,28,14},
{142073857,120959214,28,13},
{142012417,123716427,28,12},
{141967361,27290122,28,14},
{141905921,76733765,28,12},
{141889537,139997910,28,12},
{141852673,12957573,28,15},
{141832193,130132150,28,12},
{141754369,96676556,28,16},
{141680641,23172195,28,13},
{141561857,118268805,28,12},
{141557761,2025374,28,20},
{141537281,86447539,28,12},
{141500417,45112792,28,13},
{141484033,79389342,28,13},
{141447169,62531221,28,12},
{141438977,30177566,28,12},
{141402113,97362263,28,13},
{141398017,76565711,28,12},
{141365249,29201764,28,12},
{141340673,134809686,28,12},
{141336577,28105237,28,13},
{141324289,63072072,28,12},
{141312001,22228053,28,14},
{141303809,83378586,28,13},
{141275137,94234327,28,12},
{141254657,5258880,28,13},
{141189121,112175687,28,13},
{141180929,118164251,28,14},
{141139969,137979721,28,13},
{141094913,116771352,28,12},
{141045761,130135793,28,12},
{140972033,15469847,28,12},
{140935169,24475794,28,15},
{140873729,37839284,28,12},
{140845057,43031772,28,13},
{140820481,101769221,28,14},
{140771329,129228525,28,18},
{140759041,135162830,28,12},
{140685313,140119344,28,12},
{140664833,24539479,28,13},
{140627969,59216168,28,12},
{140587009,33735569,28,12},
{140578817,12590202,28,12},
{140566529,117468545,28,13},
{140554241,109801592,28,12},
{140525569,46790444,28,14},
{140513281,27258794,28,12},
{140505089,21211171,28,12},
{140492801,99797987,28,14},
{140480513,47593083,28,12},
{140455937,116435175,28,12},
{140439553,64707113,28,12},
{140394497,122286817,28,14},
{140390401,29679699,28,12},
{140369921,131963805,28,13},
{140308481,8491698,28,12},
{140234753,50542048,28,12},
{140218369,56029031,28,12},
{140206081,5156099,28,13},
{140193793,128969853,28,12},
{140136449,87438017,28,12},
{140095489,131604965,28,12},
{140083201,15534364,28,15},
{140025857,45866092,28,13},
{140013569,118837441,28,12},
{139988993,71479719,28,12},
{139960321,56331870,28,13},
{139952129,93540477,28,15},
{139948033,63415870,28,12},
{139911169,102566175,28,13},
{139890689,42220594,28,12},
{139804673,124295104,28,14},
{139788289,63577713,28,16},
{139739137,103109056,28,14},
{139726849,16073666,28,12},
{139702273,83611592,28,12},
{139694081,31804811,28,12},
{139644929,43473590,28,12},
{139603969,22608156,28,12},
{139534337,18807862,28,13},
{139517953,3873206,28,13},
{139493377,83696936,28,15},
{139411457,67490962,28,14},
{139358209,81951359,28,12},
{139309057,39474919,28,12},
{139288577,70861053,28,13},
{139272193,53749284,28,13},
{139251713,60519123,28,12},
{139247617,25742723,28,14},
{139223041,27037413,28,13},
{139214849,136962690,28,14},
{139153409,56782383,28,12},
{139104257,112708927,28,12},
{139087873,33229580,28,12},
{139063297,91786448,28,12},
{139051009,55894834,28,14},
{138981377,123371083,28,12},
{138977281,79855482,28,13},
{138944513,58457129,28,13},
{138858497,33712252,28,12},
{138846209,34427880,28,13},
{138792961,51091416,28,12},
{138784769,24314736,28,12},
{138735617,130589334,28,12},
{138694657,41748694,28,12},
{138661889,56936517,28,12},
{138588161,62516986,28,12},
{138514433,48677136,28,12},
{138485761,22486478,28,13},
{138465281,107358753,28,12},
{138428417,37357046,28,14},
{138416129,73240221,28,12},
{138412033,44372258,28,22},
{138403841,115546439,28,13},
{138350593,2290407,28,12},
{138301441,3854852,28,12},
{138289153,71085374,28,13},
{138268673,4568126,28,12},
{138231809,125424098,28,14},
{138190849,15346939,28,13},
{138182657,76453115,28,15},
{138145793,72585671,28,12},
{138055681,25759197,28,12},
{138047489,25152846,28,12},
{137998337,27673912,28,12},
{137986049,127396440,28,15},
{137973761,128339794,28,12},
{137900033,37421217,28,12},
{137760769,53693402,28,12},
{137752577,80131653,28,12},
{137740289,21197286,28,14},
{137674753,112422046,28,14},
{137629697,25813963,28,12},
{137617409,116958600,28,13},
{137576449,133481415,28,14},
{137555969,52452618,28,12},
{137551873,111459820,28,13},
{137490433,101245375,28,12},
{137469953,92716003,28,13},
{137379841,133245248,28,14},
{137371649,74593886,28,13},
{137367553,7204116,28,12},
{137310209,68549605,28,12},
{137297921,118366199,28,16},
{137285633,55309872,28,12},
{137256961,122566425,28,13},
{137224193,80009469,28,13},
{137199617,38320933,28,15},
{137195521,112953104,28,12},
{137125889,14131134,28,13},
{137084929,4081171,28,14},
{137072641,106923120,28,12},
{137064449,27174305,28,12},
{136978433,44182831,28,13},
{136953857,71887527,28,14},
{136937473,14199970,28,15},
{136892417,37384029,28,12},
{136888321,49544131,28,14},
{136814593,23560113,28,13},
{136769537,5884223,28,12},
{136753153,62840629,28,12},
{136671233,64427812,28,12},
{136609793,45062725,28,15},
{136548353,7084428,28,12},
{136511489,3613797,28,16},
{136486913,96585470,28,13},
{136450049,28650097,28,12},
{136437761,110327408,28,13},
{136421377,96571777,28,13},
{136314881,125283503,28,21},
{136286209,33039320,28,12},
{136278017,103120746,28,12},
{136265729,76414205,28,14},
{136253441,91117627,28,12},
{136138753,129019182,28,12},
{136077313,117658710,28,13},
{135946241,115569276,28,13},
{135847937,128284487,28,13},
{135835649,77668518,28,12},
{135823361,111768578,28,15},
{135811073,68111536,28,12},
{135806977,30331243,28,14},
{135794689,22420642,28,12},
{135745537,1416836,28,12},
{135733249,100086519,28,13},
{135720961,47078454,28,12},
{135712769,34454382,28,12},
{135663617,35481633,28,12},
{135639041,27086915,28,12},
{135622657,126833122,28,12},
{135536641,106631534,28,13},
{135503873,129201177,28,13},
{135475201,66882081,28,12},
{135454721,19954453,28,13},
{135376897,61673971,28,12},
{135344129,47389931,28,12},
{135319553,32836571,28,12},
{135217153,5130012,28,14},
{135180289,133953738,28,12},
{135172097,99019747,28,12},
{135135233,48046744,28,17},
{135131137,71315913,28,12},
{135118849,11772344,28,14},
{135024641,88932762,28,12},
{135008257,11128802,28,12},
{134987777,67778341,28,14},
{134963201,69009505,28,13},
{134946817,50919464,28,13},
{134934529,45261307,28,12},
{134922241,132051402,28,14},
{134864897,21180983,28,13},
{134848513,71254200,28,13},
{134828033,72342287,28,12},
{134823937,7403535,28,14},
{134787073,28107332,28,12},
{134737921,130466231,28,12},
{134729729,123683990,28,12},
{134701057,111610302,28,13},
{134680577,98329799,28,12},
{134664193,28297318,28,12},
{134565889,111939765,28,12},
{134520833,15212910,28,13},
{134516737,114389434,28,12},
{134492161,26007861,28,12},
{134483969,119184416,28,12},
{134443009,37234444,28,12},
{134397953,51608148,28,14},
{134348801,113157182,28,17},
{134336513,133349315,28,12},
{134275073,82605566,28,13},
{134250497,110634935,28,15},
{134246401,39006959,28,12},
{134176769,63945361,27,13},
{134111233,29876061,27,13},
{134025217,7592870,27,12},
{134012929,8042558,27,13},
{133963777,121075269,27,13},
{133881857,79293159,27,13},
{133857281,27914175,27,15},
{133844993,18196029,27,12},
{133746689,59208234,27,12},
{133681153,16314534,27,12},
{133644289,41688424,27,14},
{133611521,23558138,27,14},
{133513217,9134797,27,14},
{133509121,54865809,27,12},
{133500929,60132147,27,12},
{133472257,112730432,27,13},
{133459969,92631039,27,12},
{133427201,49863026,27,12},
{133386241,14451041,27,12},
{133373953,114394191,27,13},
{133304321,131062064,27,12},
{133251073,19973773,27,14},
{133144577,9168953,27,13},
{133046273,115731848,27,13},
{133029889,60196504,27,13},
{132997121,56506245,27,13},
{132837377,95059843,27,12},
{132825089,19421313,27,14},
{132820993,72489013,27,12},
{132759553,22548742,27,14},
{132751361,28615598,27,13},
{132714497,46070981,27,12},
{132710401,115236244,27,16},
{132640769,126151755,27,12},
{132612097,67801901,27,15},
{132599809,120973534,27,12},
{132591617,112314978,27,12},
{132538369,126535179,27,13},
{132526081,131551899,27,12},
{132468737,20959505,27,12},
{132464641,56180594,27,14},
{132354049,112714559,27,12},
{132333569,38380684,27,14},
{132247553,76067779,27,12},
{132243457,101969632,27,13},
{132206593,124553297,27,12},
{132169729,62519389,27,14},
{132161537,54491295,27,13},
{132120577,61462611,27,21},
{132108289,6588559,27,12},
{132100097,74017400,27,12},
{132063233,57494612,27,13},
{131923969,131902631,27,16},
{131862529,19873393,27,12},
{131850241,56329108,27,13},
{131719169,37962428,27,13},
{131694593,71495587,27,15},
{131690497,113177605,27,12},
{131670017,26233147,27,13},
{131645441,74571118,27,14},
{131633153,48899629,27,12},
{131604481,99915012,27,13},
{131547137,76530967,27,14},
{131530753,78490098,27,16},
{131448833,35345812,27,14},
{131444737,105712287,27,12},
{131432449,99158316,27,15},
{131424257,86602718,27,13},
{131407873,116799173,27,13},
{131383297,57279334,27,14},
{131362817,92491336,27,12},
{131350529,22983769,27,14},
{131346433,118805980,27,12},
{131321857,78606132,27,12},
{131289089,52141368,27,12},
{131264513,58734798,27,12},
{131239937,61527723,27,12},
{131215361,2109954,27,12},
{131174401,14947717,27,12},
{131162113,112290018,27,13},
{131080193,29653853,27,13},
{131018753,21097604,27,12},
{130977793,18256054,27,12},
{130895873,12169668,27,12},
{130809857,7493603,27,18},
{130744321,92134475,27,16},
{130736129,66915564,27,13},
{130674689,34271547,27,12},
{130600961,69242528,27,12},
{130527233,102874011,27,12},
{130490369,120812733,27,13},
{130486273,104994569,27,12},
{130478081,49789699,27,12},
{130461697,57047094,27,12},
{130363393,126505240,27,12},
{130342913,20182424,27,13},
{130301953,129551622,27,14},
{130265089,39718668,27,12},
{130256897,71230611,27,12},
{130191361,41426512,27,12},
{130179073,87123974,27,13},
{130158593,47295679,27,12},
{130121729,34271360,27,15},
{130097153,61431669,27,13},
{130072577,82659196,27,14},
{130068481,25207443,27,12},
{130056193,69072452,27,15},
{130048001,58713940,27,13},
{129986561,108159078,27,12},
{129970177,44105988,27,12},
{129933313,80483981,27,13},
{129912833,63416991,27,12},
{129896449,50585168,27,12},
{129871873,99743245,27,12},
{129810433,39737058,27,14},
{129802241,84889409,27,13},
{129617921,100371294,27,12},
{129576961,15836424,27,12},
{129556481,21296954,27,13},
{129544193,39975876,27,12},
{129515521,14634498,27,14},
{129445889,101335451,27,12},
{129417217,17312200,27,14},
{129146881,46670364,27,13},
{129138689,14985946,27,15},
{129126401,75746080,27,12},
{129114113,48815745,27,13},
{129097729,14409149,27,13},
{129089537,79505016,27,14},
{129011713,50349121,27,12},
{128987137,126346630,27,12},
{128954369,58694155,27,12},
{128913409,32989165,27,12},
{128868353,101230027,27,13},
{128851969,55242398,27,13},
{128839681,13400196,27,12},
{128806913,8128484,27,12},
{128782337,4721350,27,12},
{128741377,21069901,27,12},
{128708609,68051823,27,12},
{128655361,49729645,27,13},
{128634881,51650217,27,12},
{128495617,3922762,27,12},
{128434177,77549951,27,14},
{128413697,15714937,27,12},
{128348161,64690188,27,12},
{128290817,38879603,27,12},
{128253953,31436382,27,16},
{128229377,99349394,27,13},
{128151553,7188328,27,12},
{128053249,88577862,27,12},
{128032769,78991876,27,13},
{128008193,39445534,27,14},
{127983617,32458552,27,13},
{127922177,104499493,27,12},
{127905793,93162647,27,12},
{127807489,88332118,27,12},
{127799297,35059162,27,12},
{127795201,30686035,27,17},
{127664129,57890268,27,18},
{127635457,121361849,27,12},
{127623169,119913790,27,13},
{127574017,28794062,27,13},
{127561729,3291632,27,12},
{127553537,53918460,27,12},
{127512577,50049775,27,12},
{127479809,4620221,27,12},
{127438849,108600674,27,12},
{127295489,61390544,27,13},
{127246337,12458268,27,13},
{127193089,41907172,27,12},
{127172609,33226722,27,15},
{127119361,44147019,27,12},
{127049729,22520549,27,13},
{126988289,84928968,27,12},
{126976001,32394488,27,15},
{126853121,22450923,27,13},
{126799873,50876625,27,12},
{126791681,118833875,27,12},
{126717953,108515336,27,12},
{126713857,60411184,27,15},
{126693377,50079593,27,12},
{126631937,105567765,27,14},
{126615553,66933366,27,18},
{126607361,24661165,27,13},
{126533633,63265091,27,14},
{126529537,44848982,27,12},
{126431233,48482738,27,12},
{126423041,40350469,27,12},
{126394369,93949377,27,13},
{126345217,13905578,27,13},
{126320641,6392858,27,15},
{126251009,5860515,27,12},
{126226433,74707055,27,12},
{126222337,108426031,27,17},
{126197761,105080720,27,13},
{126160897,82945429,27,12},
{126148609,119588397,27,13},
{126115841,53588648,27,13},
{126103553,115374010,27,12},
{126074881,32198679,27,14},
{126062593,33839875,27,12},
{126025729,37140656,27,16},
{126013441,86420529,27,12},
{125976577,34215718,27,14},
{125956097,7856829,27,12},
{125943809,105929168,27,14},
{125882369,54949812,27,12},
{125878273,6997937,27,14},
{125857793,80417905,27,12},
{125853697,74077505,27,13},
{125833217,84966841,27,12},
{125796353,16357130,27,15},
{125710337,75724751,27,12},
{125706241,72934535,27,13},
{125698049,86539884,27,17},
{125669377,116877909,27,12},
{125632513,1022427,27,16},
{125612033,39414077,27,12},
{125587457,98204374,27,12},
{125534209,78999581,27,15},
{125489153,24893590,27,12},
{125472769,112012162,27,12},
{125440001,116594901,27,12},
{125427713,74534404,27,13},
{125399041,86885870,27,12},
{125255681,4432594,27,14},
{125227009,31211541,27,12},
{125194241,8667200,27,12},
{125157377,57847446,27,14},
{125083649,54654578,27,13},
{125042689,80960682,27,18},
{125009921,1462231,27,15},
{124997633,100073676,27,12},
{124887041,64587366,27,13},
{124813313,53751457,27,15},
{124674049,61303218,27,13},
{124665857,91933990,27,14},
{124653569,86726677,27,12},
{124628993,26427930,27,12},
{124624897,11265823,27,13},
{124456961,13939876,27,12},
{124428289,32082958,27,13},
{124416001,56123114,27,12},
{124358657,79619901,27,12},
{124280833,105678148,27,13},
{124272641,11988944,27,14},
{124235777,46703492,27,12},
{124219393,88488248,27,12},
{124194817,19558010,27,12},
{124182529,110680866,27,13},
{124133377,90649943,27,13},
{124014593,75244293,27,12},
{123998209,6790556,27,12},
{123990017,79340764,27,12},
{123953153,905045,27,13},
{123863041,108651086,27,17},
{123842561,79192303,27,12},
{123805697,70429025,27,13},
{123793409,20505091,27,12},
{123781121,86034149,27,14},
{123764737,112112029,27,15},
{123752449,23725535,27,12},
{123719681,26950618,27,12},
{123703297,111301476,27,12},
{123682817,76655283,27,14},
{123617281,115404041,27,14},
{123604993,50651622,27,12},
{123580417,105091360,27,12},
{123547649,3526600,27,12},
{123535361,9416053,27,16},
{123506689,91241078,27,12},
{123498497,110519045,27,12},
{123301889,33037027,27,12},
{123297793,2917672,27,13},
{123277313,34981603,27,12},
{123248641,103567268,27,13},
{123240449,16460995,27,15},
{123236353,119365195,27,12},
{123179009,88426846,27,12},
{123064321,54586887,27,12},
{123015169,35425205,27,12},
{122994689,106716270,27,14},
{122982401,38206349,27,12},
{122953729,62389332,27,13},
{122847233,2445282,27,15},
{122757121,113009550,27,13},
{122736641,94567165,27,12},
{122724353,8026024,27,13},
{122707969,47892366,27,13},
{122687489,20395746,27,12},
{122638337,4994134,27,12},
{122560513,69872769,27,13},
{122474497,95310047,27,12},
{122441729,103145225,27,12},
{122380289,11314026,27,13},
{122376193,52499262,27,12},
{122355713,97193137,27,16},
{122351617,107853078,27,12},
{122318849,47179780,27,12},
{122204161,71894473,27,12},
{122183681,50659162,27,13},
{122122241,5773457,27,12},
{122105857,69429918,27,12},
{122085377,60995822,27,13},
{121946113,100552472,27,14},
{121901057,11332949,27,12},
{121884673,72678548,27,12},
{121876481,79267314,27,12},
{121847809,93444058,27,14},
{121839617,13113906,27,13},
{121835521,74860859,27,12},
{121778177,15137741,27,12},
{121753601,13835957,27,12},
{121724929,120753102,27,13},
{121716737,98540950,27,14},
{121675777,47215505,27,13},
{121630721,119597793,27,12},
{121618433,65995778,27,14},
{121602049,100119720,27,15},
{121577473,96947524,27,13},
{121569281,110651813,27,16},
{121495553,16564394,27,13},
{121491457,40413270,27,12},
{121470977,117218934,27,15},
{121466881,8186286,27,12},
{121430017,29080596,27,13},
{121405441,91939983,27,15},
{121397249,58702631,27,13},
{121344001,55754833,27,12},
{121331713,56341347,27,13},
{121245697,85790198,27,12},
{121184257,81767649,27,13},
{121147393,12954615,27,12},
{121139201,114884505,27,12},
{121122817,115056233,27,12},
{121061377,41274790,27,14},
{121016321,118389758,27,12},
{120926209,8702177,27,12},
{120901633,13022064,27,12},
{120881153,102635337,27,15},
{120864769,97299068,27,14},
{120856577,89794312,27,13},
{120852481,77051254,27,12},
{120803329,95169886,27,12},
{120741889,16264168,27,13},
{120680449,62378951,27,12},
{120659969,77645336,27,13},
{120586241,92367763,27,20},
{120524801,69197486,27,12},
{120451073,104502375,27,12},
{120410113,32579922,27,12},
{120373249,38192863,27,14},
{120324097,23614618,27,18},
{120299521,42790409,27,13},
{120266753,114992938,27,13},
{120262657,96668789,27,12},
{120205313,19843636,27,12},
{120180737,74424054,27,12},
{120168449,49701126,27,13},
{120156161,46145898,27,12},
{120127489,60704319,27,16},
{120082433,95270576,27,12},
{120020993,3737920,27,13},
{119943169,73499177,27,12},
{119934977,34748990,27,12},
{119922689,86884119,27,13},
{119918593,3275401,27,12},
{119848961,1983355,27,14},
{119812097,64678439,27,12},
{119795713,93321594,27,12},
{119713793,72066109,27,12},
{119709697,37168700,27,13},
{119676929,34955389,27,13},
{119652353,9559377,27,14},
{119623681,78239992,27,12},
{119603201,84703546,27,16},
{119554049,12367166,27,14},
{119504897,44208338,27,15},
{119488513,84726370,27,14},
{119480321,30504893,27,13},
{119463937,3418655,27,13},
{119402497,103378333,27,12},
{119369729,49749589,27,12},
{119365633,67664251,27,13},
{119345153,26002558,27,12},
{119320577,78367768,27,12},
{119308289,99960866,27,15},
{119259137,78755103,27,14},
{119255041,13559492,27,12},
{119234561,84718453,27,13},
{119173121,59651190,27,12},
{119132161,90560464,27,12},
{119050241,75177806,27,12},
{119009281,79176060,27,12},
{118996993,77053703,27,14},
{118988801,65202506,27,13},
{118972417,61551312,27,13},
{118947841,102472815,27,16},
{118939649,82745955,27,13},
{118915073,100701318,27,15},
{118910977,110079117,27,12},
{118804481,104928364,27,12},
{118763521,69831778,27,12},
{118751233,108944461,27,18},
{118702081,88717870,27,14},
{118644737,49467681,27,13},
{118607873,14113565,27,12},
{118591489,78036428,27,12},
{118546433,20691600,27,13},
{118423553,74923808,27,16},
{118386689,37929449,27,12},
{118345729,56956221,27,12},
{118272001,36300278,27,12},
{118235137,16490167,27,13},
{118177793,28048948,27,14},
{118173697,10524075,27,12},
{118161409,4867730,27,16},
{118149121,54285436,27,12},
{118140929,90260560,27,12},
{117977089,94301963,27,12},
{117964801,16338907,27,19},
{117915649,76085061,27,14},
{117903361,11503247,27,12},
{117882881,8088788,27,14},
{117829633,54109881,27,12},
{117784577,55208643,27,14},
{117772289,57663957,27,12},
{117743617,35705627,27,13},
{117657601,9087465,27,12},
{117645313,3370452,27,13},
{117624833,40936665,27,12},
{117600257,34979035,27,12},
{117559297,83144360,27,12},
{117534721,57503976,27,12},
{117497857,96262355,27,13},
{117477377,94501156,27,12},
{117452801,26874870,27,12},
{117415937,49583291,27,13},
{117399553,101935640,27,13},
{117391361,106916538,27,14},
{117338113,55624698,27,12},
{117317633,89408687,27,13},
{117288961,25317444,27,12},
{117280769,60858934,27,12},
{117276673,38587279,27,15},
{117231617,109567515,27,12},
{117219329,91444040,27,13},
{117215233,12467221,27,12},
{117157889,5130420,27,12},
{117104641,53236548,27,13},
{117084161,15102623,27,12},
{116973569,89706006,27,13},
{116887553,27001830,27,12},
{116883457,6776270,27,15},
{116850689,95116071,27,16},
{116838401,35189885,27,12},
{116826113,30167097,27,13},
{116801537,64775527,27,14},
{116764673,88278675,27,12},
{116736001,5807763,27,14},
{116723713,67773649,27,12},
{116686849,111442763,27,15},
{116678657,29190793,27,13},
{116641793,34709896,27,12},
{116600833,66629329,27,12},
{116563969,71375144,27,13},
{116514817,87481731,27,13},
{116453377,63961336,27,12},
{116420609,58762509,27,12},
{116371457,108910149,27,12},
{116355073,17263966,27,12},
{116330497,93610602,27,12},
{116310017,24968717,27,14},
{116248577,92855247,27,12},
{116211713,83823351,27,14},
{116195329,115918714,27,16},
{116125697,53620405,27,12},
{116072449,80809640,27,13},
{115998721,62071826,27,17},
{115990529,19483828,27,13},
{115879937,77807996,27,12},
{115855361,35623603,27,12},
{115818497,66110407,27,14},
{115814401,115216486,27,12},
{115765249,79621338,27,12},
{115683329,48574347,27,12},
{115679233,4739108,27,13},
{115621889,32584526,27,14},
{115609601,93451852,27,12},
{115568641,109298419,27,12},
{115560449,47826685,27,12},
{115535873,91700252,27,12},
{115531777,25091616,27,13},
{115507201,5930994,27,15},
{115470337,88593399,27,12},
{115433473,29664084,27,13},
{115425281,100117971,27,14},
{115351553,47725879,27,13},
{115322881,102172065,27,12},
{115249153,2308866,27,12},
{115212289,59994581,27,17},
{115187713,14825636,27,13},
{115179521,111704252,27,15},
{115130369,29595194,27,14},
{115126273,82551675,27,12},
{115089409,26138000,27,13},
{115081217,24212983,27,18},
{115068929,54393099,27,12},
{114982913,107000366,27,15},
{114954241,69286441,27,12},
{114892801,15419080,27,13},
{114872321,8286354,27,12},
{114860033,82810204,27,13},
{114831361,38653614,27,12},
{114823169,30667567,27,12},
{114782209,9906470,27,12},
{114708481,1586442,27,12},
{114671617,60420232,27,14},
{114552833,10089708,27,12},
{114503681,91429885,27,12},
{114393089,54154728,27,15},
{114364417,15956587,27,12},
{114331649,89999242,27,12},
{114327553,63213934,27,15},
{114221057,66467823,27,13},
{114143233,98573002,27,12},
{114135041,33627036,27,12},
{114073601,109567051,27,13},
{114057217,24470853,27,13},
{114032641,97346619,27,18},
{114020353,4061312,27,12},
{114012161,20998707,27,12},
{113975297,73890209,27,13},
{113963009,87298199,27,12},
{113950721,7483055,27,14},
{113913857,11409503,27,12},
{113872897,15675182,27,12},
{113860609,33902232,27,13},
{113836033,42367605,27,16},
{113815553,47578903,27,12},
{113790977,24760704,27,12},
{113778689,52098898,27,13},
{113729537,59920131,27,13},
{113725441,76547951,27,12},
{113606657,81810734,27,15},
{113602561,59641262,27,12},
{113532929,2350359,27,13},
{113491969,54682652,27,14},
{113446913,110234184,27,12},
{113430529,3650093,27,12},
{113418241,76921039,27,13},
{113397761,46313005,27,12},
{113381377,90413083,27,12},
{113246209,23676257,27,22},
{113176577,6966872,27,12},
{113160193,25085336,27,12},
{113115137,68702927,27,17},
{113090561,40823395,27,13},
{113037313,97734787,27,12},
{112967681,80605928,27,14},
{112955393,11671054,27,12},
{112939009,104191239,27,12},
{112930817,97499215,27,12},
{112844801,39567990,27,13},
{112754689,2845322,27,15},
{112709633,43460289,27,12},
{112693249,36131628,27,12},
{112607233,104044822,27,14},
{112586753,101549676,27,12},
{112549889,24367964,27,13},
{112500737,23488879,27,13},
{112496641,84469903,27,12},
{112398337,42512589,27,12},
{112365569,16512882,27,12},
{112336897,35893068,27,13},
{112279553,103641825,27,14},
{112254977,107327155,27,13},
{112230401,12186016,27,15},
{112201729,1310659,27,12},
{112168961,59673519,27,12},
{112128001,6921301,27,12},
{112119809,24214182,27,12},
{112091137,97501229,27,13},
{112066561,40743042,27,17},
{112054273,102716207,27,12},
{112033793,42493746,27,15},
{111943681,88868937,27,13},
{111808513,27761736,27,12},
{111751169,22261697,27,12},
{111747073,70965318,27,13},
{111661057,62085888,27,12},
{111640577,23450752,27,15},
{111599617,37619543,27,13},
{111575041,97897918,27,15},
{111538177,99168596,27,12},
{111525889,109711134,27,14},
{111513601,58995424,27,12},
{111505409,7038519,27,12},
{111403009,59964209,27,13},
{111382529,851786,27,12},
{111378433,2162787,27,15},
{111370241,101243377,27,13},
{111333377,51880034,27,12},
{111280129,81154454,27,17},
{111194113,44693207,27,12},
{111149057,43310727,27,21},
{111108097,19524897,27,13},
{111075329,13725701,27,13},
{110989313,109515882,27,12},
{110952449,100242642,27,16},
{110866433,85325384,27,12},
{110862337,24793439,27,13},
{110850049,59128685,27,12},
{110694401,81069705,27,12},
{110665729,58045164,27,13},
{110653441,66325690,27,12},
{110530561,55147208,27,12},
{110522369,87514244,27,12},
{110518273,6026136,27,13},
{110395393,64932311,27,15},
{110358529,50852080,27,12},
{110313473,6736721,27,14},
{110276609,78392595,27,12},
{110252033,36911131,27,12},
{110235649,21768778,27,12},
{110227457,84583138,27,12},
{110202881,86875822,27,12},
{110051329,40993548,27,14},
{110043137,94558298,27,13},
{110026753,8936147,27,13},
{110002177,3733293,27,15},
{109965313,77667874,27,12},
{109944833,47148773,27,13},
{109854721,33164881,27,14},
{109821953,38210136,27,14},
{109817857,40371849,27,12},
{109805569,23669329,27,15},
{109756417,89542909,27,14},
{109731841,69413302,27,13},
{109662209,50463194,27,12},
{109596673,24878490,27,12},
{109588481,28541417,27,12},
{109572097,108760947,27,12},
{109510657,90741648,27,16},
{109449217,65657156,27,12},
{109424641,38097024,27,12},
{109387777,77266634,27,13},
{109355009,95210894,27,13},
{109289473,20323080,27,13},
{109281281,6901650,27,15},
{109244417,55639256,27,12},
{109191169,35703686,27,13},
{109142017,46517821,27,13},
{109084673,60813966,27,15},
{109019137,98642621,27,15},
{108986369,95772996,27,16},
{108982273,23988274,27,12},
{108945409,31221369,27,13},
{108810241,85445581,27,12},
{108740609,50499590,27,14},
{108716033,61597821,27,13},
{108650497,84657621,27,13},
{108564481,34974359,27,12},
{108552193,43785082,27,13},
{108507137,50586702,27,12},
{108371969,103718007,27,13},
{108367873,18538678,27,12},
{108343297,59097467,27,12},
{108269569,80458870,27,12},
{108244993,102627544,27,12},
{108208129,105711456,27,13},
{108199937,6091728,27,16},
{108163073,72108976,27,12},
{108040193,16395389,27,12},
{107954177,12110368,27,14},
{107892737,103710951,27,12},
{107868161,31263781,27,12},
{107855873,93202332,27,14},
{107839489,12724080,27,15},
{107814913,104130179,27,13},
{107765761,99354075,27,13},
{107732993,92511454,27,13},
{107728897,70204417,27,12},
{107683841,37157946,27,13},
{107593729,100222432,27,14},
{107569153,40519554,27,13},
{107507713,41290893,27,12},
{107499521,70346921,27,12},
{107470849,48970275,27,13},
{107462657,11074125,27,14},
{107425793,48842068,27,12},
{107360257,90543317,27,12},
{107339777,72883396,27,13},
{107302913,79471183,27,12},
{107216897,83299523,27,18},
{107180033,37471236,27,12},
{107089921,66018268,27,12},
{107020289,48288829,27,16},
{107016193,87808503,27,12},
{106909697,28769757,27,12},
{106897409,63341631,27,13},
{106872833,105442328,27,14},
{106848257,51460973,27,13},
{106807297,27065457,27,14},
{106663937,28479781,27,12},
{106524673,86549790,27,12},
{106487809,72383158,27,13},
{106475521,56313484,27,12},
{106463233,64788755,27,15},
{106442753,20463054,27,12},
{106377217,34602136,27,12},
{106352641,60223698,27,12},
{106344449,8127747,27,12},
{106303489,42441845,27,12},
{106295297,41421863,27,12},
{106233857,35890044,27,16},
{106221569,38467181,27,12},
{106160129,52352373,27,13},
{106147841,51919661,27,12},
{106135553,96018985,27,15},
{106086401,32839328,27,14},
{106057729,57887651,27,12},
{106037249,62297989,27,17},
{106033153,71340734,27,12},
{105922561,73079185,27,14},
{105873409,78823293,27,15},
{105848833,8057074,27,13},
{105828353,48054903,27,12},
{105791489,72825820,27,14},
{105762817,75415720,27,12},
{105725953,88386713,27,14},
{105717761,32659710,27,13},
{105701377,77178504,27,13},
{105668609,41757419,27,13},
{105619457,93649897,27,13},
{105603073,72220001,27,13},
{105517057,76156905,27,12},
{105504769,85385665,27,13},
{105492481,85850885,27,12},
{105455617,61481134,27,13},
{105443329,83089001,27,12},
{105361409,20123488,27,12},
{105295873,41289733,27,12},
{105271297,79924715,27,12},
{105246721,45160565,27,12},
{105234433,431030,27,14},
{105172993,3168713,27,12},
{105152513,489616,27,15},
{105123841,94276432,27,12},
{105074689,16177956,27,12},
{105041921,44272860,27,12},
{105029633,12128826,27,13},
{105025537,83565715,27,12},
{105005057,70942957,27,14},
{104943617,101804169,27,12},
{104857601,90254352,27,22},
{104759297,64582466,27,15},
{104755201,10917380,27,12},
{104685569,76937095,27,13},
{104673281,38329746,27,12},
{104656897,69696872,27,12},
{104599553,64167762,27,12},
{104538113,100511986,27,13},
{104501249,9956895,27,12},
{104460289,30959484,27,12},
{104435713,67103596,27,12},
{104366081,50788537,27,15},
{104353793,91009495,27,12},
{104325121,62034040,27,13},
{104267777,34822900,27,16},
{104194049,63020428,27,13},
{104165377,635695,27,12},
{104153089,96565404,27,14},
{104128513,17242645,27,13},
{104120321,58966208,27,14},
{104058881,18079967,27,12},
{104030209,76549692,27,13},
{104009729,34720187,27,12},
{103997441,79042584,27,13},
{103985153,23648010,27,12},
{103981057,25475840,27,13},
{103919617,31729303,27,12},
{103821313,28844254,27,12},
{103784449,75756505,27,13},
{103739393,46689296,27,12},
{103641089,1710811,27,12},
{103636993,97934056,27,13},
{103628801,65193661,27,14},
{103518209,33361842,27,12},
{103505921,92289427,27,13},
{103489537,79885549,27,13},
{103428097,51122258,27,12},
{103366657,18430120,27,14},
{103342081,90748621,27,13},
{103292929,74824174,27,13},
{103284737,988576,27,19},
{103280641,57982834,27,12},
{103260161,59854678,27,13},
{103247873,37569869,27,12},
{103219201,84284791,27,16},
{103206913,20318556,27,12},
{103182337,98103981,27,12},
{103170049,75457066,27,14},
{103161857,36729454,27,13},
{103149569,86605336,27,12},
{103063553,99395954,27,13},
{103038977,84872253,27,14},
{102965249,48197355,27,13},
{102952961,5644933,27,12},
{102879233,97382299,27,12},
{102838273,99323966,27,12},
{102793217,23270098,27,15},
{102739969,31627453,27,12},
{102707201,58215833,27,12},
{102694913,854483,27,16},
{102653953,7587247,27,13},
{102629377,51349779,27,17},
{102608897,54509141,27,12},
{102531073,26363973,27,15},
{102510593,102272767,27,12},
{102506497,3320532,27,13},
{102371329,98886676,27,12},
{102346753,93126225,27,12},
{102227969,11192485,27,13},
{102215681,70084560,27,12},
{102203393,62990730,27,15},
{102187009,68149056,27,14},
{102162433,8558711,27,13},
{102141953,82233427,27,12},
{102080513,25096974,27,13},
{102031361,91536196,27,13},
{102002689,10757003,27,12},
{101908481,43141621,27,16},
{101879809,13549167,27,12},
{101871617,29759059,27,12},
{101855233,84737972,27,12},
{101847041,3465914,27,12},
{101818369,51346008,27,13},
{101797889,43502066,27,12},
{101793793,65930978,27,14},
{101773313,83162565,27,12},
{101744641,57671298,27,15},
{101711873,28540439,27,20},
{101670913,95314005,27,13},
{101621761,5369898,27,13},
{101613569,62016883,27,15},
{101564417,4470981,27,14},
{101511169,76890406,27,12},
{101502977,64261068,27,12},
{101462017,15151962,27,12},
{101441537,53039720,27,13},
{101425153,1478264,27,13},
{101367809,17045088,27,14},
{101355521,28466131,27,12},
{101314561,44249788,27,12},
{101306369,83014383,27,12},
{101281793,58267620,27,12},
{101277697,64062172,27,13},
{101253121,38269387,27,16},
{101244929,33655008,27,13},
{101240833,11468051,27,12},
{101232641,32072475,27,12},
{101171201,38339783,27,14},
{101154817,43161979,27,15},
{101134337,16847125,27,12},
{101072897,58984111,27,14},
{101068801,28854338,27,12},
{101031937,19183057,27,13},
{101019649,34202404,27,12},
{100999169,83418162,27,13},
{100896769,24141093,27,12},
{100876289,78088512,27,14},
{100872193,51256658,27,12},
{100827137,23734888,27,15},
{100810753,94620227,27,14},
{100773889,18983659,27,12},
{100704257,35863642,27,13},
{100679681,22809942,27,14},
{100638721,25943085,27,13},
{100630529,77675889,27,15},
{100556801,589130,27,13},
{100515841,95642432,27,14},
{100495361,7795048,27,12},
{100397057,85284132,27,12},
{100392961,41880419,27,13},
{100335617,4457102,27,16},
{100331521,18293285,27,12},
{100298753,81462281,27,12},
{100257793,38028242,27,12},
{100139009,38788504,27,19},
{100126721,69927844,27,12},
{100114433,95298743,27,13},
{100110337,39105458,27,12},
{100077569,40421210,27,12},
{100073473,86929998,27,16},
{100036609,83840748,27,12},
{100016129,24130536,27,13},
{99987457,40428451,27,12},
{99954689,57814006,27,12},
{99950593,19116534,27,13},
{99893249,57828247,27,14},
{99868673,52683550,27,13},
{99840001,67680094,27,12},
{99807233,43012610,27,12},
{99790849,17654501,27,12},
{99778561,60384245,27,15},
{99667969,67145172,27,12},
{99655681,21238432,27,13},
{99635201,70191358,27,12},
{99618817,89752656,27,12},
{99598337,67736502,27,14},
{99532801,5232005,27,14},
{99512321,98618700,27,12},
{99500033,6080091,27,14},
{99483649,52846185,27,17},
{99422209,14152437,27,12},
{99414017,82550824,27,12},
{99348481,57202986,27,12},
{99328001,42921574,27,13},
{99266561,15802517,27,12},
{99254273,74848000,27,15},
{99188737,74663592,27,15},
{99168257,23362416,27,12},
{99127297,39391441,27,12},
{99106817,10589536,27,14},
{99102721,44930043,27,12},
{99094529,52479281,27,12},
{99069953,19426773,27,12},
{98992129,28268929,27,15},
{98959361,78304019,27,17},
{98918401,70150469,27,13},
{98906113,78470100,27,12},
{98861057,47850463,27,15},
{98848769,28064777,27,12},
{98787329,78932199,27,13},
{98783233,84549417,27,12},
{98746369,43427274,27,14},
{98721793,13453032,27,13},
{98701313,77086583,27,12},
{98697217,59090823,27,17},
{98590721,2132294,27,13},
{98549761,11047109,27,14},
{98476033,68092651,27,13},
{98414593,37421574,27,12},
{98377729,77951655,27,13},
{98365441,5877361,27,12},
{98295809,9215161,27,13},
{98234369,4479185,27,12},
{98230273,55433127,27,13},
{98193409,70275251,27,12},
{98144257,36783565,27,12},
{98123777,38122547,27,14},
{98062337,15516173,27,12},
{97964033,61703188,27,12},
{97959937,93164869,27,14},
{97947649,75915084,27,12},
{97923073,35743164,27,12},
{97914881,24895497,27,12},
{97792001,91110912,27,12},
{97763329,27428692,27,14},
{97701889,20865051,27,12},
{97619969,84133517,27,12},
{97615873,32183284,27,15},
{97570817,28624978,27,12},
{97497089,73863011,27,12},
{97472513,89322421,27,12},
{97325057,65839206,27,12},
{97320961,35793176,27,16},
{97247233,27587416,27,13},
{97239041,65427088,27,14},
{97202177,47853574,27,12},
{97189889,64786925,27,16},
{97177601,20464869,27,12},
{97161217,20997765,27,12},
{97005569,95567589,27,12},
{96919553,9665221,27,13},
{96870401,41671821,27,13},
{96833537,27087818,27,12},
{96808961,72051582,27,12},
{96772097,86770670,27,13},
{96759809,36229167,27,12},
{96686081,52772639,27,12},
{96673793,90000973,27,13},
{96669697,58528695,27,12},
{96645121,68756824,27,12},
{96575489,24565110,27,13},
{96571393,7662245,27,12},
{96485377,33874068,27,14},
{96464897,8618993,27,12},
{96460801,88969809,27,13},
{96440321,9354263,27,12},
{96423937,72779628,27,12},
{96411649,57102640,27,13},
{96403457,39148961,27,16},
{96399361,94485891,27,12},
{96387073,96232159,27,14},
{96366593,42593094,27,12},
{96202753,51603915,27,12},
{96178177,26218103,27,12},
{96153601,81884027,27,12},
{96116737,57793373,27,13},
{96079873,18587974,27,12},
{96071681,61324986,27,12},
{96030721,53978897,27,12},
{96022529,80554681,27,12},
{96010241,7241279,27,16},
{95920129,95777022,27,13},
{95870977,87685968,27,13},
{95858689,42729240,27,12},
{95838209,90038616,27,13},
{95813633,63545059,27,17},
{95809537,20217942,27,12},
{95784961,44524874,27,12},
{95711233,79848253,27,12},
{95662081,89946923,27,12},
{95625217,28363448,27,13},
{95563777,70834437,27,12},
{95543297,39519124,27,13},
{95490049,37553709,27,12},
{95481857,70306793,27,12},
{95395841,39157056,27,13},
{95367169,29689667,27,12},
{95354881,90094317,27,16},
{95297537,20099656,27,13},
{95293441,25576164,27,12},
{95232001,72951076,27,13},
{95170561,5806455,27,12},
{95088641,18553979,27,12},
{95076353,94423474,27,14},
{95039489,77219442,27,12},
{95027201,40071111,27,17},
{94998529,6943139,27,12},
{94904321,55908097,27,13},
{94887937,91026968,27,13},
{94863361,10565,27,15},
{94789633,47909264,27,13},
{94781441,7970565,27,14},
{94752769,20327600,27,12},
{94720001,51390343,27,12},
{94707713,55844833,27,13},
{94609409,20396137,27,13},
{94547969,6066194,27,12},
{94519297,3661986,27,14},
{94486529,58148402,27,14},
{94482433,76398992,27,12},
{94445569,94104177,27,13},
{94433281,10775592,27,12},
{94400513,14778800,27,12},
{94314497,59618379,27,13},
{94273537,42620684,27,15},
{94261249,55226878,27,12},
{94179329,46164516,27,12},
{94167041,53361928,27,13},
{94130177,39199408,27,12},
{94113793,55240544,27,12},
{94089217,87982216,27,12},
{93990913,77248805,27,12},
{93941761,43671601,27,12},
{93892609,56365013,27,12},
{93880321,23350167,27,15},
{93847553,27681545,27,19},
{93831169,73071904,27,14},
{93822977,40725796,27,13},
{93708289,3937183,27,13},
{93700097,45637954,27,14},
{93646849,64711395,27,12},
{93634561,4040334,27,14},
{93601793,72206452,27,14},
{93585409,12022954,27,18},
{93560833,13873601,27,13},
{93491201,51823163,27,12},
{93462529,59550210,27,13},
{93442049,22659346,27,12},
{93429761,85098298,27,13},
{93413377,58334374,27,13},
{93368321,49503756,27,12},
{93356033,56853608,27,15},
{93319169,77868909,27,12},
{93290497,43429290,27,15},
{93270017,70112130,27,12},
{93229057,22820738,27,12},
{93196289,32070936,27,12},
{93192193,38151875,27,17},
{93130753,14822577,27,12},
{93110273,26373274,27,14},
{93081601,75202661,27,12},
{92987393,70442317,27,13},
{92946433,10895439,27,14},
{92925953,61828728,27,12},
{92909569,50024432,27,12},
{92897281,27880976,27,15},
{92884993,78200156,27,12},
{92762113,71663798,27,12},
{92717057,45162443,27,14},
{92676097,19911582,27,13},
{92655617,3961173,27,12},
{92643329,21135520,27,13},
{92631041,54382874,27,12},
{92602369,36007007,27,16},
{92590081,16965859,27,12},
{92528641,49868277,27,13},
{92516353,11319003,27,12},
{92471297,24694304,27,16},
{92459009,66063133,27,12},
{92393473,73822040,27,12},
{92286977,15167917,27,12},
{92282881,79394227,27,13},
{92246017,80705602,27,12},
{92200961,70057259,27,13},
{92184577,80990787,27,13},
{92164097,17367317,27,12},
{92160001,39408845,27,14},
{92139521,80724795,27,12},
{92110849,36972586,27,15},
{92049409,16437596,27,12},
{92041217,68185737,27,12},
{92028929,7465231,27,14},
{92016641,84064312,27,12},
{91942913,69554688,27,12},
{91938817,73550319,27,13},
{91914241,40115869,27,15},
{91906049,16737854,27,13},
{91893761,71231227,27,12},
{91865089,64184452,27,14},
{91844609,36592979,27,12},
{91815937,56114949,27,16},
{91791361,11322647,27,13},
{91783169,19661795,27,15},
{91758593,16794548,27,13},
{91697153,39025084,27,12},
{91672577,27327601,27,12},
{91611137,59921883,27,13},
{91607041,70287253,27,12},
{91512833,1212742,27,13},
{91508737,71097796,27,12},
{91365377,67907412,27,13},
{91303937,88707377,27,12},
{91299841,24860193,27,13},
{91267073,76391464,27,13},
{91189249,86375308,27,12},
{91176961,68525646,27,14},
{91168769,30434865,27,13},
{91164673,11628364,27,12},
{91119617,2951472,27,13},
{91066369,11934739,27,12},
{91021313,75527458,27,13},
{90931201,59835665,27,15},
{90918913,20458643,27,12},
{90603521,37718756,27,15},
{90451969,89856926,27,12},
{90443777,28715187,27,12},
{90439681,84614459,27,18},
{90382337,81280973,27,13},
{90329089,3717077,27,12},
{90243073,4025190,27,16},
{90218497,79113478,27,13},
{90206209,59215179,27,12},
{90157057,89915333,27,12},
{90095617,66399830,27,14},
{90062849,69451896,27,14},
{89989121,17477816,27,13},
{89960449,34357603,27,12},
{89927681,40960420,27,12},
{89849857,9281854,27,16},
{89812993,56019850,27,12},
{89776129,88368355,27,13},
{89726977,51135748,27,13},
{89669633,37841438,27,14},
{89628673,68484412,27,13},
{89583617,66579236,27,12},
{89522177,9875334,27,17},
{89518081,38144464,27,12},
{89382913,22731654,27,13},
{89362433,30425278,27,12},
{89325569,82530466,27,16},
{89321473,31831494,27,12},
{89284609,69483345,27,13},
{89264129,31283989,27,12},
{89210881,85373076,27,14},
{89174017,24257633,27,12},
{89116673,45314964,27,12},
{89112577,27271102,27,14},
{89100289,6792286,27,12},
{89075713,85779634,27,12},
{89055233,51881107,27,13},
{89014273,79080301,27,14},
{88989697,7114416,27,13},
{88956929,20014729,27,13},
{88952833,84030492,27,12},
{88944641,8095941,27,12},
{88932353,71792070,27,16},
{88891393,63869614,27,13},
{88780801,71855469,27,12},
{88772609,12051546,27,12},
{88743937,27489541,27,13},
{88731649,75477310,27,12},
{88698881,63425549,27,12},
{88686593,43281680,27,14},
{88588289,35283137,27,14},
{88539137,42189841,27,16},
{88498177,21594366,27,13},
{88485889,52144450,27,12},
{88424449,755203,27,14},
{88375297,39823840,27,15},
{88354817,1643257,27,12},
{88338433,9494033,27,12},
{88268801,46781957,27,13},
{88231937,82251083,27,12},
{88096769,26060035,27,14},
{88084481,85357459,27,12},
{88055809,17513789,27,13},
{87973889,13489084,27,13},
{87924737,27651579,27,13},
{87920641,74648172,27,12},
{87900161,77645804,27,14},
{87883777,71496319,27,16},
{87838721,5960615,27,12},
{87785473,58168388,27,15},
{87764993,35513383,27,12},
{87736321,76576759,27,14},
{87724033,23455846,27,12},
{87699457,21160500,27,12},
{87654401,79555726,27,15},
{87613441,31864118,27,13},
{87539713,23366824,27,14},
{87478273,69044539,27,12},
{87457793,15880259,27,15},
{87433217,85372294,27,13},
{87355393,64929525,27,12},
{87318529,27796940,27,13},
{87293953,11347693,27,18},
{87248897,79147469,27,12},
{87195649,4422206,27,15},
{87150593,36378270,27,12},
{87146497,30745660,27,14},
{87064577,10098035,27,15},
{87040001,45820565,27,13},
{87027713,53556717,27,12},
{87011329,18519575,27,12},
{86962177,66366153,27,12},
{86925313,16830730,27,13},
{86867969,20175743,27,15},
{86806529,83522347,27,12},
{86753281,53524565,27,14},
{86732801,36728508,27,12},
{86654977,76839037,27,14},
{86593537,3894477,27,12},
{86548481,17773937,27,13},
{86536193,31124442,27,12},
{86458369,48319758,27,14},
{86388737,19947864,27,12},
{86302721,16982480,27,13},
{86290433,4458896,27,12},
{86274049,28337754,27,12},
{86261761,75367779,27,14},
{86188033,48102176,27,13},
{86163457,55504910,27,14},
{86118401,83593271,27,12},
{86102017,32582618,27,12},
{86077441,32067000,27,12},
{86065153,24085040,27,14},
{85946369,62066370,27,12},
{85921793,19473838,27,12},
{85917697,61736760,27,16},
{85905409,31335232,27,12},
{85893121,81204320,27,13},
{85770241,46798809,27,14},
{85762049,33868977,27,13},
{85688321,72509373,27,15},
{85598209,1534561,27,13},
{85590017,35996093,27,17},
{85573633,43612178,27,14},
{85528577,83335965,27,12},
{85516289,6510573,27,13},
{85487617,41920075,27,12},
{85463041,62723943,27,12},
{85450753,29836366,27,13},
{85430273,6282750,27,12},
{85426177,41410,27,15},
{85401601,82607930,27,13},
{85389313,7031202,27,12},
{85331969,50086265,27,12},
{85307393,11989084,27,12},
{85291009,22046770,27,12},
{85217281,9861645,27,12},
{85204993,39122887,27,13},
{85196801,8797052,27,18},
{85155841,13970371,27,13},
{85135361,56571899,27,12},
{85106689,349740,27,13},
{85082113,30382062,27,14},
{85057537,16520306,27,13},
{85045249,57242334,27,12},
{84996097,57730388,27,12},
{84975617,43535346,27,13},
{84971521,80348017,27,12},
{84938753,1414098,27,12},
{84901889,8065448,27,15},
{84852737,41074827,27,14},
{84848641,17051015,27,12},
{84840449,84082043,27,12},
{84791297,46030484,27,12},
{84729857,407046,27,13},
{84705281,21196697,27,15},
{84688897,44745247,27,14},
{84652033,53867476,27,12},
{84504577,72911181,27,12},
{84480001,81876737,27,12},
{84369409,47566061,27,13},
{84344833,51675633,27,16},
{84336641,55749180,27,13},
{84307969,81981096,27,12},
{84283393,62249531,27,12},
{84226049,34506987,27,12},
{84213761,46728977,27,16},
{84201473,84184319,27,12},
{84185089,21027061,27,12},
{84164609,15138698,27,14},
{84160513,19167596,27,12},
{84140033,970939,27,13},
{84123649,34303923,27,13},
{84111361,64271131,27,12},
{84103169,63018207,27,12},
{84037633,78381843,27,12},
{84029441,19486775,27,12},
{84000769,21274382,27,14},
{83939329,54493403,27,12},
{83906561,570996,27,12},
{83894273,23443965,27,13},
{83869697,5094015,27,14},
{83857409,73882899,27,12},
{83845121,2322999,27,13},
{83816449,9037685,27,12},
{83783681,35474987,27,12},
{83742721,16993582,27,12},
{83730433,28382588,27,13},
{83685377,9114372,27,12},
{83668993,2786424,27,12},
{83623937,40043845,27,18},
{83570689,6767102,27,12},
{83550209,416832,27,13},
{83496961,11531834,27,12},
{83447809,44657229,27,12},
{83415041,16601965,27,12},
{83361793,40994065,27,19},
{83337217,76607919,27,13},
{83279873,73480553,27,14},
{83238913,8458476,27,13},
{83218433,82516240,27,12},
{83193857,26609825,27,12},
{83181569,67491660,27,14},
{83140609,6590407,27,13},
{83132417,55937115,27,15},
{83120129,23331401,27,12},
{82993153,78986408,27,13},
{82984961,15851722,27,14},
{82911233,1029683,27,13},
{82907137,79999869,27,12},
{82870273,27227381,27,15},
{82825217,18762772,27,12},
{82821121,48200595,27,14},
{82661377,41463867,27,12},
{82640897,29774958,27,16},
{82624513,57140140,27,14},
{82616321,61678261,27,13},
{82538497,56841661,27,12},
{82505729,78314934,27,12},
{82493441,36467080,27,14},
{82444289,21169335,27,17},
{82419713,15245158,27,13},
{82391041,13993175,27,12},
{82321409,23339047,27,13},
{82219009,9270020,27,12},
{82149377,50026991,27,15},
{82071553,69780291,27,12},
{82022401,57840371,27,12},
{82010113,61657198,27,13},
{81973249,38298547,27,12},
{81952769,63723037,27,15},
{81879041,30318551,27,13},
{81862657,25626860,27,13},
{81850369,74537837,27,12},
{81829889,45362915,27,13},
{81805313,4190494,27,14},
{81801217,43976880,27,12},
{81788929,20191076,27,21},
{81776641,57796626,27,12},
{81727489,55074528,27,12},
{81715201,22873901,27,13},
{81694721,37266104,27,12},
{81633281,78491398,27,13},
{81616897,76440349,27,13},
{81604609,72042590,27,12},
{81592321,70873167,27,16},
{81555457,67033025,27,12},
{81522689,64932774,27,12},
{81469441,1183941,27,13},
{81432577,57028879,27,12},
{81420289,17613937,27,13},
{81285121,60506049,27,12},
{81272833,78553995,27,13},
{81248257,11804027,27,14},
{81227777,10888456,27,12},
{81215489,48748139,27,14},
{81211393,65823153,27,12},
{81174529,62475865,27,13},
{81162241,32388389,27,12},
{81154049,41659680,27,12},
{81149953,5297335,27,14},
{80883713,76847101,27,12},
{80859137,76329588,27,12},
{80855041,23969880,27,14},
{80805889,29568175,27,16},
{80797697,54450254,27,13},
{80760833,27733013,27,12},
{80711681,39904398,27,12},
{80695297,38610306,27,12},
{80658433,17165616,27,14},
{80601089,32352301,27,13},
{80576513,12291796,27,15},
{80515073,43249964,27,12},
{80510977,28573125,27,15},
{80465921,32597184,27,12},
{80416769,24014707,27,12},
{80388097,3316144,27,13},
{80375809,2515951,27,12},
{80330753,29149186,27,14},
{80326657,43779977,27,12},
{80302081,30252517,27,12},
{80252929,77782477,27,12},
{80228353,8158096,27,12},
{80203777,3312258,27,12},
{80117761,13657030,27,15},
{80084993,16628543,27,17},
{80056321,44327034,27,12},
{80044033,78971957,27,13},
{79986689,42179071,27,15},
{79982593,28907770,27,12},
{79925249,37770346,27,12},
{79912961,32929567,27,13},
{79851521,70285161,27,12},
{79810561,2695820,27,12},
{79716353,39481437,27,13},
{79687681,78503383,27,12},
{79679489,11589135,27,12},
{79638529,25960702,27,12},
{79605761,12046776,27,12},
{79544321,6049276,27,14},
{79527937,68364704,27,15},
{79470593,37679806,27,13},
{79405057,8113458,27,13},
{79347713,55951280,27,14},
{79306753,49544485,27,13},
{79261697,71606256,27,12},
{79257601,74947453,27,13},
{79147009,52135236,27,12},
{79077377,16716297,27,13},
{79003649,69201956,27,15},
{78999553,70007553,27,12},
{78950401,73573114,27,12},
{78893057,26226338,27,12},
{78876673,76157820,27,12},
{78852097,33285832,27,12},
{78753793,19143959,27,12},
{78733313,68706891,27,13},
{78716929,71888414,27,13},
{78647297,13006821,27,12},
{78635009,44355817,27,13},
{78606337,20277534,27,12},
{78581761,28992820,27,12},
{78561281,42260168,27,14},
{78512129,1487666,27,17},
{78508033,41849596,27,12},
{78458881,16742371,27,12},
{78450689,66968671,27,12},
{78446593,59602952,27,16},
{78389249,29923742,27,13},
{78364673,34159280,27,14},
{78336001,72635071,27,12},
{78286849,56209767,27,12},
{78266369,32206762,27,14},
{78139393,11195292,27,12},
{78094337,18521594,27,13},
{78090241,12764196,27,12},
{78053377,54785284,27,16},
{78020609,73162919,27,15},
{78016513,8215510,27,12},
{77971457,3224045,27,14},
{77959169,17163178,27,12},
{77893633,56794024,27,12},
{77848577,24552416,27,13},
{77836289,26461188,27,12},
{77770753,72773129,27,12},
{77651969,6972413,27,13},
{77541377,53587420,27,12},
{77516801,34165315,27,12},
{77488129,46145575,27,13},
{77455361,63257435,27,13},
{77443073,74078387,27,12},
{77320193,40294953,27,12},
{77291521,4230229,27,13},
{77283329,15341417,27,14},
{77242369,53668142,27,13},
{77230081,36568277,27,12},
{77197313,23247669,27,12},
{77160449,55955820,27,13},
{77135873,74490791,27,16},
{77070337,62939096,27,19},
{77025281,38222381,27,12},
{76996609,10251003,27,13},
{76976129,24342787,27,12},
{76963841,2358835,27,13},
{76926977,19219623,27,12},
{76910593,54993409,27,12},
{76840961,47005017,27,15},
{76812289,49823686,27,12},
{76804097,71181607,27,12},
{76800001,14003553,27,13},
{76681217,23510861,27,12},
{76677121,67688067,27,17},
{76640257,42109090,27,12},
{76615681,63793669,27,12},
{76603393,36492125,27,13},
{76480513,3527091,27,16},
{76455937,75699341,27,13},
{76431361,63656595,27,14},
{76398593,36680301,27,14},
{76382209,73422956,27,15},
{76361729,23132097,27,12},
{76337153,39370269,27,12},
{76308481,44582541,27,13},
{76288001,38110219,27,12},
{76271617,9811114,27,12},
{76185601,23978656,27,15},
{76173313,59740492,27,12},
{76115969,42455342,27,12},
{76103681,65446348,27,14},
{76001281,9910854,27,12},
{75993089,63711138,27,12},
{75988993,55540778,27,15},
{75968513,45686034,27,12},
{75878401,49247583,27,12},
{75870209,72285121,27,12},
{75845633,67885883,27,12},
{75841537,50057613,27,14},
{75780097,4482590,27,12},
{75755521,44992968,27,12},
{75722753,2556690,27,12},
{75657217,29135111,27,12},
{75620353,4747608,27,13},
{75612161,18083857,27,14},
{75558913,25678829,27,12},
{75522049,24726001,27,13},
{75513857,54729157,27,14},
{75472897,6053668,27,13},
{75452417,13912938,27,12},
{75427841,23737565,27,12},
{75399169,38166127,27,15},
{75169793,74821289,27,16},
{75165697,56870660,27,12},
{75120641,64304730,27,14},
{75108353,14847660,27,12},
{75104257,60876292,27,17},
{75091969,66626030,27,12},
{75083777,39180610,27,12},
{75079681,29460914,27,13},
{75042817,55383156,27,12},
{74981377,73464041,27,13},
{74899457,41855759,27,13},
{74895361,39409019,27,12},
{74797057,66162985,27,12},
{74764289,18308905,27,12},
{74711041,1992138,27,18},
{74698753,43468855,27,12},
{74641409,40863681,27,12},
{74637313,37120757,27,13},
{74616833,19691886,27,12},
{74592257,25164722,27,12},
{74588161,22651406,27,13},
{74539009,52076213,27,13},
{74530817,43094814,27,14},
{74477569,68649025,27,12},
{74452993,65153007,27,12},
{74444801,70545032,27,12},
{74432513,62175007,27,14},
{74416129,54570348,27,15},
{74407937,56749882,27,13},
{74366977,30666757,27,14},
{74334209,64860466,27,14},
{74305537,27403778,27,12},
{74260481,55544671,27,13},
{74211329,35022625,27,13},
{74207233,32608447,27,12},
{74145793,43924905,27,13},
{74100737,25573872,27,12},
{74096641,36565944,27,13},
{74076161,65959001,27,12},
{73973761,29216855,27,14},
{73936897,15112928,27,12},
{73863169,69579591,27,12},
{73752577,44952703,27,13},
{73719809,46712107,27,13},
{73695233,57275430,27,15},
{73678849,4752000,27,14},
{73666561,70949297,27,12},
{73658369,43823467,27,12},
{73629697,2672622,27,15},
{73617409,2302173,27,12},
{73572353,40888198,27,13},
{73547777,41125126,27,14},
{73523201,15131833,27,13},
{73469953,49219236,27,12},
{73445377,65475402,27,12},
{73420801,68764490,27,12},
{73412609,34881863,27,12},
{73388033,2442479,27,12},
{73351169,15373400,27,14},
{73297921,29710750,27,12},
{73228289,59171489,27,13},
{73142273,26785404,27,12},
{73101313,12448093,27,12},
{73039873,32632334,27,15},
{73019393,5206476,27,12},
{72990721,25339131,27,14},
{72953857,23766718,27,12},
{72929281,13521758,27,12},
{72916993,72196898,27,13},
{72871937,8002777,27,12},
{72859649,54566133,27,14},
{72757249,21587497,27,12},
{72749057,15869712,27,12},
{72744961,17209666,27,17},
{72613889,18838602,27,18},
{72609793,69652016,27,12},
{72540161,67606497,27,13},
{72511489,41641681,27,12},
{72499201,63356673,27,14},
{72429569,159455,27,12},
{72368129,53946787,27,14},
{72327169,59119807,27,13},
{72183809,2523042,27,12},
{72179713,26420472,27,13},
{72060929,17621451,27,12},
{72011777,8085196,27,12},
{71974913,47721570,27,14},
{71950337,32184479,27,13},
{71913473,7871156,27,12},
{71823361,29585903,27,12},
{71811073,62248031,27,14},
{71786497,68772623,27,13},
{71741441,23611947,27,12},
{71729153,57126907,27,15},
{71692289,11962921,27,12},
{71688193,4293953,27,13},
{71663617,35921282,27,15},
{71577601,64420886,27,12},
{71544833,34820873,27,12},
{71528449,3513141,27,12},
{71520257,37965179,27,12},
{71495681,50476843,27,12},
{71458817,15358870,27,13},
{71434241,45947983,27,17},
{71393281,37460018,27,13},
{71380993,71324048,27,12},
{71372801,18443234,27,12},
{71270401,3258344,27,15},
{71196673,48757545,27,13},
{71151617,10797438,27,12},
{71127041,296397,27,12},
{71114753,25946959,27,13},
{71004161,36045987,27,12},
{70991873,24827371,27,14},
{70955009,16393496,27,12},
{70893569,27158212,27,14},
{70807553,70737949,27,12},
{70705153,2134081,27,13},
{70696961,60085013,27,14},
{70684673,13855825,27,12},
{70668289,7629710,27,12},
{70623233,59708217,27,13},
{70619137,64769137,27,12},
{70598657,39767108,27,14},
{70561793,28301337,27,12},
{70483969,61213093,27,15},
{70397953,49475712,27,12},
{70340609,18826782,27,12},
{70254593,50025960,27,20},
{70238209,12361167,27,14},
{70225921,61236589,27,12},
{70205441,39508544,27,14},
{70189057,60000858,27,16},
{70164481,17669045,27,13},
{70144001,8154543,27,12},
{70066177,18393477,27,13},
{70033409,59255165,27,13},
{69971969,64060015,27,12},
{69922817,1491573,27,12},
{69885953,9839711,27,13},
{69881857,68212920,27,12},
{69849089,69003374,27,12},
{69763073,21898058,27,15},
{69738497,25737624,27,13},
{69660673,46887354,27,12},
{69615617,68874041,27,14},
{69603329,64423505,27,12},
{69517313,2721506,27,14},
{69480449,26862350,27,12},
{69455873,14438785,27,12},
{69414913,29745250,27,12},
{69365761,5495462,27,12},
{69308417,67487316,27,12},
{69304321,30275839,27,15},
{69292033,48860329,27,12},
{69255169,37202147,27,14},
{69206017,27271332,27,21},
{69185537,22732465,27,12},
{69160961,1499468,27,12},
{69132289,30224133,27,13},
{69046273,45495323,27,12},
{68997121,62473896,27,12},
{68984833,56132533,27,13},
{68976641,62984441,27,15},
{68947969,46953963,27,12},
{68935681,21642817,27,13},
{68902913,10227788,27,13},
{68861953,62346504,27,14},
{68853761,57782544,27,13},
{68775937,24780613,27,12},
{68718593,59246344,27,12},
{68702209,15937823,27,12},
{68681729,37650325,27,19},
{68669441,66992582,27,12},
{68640769,13284496,27,13},
{68595713,11278439,27,12},
{68567041,30023893,27,14},
{68558849,15492045,27,13},
{68485121,22250320,27,16},
{68448257,31212066,27,12},
{68362241,2185975,27,13},
{68325377,9455372,27,12},
{68190209,39197518,27,15},
{68136961,20875645,27,12},
{68018177,59370213,27,13},
{67981313,20026706,27,12},
{67956737,19655007,27,12},
{67915777,50946983,27,12},
{67903489,54648923,27,13},
{67858433,35846294,27,12},
{67817473,32996269,27,12},
{67768321,28339291,27,12},
{67731457,57756546,27,15},
{67694593,61587275,27,12},
{67657729,33975508,27,13},
{67649537,7728579,27,14},
{67588097,25968949,27,12},
{67584001,35972009,27,14},
{67563521,55011060,27,12},
{67510273,22459938,27,13},
{67502081,49213124,27,17},
{67473409,32019509,27,12},
{67465217,24660155,27,12},
{67452929,54591033,27,14},
{67424257,50592011,27,12},
{67411969,60089914,27,13},
{67342337,62682152,27,12},
{67280897,56783014,27,13},
{67276801,7113752,27,12},
{67239937,40958807,27,17},
{67227649,50080831,27,12},
{67219457,42935345,27,12},
{67153921,22172832,27,12},
{67104769,3166240,26,12},
{67084289,18006223,26,13},
{67043329,26583782,26,16},
{66998273,56094641,26,12},
{66994177,46220390,26,14},
{66969601,35216082,26,13},
{66961409,53003538,26,14},
{66949121,58556984,26,12},
{66936833,4832912,26,13},
{66908161,48588806,26,12},
{66813953,3894110,26,15},
{66777089,55873501,26,12},
{66723841,65308779,26,13},
{66703361,48634644,26,12},
{66605057,63980784,26,12},
{66551809,24389207,26,15},
{66531329,52009178,26,12},
{66420737,48006736,26,15},
{66404353,15964221,26,14},
{66379777,58153393,26,13},
{66347009,39635745,26,13},
{66334721,42962056,26,12},
{66318337,41365564,26,12},
{66281473,22965826,26,13},
{66260993,13626424,26,12},
{66244609,37455311,26,12},
{66195457,37288683,26,12},
{66134017,37638381,26,13},
{66097153,50700019,26,12},
{66052097,49082215,26,13},
{66011137,65396718,26,14},
{65978369,55910211,26,14},
{65929217,17844580,26,17},
{65925121,33570728,26,12},
{65794049,10566692,26,12},
{65781761,30531703,26,14},
{65720321,26604647,26,12},
{65671169,31083973,26,12},
{65658881,9805835,26,13},
{65630209,1318607,26,12},
{65609729,40019412,26,13},
{65548289,2371353,26,12},
{65523713,57338738,26,12},
{65474561,25190125,26,12},
{65462273,62182275,26,13},
{65413121,29807702,26,13},
{65376257,35506719,26,12},
{65290241,48514687,26,14},
{65241089,41927439,26,15},
{65089537,49137884,26,12},
{65077249,14278629,26,16},
{65056769,64036315,26,12},
{65044481,27378495,26,15},
{65028097,20393091,26,14},
{64983041,27115603,26,12},
{64946177,51062112,26,16},
{64942081,3493163,26,12},
{64933889,3213895,26,12},
{64892929,58223279,26,12},
{64884737,45406300,26,12},
{64819201,12409485,26,12},
{64811009,42352510,26,12},
{64770049,62910985,26,12},
{64757761,47925152,26,13},
{64749569,54880593,26,18},
{64700417,35350852,26,14},
{64696321,54155861,26,12},
{64684033,5199058,26,16},
{64663553,47911778,26,12},
{64647169,40916672,26,12},
{64626689,60192244,26,13},
{64561153,26181035,26,13},
{64524289,52128701,26,12},
{64512001,48414112,26,13},
{64499713,55243221,26,12},
{64438273,1472006,26,14},
{64401409,30600865,26,12},
{64376833,51488892,26,12},
{64258049,1790910,26,15},
{64229377,17870746,26,12},
{64208897,13905983,26,14},
{64196609,61425523,26,12},
{64184321,35652300,26,13},
{64131073,61489310,26,12},
{64122881,1227958,26,12},
{64086017,33592746,26,13},
{64045057,1381969,26,14},
{64032769,48777623,26,12},
{63987713,38465329,26,13},
{63971329,35739706,26,13},
{63959041,63730547,26,12},
{63909889,34934822,26,12},
{63901697,25279558,26,12},
{63897601,28075991,26,16},
{63815681,4290133,26,14},
{63799297,57540949,26,15},
{63778817,45864490,26,12},
{63766529,54529986,26,16},
{63713281,7063355,26,12},
{63700993,31097012,26,18},
{63643649,51738863,26,13},
{63614977,56696014,26,12},
{63594497,20609803,26,13},
{63528961,41564422,26,13},
{63492097,4813768,26,12},
{63434753,18469137,26,12},
{63410177,63109408,26,12},
{63393793,47085426,26,12},
{63385601,46361255,26,12},
{63356929,58859394,26,14},
{63283201,19152228,26,13},
{63184897,11896219,26,13},
{63152129,56290983,26,13},
{63123457,59766504,26,12},
{63062017,48675542,26,14},
{62943233,32967331,26,12},
{62939137,27564290,26,13},
{62894081,26804112,26,12},
{62857217,57371530,26,13},
{62791681,52623273,26,13},
{62771201,29466875,26,12},
{62754817,6050606,26,12},
{62545921,56458326,26,13},
{62537729,49203565,26,14},
{62513153,31167883,26,13},
{62423041,26575264,26,15},
{62365697,18482753,26,13},
{62361601,26028992,26,12},
{62353409,37939846,26,12},
{62304257,37024885,26,12},
{62291969,61319858,26,15},
{62279681,53075297,26,12},
{62267393,40862449,26,13},
{62238721,34048243,26,12},
{62226433,27874429,26,15},
{62177281,52497884,26,14},
{62144513,55243454,26,14},
{62103553,54172131,26,13},
{62078977,50412522,26,14},
{62054401,17321015,26,13},
{61992961,27633330,26,12},
{61972481,24094576,26,13},
{61935617,4229111,26,12},
{61861889,27663485,26,12},
{61820929,45834015,26,12},
{61808641,37572222,26,13},
{61775873,3339913,26,13},
{61734913,20691284,26,17},
{61689857,26629709,26,12},
{61652993,4415413,26,14},
{61636609,32528588,26,15},
{61566977,4143927,26,12},
{61542401,55773292,26,12},
{61480961,43083190,26,13},
{61431809,39071900,26,13},
{61378561,57229949,26,12},
{61370369,34756867,26,12},
{61329409,56088554,26,12},
{61317121,15832938,26,13},
{61304833,39518023,26,12},
{61259777,57670429,26,14},
{61161473,41228903,26,14},
{61132801,42305516,26,12},
{61022209,21080921,26,13},
{60977153,59994281,26,12},
{60960769,35693104,26,12},
{60940289,26985515,26,13},
{60899329,17756121,26,14},
{60887041,40075916,26,12},
{60854273,34385030,26,12},
{60776449,53586873,26,13},
{60743681,38003357,26,13},
{60669953,20085726,26,14},
{60641281,47692908,26,12},
{60559361,38139463,26,12},
{60547073,14385307,26,13},
{60510209,58618041,26,12},
{60506113,29429022,26,14},
{60469249,54500853,26,12},
{60461057,6921686,26,12},
{60456961,4355998,26,15},
{60448769,15881796,26,13},
{60424193,21535360,26,17},
{60399617,21778660,26,13},
{60387329,5756852,26,12},
{60383233,11205163,26,13},
{60334081,7346032,26,13},
{60297217,13780725,26,12},
{60252161,6820223,26,13},
{60223489,53490231,26,12},
{60211201,34476086,26,14},
{60198913,42058493,26,12},
{60190721,6960347,26,12},
{60174337,55610003,26,12},
{60141569,7362690,26,12},
{60014593,19417326,26,14},
{59994113,58383820,26,12},
{59969537,50054348,26,12},
{59932673,5262019,26,15},
{59908097,22703146,26,13},
{59904001,48129417,26,12},
{59854849,19935771,26,12},
{59842561,5044655,26,13},
{59781121,27804793,26,12},
{59711489,243933,26,13},
{59707393,89782,26,12},
{59699201,10605125,26,12},
{59658241,53455768,26,12},
{59650049,43771653,26,12},
{59637761,33825441,26,17},
{59625473,20093741,26,12},
{59621377,3891307,26,14},
{59559937,28233139,26,12},
{59535361,39052788,26,12},
{59523073,5189086,26,14},
{59478017,18834487,26,12},
{59453441,41993233,26,12},
{59437057,7005862,26,12},
{59424769,33618833,26,14},
{59412481,9118047,26,12},
{59277313,39702673,26,15},
{59158529,54278592,26,12},
{59109377,31935855,26,12},
{59105281,44589766,26,13},
{59068417,969568,26,12},
{59043841,17984932,26,12},
{59035649,49688463,26,12},
{59023361,33498433,26,13},
{58970113,43436806,26,12},
{58900481,38133598,26,14},
{58863617,2257375,26,12},
{58851329,54619186,26,17},
{58847233,50097241,26,12},
{58822657,7500902,26,12},
{58789889,238334,26,12},
{58777601,12844902,26,13},
{58613761,130061,26,13},
{58552321,54488361,26,12},
{58531841,8675611,26,13},
{58490881,31235766,26,15},
{58482689,37762640,26,13},
{58478593,41648221,26,12},
{58441729,44226863,26,14},
{58421249,42197335,26,12},
{58347521,21414854,26,12},
{58318849,29371485,26,13},
{58310657,16337835,26,14},
{58294273,18592208,26,15},
{58236929,18372405,26,13},
{58163201,2120437,26,15},
{58150913,11199852,26,12},
{58060801,32693905,26,12},
{58023937,11516407,26,13},
{58011649,44559245,26,12},
{57987073,8488510,26,12},
{57978881,51911648,26,12},
{57966593,23855758,26,15},
{57962497,51408521,26,12},
{57917441,45524454,26,14},
{57901057,50523564,26,15},
{57880577,56274624,26,12},
{57815041,34761699,26,12},
{57802753,29743585,26,17},
{57782273,53391144,26,12},
{57720833,15720602,26,14},
{57696257,7153132,26,13},
{57679873,52389241,26,13},
{57634817,13122644,26,12},
{57630721,48667412,26,13},
{57622529,17608214,26,14},
{57593857,12214723,26,12},
{57581569,4908000,26,13},
{57573377,18050558,26,15},
{57532417,1989560,26,13},
{57499649,38235591,26,13},
{57495553,18614306,26,12},
{57384961,9883851,26,13},
{57376769,54786262,26,15},
{57372673,14494388,26,12},
{57335809,11816663,26,13},
{57315329,50009206,26,12},
{57286657,28054544,26,13},
{57274369,18192781,26,12},
{57212929,26747461,26,16},
{57180161,5193016,26,15},
{57143297,20957006,26,12},
{57069569,25404751,26,12},
{57044993,26568378,26,12},
{57008129,9044501,26,13},
{56958977,33888965,26,13},
{56922113,40503461,26,12},
{56836097,16618228,26,14},
{56799233,35515646,26,12},
{56774657,35169084,26,12},
{56770561,8486807,26,14},
{56733697,48456327,26,12},
{56672257,40885415,26,14},
{56647681,21793731,26,13},
{56635393,23210343,26,12},
{56512513,24543710,26,12},
{56463361,19708053,26,12},
{56430593,27610984,26,12},
{56414209,43414126,26,12},
{56401921,5574134,26,13},
{56369153,41611340,26,13},
{56340481,40537705,26,12},
{56283137,33201520,26,12},
{56246273,13009807,26,14},
{56242177,22219787,26,12},
{56205313,17639593,26,13},
{56086529,38466389,26,12},
{56074241,450035,26,13},
{56061953,53252387,26,12},
{56045569,4702578,26,12},
{56000513,6426071,26,15},
{55971841,53197489,26,12},
{55914497,24691598,26,12},
{55898113,42136303,26,12},
{55889921,6363951,26,12},
{55873537,51971292,26,12},
{55750657,16053735,26,12},
{55738369,23034469,26,15},
{55664641,35767055,26,13},
{55595009,14762150,26,12},
{55554049,16009154,26,12},
{55521281,32892027,26,12},
{55443457,47717238,26,17},
{55422977,43843131,26,12},
{55398401,50231267,26,12},
{55324673,18238301,26,12},
{55308289,24720884,26,12},
{55197697,37606237,26,14},
{55185409,7008744,26,12},
{55173121,17751678,26,13},
{55164929,48349119,26,14},
{55037953,44303362,26,12},
{54878209,6651461,26,13},
{54857729,29940951,26,12},
{54853633,19800407,26,16},
{54833153,9760310,26,12},
{54796289,47559149,26,13},
{54792193,39996745,26,12},
{54784001,2300609,26,12},
{54767617,1675745,26,12},
{54747137,53014147,26,13},
{54743041,33064283,26,12},
{54710273,43082562,26,12},
{54648833,9407325,26,13},
{54607873,42256153,26,14},
{54599681,33912291,26,13},
{54571009,13174256,26,12},
{54546433,19276512,26,12},
{54427649,9242565,26,15},
{54423553,32252946,26,12},
{54398977,15385061,26,12},
{54374401,10060853,26,12},
{54353921,21691207,26,13},
{54251521,27735469,26,12},
{54239233,27749810,26,13},
{54067201,9264556,26,16},
{54046721,44247524,26,12},
{54030337,36619877,26,12},
{53997569,45670767,26,12},
{53948417,49149906,26,12},
{53923841,42780102,26,12},
{53907457,19111962,26,12},
{53833729,39126577,26,12},
{53821441,48850631,26,14},
{53788673,3081545,26,14},
{53710849,3756653,26,12},
{53686273,26562463,26,12},
{53665793,9997651,26,13},
{53661697,4448625,26,12},
{53637121,31981743,26,12},
{53624833,23622174,26,14},
{53575681,11119280,26,15},
{53567489,35580204,26,13},
{53501953,37925289,26,13},
{53465089,32694656,26,12},
{53444609,17203785,26,15},
{53420033,37021506,26,13},
{53415937,50992858,26,12},
{53370881,15054345,26,13},
{53256193,29551299,26,13},
{53248001,21930054,26,15},
{53219329,31372229,26,12},
{53149697,50882116,26,16},
{53145601,28536408,26,12},
{53075969,38742744,26,13},
{53071873,23811911,26,12},
{53051393,21229091,26,15},
{53014529,20471243,26,12},
{52985857,1684521,26,15},
{52940801,46011868,26,12},
{52899841,38584758,26,12},
{52768769,47986885,26,12},
{52682753,11332214,26,13},
{52654081,26642847,26,12},
{52621313,23799482,26,12},
{52617217,51793039,26,13},
{52584449,51384269,26,13},
{52572161,18657415,26,12},
{52543489,47178893,26,14},
{52482049,5950106,26,12},
{52461569,20235440,26,15},
{52457473,32180309,26,12},
{52449281,32718915,26,12},
{52420609,1005122,26,13},
{52412417,42287268,26,14},
{52375553,31544618,26,12},
{52359169,21731405,26,12},
{52314113,27856456,26,14},
{52277249,51010701,26,12},
{52273153,19883001,26,13},
{52224001,27676976,26,13},
{52174849,46196927,26,13},
{52166657,17319876,26,18},
{52039681,1572210,26,12},
{52031489,33186503,26,12},
{51990529,22494495,26,12},
{51970049,30268680,26,16},
{51929089,44639737,26,13},
{51916801,5075960,26,12},
{51843073,49754493,26,12},
{51761153,34526208,26,12},
{51658753,13485322,26,14},
{51650561,46447364,26,13},
{51572737,46748644,26,12},
{51560449,34561010,26,14},
{51527681,25789546,26,14},
{51511297,4788133,26,17},
{51474433,4730146,26,12},
{51453953,413683,26,13},
{51437569,30418660,26,13},
{51240961,4893280,26,13},
{51228673,39441037,26,12},
{51191809,17936173,26,13},
{51142657,7463552,26,13},
{51130369,22215543,26,12},
{51122177,30975331,26,12},
{51085313,22721233,26,15},
{51068929,26256835,26,14},
{51056641,30046920,26,12},
{50958337,47787648,26,12},
{50933761,43799488,26,12},
{50896897,11949444,26,13},
{50876417,47273162,26,12},
{50839553,40396511,26,14},
{50798593,36246123,26,13},
{50778113,11693567,26,12},
{50753537,46623979,26,12},
{50655233,49137520,26,12},
{50651137,44390674,26,13},
{50589697,36348731,26,12},
{50565121,17955520,26,12},
{50552833,22363356,26,13},
{50491393,34375445,26,12},
{50307073,29784805,26,13},
{50188289,9283260,26,12},
{50077697,17038862,26,13},
{50073601,20026976,26,12},
{50061313,2522833,26,13},
{49991681,15966489,26,12},
{49963009,23086427,26,13},
{49950721,39713553,26,12},
{49938433,37876037,26,17},
{49852417,23602028,26,12},
{49709057,7596022,26,15},
{49696769,47903084,26,12},
{49647617,33358560,26,12},
{49635329,37152495,26,13},
{49606657,25943915,26,12},
{49586177,6425677,26,13},
{49573889,971429,26,12},
{49520641,33826616,26,13},
{49508353,33159532,26,12},
{49471489,2548961,26,13},
{49438721,48626255,26,13},
{49385473,32690195,26,12},
{49287169,37059423,26,12},
{49274881,16155399,26,13},
{49262593,19725354,26,12},
{49242113,23321511,26,13},
{49205249,9367278,26,12},
{49201153,28498737,26,14},
{49180673,44954096,26,12},
{49152001,46999625,26,17},
{49119233,32954624,26,15},
{49057793,36934725,26,12},
{48992257,34833064,26,12},
{48971777,8300365,26,14},
{48906241,46369984,26,14},
{48898049,41137619,26,13},
{48848897,18334242,26,13},
{48812033,10246299,26,12},
{48721921,16020499,26,12},
{48701441,4778048,26,13},
{48685057,45082074,26,13},
{48640001,27809446,26,12},
{48549889,43616249,26,12},
{48541697,489525,26,12},
{48517121,18175839,26,12},
{48488449,43937433,26,13},
{48463873,39674883,26,15},
{48443393,42614526,26,12},
{48427009,27799381,26,12},
{48406529,3867187,26,13},
{48381953,48026796,26,14},
{48353281,18215230,26,12},
{48283649,13078146,26,14},
{48271361,41261073,26,12},
{48181249,13589299,26,12},
{48168961,45633357,26,16},
{48160769,20254961,26,13},
{48148481,9519206,26,12},
{48074753,14477603,26,12},
{48070657,3227164,26,15},
{48009217,21060507,26,12},
{47923201,1367304,26,14},
{47915009,2836646,26,13},
{47800321,30403240,26,13},
{47779841,33727175,26,12},
{47738881,28744304,26,12},
{47718401,12988889,26,13},
{47665153,13227154,26,12},
{47644673,4677867,26,16},
{47640577,23686633,26,12},
{47628289,35336453,26,14},
{47607809,41238717,26,12},
{47558657,23428602,26,12},
{47542273,30362108,26,12},
{47497217,12439196,26,14},
{47382529,30449715,26,16},
{47349761,34937139,26,15},
{47308801,17653847,26,13},
{47300609,6374475,26,14},
{47239169,42523710,26,12},
{47112193,3540893,26,13},
{47087617,35124238,26,15},
{47063041,9621281,26,13},
{47042561,2595402,26,12},
{47001601,3501637,26,12},
{46968833,25846126,26,12},
{46964737,9248782,26,13},
{46952449,29144249,26,12},
{46944257,25277537,26,12},
{46927873,27058079,26,12},
{46882817,33947832,26,13},
{46809089,12341810,26,14},
{46804993,23293729,26,12},
{46780417,44755928,26,12},
{46735361,15281503,26,13},
{46686209,8152527,26,13},
{46632961,18142849,26,12},
{46624769,39408876,26,12},
{46612481,23910928,26,14},
{46600193,21723683,26,12},
{46538753,14393032,26,13},
{46522369,17575566,26,13},
{46514177,39192705,26,14},
{46497793,42776244,26,15},
{46391297,39447247,26,13},
{46325761,8435706,26,13},
{46288897,25708105,26,12},
{46264321,27145891,26,12},
{46256129,29878246,26,12},
{46227457,2638670,26,13},
{46190593,20909331,26,12},
{46145537,28378196,26,13},
{46022657,34274611,26,14},
{46010369,3743617,26,12},
{45981697,32497581,26,13},
{45969409,6887940,26,12},
{45920257,7185722,26,12},
{45907969,35343066,26,15},
{45846529,2795450,26,12},
{45797377,12625339,26,12},
{45772801,8377302,26,12},
{45723649,3350973,26,12},
{45662209,15580972,26,14},
{45649921,29197145,26,12},
{45592577,28173790,26,12},
{45588481,22610446,26,13},
{45518849,32437937,26,12},
{45506561,16204632,26,13},
{45457409,25004552,26,13},
{45445121,30413570,26,12},
{45432833,28070186,26,14},
{45428737,44095801,26,12},
{45408257,37040214,26,13},
{45395969,5633688,26,12},
{45371393,9728707,26,12},
{45330433,33971839,26,12},
{45260801,16811092,26,13},
{45207553,12578206,26,12},
{45137921,28245157,26,14},
{45101057,38706727,26,12},
{45027329,19468567,26,12},
{45002753,29370985,26,12},
{44978177,13308676,26,12},
{44941313,23330461,26,14},
{44904449,35278755,26,12},
{44900353,6253890,26,13},
{44892161,11651615,26,16},
{44851201,2361788,26,13},
{44802049,10551158,26,13},
{44769281,11118865,26,13},
{44740609,10971183,26,12},
{44732417,17295089,26,12},
{44646401,21753925,26,14},
{44445697,14186470,26,12},
{44433409,38457168,26,17},
{44421121,33361802,26,12},
{44400641,21380866,26,15},
{44384257,36474399,26,14},
{44326913,31843793,26,13},
{44285953,21646948,26,14},
{44249089,31217134,26,12},
{44240897,17601204,26,12},
{44105729,3987148,26,16},
{44056577,1694798,26,14},
{44003329,42029911,26,12},
{43995137,27419181,26,12},
{43929601,37686572,26,12},
{43868161,12645876,26,13},
{43859969,5594983,26,14},
{43831297,269321,26,12},
{43810817,19631319,26,15},
{43769857,31373039,26,13},
{43745281,9014713,26,15},
{43687937,30244420,26,13},
{43651073,9650929,26,12},
{43626497,2913183,26,12},
{43528193,26915544,26,12},
{43429889,18560946,26,12},
{43425793,10145215,26,13},
{43356161,28662961,26,12},
{43327489,41593249,26,13},
{43307009,684676,26,12},
{43294721,22335751,26,13},
{43278337,25172316,26,13},
{43216897,7538802,26,12},
{43184129,37682927,26,12},
{43155457,10189168,26,15},
{43143169,18974868,26,12},
{43110401,36355837,26,12},
{43081729,21533348,26,13},
{43069441,12483215,26,12},
{42995713,31405150,26,12},
{42987521,3012139,26,12},
{42938369,13098580,26,12},
{42876929,41862668,26,14},
{42872833,25718848,26,12},
{42811393,8638905,26,14},
{42786817,21070845,26,13},
{42762241,24613471,26,15},
{42741761,13329576,26,12},
{42729473,13293912,26,18},
{42704897,7424610,26,13},
{42680321,1079474,26,14},
{42663937,13704409,26,16},
{42590209,36727507,26,13},
{42582017,6898672,26,14},
{42557441,30643479,26,13},
{42483713,28631555,26,14},
{42418177,8140642,26,14},
{42405889,32746637,26,12},
{42356737,39602899,26,12},
{42332161,22458779,26,12},
{42319873,17003437,26,14},
{42311681,34613545,26,13},
{42299393,7490162,26,12},
{42283009,39235114,26,12},
{42213377,13900261,26,13},
{42127361,19037201,26,12},
{42016769,2399526,26,13},
{42004481,39362132,26,12},
{41988097,1187998,26,12},
{41951233,19729970,26,13},
{41930753,18703653,26,12},
{41893889,25119703,26,14},
{41803777,5324829,26,13},
{41766913,2700759,26,12},
{41746433,22857207,26,16},
{41730049,11749908,26,14},
{41717761,26195903,26,12},
{41705473,1257908,26,13},
{41697281,37243412,26,14},
{41680897,15776995,26,18},
{41623553,28890080,26,13},
{41537537,14816230,26,12},
{41500673,19221711,26,14},
{41291777,38661699,26,12},
{41267201,32027663,26,12},
{41193473,37619590,26,12},
{41144321,19971496,26,12},
{41132033,9225251,26,13},
{41127937,31628525,26,12},
{41066497,33695517,26,13},
{41046017,17914817,26,12},
{41041921,10492360,26,14},
{40960001,10291446,26,16},
{40923137,28250305,26,12},
{40869889,18797806,26,13},
{40857601,40123273,26,12},
{40849409,36557174,26,12},
{40820737,28935072,26,13},
{40685569,2246706,26,12},
{40636417,28536193,26,12},
{40562689,34932544,26,12},
{40513537,37276138,26,12},
{40488961,23782812,26,12},
{40456193,1451470,26,12},
{40427521,2191105,26,13},
{40370177,3457847,26,19},
{40353793,17481476,26,14},
{40333313,641607,26,12},
{40329217,39663786,26,13},
{40292353,2641051,26,12},
{40243201,17182502,26,12},
{40235009,2995517,26,12},
{40230913,29639533,26,13},
{40210433,9492601,26,12},
{40161281,22209232,26,12},
{40148993,35730862,26,13},
{40071169,2074416,26,12},
{40058881,10775502,26,14},
{40026113,4779432,26,14},
{39960577,16779290,26,14},
{39948289,12920331,26,12},
{39899137,19680956,26,12},
{39874561,800919,26,12},
{39866369,37341590,26,12},
{39854081,19475681,26,13},
{39841793,15101033,26,12},
{39776257,31914813,26,12},
{39743489,4960711,26,12},
{39714817,29671547,26,17},
{39669761,25549285,26,12},
{39628801,6448540,26,12},
{39616513,10397000,26,15},
{39530497,29506036,26,12},
{39510017,16665797,26,13},
{39497729,33686123,26,12},
{39493633,19118047,26,13},
{39473153,33394930,26,12},
{39444481,26929642,26,13},
{39395329,12785462,26,13},
{39387137,19687912,26,16},
{39370753,8459215,26,14},
{39325697,6997839,26,12},
{39264257,29155810,26,13},
{39251969,5749514,26,12},
{39223297,8890811,26,15},
{39165953,405575,26,13},
{39149569,4582532,26,13},
{39129089,315233,26,12},
{39100417,9060671,26,13},
{39014401,4879525,26,12},
{38993921,16904471,26,16},
{38957057,21294145,26,12},
{38940673,17888647,26,12},
{38842369,13041495,26,12},
{38793217,7227233,26,12},
{38748161,10749197,26,14},
{38711297,19703086,26,12},
{38637569,35791396,26,12},
{38625281,12225581,26,13},
{38596609,3029957,26,12},
{38563841,9864827,26,12},
{38551553,35119418,26,14},
{38535169,12823247,26,18},
{38526977,13510136,26,13},
{38514689,37049435,26,12},
{38490113,27169463,26,12},
{38412289,36289269,26,13},
{38363137,1287792,26,13},
{38305793,9157681,26,15},
{38289409,25299423,26,14},
{38256641,32068387,26,14},
{38219777,4605405,26,12},
{38178817,11308461,26,12},
{38154241,16813327,26,12},
{38133761,5544193,26,13},
{38117377,20971948,26,13},
{38031361,14697744,26,12},
{37982209,36867688,26,12},
{37974017,6794709,26,12},
{37937153,24020344,26,13},
{37920769,12430398,26,13},
{37896193,10292881,26,14},
{37888001,8612321,26,13},
{37875713,31672147,26,12},
{37777409,27187315,26,12},
{37773313,15269852,26,13},
{37703681,1483483,26,12},
{37691393,2548325,26,13},
{37662721,33068757,26,12},
{37601281,21061904,26,14},
{37580801,10194764,26,12},
{37457921,25146413,26,12},
{37421057,23518309,26,16},
{37416961,34623836,26,12},
{37343233,30186302,26,12},
{37306369,13054025,26,14},
{37285889,5554559,26,12},
{37281793,18282536,26,13},
{37273601,34802853,26,14},
{37232641,7160463,26,13},
{37224449,19231464,26,19},
{37220353,35045041,26,12},
{37060609,35283686,26,15},
{36929537,14637979,26,15},
{36892673,11890409,26,12},
{36876289,34694178,26,12},
{36806657,27694577,26,13},
{36802561,25797523,26,12},
{36765697,33649666,26,16},
{36745217,7788976,26,12},
{36741121,18299081,26,13},
{36671489,11643436,26,12},
{36605953,13110693,26,12},
{36585473,21606419,26,14},
{36544513,34738155,26,13},
{36507649,12335321,26,12},
{36474881,7488703,26,12},
{36462593,13778727,26,13},
{36446209,14420704,26,13},
{36413441,8892664,26,13},
{36372481,25851829,26,16},
{36290561,6874166,26,14},
{36261889,12909390,26,12},
{36229121,1934731,26,12},
{36192257,14333887,26,14},
{36175873,25570022,26,19},
{36130817,33845348,26,12},
{36069377,10633170,26,13},
{35966977,24923247,26,12},
{35946497,2796608,26,15},
{35880961,17071028,26,15},
{35868673,2701061,26,12},
{35819521,14873054,26,12},
{35811329,5973038,26,12},
{35799041,4712150,26,14},
{35786753,32921211,26,12},
{35758081,22849001,26,13},
{35745793,20444540,26,12},
{35708929,30343045,26,13},
{35700737,1969299,26,14},
{35688449,22590850,26,12},
{35684353,24217775,26,15},
{35676161,19208086,26,13},
{35639297,28937621,26,12},
{35622913,2214976,26,12},
{35524609,7537844,26,12},
{35500033,27295029,26,12},
{35479553,3766755,26,13},
{35454977,7726958,26,16},
{35442689,21156713,26,12},
{35430401,2887212,26,13},
{35389441,6468772,26,18},
{35368961,25190883,26,12},
{35254273,11014035,26,12},
{35229697,2293391,26,12},
{35217409,14399128,26,13},
{35155969,20940786,26,12},
{35135489,9543665,26,13},
{35110913,5229145,26,14},
{35106817,14516643,26,12},
{35094529,32652690,26,15},
{35049473,25479965,26,12},
{35045377,9305834,26,14},
{35024897,1772020,26,12},
{35008513,22084079,26,12},
{35000321,28449432,26,12},
{34988033,11471554,26,13},
{34910209,9672023,26,12},
{34897921,17104452,26,15},
{34877441,21418858,26,12},
{34848769,15838853,26,14},
{34828289,33719112,26,12},
{34824193,22121001,26,13},
{34738177,10139845,26,12},
{34676737,15329488,26,13},
{34652161,17639711,26,14},
{34643969,34344954,26,13},
{34578433,9435503,26,13},
{34570241,3938816,26,15},
{34557953,22422180,26,12},
{34529281,16729284,26,13},
{34496513,8268219,26,13},
{34492417,17137990,26,12},
{34467841,13487700,26,12},
{34357249,28212894,26,14},
{34324481,9783696,26,14},
{34308097,24886350,26,15},
{34295809,32565661,26,12},
{34271233,30378541,26,12},
{34246657,12764219,26,12},
{34222081,34207213,26,12},
{34164737,12383374,26,12},
{34160641,31987515,26,14},
{34099201,5071488,26,12},
{34066433,7772411,26,12},
{34062337,32677638,26,14},
{34037761,20737880,26,13},
{34017281,26937446,26,12},
{33939457,7943494,26,13},
{33918977,32511919,26,12},
{33878017,20348095,26,12},
{33832961,18891519,26,14},
{33730561,8800789,26,12},
{33710081,23810544,26,13},
{33697793,22972405,26,12},
{33681409,22663316,26,12},
{33673217,13054957,26,12},
{33574913,21792306,26,12},
{33550337,16590339,25,12},
{33538049,24896852,25,14},
{33533953,33053032,25,12},
{33411073,3379895,25,12},
{33402881,22698138,25,12},
{33349633,29411199,25,13},
{33304577,16311226,25,12},
{33292289,759474,25,18},
{33189889,29185667,25,12},
{33177601,2964399,25,14},
{33128449,10322085,25,15},
{33120257,17118124,25,13},
{33005569,6248767,25,13},
{32993281,16350349,25,12},
{32960513,53869,25,12},
{32931841,30043065,25,15},
{32899073,20209192,25,17},
{32894977,12677307,25,12},
{32858113,21736489,25,13},
{32776193,28920082,25,13},
{32751617,25264260,25,14},
{32686081,248278,25,14},
{32673793,20986049,25,12},
{32665601,7301029,25,12},
{32612353,1441643,25,13},
{32575489,17625168,25,12},
{32489473,8687845,25,14},
{32468993,2600571,25,12},
{32440321,32147340,25,16},
{32419841,18797846,25,12},
{32403457,21381741,25,12},
{32284673,12895880,25,13},
{32256001,17687315,25,12},
{32198657,21083026,25,12},
{32100353,16111742,25,12},
{32071681,23177818,25,13},
{32063489,24752834,25,14},
{32010241,24730758,25,12},
{32002049,17450534,25,12},
{31989761,15005331,25,13},
{31973377,12904957,25,13},
{31948801,11235632,25,15},
{31916033,4238016,25,16},
{31911937,21262935,25,12},
{31805441,7647126,25,12},
{31789057,3343469,25,12},
{31776769,13070761,25,13},
{31744001,28207054,25,13},
{31727617,8185769,25,13},
{31703041,19563952,25,14},
{31694849,26185773,25,13},
{31641601,13108562,25,12},
{31559681,23963275,25,12},
{31485953,10006041,25,12},
{31469569,27809301,25,12},
{31444993,27132584,25,12},
{31424513,24956285,25,15},
{31395841,17576959,25,12},
{31387649,29438761,25,12},
{31383553,31180149,25,13},
{31326209,27549117,25,17},
{31313921,22756027,25,12},
{31285249,27084378,25,13},
{31264769,25324547,25,12},
{31236097,15969922,25,13},
{31174657,19151134,25,12},
{31117313,28306363,25,12},
{31113217,5527908,25,14},
{30994433,26470102,25,12},
{30969857,30010268,25,12},
{30965761,12182138,25,15},
{30916609,25196447,25,14},
{30830593,23661116,25,12},
{30810113,26692216,25,13},
{30785537,13325995,25,14},
{30769153,20916066,25,15},
{30744577,3492133,25,13},
{30699521,30540653,25,12},
{30687233,24348925,25,14},
{30658561,14212147,25,12},
{30547969,16861108,25,13},
{30539777,16635446,25,17},
{30515201,2766364,25,13},
{30486529,19885936,25,12},
{30466049,3877204,25,13},
{30412801,8313531,25,12},
{30404609,19485840,25,12},
{30375937,6610480,25,15},
{30351361,13948720,25,13},
{30318593,2956833,25,13},
{30289921,22103813,25,12},
{30281729,21445288,25,12},
{30232577,14750785,25,12},
{30195713,19094036,25,14},
{30179329,4456977,25,15},
{30105601,47311,25,13},
{30035969,6774108,25,12},
{30007297,23447706,25,13},
{29970433,28089991,25,12},
{29913089,23181263,25,12},
{29884417,1342046,25,19},
{29839361,25659162,25,12},
{29802497,830608,25,14},
{29798401,28522834,25,12},
{29790209,7176641,25,12},
{29765633,19702514,25,12},
{29687809,10954911,25,16},
{29675521,23540158,25,12},
{29519873,14747840,25,12},
{29483009,10564979,25,13},
{29478913,2583025,25,12},
{29433857,14702020,25,13},
{29429761,6939943,25,12},
{29421569,19605749,25,12},
{29417473,2323033,25,13},
{29368321,1236126,25,13},
{29306881,27695749,25,12},
{29294593,22338592,25,16},
{29286401,23133583,25,13},
{29245441,8646634,25,14},
{29147137,22321783,25,14},
{29089793,11231325,25,13},
{29073409,14193376,25,13},
{29052929,22719384,25,12},
{28991489,10717141,25,13},
{28938241,3321207,25,12},
{28930049,9748171,25,12},
{28827649,4402363,25,13},
{28745729,8017385,25,13},
{28704769,214356,25,17},
{28659713,10787813,25,12},
{28655617,20449238,25,14},
{28635137,18203627,25,12},
{28618753,20579208,25,12},
{28569601,17492472,25,12},
{28561409,24138900,25,12},
{28557313,23722859,25,14},
{28520449,6911977,25,12},
{28512257,25958208,25,12},
{28499969,24184991,25,13},
{28487681,7754977,25,12},
{28475393,5369374,25,15},
{28459009,21866502,25,14},
{28446721,20663530,25,12},
{28434433,7007944,25,13},
{28336129,16532476,25,13},
{28311553,24430610,25,20},
{28303361,21053894,25,13},
{28291073,20081360,25,12},
{28262401,27312909,25,14},
{28254209,12999657,25,13},
{28241921,20502118,25,12},
{28229633,655693,25,14},
{28225537,1346183,25,12},
{28200961,12987913,25,12},
{28131329,5209581,25,14},
{28082177,16698975,25,15},
{28078081,26066802,25,12},
{28069889,23884346,25,12},
{28041217,3922416,25,13},
{27955201,11275978,25,12},
{27934721,20796679,25,14},
{27918337,13844194,25,17},
{27795457,20208558,25,13},
{27783169,4912655,25,12},
{27713537,7578753,25,13},
{27688961,10078300,25,15},
{27660289,19147063,25,12},
{27627521,22256169,25,12},
{27615233,7158936,25,13},
{27590657,11654436,25,16},
{27512833,7291109,25,12},
{27488257,4296709,25,12},
{27475969,17938020,25,14},
{27451393,13436853,25,13},
{27430913,19496871,25,12},
{27353089,27237266,25,13},
{27328513,2735736,25,16},
{27308033,21832669,25,12},
{27185153,14060865,25,12},
{27168769,15749512,25,12},
{27144193,5405494,25,12},
{27074561,11962314,25,13},
{27037697,24289386,25,12},
{27025409,9036988,25,13},
{27000833,26801414,25,18},
{26984449,7021477,25,14},
{26972161,7961121,25,12},
{26963969,18698790,25,12},
{26923009,18545332,25,12},
{26910721,25219379,25,13},
{26853377,13386843,25,14},
{26836993,26290640,25,15},
{26816513,23244555,25,12},
{26787841,3757049,25,14},
{26714113,18233671,25,13},
{26693633,20515198,25,12},
{26591233,11263720,25,14},
{26554369,12632261,25,12},
{26484737,16975687,25,13},
{26468353,1001930,25,13},
{26447873,3058540,25,12},
{26419201,9481267,25,13},
{26411009,24570100,25,16},
{26382337,14594882,25,12},
{26370049,13026116,25,13},
{26361857,8267549,25,14},
{26337281,20545937,25,13},
{26238977,14195320,25,13},
{26214401,21466523,25,20},
{26152961,18700564,25,12},
{26136577,3783800,25,12},
{26103809,13675155,25,12},
{26038273,128214,25,12},
{26017793,6406814,25,16},
{25968641,16743578,25,14},
{25956353,4900047,25,12},
{25931777,24343183,25,12},
{25833473,13868476,25,12},
{25796609,23676881,25,13},
{25681921,24804002,25,13},
{25620481,21909754,25,12},
{25587713,23803800,25,12},
{25583617,10501170,25,13},
{25563137,19394696,25,12},
{25550849,10733094,25,13},
{25538561,21801391,25,12},
{25464833,8310497,25,12},
{25378817,3428580,25,14},
{25366529,7463914,25,12},
{25276417,22459369,25,12},
{25243649,8345869,25,12},
{25231361,7317421,25,16},
{25202689,19806203,25,12},
{25178113,21884638,25,12},
{25092097,17702518,25,13},
{25067521,19155289,25,15},
{25006081,3431171,25,12},
{24956929,10652921,25,12},
{24944641,6483853,25,13},
{24801281,14026700,25,12},
{24772609,23100074,25,17},
{24764417,10350177,25,13},
{24748033,8389033,25,13},
{24698881,21773462,25,13},
{24690689,10189923,25,14},
{24686593,9078817,25,12},
{24629249,21982898,25,12},
{24616961,20118326,25,13},
{24576001,14422017,25,16},
{24526849,13563486,25,14},
{24494081,4556632,25,14},
{24416257,7128557,25,12},
{24334337,15494566,25,12},
{24260609,8126266,25,12},
{24199169,11621199,25,14},
{24150017,258961,25,15},
{24072193,5059286,25,12},
{24035329,17679151,25,14},
{24014849,16265594,25,12},
{23961601,21738861,25,13},
{23949313,5300149,25,12},
{23842817,19980427,25,12},
{23801857,738340,25,12},
{23789569,14918618,25,16},
{23740417,1558565,25,14},
{23719937,9360288,25,12},
{23715841,16973565,25,13},
{23703553,20468346,25,12},
{23683073,13246466,25,13},
{23666689,22166340,25,13},
{23605249,18922502,25,12},
{23580673,9333015,25,12},
{23556097,13790471,25,12},
{23498753,23318050,25,12},
{23482369,406497,25,12},
{23412737,10818439,25,14},
{23351297,21580124,25,12},
{23339009,19479497,25,13},
{23285761,15050948,25,12},
{23252993,16007263,25,12},
{23187457,17900541,25,12},
{23175169,7517292,25,13},
{23154689,7666304,25,12},
{23150593,21914865,25,14},
{23130113,11160263,25,12},
{23089153,2944975,25,12},
{23068673,15138801,25,21},
{23044097,9290278,25,13},
{22958081,18246978,25,12},
{22917121,3180693,25,12},
{22908929,18179559,25,12},
{22896641,19142062,25,13},
{22884353,6723607,25,12},
{22835201,15514831,25,12},
{22806529,146890,25,18},
{22794241,784805,25,12},
{22745089,6579845,25,12},
{22724609,7367478,25,14},
{22700033,1031374,25,13},
{22683649,6384823,25,13},
{22638593,19808986,25,12},
{22622209,16821714,25,12},
{22614017,8974778,25,12},
{22601729,16477236,25,13},
{22577153,19030039,25,15},
{22552577,20217690,25,13},
{22548481,17851254,25,12},
{22536193,16784274,25,13},
{22499329,1162721,25,12},
{22491137,461685,25,12},
{22487041,9731200,25,13},
{22454273,16774867,25,13},
{22450177,16655407,25,12},
{22437889,6554656,25,13},
{22429697,19592620,25,14},
{22392833,16111206,25,12},
{22364161,19502750,25,14},
{22327297,16986993,25,12},
{22269953,11267225,25,12},
{22265857,11548906,25,14},
{22241281,18240302,25,13},
{22208513,3134377,25,13},
{22204417,10713392,25,12},
{22142977,14072645,25,13},
{22122497,2255004,25,12},
{22118401,16006390,25,15},
{22069249,21328192,25,14},
{22036481,5302229,25,14},
{22024193,841831,25,12},
{21946369,3730218,25,13},
{21913601,21706112,25,13},
{21876737,12026647,25,12},
{21860353,1946945,25,12},
{21778433,759913,25,12},
{21741569,19773158,25,14},
{21676033,8830390,25,14},
{21655553,11059478,25,12},
{21626881,5342674,25,17},
{21594113,17311698,25,15},
{21577729,18223692,25,14},
{21495809,13321573,25,19},
{21446657,3215409,25,14},
{21409793,2176022,25,12},
{21360641,3356376,25,12},
{21237761,5141286,25,12},
{21225473,1772298,25,13},
{21221377,20002038,25,12},
{21200897,17940055,25,15},
{21123073,16018808,25,12},
{21114881,7970501,25,12},
{21016577,8229265,25,12},
{21000193,12771129,25,12},
{20914177,14341414,25,13},
{20901889,5909565,25,12},
{20877313,7396444,25,12},
{20779009,20469389,25,12},
{20746241,4897010,25,12},
{20717569,3214450,25,13},
{20705281,15872784,25,12},
{20635649,2548602,25,13},
{20606977,8587001,25,12},
{20586497,1610549,25,13},
{20512769,7853272,25,16},
{20484097,10831989,25,12},
{20471809,301264,25,13},
{20463617,9756630,25,14},
{20451329,11854076,25,12},
{20422657,12711568,25,13},
{20365313,7261371,25,14},
{20316161,18620345,25,17},
{20287489,8368743,25,12},
{20242433,11368934,25,13},
{20213761,18420452,25,12},
{20144129,10332722,25,13},
{20119553,7996758,25,16},
{20078593,4755215,25,13},
{20054017,3737251,25,17},
{20041729,16197928,25,12},
{20033537,11175070,25,12},
{19968001,16697144,25,12},
{19959809,3019889,25,12},
{19869697,11235684,25,12},
{19845121,6078238,25,12},
{19824641,17052652,25,15},
{19795969,14975284,25,12},
{19787777,6708847,25,12},
{19763201,11525739,25,12},
{19701761,2114025,25,13},
{19689473,10191821,25,12},
{19673089,9380735,25,12},
{19623937,11391365,25,12},
{19603457,17973491,25,13},
{19529729,17670446,25,17},
{19476481,8359507,25,12},
{19419137,5690625,25,12},
{19415041,5568954,25,14},
{19382273,7119252,25,14},
{19345409,12164457,25,12},
{19296257,90349,25,12},
{19243009,7549138,25,13},
{19210241,7861964,25,13},
{19107841,3344061,25,12},
{19095553,18547959,25,13},
{19070977,12335268,25,16},
{19009537,10921850,25,12},
{18997249,4315580,25,13},
{18964481,2696567,25,13},
{18927617,5399307,25,12},
{18841601,2760351,25,15},
{18825217,5603435,25,14},
{18812929,1959164,25,12},
{18800641,7084933,25,13},
{18788353,12337118,25,12},
{18681857,3976952,25,12},
{18669569,6266000,25,13},
{18657281,8641134,25,12},
{18644993,8065239,25,15},
{18620417,8508093,25,13},
{18558977,10789839,25,12},
{18542593,9225872,25,12},
{18497537,16822292,25,14},
{18485249,13090358,25,12},
{18444289,17577781,25,12},
{18436097,2181254,25,12},
{18411521,9302083,25,12},
{18399233,11742310,25,14},
{18395137,6504692,25,12},
{18382849,4768307,25,15},
{18362369,4997333,25,12},
{18358273,14151936,25,13},
{18333697,613674,25,14},
{18210817,4893098,25,13},
{18149377,1386673,25,12},
{18137089,6086338,25,14},
{18128897,8796061,25,13},
{18075649,4470497,25,12},
{18063361,12917181,25,13},
{18014209,9024903,25,13},
{18006017,17275860,25,14},
{17907713,2337975,25,14},
{17879041,3180962,25,12},
{17846273,3915742,25,12},
{17797121,5563562,25,12},
{17735681,15984578,25,13},
{17719297,14250295,25,13},
{17707009,12860803,25,12},
{17633281,5270843,25,12},
{17584129,601934,25,12},
{17575937,2256366,25,12},
{17522689,8541831,25,13},
{17448961,7495643,25,14},
{17440769,9851282,25,13},
{17416193,14176791,25,14},
{17391617,9085440,25,13},
{17375233,5625373,25,13},
{17367041,277979,25,16},
{17276929,1682011,25,13},
{17264641,4490415,25,12},
{17252353,13118611,25,14},
{17231873,7515831,25,12},
{17182721,7753846,25,12},
{17129473,1462559,25,13},
{17059841,4332185,25,12},
{17010689,3873738,25,12},
{17006593,7620586,25,15},
{16986113,5278095,25,12},
{16957441,13851359,25,14},
{16900097,15478463,25,13},
{16863233,16522103,25,12},
{16801793,8125281,25,13},
#endif
{16760833,15385313,24,14},
{16736257,894396,24,13},
{16699393,12391510,24,12},
{16674817,16070823,24,12},
{16650241,2033650,24,12},
{16617473,1584607,24,12},
{16592897,5788011,24,12},
{16588801,10844155,24,13},
{16580609,7695644,24,16},
{16519169,11699175,24,12},
{16515073,8155929,24,18},
{16494593,11634973,24,12},
{16490497,2089355,24,13},
{16465921,13999142,24,14},
{16384001,4442161,24,17},
{16371713,585249,24,12},
{16355329,14233877,24,12},
{16293889,7920498,24,13},
{16269313,2633325,24,14},
{16261121,11780226,24,13},
{16244737,11322917,24,13},
{16125953,6318182,24,12},
{16121857,4312778,24,17},
{16064513,3343146,24,13},
{16015361,12023039,24,13},
{15998977,8897606,24,13},
{15978497,15463745,24,12},
{15974401,14066128,24,14},
{15962113,7638639,24,12},
{15941633,1629555,24,14},
{15900673,15838252,24,13},
{15831041,13530587,24,12},
{15818753,10863350,24,13},
{15790081,4013339,24,12},
{15781889,6959691,24,12},
{15732737,13994878,24,12},
{15630337,9264567,24,15},
{15618049,1044748,24,12},
{15605761,2403399,24,13},
{15572993,5893184,24,13},
{15556609,9768391,24,13},
{15548417,4594039,24,14},
{15523841,2611339,24,13},
{15511553,9493849,24,12},
{15474689,14918107,24,13},
{15470593,866181,24,12},
{15372289,8878164,24,12},
{15298561,7158125,24,12},
{15228929,7604317,24,13},
{15200257,12142870,24,12},
{15167489,12857562,24,12},
{15052801,1396852,24,12},
{14970881,4735165,24,12},
{14942209,5661070,24,18},
{14909441,11620785,24,15},
{14893057,11006052,24,14},
{14880769,5343498,24,12},
{14872577,10813522,24,12},
{14831617,5393565,24,12},
{14774273,2974985,24,12},
{14770177,14087359,24,13},
{14749697,13347112,24,12},
{14684161,7255080,24,12},
{14663681,11275756,24,14},
{14651393,6141891,24,12},
{14610433,7729920,24,12},
{14499841,14408404,24,14},
{14438401,5911408,24,12},
{14430209,5625637,24,12},
{14344193,12061774,24,13},
{14340097,6632467,24,12},
{14307329,6964289,24,12},
{14282753,9346124,24,12},
{14258177,10061122,24,12},
{14241793,7228958,24,12},
{14196737,2482955,24,13},
{14172161,380693,24,14},
{14155777,8046887,24,19},
{14123009,1341319,24,15},
{14118913,2671262,24,12},
{14110721,10530474,24,12},
{14036993,7346962,24,12},
{14012417,7892259,24,12},
{13877249,6369623,24,14},
{13811713,6667098,24,14},
{13766657,6784592,24,12},
{13754369,7148271,24,13},
{13664257,9731810,24,15},
{13631489,11496326,24,20},
{13606913,8007054,24,13},
{13578241,8766224,24,12},
{13570049,9000364,24,12},
{13565953,7151880,24,16},
{13541377,1982551,24,13},
{13496321,6492324,24,12},
{13381633,8369392,24,12},
{13344769,9635903,24,13},
{13336577,103081,24,15},
{13332481,13250246,24,12},
{13312001,12591683,24,13},
{13283329,2849273,24,12},
{13238273,3192219,24,17},
{13197313,9010336,24,13},
{13152257,577700,24,12},
{13135873,8462754,24,12},
{13074433,1101900,24,15},
{13066241,1976206,24,13},
{13037569,1760126,24,12},
{13029377,4604716,24,12},
{13004801,8045034,24,12},
{12931073,10246032,24,12},
{12906497,1231143,24,12},
{12902401,11642758,24,13},
{12865537,3413796,24,12},
{12820481,229364,24,13},
{12808193,7867856,24,12},
{12771329,11546108,24,13},
{12767233,3437574,24,12},
{12759041,12155813,24,12},
{12685313,5781253,24,12},
{12681217,8960683,24,15},
{12644353,3911032,24,12},
{12623873,2716382,24,13},
{12599297,11930674,24,14},
{12587009,2233783,24,12},
{12521473,10409035,24,12},
{12484609,6428742,24,15},
{12451841,561305,24,17},
{12390401,1102023,24,12},
{12361729,11556424,24,13},
{12230657,6891814,24,13},
{12226561,11504852,24,12},
{12214273,10773316,24,13},
{12206081,3877133,24,14},
{12193793,11751495,24,12},
{12177409,3036057,24,12},
{12128257,1897959,24,12},
{12115969,1576393,24,13},
{12070913,3022754,24,12},
{12046337,4952418,24,12},
{12042241,4875103,24,14},
{12021761,10528529,24,12},
{11919361,6925701,24,13},
{11907073,11731243,24,12},
{11898881,11382703,24,12},
{11886593,6577348,24,13},
{11759617,11117826,24,12},
{11677697,3600672,24,12},
{11673601,2087472,24,13},
{11653121,3149362,24,12},
{11624449,6665188,24,13},
{11599873,2984692,24,16},
{11591681,4318356,24,13},
{11575297,11322098,24,13},
{11517953,9879665,24,14},
{11501569,4653893,24,15},
{11468801,6791298,24,16},
{11456513,4163664,24,12},
{11370497,2643173,24,15},
{11358209,6395865,24,12},
{11345921,10944876,24,13},
{11309057,10192023,24,12},
{11304961,9184073,24,15},
{11272193,1584196,24,18},
{11186177,6228374,24,12},
{11169793,2829783,24,12},
{11112449,7841834,24,12},
{11087873,2968330,24,12},
{11059201,417592,24,14},
{11046913,7826769,24,12},
{11038721,5171441,24,12},
{10997761,1783401,24,12},
{10989569,408203,24,12},
{10940417,3124940,24,12},
{10924033,6355830,24,12},
{10842113,6101455,24,12},
{10838017,5003722,24,13},
{10780673,8986326,24,15},
{10739713,9167074,24,13},
{10715137,254064,24,15},
{10702849,8282283,24,12},
{10678273,2432584,24,12},
{10629121,8595471,24,12},
{10579969,6552101,24,12},
{10571777,10032709,24,12},
{10559489,4949614,24,13},
{10534913,1615896,24,14},
{10498049,3664327,24,12},
{10493953,7301118,24,13},
{10473473,5284356,24,12},
{10457089,111567,24,12},
{10444801,492256,24,13},
{10436609,4483499,24,14},
{10383361,3110859,24,12},
{10362881,7608509,24,13},
{10334209,2748609,24,12},
{10223617,10025497,24,18},
{10186753,4128819,24,12},
{10162177,2250627,24,12},
{10076161,9845213,24,14},
{10067969,3656282,24,13},
{10063873,6162645,24,12},
{10039297,5471577,24,12},
{10027009,5891267,24,16},
{9920513,4349134,24,13},
{9834497,6577428,24,12},
{9781249,3514139,24,14},
{9760769,9239094,24,12},
{9732097,2795413,24,15},
{9711617,2390345,24,12},
{9695233,5965274,24,12},
{9646081,5580445,24,12},
{9588737,4680061,24,12},
{9547777,4702710,24,12},
{9502721,8985261,24,16},
{9453569,5656909,24,14},
{9441281,559895,24,12},
{9392129,8141488,24,12},
{9379841,263048,24,13},
{9338881,3495002,24,15},
{9330689,3157919,24,13},
{9326593,5326574,24,12},
{9220097,4885720,24,12},
{9166849,4959296,24,13},
{9117697,1103980,24,13},
{9093121,425177,24,14},
{9080833,1840920,24,12},
{9035777,3303775,24,13},
{9031681,1199218,24,12},
{9023489,145868,24,12},
{9019393,6922239,24,13},
{9011201,8676539,24,15},
{8949761,3136210,24,12},
{8876033,185571,24,12},
{8851457,6524968,24,12},
{8814593,199766,24,15},
{8753153,5210070,24,12},
{8716289,85079,24,16},
{8667137,1362865,24,14},
{8650753,3961843,24,18},
{8527873,2766023,24,13},
{8519681,3999445,24,17},
{8466433,2982250,24,12},
{8441857,3395324,24,12},
{8404993,4907413,24,14},
{8380417,1956502,23,13},
{8318977,3436892,23,12},
{8286209,2480738,23,12},
{8273921,7188916,23,14},
{8257537,4919605,23,17},
{8245249,2364662,23,12},
{8183809,7140789,23,13},
{8163329,7363701,23,12},
{8159233,6721528,23,15},
{8134657,5065770,23,13},
{8122369,2960141,23,12},
{8114177,3287989,23,12},
{8040449,821956,23,12},
{7979009,1246096,23,14},
{7925761,5030372,23,12},
{7913473,1687049,23,14},
{7815169,5897294,23,14},
{7806977,1333420,23,13},
{7790593,877578,23,13},
{7745537,6062330,23,12},
{7741441,7099975,23,13},
{7729153,512905,23,12},
{7704577,7195855,23,12},
{7671809,5959808,23,12},
{7667713,1294281,23,16},
{7659521,152168,23,13},
{7643137,5639668,23,13},
{7630849,3283492,23,12},
{7569409,4136604,23,15},
{7548929,5094076,23,12},
{7544833,63362,23,13},
{7475201,2807323,23,12},
{7462913,3680790,23,13},
{7438337,2284671,23,15},
{7434241,4555913,23,12},
{7413761,2014433,23,13},
{7360513,2204332,23,12},
{7352321,1292238,23,12},
{7340033,5406612,23,20},
{7229441,3547187,23,12},
{7200769,5695619,23,13},
{7188481,808181,23,12},
{7168001,6580369,23,13},
{7139329,6566353,23,12},
{7114753,2841309,23,12},
{7090177,6334133,23,12},
{7065601,2971474,23,12},
{7057409,5350163,23,12},
{6955009,2382666,23,13},
{6946817,1605231,23,17},
{6942721,2416777,23,12},
{6885377,4948460,23,12},
{6873089,859592,23,13},
{6782977,2092473,23,15},
{6750209,4393336,23,16},
{6737921,1554707,23,12},
{6725633,2184291,23,13},
{6684673,2824386,23,17},
{6635521,5913944,23,14},
{6602753,5067760,23,14},
{6578177,6175586,23,13},
{6574081,1163930,23,12},
{6537217,3326255,23,14},
{6463489,5716674,23,13},
{6455297,556661,23,15},
{6402049,1461931,23,12},
{6393857,4899224,23,12},
{6381569,325849,23,13},
{6320129,3413025,23,12},
{6307841,6163736,23,14},
{6258689,390228,23,15},
{6254593,3713878,23,12},
{6234113,3983231,23,13},
{6230017,4132879,23,12},
{6209537,3499870,23,14},
{6156289,4871639,23,12},
{6144001,4529164,23,14},
{6111233,4154923,23,14},
{6086657,207637,23,13},
{6082561,2910697,23,12},
{6008833,4766377,23,12},
{6000641,3987685,23,12},
{5984257,638854,23,12},
{5951489,575869,23,12},
{5910529,907356,23,12},
{5865473,3726352,23,15},
{5849089,171715,23,14},
{5824513,1832942,23,13},
{5804033,3684182,23,12},
{5779457,4498684,23,12},
{5767169,4527514,23,19},
{5763073,2599598,23,12},
{5738497,3012505,23,12},
{5726209,4578065,23,13},
{5677057,2233973,23,13},
{5656577,1556450,23,12},
{5632001,3513414,23,12},
{5591041,1440990,23,12},
{5578753,4151573,23,13},
{5517313,5287434,23,12},
{5492737,105629,23,12},
{5431297,3907858,23,13},
{5410817,5363414,23,12},
{5398529,3491766,23,13},
{5369857,1240969,23,12},
{5345281,2856158,23,12},
{5337089,3703525,23,12},
{5324801,3366130,23,14},
{5308417,1978857,23,16},
{5287937,5250807,23,12},
{5246977,2760355,23,12},
{5234689,3212580,23,13},
{5222401,2942007,23,12},
{5189633,1687144,23,12},
{5140481,5098129,23,12},
{5066753,3504441,23,12},
{5050369,3842087,23,12},
{4907009,1401718,23,13},
{4902913,964213,23,12},
{4882433,126932,23,15},
{4866049,4006615,23,14},
{4845569,2229907,23,12},
{4816897,1479767,23,15},
{4780033,451374,23,12},
{4771841,658263,23,12},
{4759553,4101363,23,13},
{4694017,4057263,23,13},
{4632577,3409912,23,12},
{4620289,4435914,23,15},
{4595713,2051172,23,13},
{4550657,826482,23,12},
{4513793,3236392,23,13},
{4476929,3447200,23,12},
{4464641,1784381,23,13},
{4452353,1306468,23,12},
{4435969,2091564,23,12},
{4427777,4245509,23,12},
{4423681,4157823,23,15},
{4366337,2016741,23,13},
{4304897,300642,23,12},
{4300801,4269574,23,13},
{4263937,1452203,23,12},
{4206593,3417158,23,12},
{4169729,312302,22,13},
{4165633,2604684,22,12},
{4141057,3475840,22,12},
{4120577,2965400,22,13},
{4104193,2458989,22,13},
{4079617,2315893,22,14},
{4046849,460053,22,14},
{4005889,839024,22,13},
{3993601,2436417,22,12},
{3985409,3750482,22,12},
{3960833,2187556,22,12},
{3956737,2276656,22,13},
{3944449,3649928,22,12},
{3919873,2648749,22,12},
{3911681,2283101,22,12},
{3870721,543032,22,12},
{3850241,2716667,22,14},
{3735553,722233,22,16},
{3690497,3604458,22,12},
{3686401,3601163,22,14},
{3612673,3338110,22,13},
{3604481,193403,22,16},
{3588097,3246144,22,14},
{3543041,1668344,22,12},
{3526657,1047403,22,12},
{3489793,2577905,22,14},
{3469313,1583884,22,12},
{3452929,806490,22,12},
{3428353,2126521,22,12},
{3420161,2078757,22,12},
{3391489,1485981,22,14},
{3383297,237235,22,13},
{3305473,2973853,22,12},
{3280897,2606620,22,12},
{3260417,2805450,22,14},
{3219457,3167868,22,13},
{3198977,36978,22,12},
{3194881,1426283,22,14},
{3174401,2402789,22,12},
{3133441,423280,22,12},
{3076097,1063691,22,12},
{3072001,2884468,22,13},
{3022849,472837,22,13},
{3002369,434260,22,12},
{2936833,2293128,22,12},
{2912257,77724,22,12},
{2875393,103704,22,13},
{2768897,11359,22,14},
{2756609,2543113,22,12},
{2752513,2483664,22,17},
{2715649,1945821,22,12},
{2707457,1200346,22,12},
{2654209,2176633,22,15},
{2641921,2270706,22,12},
{2592769,2134423,22,12},
{2572289,1117898,22,14},
{2543617,1118662,22,12},
{2486273,2291237,22,12},
{2482177,2291731,22,13},
{2469889,297329,22,12},
{2437121,1904322,22,12},
{2424833,1836810,22,16},
{2387969,999089,22,12},
{2363393,399226,22,12},
{2314241,422736,22,12},
{2297857,589656,22,12},
{2277377,486428,22,14},
{2236417,1935978,22,13},
{2101249,1339057,22,12},
{2056193,923804,21,13},
{2052097,1125320,21,12},
{1990657,1893144,21,13},
{1908737,1734742,21,13},
{1892353,506921,21,13},
{1847297,1172190,21,12},
{1843201,1043343,21,13},
{1810433,1075944,21,13},
{1794049,1608919,21,13},
{1785857,872740,21,14},
{1769473,514853,21,16},
{1748993,570818,21,12},
{1732609,1627341,21,12},
{1724417,443029,21,12},
{1720321,1030518,21,14},
{1712129,173016,21,13},
{1708033,1614755,21,12},
{1662977,126725,21,13},
{1597441,869319,21,13},
{1589249,26134,21,14},
{1503233,1194989,21,12},
{1454081,167029,21,12},
{1437697,89503,21,12},
{1417217,189813,21,13},
{1376257,906980,21,16},
{1355777,1218448,21,12},
{1318913,507647,21,13},
{1253377,650210,21,13},
{1196033,240870,21,14},
{1191937,879692,21,12},
{1179649,608817,21,17},
{1146881,573655,21,15},
{1130497,297764,21,14},
{1097729,306786,21,14},
{1093633,172277,21,12},
{1073153,916028,21,13},
{1032193,396059,20,14},
{995329,408789,20,12},
{974849,709671,20,13},
{962561,260290,20,12},
{946177,295553,20,12},
{925697,199226,20,13},
{921601,485466,20,12},
{790529,55460,20,12},
{786433,11837,20,18},
{778241,117636,20,13},
{765953,534230,20,12},
{737281,731492,20,14},
{724993,202567,20,12},
{675841,47755,20,12},
{667649,250583,20,12},
{643073,134098,20,12},
{638977,310979,20,14},
{577537,396822,20,12},
{557057,284046,20,15},
{520193,439579,19,12},
{495617,236411,19,12},
{471041,231520,19,12},
{430081,150326,19,12},
{417793,324366,19,13},
{380929,206232,19,12},
{331777,4477,19,12},
{319489,227794,19,13},
{307201,71105,19,12},
{286721,161908,19,13},
{270337,101045,19,13},
{249857,48701,18,12},
{188417,164329,18,13},
{184321,155567,18,12},
{176129,67451,18,12},
{163841,142754,18,15},
{151553,38298,18,12},
{147457,101599,18,14},
{114689,57361,17,14},
{86017,17710,17,12},
{65537,53761,17,16},
{61441,30111,16,12},
{40961,4971,16,13},
{12289,9814,14,12},
{0,0,0,0},
};

#define MAX_D 26

static int blen_prod_fftprime[MAX_D+1] =
{375772,375772,375772,375772,
 375772,375772,375772,375772,
 375772,375772,375772,375772,
 375772,186706,92384,46626,
 23388,11701,5783,2940,
 1509,771,276,85,
 57,29,29};

/*
   d1 = deg(f1), n1 = |f1|oo,
   d2 = deg(f2), n2 = |f2|oo
   return 1 if sufficiently many fft_primes.
          0 if not.
*/

int int_bits(int);

int fft_available(int d1,int n1,int d2,int n2)
{
	int dmin,bound,dlen;

	dmin = d1>d2?d2:d1;
	bound = n1+n2+int_bits(dmin)+1;
	dlen = int_bits(d1+d2);
	if ( dlen > MAX_D )
		return 0;
	else if ( blen_prod_fftprime[dlen] <= bound )
		return 0;
	else
		return 1;
}

void get_fft_prime(int index,int *p,int *d)
{
	if ( index < 0 || index >= NPrimes ) {
		*p = 0; *d = 0;
	} else {
		*p = Primes[index].prime; *d = Primes[index].d;
	}
}
